## Original file prepared in 2011 by Windell H. Oskay, www.evilmadscientist.com
##
##
## Contents adapted from emergent.unpythonic.net/software/hershey
##  by way of http://www.thingiverse.com/thing:6168
##
##The Hershey Fonts are a set of vector fonts with a liberal license.
##
##USE RESTRICTION:
##	This distribution of the Hershey Fonts may be used by anyone for
##	any purpose, commercial or otherwise, providing that:
##		1. The following acknowledgements must be distributed with
##			the font data:
##			- The Hershey Fonts were originally created by Dr.
##				A. V. Hershey while working at the U. S.
##				National Bureau of Standards.
##			- The format of the Font data in this distribution
##				was originally created by
##					James Hurt
##					Cognition, Inc.
##					900 Technology Park Drive
##					Billerica, MA 01821
##					(mit-eddie!ci-dandelion!hurt)
##		2. The font data in this distribution may be converted into
##			any other format *EXCEPT* the format distributed by
##			the U.S. NTIS (which organization holds the rights
##			to the distribution and use of the font data in that
##			particular format). Not that anybody would really
##			*want* to use their format... each point is described
##			in eight bytes as "xxx yyy:", where xxx and yyy are
##			the coordinate values as ASCII numbers.

module Hershey
  FONTS = {
    :astrology => ["-8 8","-12 12 M-8 -10 L-4 -8 L-2 -6 L-1 -3 L-1 0 L-2 3 L-4 5 L-8 7 M-8 -10 L-5 -9 L-3 -8 L-1 -6 L0 -3 M0 0 L-1 3 L-3 5 L-5 6 L-8 7 M8 -10 L5 -9 L3 -8 L1 -6 L0 -3 M0 0 L1 3 L3 5 L5 6 L8 7 M8 -10 L4 -8 L2 -6 L1 -3 L1 0 L2 3 L4 5 L8 7 M-9 -2 L9 -2 M-9 -1 L9 -1","-9 9 M-4 -12 L-5 -11 L-5 -5 M-4 -11 L-5 -5 M-4 -12 L-3 -11 L-5 -5 M5 -12 L4 -11 L4 -5 M5 -11 L4 -5 M5 -12 L6 -11 L4 -5","-13 14 M-1 -12 L-4 -11 L-7 -9 L-9 -6 L-10 -3 L-10 0 L-9 3 L-7 6 L-4 8 L-1 9 L2 9 L5 8 L8 6 L10 3 L11 0 L11 -3 L10 -6 L8 -9 L5 -11 L2 -12 L-1 -12 M0 -3 L-1 -2 L-1 -1 L0 0 L1 0 L2 -1 L2 -2 L1 -3 L0 -3 M0 -2 L0 -1 L1 -1 L1 -2 L0 -2","-8 9 M-2 -12 L-4 -11 L-3 -9 L-1 -8 M-2 -12 L-3 -11 L-3 -9 M3 -12 L5 -11 L4 -9 L2 -8 M3 -12 L4 -11 L4 -9 M-1 -8 L-3 -7 L-4 -6 L-5 -4 L-5 -1 L-4 1 L-3 2 L-1 3 L2 3 L4 2 L5 1 L6 -1 L6 -4 L5 -6 L4 -7 L2 -8 L-1 -8 M0 3 L0 9 M1 3 L1 9 M-4 6 L5 6","-9 10 M0 -12 L-3 -11 L-5 -9 L-6 -6 L-6 -5 L-5 -2 L-3 0 L0 1 L1 1 L4 0 L6 -2 L7 -5 L7 -6 L6 -9 L4 -11 L1 -12 L0 -12 M0 1 L0 9 M1 1 L1 9 M-4 5 L5 5","-14 14 M-2 -12 L-5 -11 L-8 -9 L-10 -6 L-11 -3 L-11 1 L-10 4 L-8 7 L-5 9 L-2 10 L2 10 L5 9 L8 7 L10 4 L11 1 L11 -3 L10 -6 L8 -9 L5 -11 L2 -12 L-2 -12 M0 -12 L0 10 M-11 -1 L11 -1","-11 14 M-2 -5 L-5 -4 L-7 -2 L-8 1 L-8 2 L-7 5 L-5 7 L-2 8 L-1 8 L2 7 L4 5 L5 2 L5 1 L4 -2 L2 -4 L-1 -5 L-2 -5 M11 -11 L5 -11 L9 -10 L3 -4 M11 -11 L11 -5 L10 -9 L4 -3 M10 -10 L4 -4","-7 7 M4 -16 L2 -14 L0 -11 L-2 -7 L-3 -2 L-3 2 L-2 7 L0 11 L2 14 L4 16 M2 -14 L0 -10 L-1 -7 L-2 -2 L-2 2 L-1 7 L0 10 L2 14","-7 7 M-4 -16 L-2 -14 L0 -11 L2 -7 L3 -2 L3 2 L2 7 L0 11 L-2 14 L-4 16 M-2 -14 L0 -10 L1 -7 L2 -2 L2 2 L1 7 L0 10 L-2 14","-12 10 M-9 -9 L-8 -11 L-6 -12 L-3 -12 L-1 -11 L0 -9 L0 -6 L-1 -3 L-2 -1 L-4 1 L-7 3 M-3 -12 L-2 -11 L-1 -9 L-1 -5 L-2 -2 L-4 1 M4 -12 L2 9 M5 -12 L1 9 M-7 3 L7 3","-9 10 M-5 -12 L-5 3 M-4 -12 L-5 -1 M-5 -1 L-4 -3 L-3 -4 L-1 -5 L2 -5 L5 -4 L6 -2 L6 0 L5 2 L3 4 M2 -5 L4 -4 L5 -2 L5 0 L2 6 L2 8 L3 9 L5 9 L7 7 M-7 -12 L-4 -12","-4 4 M1 5 L0 6 L-1 5 L0 4 L1 5 L1 7 L-1 9","-9 10 M0 -4 L-3 -3 L-5 -1 L-6 2 L-6 3 L-5 6 L-3 8 L0 9 L1 9 L4 8 L6 6 L7 3 L7 2 L6 -1 L4 -3 L1 -4 L0 -4 M0 -10 L-4 -8 L0 -12 L0 -4 M1 -10 L5 -8 L1 -12 L1 -4 M0 1 L-1 2 L-1 3 L0 4 L1 4 L2 3 L2 2 L1 1 L0 1 M0 2 L0 3 L1 3 L1 2 L0 2","-4 4 M0 4 L-1 5 L0 6 L1 5 L0 4","-11 12 M-1 -10 L0 -12 L0 9 M2 -10 L1 -12 L1 9 M-8 -10 L-7 -12 L-7 -5 L-6 -2 L-4 0 L-1 1 L0 1 M-5 -10 L-6 -12 L-6 -4 L-5 -1 M9 -10 L8 -12 L8 -5 L7 -2 L5 0 L2 1 L1 1 M6 -10 L7 -12 L7 -4 L6 -1 M-4 5 L5 5","-10 11 M2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 4 L-6 7 L-5 8 L-3 9 L-1 9 L2 8 L4 6 L6 3 L7 0 L8 -4 L8 -7 L7 -10 L6 -11 L4 -12 L2 -12 M-1 -10 L-3 -8 L-4 -6 L-5 -3 L-6 1 L-6 5 L-5 7 M2 7 L4 5 L5 3 L6 0 L7 -4 L7 -8 L6 -10 M2 -12 L0 -11 L-2 -8 L-3 -6 L-4 -3 L-5 1 L-5 6 L-4 8 L-3 9 M-1 9 L1 8 L3 5 L4 3 L5 0 L6 -4 L6 -9 L5 -11 L4 -12","-10 11 M2 -8 L-3 9 L-1 9 M5 -12 L3 -8 L-2 9 M5 -12 L-1 9 M5 -12 L2 -9 L-1 -7 L-3 -6 M2 -8 L0 -7 L-3 -6","-10 11 M-3 -7 L-3 -8 L-2 -8 L-2 -6 L-4 -6 L-4 -8 L-3 -10 L-2 -11 L1 -12 L4 -12 L7 -11 L8 -9 L8 -7 L7 -5 L5 -3 L-5 3 L-7 5 L-9 9 M6 -11 L7 -9 L7 -7 L6 -5 L4 -3 L1 -1 M4 -12 L5 -11 L6 -9 L6 -7 L5 -5 L3 -3 L-5 3 M-8 7 L-7 6 L-5 6 L0 7 L5 7 L6 6 M-5 6 L0 8 L5 8 M-5 6 L0 9 L3 9 L5 8 L6 6 L6 5","-10 11 M-3 -7 L-3 -8 L-2 -8 L-2 -6 L-4 -6 L-4 -8 L-3 -10 L-2 -11 L1 -12 L4 -12 L7 -11 L8 -9 L8 -7 L7 -5 L6 -4 L4 -3 L1 -2 M6 -11 L7 -9 L7 -7 L6 -5 L5 -4 M4 -12 L5 -11 L6 -9 L6 -7 L5 -5 L3 -3 L1 -2 M-1 -2 L1 -2 L4 -1 L5 0 L6 2 L6 5 L5 7 L3 8 L0 9 L-3 9 L-6 8 L-7 7 L-8 5 L-8 3 L-6 3 L-6 5 L-7 5 L-7 4 M4 0 L5 2 L5 5 L4 7 M1 -2 L3 -1 L4 1 L4 5 L3 7 L2 8 L0 9","-10 11 M5 -8 L0 9 L2 9 M8 -12 L6 -8 L1 9 M8 -12 L2 9 M8 -12 L-8 3 L8 3","-10 11 M-1 -12 L-6 -2 M-1 -12 L9 -12 M-1 -11 L7 -11 M-2 -10 L3 -10 L7 -11 L9 -12 M-6 -2 L-5 -3 L-2 -4 L1 -4 L4 -3 L5 -2 L6 0 L6 3 L5 6 L3 8 L-1 9 L-4 9 L-6 8 L-7 7 L-8 5 L-8 3 L-6 3 L-6 5 L-7 5 L-7 4 M4 -2 L5 0 L5 3 L4 6 L2 8 M1 -4 L3 -3 L4 -1 L4 3 L3 6 L1 8 L-1 9","-10 11 M7 -8 L7 -9 L6 -9 L6 -7 L8 -7 L8 -9 L7 -11 L5 -12 L2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 4 L-6 7 L-5 8 L-3 9 L0 9 L3 8 L5 6 L6 4 L6 1 L5 -1 L4 -2 L2 -3 L-1 -3 L-3 -2 L-4 -1 L-5 1 M-2 -9 L-4 -6 L-5 -3 L-6 1 L-6 5 L-5 7 M4 6 L5 4 L5 1 L4 -1 M2 -12 L0 -11 L-2 -8 L-3 -6 L-4 -3 L-5 1 L-5 6 L-4 8 L-3 9 M0 9 L2 8 L3 7 L4 4 L4 0 L3 -2 L2 -3","-10 11 M-4 -12 L-6 -6 M9 -12 L8 -9 L6 -6 L2 -1 L0 2 L-1 5 L-2 9 M0 1 L-2 5 L-3 9 M6 -6 L0 0 L-2 3 L-3 5 L-4 9 L-2 9 M-5 -9 L-2 -12 L0 -12 L5 -9 M-3 -11 L0 -11 L5 -9 M-5 -9 L-3 -10 L0 -10 L5 -9 L7 -9 L8 -10 L9 -12","-10 11 M1 -12 L-2 -11 L-3 -10 L-4 -8 L-4 -5 L-3 -3 L-1 -2 L2 -2 L5 -3 L7 -4 L8 -6 L8 -9 L7 -11 L5 -12 L1 -12 M3 -12 L-2 -11 M-2 -10 L-3 -8 L-3 -4 L-2 -3 M-3 -3 L0 -2 M1 -2 L5 -3 M6 -4 L7 -6 L7 -9 L6 -11 M7 -11 L3 -12 M1 -12 L-1 -10 L-2 -8 L-2 -4 L-1 -2 M2 -2 L4 -3 L5 -4 L6 -6 L6 -10 L5 -12 M-1 -2 L-5 -1 L-7 1 L-8 3 L-8 6 L-7 8 L-4 9 L0 9 L4 8 L5 7 L6 5 L6 2 L5 0 L4 -1 L2 -2 M0 -2 L-5 -1 M-4 -1 L-6 1 L-7 3 L-7 6 L-6 8 M-7 8 L-2 9 L4 8 M4 7 L5 5 L5 2 L4 0 M4 -1 L1 -2 M-1 -2 L-3 -1 L-5 1 L-6 3 L-6 6 L-5 8 L-4 9 M0 9 L2 8 L3 7 L4 5 L4 1 L3 -1 L2 -2","-10 11 M6 -4 L5 -2 L4 -1 L2 0 L-1 0 L-3 -1 L-4 -2 L-5 -4 L-5 -7 L-4 -9 L-2 -11 L1 -12 L4 -12 L6 -11 L7 -10 L8 -7 L8 -4 L7 0 L6 3 L4 6 L2 8 L-1 9 L-4 9 L-6 8 L-7 6 L-7 4 L-5 4 L-5 6 L-6 6 L-6 5 M-3 -2 L-4 -4 L-4 -7 L-3 -9 M6 -10 L7 -8 L7 -4 L6 0 L5 3 L3 6 M-1 0 L-2 -1 L-3 -3 L-3 -7 L-2 -10 L-1 -11 L1 -12 M4 -12 L5 -11 L6 -9 L6 -4 L5 0 L4 3 L3 5 L1 8 L-1 9","-11 11 M-6 -12 L-6 9 M-5 -12 L-5 9 M-9 -12 L3 -12 L6 -11 L7 -10 L8 -8 L8 -5 L7 -3 L6 -2 L3 -1 L-5 -1 M3 -12 L5 -11 L6 -10 L7 -8 L7 -5 L6 -3 L5 -2 L3 -1 M-9 9 L7 9 L7 4 L6 9","-10 9 M7 -11 L3 -11 L-1 -10 L-4 -8 L-6 -5 L-7 -2 L-7 1 L-6 4 L-4 7 L-1 9 L3 10 L7 10 M7 -11 L4 -10 L1 -8 L-1 -5 L-2 -2 L-2 1 L-1 4 L1 7 L4 9 L7 10","-12 13 M-3 -1 L-5 -1 L-7 0 L-8 1 L-9 3 L-9 5 L-8 7 L-7 8 L-5 9 L-3 9 L-1 8 L0 7 L1 5 L1 3 L0 1 L-1 0 L-3 -1 M1 -10 L-2 -1 M8 -8 L0 0 M10 -1 L1 2","-10 10 M-3 -7 L3 7 M3 -7 L-3 7 M-7 -3 L7 3 M7 -3 L-7 3","-12 12 M-4 4 L-6 3 L-7 3 L-9 4 L-10 6 L-10 7 L-9 9 L-7 10 L-6 10 L-4 9 L-3 7 L-3 6 L-4 4 L-7 0 L-8 -3 L-8 -5 L-7 -8 L-5 -10 L-2 -11 L2 -11 L5 -10 L7 -8 L8 -5 L8 -3 L7 0 L4 4 L3 6 L3 7 L4 9 L6 10 L7 10 L9 9 L10 7 L10 6 L9 4 L7 3 L6 3 L4 4 M-8 -5 L-7 -7 L-5 -9 L-2 -10 L2 -10 L5 -9 L7 -7 L8 -5","-12 12 M-4 -5 L-6 -4 L-7 -4 L-9 -5 L-10 -7 L-10 -8 L-9 -10 L-7 -11 L-6 -11 L-4 -10 L-3 -8 L-3 -7 L-4 -5 L-7 -1 L-8 2 L-8 4 L-7 7 L-5 9 L-2 10 L2 10 L5 9 L7 7 L8 4 L8 2 L7 -1 L4 -5 L3 -7 L3 -8 L4 -10 L6 -11 L7 -11 L9 -10 L10 -8 L10 -7 L9 -5 L7 -4 L6 -4 L4 -5 M-8 4 L-7 6 L-5 8 L-2 9 L2 9 L5 8 L7 6 L8 4","-12 13 M-8 -5 L-9 -6 L-9 -8 L-8 -10 L-6 -11 L-4 -11 L-2 -10 L-1 -9 L0 -7 L1 -2 M-9 -8 L-7 -10 L-5 -10 L-3 -9 L-2 -8 L-1 -6 L0 -2 L0 9 M9 -5 L10 -6 L10 -8 L9 -10 L7 -11 L5 -11 L3 -10 L2 -9 L1 -7 L0 -2 M10 -8 L8 -10 L6 -10 L4 -9 L3 -8 L2 -6 L1 -2 L1 9","-10 10 M0 -12 L-7 8 M-1 -9 L5 9 M0 -9 L6 9 M0 -12 L7 9 M-5 3 L4 3 M-9 9 L-3 9 M2 9 L9 9 M-7 8 L-8 9 M-7 8 L-5 9 M5 8 L3 9 M5 7 L4 9 M6 7 L8 9","-11 11 M-6 -12 L-6 9 M-5 -11 L-5 8 M-4 -12 L-4 9 M-9 -12 L3 -12 L6 -11 L7 -10 L8 -8 L8 -6 L7 -4 L6 -3 L3 -2 M6 -10 L7 -8 L7 -6 L6 -4 M3 -12 L5 -11 L6 -9 L6 -5 L5 -3 L3 -2 M-4 -2 L3 -2 L6 -1 L7 0 L8 2 L8 5 L7 7 L6 8 L3 9 L-9 9 M6 0 L7 2 L7 5 L6 7 M3 -2 L5 -1 L6 1 L6 6 L5 8 L3 9 M-8 -12 L-6 -11 M-7 -12 L-6 -10 M-3 -12 L-4 -10 M-2 -12 L-4 -11 M-6 8 L-8 9 M-6 7 L-7 9 M-4 7 L-3 9 M-4 8 L-2 9","-11 10 M6 -9 L7 -12 L7 -6 L6 -9 L4 -11 L2 -12 L-1 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 L-1 9 L2 9 L4 8 L6 6 L7 4 M-5 -9 L-6 -7 L-7 -4 L-7 1 L-6 4 L-5 6 M-1 -12 L-3 -11 L-5 -8 L-6 -4 L-6 1 L-5 5 L-3 8 L-1 9","-11 11 M-6 -12 L-6 9 M-5 -11 L-5 8 M-4 -12 L-4 9 M-9 -12 L1 -12 L4 -11 L6 -9 L7 -7 L8 -4 L8 1 L7 4 L6 6 L4 8 L1 9 L-9 9 M5 -9 L6 -7 L7 -4 L7 1 L6 4 L5 6 M1 -12 L3 -11 L5 -8 L6 -4 L6 1 L5 5 L3 8 L1 9 M-8 -12 L-6 -11 M-7 -12 L-6 -10 M-3 -12 L-4 -10 M-2 -12 L-4 -11 M-6 8 L-8 9 M-6 7 L-7 9 M-4 7 L-3 9 M-4 8 L-2 9","-11 10 M-6 -12 L-6 9 M-5 -11 L-5 8 M-4 -12 L-4 9 M-9 -12 L7 -12 L7 -6 M-4 -2 L2 -2 M2 -6 L2 2 M-9 9 L7 9 L7 3 M-8 -12 L-6 -11 M-7 -12 L-6 -10 M-3 -12 L-4 -10 M-2 -12 L-4 -11 M2 -12 L7 -11 M4 -12 L7 -10 M5 -12 L7 -9 M6 -12 L7 -6 M2 -6 L1 -2 L2 2 M2 -4 L0 -2 L2 0 M2 -3 L-2 -2 L2 -1 M-6 8 L-8 9 M-6 7 L-7 9 M-4 7 L-3 9 M-4 8 L-2 9 M2 9 L7 8 M4 9 L7 7 M5 9 L7 6 M6 9 L7 3","-11 9 M-6 -12 L-6 9 M-5 -11 L-5 8 M-4 -12 L-4 9 M-9 -12 L7 -12 L7 -6 M-4 -2 L2 -2 M2 -6 L2 2 M-9 9 L-1 9 M-8 -12 L-6 -11 M-7 -12 L-6 -10 M-3 -12 L-4 -10 M-2 -12 L-4 -11 M2 -12 L7 -11 M4 -12 L7 -10 M5 -12 L7 -9 M6 -12 L7 -6 M2 -6 L1 -2 L2 2 M2 -4 L0 -2 L2 0 M2 -3 L-2 -2 L2 -1 M-6 8 L-8 9 M-6 7 L-7 9 M-4 7 L-3 9 M-4 8 L-2 9","-11 12 M6 -9 L7 -12 L7 -6 L6 -9 L4 -11 L2 -12 L-1 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 L-1 9 L2 9 L4 8 L6 8 L7 9 L7 1 M-5 -9 L-6 -7 L-7 -4 L-7 1 L-6 4 L-5 6 M-1 -12 L-3 -11 L-5 -8 L-6 -4 L-6 1 L-5 5 L-3 8 L-1 9 M6 2 L6 7 M5 1 L5 7 L4 8 M2 1 L10 1 M3 1 L5 2 M4 1 L5 3 M8 1 L7 3 M9 1 L7 2","-12 12 M-7 -12 L-7 9 M-6 -11 L-6 8 M-5 -12 L-5 9 M5 -12 L5 9 M6 -11 L6 8 M7 -12 L7 9 M-10 -12 L-2 -12 M2 -12 L10 -12 M-5 -2 L5 -2 M-10 9 L-2 9 M2 9 L10 9 M-9 -12 L-7 -11 M-8 -12 L-7 -10 M-4 -12 L-5 -10 M-3 -12 L-5 -11 M3 -12 L5 -11 M4 -12 L5 -10 M8 -12 L7 -10 M9 -12 L7 -11 M-7 8 L-9 9 M-7 7 L-8 9 M-5 7 L-4 9 M-5 8 L-3 9 M5 8 L3 9 M5 7 L4 9 M7 7 L8 9 M7 8 L9 9","-6 6 M-1 -12 L-1 9 M0 -11 L0 8 M1 -12 L1 9 M-4 -12 L4 -12 M-4 9 L4 9 M-3 -12 L-1 -11 M-2 -12 L-1 -10 M2 -12 L1 -10 M3 -12 L1 -11 M-1 8 L-3 9 M-1 7 L-2 9 M1 7 L2 9 M1 8 L3 9","-8 8 M1 -12 L1 5 L0 8 L-1 9 M2 -11 L2 5 L1 8 M3 -12 L3 5 L2 8 L-1 9 L-3 9 L-5 8 L-6 6 L-6 4 L-5 3 L-4 3 L-3 4 L-3 5 L-4 6 L-5 6 M-5 4 L-5 5 L-4 5 L-4 4 L-5 4 M-2 -12 L6 -12 M-1 -12 L1 -11 M0 -12 L1 -10 M4 -12 L3 -10 M5 -12 L3 -11","-12 10 M-7 -12 L-7 9 M-6 -11 L-6 8 M-5 -12 L-5 9 M6 -11 L-5 0 M-2 -2 L5 9 M-1 -2 L6 9 M-1 -4 L7 9 M-10 -12 L-2 -12 M3 -12 L9 -12 M-10 9 L-2 9 M2 9 L9 9 M-9 -12 L-7 -11 M-8 -12 L-7 -10 M-4 -12 L-5 -10 M-3 -12 L-5 -11 M5 -12 L6 -11 M8 -12 L6 -11 M-7 8 L-9 9 M-7 7 L-8 9 M-5 7 L-4 9 M-5 8 L-3 9 M5 7 L3 9 M5 7 L8 9","-9 9 M-4 -12 L-4 9 M-3 -11 L-3 8 M-2 -12 L-2 9 M-7 -12 L1 -12 M-7 9 L8 9 L8 3 M-6 -12 L-4 -11 M-5 -12 L-4 -10 M-1 -12 L-2 -10 M0 -12 L-2 -11 M-4 8 L-6 9 M-4 7 L-5 9 M-2 7 L-1 9 M-2 8 L0 9 M3 9 L8 8 M5 9 L8 7 M6 9 L8 6 M7 9 L8 3","-13 13 M-8 -12 L-8 8 M-8 -12 L-1 9 M-7 -12 L-1 6 M-6 -12 L0 6 M6 -12 L-1 9 M6 -12 L6 9 M7 -11 L7 8 M8 -12 L8 9 M-11 -12 L-6 -12 M6 -12 L11 -12 M-11 9 L-5 9 M3 9 L11 9 M-10 -12 L-8 -11 M9 -12 L8 -10 M10 -12 L8 -11 M-8 8 L-10 9 M-8 8 L-6 9 M6 8 L4 9 M6 7 L5 9 M8 7 L9 9 M8 8 L10 9","-12 12 M-7 -12 L-7 8 M-7 -12 L7 9 M-6 -12 L6 6 M-5 -12 L7 6 M7 -11 L7 9 M-10 -12 L-5 -12 M4 -12 L10 -12 M-10 9 L-4 9 M-9 -12 L-7 -11 M5 -12 L7 -11 M9 -12 L7 -11 M-7 8 L-9 9 M-7 8 L-5 9","-11 11 M-1 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -3 L-8 0 L-7 4 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 4 L8 0 L8 -3 L7 -7 L6 -9 L4 -11 L1 -12 L-1 -12 M-5 -9 L-6 -7 L-7 -4 L-7 1 L-6 4 L-5 6 M5 6 L6 4 L7 1 L7 -4 L6 -7 L5 -9 M-1 -12 L-3 -11 L-5 -8 L-6 -4 L-6 1 L-5 5 L-3 8 L-1 9 M1 9 L3 8 L5 5 L6 1 L6 -4 L5 -8 L3 -11 L1 -12","-11 11 M-6 -12 L-6 9 M-5 -11 L-5 8 M-4 -12 L-4 9 M-9 -12 L3 -12 L6 -11 L7 -10 L8 -8 L8 -5 L7 -3 L6 -2 L3 -1 L-4 -1 M6 -10 L7 -8 L7 -5 L6 -3 M3 -12 L5 -11 L6 -9 L6 -4 L5 -2 L3 -1 M-9 9 L-1 9 M-8 -12 L-6 -11 M-7 -12 L-6 -10 M-3 -12 L-4 -10 M-2 -12 L-4 -11 M-6 8 L-8 9 M-6 7 L-7 9 M-4 7 L-3 9 M-4 8 L-2 9","-11 11 M-1 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -3 L-8 0 L-7 4 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 4 L8 0 L8 -3 L7 -7 L6 -9 L4 -11 L1 -12 L-1 -12 M-5 -9 L-6 -7 L-7 -4 L-7 1 L-6 4 L-5 6 M5 6 L6 4 L7 1 L7 -4 L6 -7 L5 -9 M-1 -12 L-3 -11 L-5 -8 L-6 -4 L-6 1 L-5 5 L-3 8 L-1 9 M1 9 L3 8 L5 5 L6 1 L6 -4 L5 -8 L3 -11 L1 -12 M-4 6 L-3 4 L-1 3 L0 3 L2 4 L3 6 L4 12 L5 14 L7 14 L8 12 L8 10 M4 10 L5 12 L6 13 L7 13 M3 6 L5 11 L6 12 L7 12 L8 11","-11 11 M-6 -12 L-6 9 M-5 -11 L-5 8 M-4 -12 L-4 9 M-9 -12 L3 -12 L6 -11 L7 -10 L8 -8 L8 -6 L7 -4 L6 -3 L3 -2 L-4 -2 M6 -10 L7 -8 L7 -6 L6 -4 M3 -12 L5 -11 L6 -9 L6 -5 L5 -3 L3 -2 M0 -2 L2 -1 L3 1 L5 7 L6 9 L8 9 L9 7 L9 5 M5 5 L6 7 L7 8 L8 8 M2 -1 L3 0 L6 6 L7 7 L8 7 L9 6 M-9 9 L-1 9 M-8 -12 L-6 -11 M-7 -12 L-6 -10 M-3 -12 L-4 -10 M-2 -12 L-4 -11 M-6 8 L-8 9 M-6 7 L-7 9 M-4 7 L-3 9 M-4 8 L-2 9","-10 10 M6 -9 L7 -12 L7 -6 L6 -9 L4 -11 L1 -12 L-2 -12 L-5 -11 L-7 -9 L-7 -6 L-6 -4 L-3 -2 L3 0 L5 1 L6 3 L6 6 L5 8 M-6 -6 L-5 -4 L-3 -3 L3 -1 L5 0 L6 2 M-5 -11 L-6 -9 L-6 -7 L-5 -5 L-3 -4 L3 -2 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-1 9 L-4 8 L-6 6 L-7 3 L-7 9 L-6 6","-10 10 M-8 -12 L-8 -6 M-1 -12 L-1 9 M0 -11 L0 8 M1 -12 L1 9 M8 -12 L8 -6 M-8 -12 L8 -12 M-4 9 L4 9 M-7 -12 L-8 -6 M-6 -12 L-8 -9 M-5 -12 L-8 -10 M-3 -12 L-8 -11 M3 -12 L8 -11 M5 -12 L8 -10 M6 -12 L8 -9 M7 -12 L8 -6 M-1 8 L-3 9 M-1 7 L-2 9 M1 7 L2 9 M1 8 L3 9","-12 12 M-7 -12 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 3 L7 -11 M-6 -11 L-6 4 L-5 6 M-5 -12 L-5 4 L-4 7 L-3 8 L-1 9 M-10 -12 L-2 -12 M4 -12 L10 -12 M-9 -12 L-7 -11 M-8 -12 L-7 -10 M-4 -12 L-5 -10 M-3 -12 L-5 -11 M5 -12 L7 -11 M9 -12 L7 -11","-10 10 M-7 -12 L0 9 M-6 -12 L0 6 L0 9 M-5 -12 L1 6 M7 -11 L0 9 M-9 -12 L-2 -12 M3 -12 L9 -12 M-8 -12 L-6 -10 M-4 -12 L-5 -10 M-3 -12 L-5 -11 M5 -12 L7 -11 M8 -12 L7 -11","-12 12 M-8 -12 L-4 9 M-7 -12 L-4 4 L-4 9 M-6 -12 L-3 4 M0 -12 L-3 4 L-4 9 M0 -12 L4 9 M1 -12 L4 4 L4 9 M2 -12 L5 4 M8 -11 L5 4 L4 9 M-11 -12 L-3 -12 M0 -12 L2 -12 M5 -12 L11 -12 M-10 -12 L-7 -11 M-9 -12 L-7 -10 M-5 -12 L-6 -10 M-4 -12 L-6 -11 M6 -12 L8 -11 M10 -12 L8 -11","-10 10 M-7 -12 L5 9 M-6 -12 L6 9 M-5 -12 L7 9 M6 -11 L-6 8 M-9 -12 L-2 -12 M3 -12 L9 -12 M-9 9 L-3 9 M2 9 L9 9 M-8 -12 L-5 -10 M-4 -12 L-5 -10 M-3 -12 L-5 -11 M4 -12 L6 -11 M8 -12 L6 -11 M-6 8 L-8 9 M-6 8 L-4 9 M5 8 L3 9 M5 7 L4 9 M5 7 L8 9","-11 11 M-8 -12 L-1 -1 L-1 9 M-7 -12 L0 -1 L0 8 M-6 -12 L1 -1 L1 9 M7 -11 L1 -1 M-10 -12 L-3 -12 M4 -12 L10 -12 M-4 9 L4 9 M-9 -12 L-7 -11 M-4 -12 L-6 -11 M5 -12 L7 -11 M9 -12 L7 -11 M-1 8 L-3 9 M-1 7 L-2 9 M1 7 L2 9 M1 8 L3 9","-10 10 M7 -12 L-7 -12 L-7 -6 M5 -12 L-7 9 M6 -12 L-6 9 M7 -12 L-5 9 M-7 9 L7 9 L7 3 M-6 -12 L-7 -6 M-5 -12 L-7 -9 M-4 -12 L-7 -10 M-2 -12 L-7 -11 M2 9 L7 8 M4 9 L7 7 M5 9 L7 6 M6 9 L7 3","-12 12 M-9 -11 L-8 -7 L-7 -5 L-5 -3 L-2 -2 L2 -2 L5 -3 L7 -5 L8 -7 L9 -11 M-9 -11 L-8 -8 L-7 -6 L-5 -4 L-2 -3 L2 -3 L5 -4 L7 -6 L8 -8 L9 -11 M-2 -3 L-4 -2 L-5 -1 L-6 1 L-6 4 L-5 6 L-3 8 L-1 9 L1 9 L3 8 L5 6 L6 4 L6 1 L5 -1 L4 -2 L2 -3 M-2 -2 L-4 -1 L-5 1 L-5 4 L-4 7 M4 7 L5 4 L5 1 L4 -1 L2 -2","-7 7 M-7 -12 L7 12","-12 12 M-5 -8 L-5 4 M-4 -7 L-4 3 M4 -7 L4 3 M5 -8 L5 4 M-9 -11 L-7 -9 L-5 -8 L-2 -7 L2 -7 L5 -8 L7 -9 L9 -11 M-9 7 L-7 5 L-5 4 L-2 3 L2 3 L5 4 L7 5 L9 7","-12 12 M9 -9 L-6 -9 L-8 -8 L-9 -6 L-9 -4 L-8 -2 L-6 -1 L-4 -1 L-2 -2 L-1 -4 L-1 -6 L-2 -8 L9 -8 M-9 -5 L-8 -3 L-7 -2 L-5 -1 M-1 -5 L-2 -7 L-3 -8 L-5 -9 M-9 6 L6 6 L8 5 L9 3 L9 1 L8 -1 L6 -2 L4 -2 L2 -1 L1 1 L1 3 L2 5 L-9 5 M9 2 L8 0 L7 -1 L5 -2 M1 2 L2 4 L3 5 L5 6","-12 11 M-3 3 L-5 2 L-6 2 L-8 3 L-9 5 L-9 6 L-8 8 L-6 9 L-5 9 L-3 8 L-2 6 L-2 5 L-3 3 L-8 -2 L-9 -4 L-9 -7 L-8 -9 L-6 -10 L-3 -11 L1 -11 L5 -10 L7 -8 L8 -6 L8 -3 L7 0 L4 3 L3 5 L3 7 L4 9 L6 9 L7 8 L8 6 M-5 1 L-7 -2 L-8 -4 L-8 -7 L-7 -9 L-6 -10 M1 -11 L4 -10 L6 -8 L7 -6 L7 -3 L6 0 L4 3","-11 13 M-10 -7 L-7 -10 L-5 -7 L-5 4 M-8 -9 L-6 -6 L-6 4 M-5 -7 L-2 -10 L0 -7 L0 3 M-3 -9 L-1 -6 L-1 3 M0 -7 L3 -10 L5 -7 L5 9 M2 -9 L4 -6 L4 9 M5 -7 L8 -10 L9 -8 L10 -5 L10 -2 L9 1 L8 3 L6 5 L3 7 L-2 9 M7 -9 L8 -8 L9 -5 L9 -2 L8 1 L7 3 L5 5 L2 7 L-2 9","-11 11 M5 -5 L3 2 L3 6 L4 8 L5 9 L7 9 L9 7 L10 5 M6 -5 L4 2 L4 8 M5 -5 L7 -5 L5 2 L4 6 M3 2 L3 -1 L2 -4 L0 -5 L-2 -5 L-5 -4 L-7 -1 L-8 2 L-8 4 L-7 7 L-6 8 L-4 9 L-2 9 L0 8 L1 7 L2 5 L3 2 M-4 -4 L-6 -1 L-7 2 L-7 5 L-6 7 M-2 -5 L-4 -3 L-5 -1 L-6 2 L-6 5 L-5 8 L-4 9","-9 10 M-2 -12 L-4 -5 L-5 1 L-5 5 L-4 7 L-3 8 L-1 9 L1 9 L4 8 L6 5 L7 2 L7 0 L6 -3 L5 -4 L3 -5 L1 -5 L-1 -4 L-2 -3 L-3 -1 L-4 2 M-1 -12 L-3 -5 L-4 -1 L-4 5 L-3 8 M4 7 L5 5 L6 2 L6 -1 L5 -3 M-5 -12 L0 -12 L-2 -5 L-4 2 M1 9 L3 7 L4 5 L5 2 L5 -1 L4 -4 L3 -5 M-4 -12 L-1 -11 M-3 -12 L-2 -10","-9 9 M5 -1 L5 -2 L4 -2 L4 0 L6 0 L6 -2 L5 -4 L3 -5 L0 -5 L-3 -4 L-5 -1 L-6 2 L-6 4 L-5 7 L-4 8 L-2 9 L0 9 L3 8 L5 5 M-3 -3 L-4 -1 L-5 2 L-5 5 L-4 7 M0 -5 L-2 -3 L-3 -1 L-4 2 L-4 5 L-3 8 L-2 9","-11 11 M7 -12 L4 -1 L3 3 L3 6 L4 8 L5 9 L7 9 L9 7 L10 5 M8 -12 L5 -1 L4 3 L4 8 M4 -12 L9 -12 L5 2 L4 6 M3 2 L3 -1 L2 -4 L0 -5 L-2 -5 L-5 -4 L-7 -1 L-8 2 L-8 4 L-7 7 L-6 8 L-4 9 L-2 9 L0 8 L1 7 L2 5 L3 2 M-5 -3 L-6 -1 L-7 2 L-7 5 L-6 7 M-2 -5 L-4 -3 L-5 -1 L-6 2 L-6 5 L-5 8 L-4 9 M5 -12 L8 -11 M6 -12 L7 -10","-9 9 M-5 4 L-1 3 L2 2 L5 0 L6 -2 L5 -4 L3 -5 L0 -5 L-3 -4 L-5 -1 L-6 2 L-6 4 L-5 7 L-4 8 L-2 9 L0 9 L3 8 L5 6 M-3 -3 L-4 -1 L-5 2 L-5 5 L-4 7 M0 -5 L-2 -3 L-3 -1 L-4 2 L-4 5 L-3 8 L-2 9","-8 8 M8 -10 L8 -11 L7 -11 L7 -9 L9 -9 L9 -11 L8 -12 L6 -12 L4 -11 L2 -9 L1 -7 L0 -4 L-1 0 L-3 9 L-4 12 L-5 14 L-7 16 M2 -8 L1 -5 L0 0 L-2 9 L-3 12 M6 -12 L4 -10 L3 -8 L2 -5 L1 0 L-1 8 L-2 11 L-3 13 L-5 15 L-7 16 L-9 16 L-10 15 L-10 13 L-8 13 L-8 15 L-9 15 L-9 14 M-4 -5 L7 -5","-10 11 M6 -5 L2 9 L1 12 L-1 15 L-3 16 M7 -5 L3 9 L1 13 M6 -5 L8 -5 L4 9 L2 13 L0 15 L-3 16 L-6 16 L-8 15 L-9 14 L-9 12 L-7 12 L-7 14 L-8 14 L-8 13 M4 2 L4 -1 L3 -4 L1 -5 L-1 -5 L-4 -4 L-6 -1 L-7 2 L-7 4 L-6 7 L-5 8 L-3 9 L-1 9 L1 8 L2 7 L3 5 L4 2 M-4 -3 L-5 -1 L-6 2 L-6 5 L-5 7 M-1 -5 L-3 -3 L-4 -1 L-5 2 L-5 5 L-4 8 L-3 9","-11 11 M-3 -12 L-9 9 L-7 9 M-2 -12 L-8 9 M-6 -12 L-1 -12 L-7 9 M-5 2 L-3 -2 L-1 -4 L1 -5 L3 -5 L5 -4 L6 -2 L6 1 L4 6 M5 -4 L5 0 L4 4 L4 8 M5 -2 L3 3 L3 6 L4 8 L5 9 L7 9 L9 7 L10 5 M-5 -12 L-2 -11 M-4 -12 L-3 -10","-7 6 M1 -12 L1 -10 L3 -10 L3 -12 L1 -12 M2 -12 L2 -10 M1 -11 L3 -11 M-6 -1 L-5 -3 L-3 -5 L-1 -5 L0 -4 L1 -2 L1 1 L-1 6 M0 -4 L0 0 L-1 4 L-1 8 M0 -2 L-2 3 L-2 6 L-1 8 L0 9 L2 9 L4 7 L5 5","-7 6 M3 -12 L3 -10 L5 -10 L5 -12 L3 -12 M4 -12 L4 -10 M3 -11 L5 -11 M-5 -1 L-4 -3 L-2 -5 L0 -5 L1 -4 L2 -2 L2 1 L0 8 L-1 11 L-2 13 L-4 15 L-6 16 L-8 16 L-9 15 L-9 13 L-7 13 L-7 15 L-8 15 L-8 14 M1 -4 L1 1 L-1 8 L-2 11 L-3 13 M1 -2 L0 2 L-2 9 L-3 12 L-4 14 L-6 16","-11 11 M-3 -12 L-9 9 L-7 9 M-2 -12 L-8 9 M-6 -12 L-1 -12 L-7 9 M7 -3 L7 -4 L6 -4 L6 -2 L8 -2 L8 -4 L7 -5 L5 -5 L3 -4 L-1 0 L-3 1 M-5 1 L-3 1 L-1 2 L0 3 L2 7 L3 8 L5 8 M-1 3 L1 7 L2 8 M-3 1 L-2 2 L0 8 L1 9 L3 9 L5 8 L7 5 M-5 -12 L-2 -11 M-4 -12 L-3 -10","-6 6 M2 -12 L-1 -1 L-2 3 L-2 6 L-1 8 L0 9 L2 9 L4 7 L5 5 M3 -12 L0 -1 L-1 3 L-1 8 M-1 -12 L4 -12 L0 2 L-1 6 M0 -12 L3 -11 M1 -12 L2 -10","-18 17 M-17 -1 L-16 -3 L-14 -5 L-12 -5 L-11 -4 L-10 -2 L-10 1 L-12 9 M-11 -4 L-11 1 L-13 9 M-11 -2 L-12 2 L-14 9 L-12 9 M-10 1 L-8 -2 L-6 -4 L-4 -5 L-2 -5 L0 -4 L1 -2 L1 1 L-1 9 M0 -4 L0 1 L-2 9 M0 -2 L-1 2 L-3 9 L-1 9 M1 1 L3 -2 L5 -4 L7 -5 L9 -5 L11 -4 L12 -2 L12 1 L10 6 M11 -4 L11 0 L10 4 L10 8 M11 -2 L9 3 L9 6 L10 8 L11 9 L13 9 L15 7 L16 5","-12 12 M-11 -1 L-10 -3 L-8 -5 L-6 -5 L-5 -4 L-4 -2 L-4 1 L-6 9 M-5 -4 L-5 1 L-7 9 M-5 -2 L-6 2 L-8 9 L-6 9 M-4 1 L-2 -2 L0 -4 L2 -5 L4 -5 L6 -4 L7 -2 L7 1 L5 6 M6 -4 L6 0 L5 4 L5 8 M6 -2 L4 3 L4 6 L5 8 L6 9 L8 9 L10 7 L11 5","-10 10 M-1 -5 L-4 -4 L-6 -1 L-7 2 L-7 4 L-6 7 L-5 8 L-2 9 L1 9 L4 8 L6 5 L7 2 L7 0 L6 -3 L5 -4 L2 -5 L-1 -5 M-4 -3 L-5 -1 L-6 2 L-6 5 L-5 7 M4 7 L5 5 L6 2 L6 -1 L5 -3 M-1 -5 L-3 -3 L-4 -1 L-5 2 L-5 5 L-4 8 L-2 9 M1 9 L3 7 L4 5 L5 2 L5 -1 L4 -4 L2 -5","-11 11 M-10 -1 L-9 -3 L-7 -5 L-5 -5 L-4 -4 L-3 -2 L-3 1 L-4 5 L-7 16 M-4 -4 L-4 1 L-5 5 L-8 16 M-4 -2 L-5 2 L-9 16 M-3 2 L-2 -1 L-1 -3 L0 -4 L2 -5 L4 -5 L6 -4 L7 -3 L8 0 L8 2 L7 5 L5 8 L2 9 L0 9 L-2 8 L-3 5 L-3 2 M6 -3 L7 -1 L7 2 L6 5 L5 7 M4 -5 L5 -4 L6 -1 L6 2 L5 5 L4 7 L2 9 M-12 16 L-4 16 M-8 15 L-11 16 M-8 14 L-10 16 M-7 14 L-6 16 M-8 15 L-5 16","-11 10 M5 -5 L-1 16 M6 -5 L0 16 M5 -5 L7 -5 L1 16 M3 2 L3 -1 L2 -4 L0 -5 L-2 -5 L-5 -4 L-7 -1 L-8 2 L-8 4 L-7 7 L-6 8 L-4 9 L-2 9 L0 8 L1 7 L2 5 L3 2 M-5 -3 L-6 -1 L-7 2 L-7 5 L-6 7 M-2 -5 L-4 -3 L-5 -1 L-6 2 L-6 5 L-5 8 L-4 9 M-4 16 L4 16 M0 15 L-3 16 M0 14 L-2 16 M1 14 L2 16 M0 15 L3 16","-9 9 M-8 -1 L-7 -3 L-5 -5 L-3 -5 L-2 -4 L-1 -2 L-1 2 L-3 9 M-2 -4 L-2 2 L-4 9 M-2 -2 L-3 2 L-5 9 L-3 9 M7 -3 L7 -4 L6 -4 L6 -2 L8 -2 L8 -4 L7 -5 L5 -5 L3 -4 L1 -2 L-1 2","-8 9 M6 -2 L6 -3 L5 -3 L5 -1 L7 -1 L7 -3 L6 -4 L3 -5 L0 -5 L-3 -4 L-4 -3 L-4 -1 L-3 1 L-1 2 L2 3 L4 4 L5 6 M-3 -4 L-4 -1 M-3 0 L-1 1 L2 2 L4 3 M5 4 L4 8 M-4 -3 L-3 -1 L-1 0 L2 1 L4 2 L5 4 L5 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-6 5 L-4 5 L-4 7 L-5 7 L-5 6","-7 7 M2 -12 L-1 -1 L-2 3 L-2 6 L-1 8 L0 9 L2 9 L4 7 L5 5 M3 -12 L0 -1 L-1 3 L-1 8 M2 -12 L4 -12 L0 2 L-1 6 M-4 -5 L6 -5","-12 12 M-11 -1 L-10 -3 L-8 -5 L-6 -5 L-5 -4 L-4 -2 L-4 1 L-6 6 M-5 -4 L-5 0 L-6 4 L-6 8 M-5 -2 L-7 3 L-7 6 L-6 8 L-4 9 L-2 9 L0 8 L2 6 L4 3 M6 -5 L4 3 L4 6 L5 8 L6 9 L8 9 L10 7 L11 5 M7 -5 L5 3 L5 8 M6 -5 L8 -5 L6 2 L5 6","-10 10 M-9 -1 L-8 -3 L-6 -5 L-4 -5 L-3 -4 L-2 -2 L-2 1 L-4 6 M-3 -4 L-3 0 L-4 4 L-4 8 M-3 -2 L-5 3 L-5 6 L-4 8 L-2 9 L0 9 L2 8 L4 6 L6 3 L7 -1 L7 -5 L6 -5 L6 -4 L7 -2","-15 15 M-14 -1 L-13 -3 L-11 -5 L-9 -5 L-8 -4 L-7 -2 L-7 1 L-9 6 M-8 -4 L-8 0 L-9 4 L-9 8 M-8 -2 L-10 3 L-10 6 L-9 8 L-7 9 L-5 9 L-3 8 L-1 6 L0 3 M2 -5 L0 3 L0 6 L1 8 L3 9 L5 9 L7 8 L9 6 L11 3 L12 -1 L12 -5 L11 -5 L11 -4 L12 -2 M3 -5 L1 3 L1 8 M2 -5 L4 -5 L2 2 L1 6","-11 11 M-8 -1 L-6 -4 L-4 -5 L-2 -5 L0 -4 L1 -2 L1 0 M-2 -5 L-1 -4 L-1 0 L-2 4 L-3 6 L-5 8 L-7 9 L-9 9 L-10 8 L-10 6 L-8 6 L-8 8 L-9 8 L-9 7 M0 -3 L0 0 L-1 4 L-1 7 M8 -3 L8 -4 L7 -4 L7 -2 L9 -2 L9 -4 L8 -5 L6 -5 L4 -4 L2 -2 L1 0 L0 4 L0 8 L1 9 M-2 4 L-2 6 L-1 8 L1 9 L3 9 L5 8 L7 5","-11 11 M-10 -1 L-9 -3 L-7 -5 L-5 -5 L-4 -4 L-3 -2 L-3 1 L-5 6 M-4 -4 L-4 0 L-5 4 L-5 8 M-4 -2 L-6 3 L-6 6 L-5 8 L-3 9 L-1 9 L1 8 L3 6 L5 2 M7 -5 L3 9 L2 12 L0 15 L-2 16 M8 -5 L4 9 L2 13 M7 -5 L9 -5 L5 9 L3 13 L1 15 L-2 16 L-5 16 L-7 15 L-8 14 L-8 12 L-6 12 L-6 14 L-7 14 L-7 13","-10 10 M7 -5 L6 -3 L4 -1 L-4 5 L-6 7 L-7 9 M6 -3 L-3 -3 L-5 -2 L-6 0 M4 -3 L0 -4 L-3 -4 L-4 -3 M4 -3 L0 -5 L-3 -5 L-5 -3 L-6 0 M-6 7 L3 7 L5 6 L6 4 M-4 7 L0 8 L3 8 L4 7 M-4 7 L0 9 L3 9 L5 7 L6 4","-12 13 M-11 -6 L-8 -9 L-5 -6 L-5 6 M-9 -8 L-6 -5 L-6 6 M-5 -6 L-2 -9 L1 -6 L1 6 M-3 -8 L0 -5 L0 6 M1 -6 L4 -9 L7 -6 L7 5 L9 7 M3 -8 L6 -5 L6 6 L8 8 L11 5","-11 11 M8 -9 L-8 7 M8 -9 L5 -8 L-1 -8 M6 -7 L3 -7 L-1 -8 M8 -9 L7 -6 L7 0 M6 -7 L6 -4 L7 0 M-1 0 L-8 0 M-2 1 L-5 1 L-8 0 M-1 0 L-1 7 M-2 1 L-2 4 L-1 7","-12 12 M-10 -3 L-8 -7 L-3 3 M-8 -5 L-3 5 L0 -2 L5 -2 L8 -3 L9 -5 L9 -7 L8 -9 L6 -10 L5 -10 L3 -9 L2 -7 L2 -5 L3 -2 L4 0 L5 3 L5 6 L3 8 M5 -10 L4 -9 L3 -7 L3 -5 L5 -1 L6 2 L6 5 L5 7 L3 8","-12 12 M-9 -3 L-6 -6 L-2 -4 M-7 -5 L-3 -3 L0 -6 L3 -4 M-1 -5 L2 -3 L5 -6 L7 -4 M4 -5 L6 -3 L9 -6 M-9 3 L-6 0 L-2 2 M-7 1 L-3 3 L0 0 L3 2 M-1 1 L2 3 L5 0 L7 2 M4 1 L6 3 L9 0","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3"],
    :cursive => ["-8 8","-5 5 M0 -12 L0 2 M0 7 L-1 8 L0 9 L1 8 L0 7","-8 8 M-4 -12 L-4 -5 M4 -12 L4 -5","-10 11 M1 -16 L-6 16 M7 -16 L0 16 M-6 -3 L8 -3 M-7 3 L7 3","-10 10 M-2 -16 L-2 13 M2 -16 L2 13 M7 -9 L5 -11 L2 -12 L-2 -12 L-5 -11 L-7 -9 L-7 -7 L-6 -5 L-5 -4 L-3 -3 L3 -1 L5 0 L6 1 L7 3 L7 6 L5 8 L2 9 L-2 9 L-5 8 L-7 6","-12 12 M9 -12 L-9 9 M-4 -12 L-2 -10 L-2 -8 L-3 -6 L-5 -5 L-7 -5 L-9 -7 L-9 -9 L-8 -11 L-6 -12 L-4 -12 L-2 -11 L1 -10 L4 -10 L7 -11 L9 -12 M5 2 L3 3 L2 5 L2 7 L4 9 L6 9 L8 8 L9 6 L9 4 L7 2 L5 2","-13 13 M10 -3 L10 -4 L9 -5 L8 -5 L7 -4 L6 -2 L4 3 L2 6 L0 8 L-2 9 L-6 9 L-8 8 L-9 7 L-10 5 L-10 3 L-9 1 L-8 0 L-1 -4 L0 -5 L1 -7 L1 -9 L0 -11 L-2 -12 L-4 -11 L-5 -9 L-5 -7 L-4 -4 L-2 -1 L3 6 L5 8 L7 9 L9 9 L10 8 L10 7","-2 2 M0 -5 L0 -1","-7 7 M4 -16 L2 -14 L0 -11 L-2 -7 L-3 -2 L-3 2 L-2 7 L0 11 L2 14 L4 16","-7 7 M-4 -16 L-2 -14 L0 -11 L2 -7 L3 -2 L3 2 L2 7 L0 11 L-2 14 L-4 16","-8 8 M0 -6 L0 6 M-5 -3 L5 3 M5 -3 L-5 3","-13 13 M0 -9 L0 9 M-9 0 L9 0","-4 4 M1 5 L0 6 L-1 5 L0 4 L1 5 L1 7 L-1 9","-13 13 M-9 0 L9 0","-4 4 M0 4 L-1 5 L0 6 L1 5 L0 4","-11 11 M9 -16 L-9 16","-10 10 M-1 -12 L-4 -11 L-6 -8 L-7 -3 L-7 0 L-6 5 L-4 8 L-1 9 L1 9 L4 8 L6 5 L7 0 L7 -3 L6 -8 L4 -11 L1 -12 L-1 -12","-10 10 M-4 -8 L-2 -9 L1 -12 L1 9","-10 10 M-6 -7 L-6 -8 L-5 -10 L-4 -11 L-2 -12 L2 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L3 -1 L-7 9 L7 9","-10 10 M-5 -12 L6 -12 L0 -4 L3 -4 L5 -3 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5","-10 10 M3 -12 L-7 2 L8 2 M3 -12 L3 9","-10 10 M5 -12 L-5 -12 L-6 -3 L-5 -4 L-2 -5 L1 -5 L4 -4 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5","-10 10 M6 -9 L5 -11 L2 -12 L0 -12 L-3 -11 L-5 -8 L-6 -3 L-6 2 L-5 6 L-3 8 L0 9 L1 9 L4 8 L6 6 L7 3 L7 2 L6 -1 L4 -3 L1 -4 L0 -4 L-3 -3 L-5 -1 L-6 2","-10 10 M7 -12 L-3 9 M-7 -12 L7 -12","-10 10 M-2 -12 L-5 -11 L-6 -9 L-6 -7 L-5 -5 L-3 -4 L1 -3 L4 -2 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 2 L-6 0 L-4 -2 L-1 -3 L3 -4 L5 -5 L6 -7 L6 -9 L5 -11 L2 -12 L-2 -12","-10 10 M6 -5 L5 -2 L3 0 L0 1 L-1 1 L-4 0 L-6 -2 L-7 -5 L-7 -6 L-6 -9 L-4 -11 L-1 -12 L0 -12 L3 -11 L5 -9 L6 -5 L6 0 L5 5 L3 8 L0 9 L-2 9 L-5 8 L-6 6","-4 4 M0 -3 L-1 -2 L0 -1 L1 -2 L0 -3 M0 4 L-1 5 L0 6 L1 5 L0 4","-4 4 M0 -3 L-1 -2 L0 -1 L1 -2 L0 -3 M1 5 L0 6 L-1 5 L0 4 L1 5 L1 7 L-1 9","-12 12 M8 -9 L-8 0 L8 9","-13 13 M-9 -3 L9 -3 M-9 3 L9 3","-12 12 M-8 -9 L8 0 L-8 9","-9 9 M-6 -7 L-6 -8 L-5 -10 L-4 -11 L-2 -12 L2 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L4 -3 L0 -1 L0 2 M0 7 L-1 8 L0 9 L1 8 L0 7","-13 14 M5 -4 L4 -6 L2 -7 L-1 -7 L-3 -6 L-4 -5 L-5 -2 L-5 1 L-4 3 L-2 4 L1 4 L3 3 L4 1 M-1 -7 L-3 -5 L-4 -2 L-4 1 L-3 3 L-2 4 M5 -7 L4 1 L4 3 L6 4 L8 4 L10 2 L11 -1 L11 -3 L10 -6 L9 -8 L7 -10 L5 -11 L2 -12 L-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L2 9 L5 8 L7 7 L8 6 M6 -7 L5 1 L5 3 L6 4","-11 9 M-11 9 L-9 8 L-6 5 L-3 1 L1 -6 L4 -12 L4 9 L3 6 L1 3 L-1 1 L-4 -1 L-6 -1 L-7 0 L-7 2 L-6 4 L-4 6 L-1 8 L2 9 L7 9","-12 11 M1 -10 L2 -9 L2 -6 L1 -2 L0 1 L-1 3 L-3 6 L-5 8 L-7 9 L-8 9 L-9 8 L-9 5 L-8 0 L-7 -3 L-6 -5 L-4 -8 L-2 -10 L0 -11 L3 -12 L6 -12 L8 -11 L9 -9 L9 -7 L8 -5 L7 -4 L5 -3 L2 -2 M1 -2 L2 -2 L5 -1 L6 0 L7 2 L7 5 L6 7 L5 8 L3 9 L0 9 L-2 8 L-3 6","-10 10 M2 -6 L2 -5 L3 -4 L5 -4 L7 -5 L8 -7 L8 -9 L7 -11 L5 -12 L2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -4 L-7 0 L-7 4 L-6 7 L-5 8 L-3 9 L-1 9 L2 8 L4 6 L5 4","-11 12 M2 -12 L0 -11 L-1 -9 L-2 -5 L-3 1 L-4 4 L-5 6 L-7 8 L-9 9 L-11 9 L-12 8 L-12 6 L-11 5 L-9 5 L-7 6 L-5 8 L-2 9 L1 9 L4 8 L6 6 L8 2 L9 -3 L9 -7 L8 -10 L7 -11 L5 -12 L2 -12 L0 -10 L0 -8 L1 -5 L3 -2 L5 0 L8 2 L10 3","-10 10 M4 -8 L4 -7 L5 -6 L7 -6 L8 -7 L8 -9 L7 -11 L4 -12 L0 -12 L-3 -11 L-4 -9 L-4 -6 L-3 -4 L-2 -3 L1 -2 L-2 -2 L-5 -1 L-6 0 L-7 2 L-7 5 L-6 7 L-5 8 L-2 9 L1 9 L4 8 L6 6 L7 4","-10 10 M0 -6 L-2 -6 L-4 -7 L-5 -9 L-4 -11 L-1 -12 L2 -12 L6 -11 L9 -11 L11 -12 M6 -11 L4 -4 L2 2 L0 6 L-2 8 L-4 9 L-6 9 L-8 8 L-9 6 L-9 4 L-8 3 L-6 3 L-4 4 M-1 -2 L8 -2","-11 12 M-11 9 L-9 8 L-5 4 L-2 -1 L-1 -4 L0 -8 L0 -11 L-1 -12 L-2 -12 L-3 -11 L-4 -9 L-4 -6 L-3 -4 L-1 -3 L3 -3 L6 -4 L7 -5 L8 -7 L8 -1 L7 4 L6 6 L4 8 L1 9 L-3 9 L-6 8 L-8 6 L-9 4 L-9 2","-12 12 M-5 -5 L-7 -6 L-8 -8 L-8 -9 L-7 -11 L-5 -12 L-4 -12 L-2 -11 L-1 -9 L-1 -7 L-2 -3 L-4 3 L-6 7 L-8 9 L-10 9 L-11 8 L-11 6 M-5 0 L4 -3 L6 -4 L9 -6 L11 -8 L12 -10 L12 -11 L11 -12 L10 -12 L8 -10 L6 -6 L4 0 L3 5 L3 8 L4 9 L5 9 L7 8 L8 7 L10 4","-9 8 M5 4 L3 2 L1 -1 L0 -3 L-1 -6 L-1 -9 L0 -11 L1 -12 L3 -12 L4 -11 L5 -9 L5 -6 L4 -1 L2 4 L1 6 L-1 8 L-3 9 L-5 9 L-7 8 L-8 6 L-8 4 L-7 3 L-5 3 L-3 4","-8 7 M2 12 L0 9 L-2 4 L-3 -2 L-3 -8 L-2 -11 L0 -12 L2 -12 L3 -11 L4 -8 L4 -5 L3 0 L0 9 L-2 15 L-3 18 L-4 20 L-6 21 L-7 20 L-7 18 L-6 15 L-4 12 L-2 10 L1 8 L5 6","-12 12 M-5 -5 L-7 -6 L-8 -8 L-8 -9 L-7 -11 L-5 -12 L-4 -12 L-2 -11 L-1 -9 L-1 -7 L-2 -3 L-4 3 L-6 7 L-8 9 L-10 9 L-11 8 L-11 6 M12 -9 L12 -11 L11 -12 L10 -12 L8 -11 L6 -9 L4 -6 L2 -4 L0 -3 L-2 -3 M0 -3 L1 -1 L1 6 L2 8 L3 9 L4 9 L6 8 L7 7 L9 4","-9 10 M-5 0 L-3 0 L1 -1 L4 -3 L6 -5 L7 -7 L7 -10 L6 -12 L4 -12 L3 -11 L2 -9 L1 -4 L0 1 L-1 4 L-2 6 L-4 8 L-6 9 L-8 9 L-9 8 L-9 6 L-8 5 L-6 5 L-4 6 L-1 8 L2 9 L4 9 L7 8 L9 6","-18 15 M-13 -5 L-15 -6 L-16 -8 L-16 -9 L-15 -11 L-13 -12 L-12 -12 L-10 -11 L-9 -9 L-9 -7 L-10 -2 L-11 2 L-13 9 M-11 2 L-8 -6 L-6 -10 L-5 -11 L-3 -12 L-2 -12 L0 -11 L1 -9 L1 -7 L0 -2 L-1 2 L-3 9 M-1 2 L2 -6 L4 -10 L5 -11 L7 -12 L8 -12 L10 -11 L11 -9 L11 -7 L10 -2 L8 5 L8 8 L9 9 L10 9 L12 8 L13 7 L15 4","-13 11 M-8 -5 L-10 -6 L-11 -8 L-11 -9 L-10 -11 L-8 -12 L-7 -12 L-5 -11 L-4 -9 L-4 -7 L-5 -2 L-6 2 L-8 9 M-6 2 L-3 -6 L-1 -10 L0 -11 L2 -12 L4 -12 L6 -11 L7 -9 L7 -7 L6 -2 L4 5 L4 8 L5 9 L6 9 L8 8 L9 7 L11 4","-10 11 M2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -4 L-7 0 L-7 4 L-6 7 L-5 8 L-3 9 L-1 9 L2 8 L4 6 L6 3 L7 1 L8 -3 L8 -7 L7 -10 L6 -11 L4 -12 L2 -12 L0 -10 L0 -7 L1 -4 L3 -1 L5 1 L8 3 L10 4","-12 13 M1 -10 L2 -9 L2 -6 L1 -2 L0 1 L-1 3 L-3 6 L-5 8 L-7 9 L-8 9 L-9 8 L-9 5 L-8 0 L-7 -3 L-6 -5 L-4 -8 L-2 -10 L0 -11 L3 -12 L8 -12 L10 -11 L11 -10 L12 -8 L12 -5 L11 -3 L10 -2 L8 -1 L5 -1 L3 -2 L2 -3","-10 12 M3 -6 L2 -4 L1 -3 L-1 -2 L-3 -2 L-4 -4 L-4 -6 L-3 -9 L-1 -11 L2 -12 L5 -12 L7 -11 L8 -9 L8 -5 L7 -2 L5 1 L1 5 L-2 7 L-4 8 L-7 9 L-9 9 L-10 8 L-10 6 L-9 5 L-7 5 L-5 6 L-2 8 L1 9 L4 9 L7 8 L9 6","-12 13 M1 -10 L2 -9 L2 -6 L1 -2 L0 1 L-1 3 L-3 6 L-5 8 L-7 9 L-8 9 L-9 8 L-9 5 L-8 0 L-7 -3 L-6 -5 L-4 -8 L-2 -10 L0 -11 L3 -12 L7 -12 L9 -11 L10 -10 L11 -8 L11 -5 L10 -3 L9 -2 L7 -1 L4 -1 L1 -2 L2 -1 L3 1 L3 6 L4 8 L6 9 L8 8 L9 7 L11 4","-10 10 M-10 9 L-8 8 L-6 6 L-3 2 L-1 -1 L1 -5 L2 -8 L2 -11 L1 -12 L0 -12 L-1 -11 L-2 -9 L-2 -7 L-1 -5 L1 -3 L4 -1 L6 1 L7 3 L7 5 L6 7 L5 8 L2 9 L-2 9 L-5 8 L-7 6 L-8 4 L-8 2","-10 9 M0 -6 L-2 -6 L-4 -7 L-5 -9 L-4 -11 L-1 -12 L2 -12 L6 -11 L9 -11 L11 -12 M6 -11 L4 -4 L2 2 L0 6 L-2 8 L-4 9 L-6 9 L-8 8 L-9 6 L-9 4 L-8 3 L-6 3 L-4 4","-13 11 M-8 -5 L-10 -6 L-11 -8 L-11 -9 L-10 -11 L-8 -12 L-7 -12 L-5 -11 L-4 -9 L-4 -7 L-5 -3 L-6 0 L-7 4 L-7 6 L-6 8 L-4 9 L-2 9 L0 8 L1 7 L3 3 L6 -5 L8 -12 M6 -5 L5 -1 L4 5 L4 8 L5 9 L6 9 L8 8 L9 7 L11 4","-12 11 M-7 -5 L-9 -6 L-10 -8 L-10 -9 L-9 -11 L-7 -12 L-6 -12 L-4 -11 L-3 -9 L-3 -7 L-4 -3 L-5 0 L-6 4 L-6 7 L-5 9 L-3 9 L-1 8 L2 5 L4 2 L6 -2 L7 -5 L8 -9 L8 -11 L7 -12 L6 -12 L5 -11 L4 -9 L4 -7 L5 -4 L7 -2 L9 -1","-15 13 M-10 -5 L-12 -6 L-13 -8 L-13 -9 L-12 -11 L-10 -12 L-9 -12 L-7 -11 L-6 -9 L-6 -6 L-7 9 M3 -12 L-7 9 M3 -12 L1 9 M15 -12 L13 -11 L10 -8 L7 -4 L4 2 L1 9","-12 12 M-4 -6 L-6 -6 L-7 -7 L-7 -9 L-6 -11 L-4 -12 L-2 -12 L0 -11 L1 -9 L1 -6 L-1 3 L-1 6 L0 8 L2 9 L4 9 L6 8 L7 6 L7 4 L6 3 L4 3 M11 -9 L11 -11 L10 -12 L8 -12 L6 -11 L4 -9 L2 -6 L-2 3 L-4 6 L-6 8 L-8 9 L-10 9 L-11 8 L-11 6","-12 11 M-7 -5 L-9 -6 L-10 -8 L-10 -9 L-9 -11 L-7 -12 L-6 -12 L-4 -11 L-3 -9 L-3 -7 L-4 -3 L-5 0 L-6 4 L-6 6 L-5 8 L-4 9 L-2 9 L0 8 L2 6 L4 3 L5 1 L7 -5 M9 -12 L7 -5 L4 5 L2 11 L0 16 L-2 20 L-4 21 L-5 20 L-5 18 L-4 15 L-2 12 L1 9 L4 7 L9 4","-10 11 M3 -6 L2 -4 L1 -3 L-1 -2 L-3 -2 L-4 -4 L-4 -6 L-3 -9 L-1 -11 L2 -12 L5 -12 L7 -11 L8 -9 L8 -5 L7 -2 L5 2 L2 5 L-2 8 L-4 9 L-7 9 L-8 8 L-8 6 L-7 5 L-4 5 L-2 6 L-1 7 L0 9 L0 12 L-1 15 L-2 17 L-4 20 L-6 21 L-7 20 L-7 18 L-6 15 L-4 12 L-1 9 L2 7 L8 4","-7 7 M-3 -16 L-3 16 M-2 -16 L-2 16 M-3 -16 L4 -16 M-3 16 L4 16","-7 7 M-7 -12 L7 12","-7 7 M2 -16 L2 16 M3 -16 L3 16 M-4 -16 L3 -16 M-4 16 L3 16","-8 8 M0 -14 L-8 0 M0 -14 L8 0","-11 9 M-11 16 L9 16","-4 4 M1 -7 L-1 -5 L-1 -3 L0 -2 L1 -3 L0 -4 L-1 -3","-6 10 M3 3 L2 1 L0 0 L-2 0 L-4 1 L-5 2 L-6 4 L-6 6 L-5 8 L-3 9 L-1 9 L1 8 L2 6 L4 0 L3 5 L3 8 L4 9 L5 9 L7 8 L8 7 L10 4","-5 9 M-5 4 L-3 1 L0 -4 L1 -6 L2 -9 L2 -11 L1 -12 L-1 -11 L-2 -9 L-3 -5 L-4 2 L-4 8 L-3 9 L-2 9 L0 8 L2 6 L3 3 L3 0 L4 4 L5 5 L7 5 L9 4","-5 6 M2 2 L2 1 L1 0 L-1 0 L-3 1 L-4 2 L-5 4 L-5 6 L-4 8 L-2 9 L1 9 L4 7 L6 4","-6 10 M3 3 L2 1 L0 0 L-2 0 L-4 1 L-5 2 L-6 4 L-6 6 L-5 8 L-3 9 L-1 9 L1 8 L2 6 L8 -12 M4 0 L3 5 L3 8 L4 9 L5 9 L7 8 L8 7 L10 4","-4 6 M-3 7 L-1 6 L0 5 L1 3 L1 1 L0 0 L-1 0 L-3 1 L-4 3 L-4 6 L-3 8 L-1 9 L1 9 L3 8 L4 7 L6 4","-3 5 M-3 4 L1 -1 L3 -4 L4 -6 L5 -9 L5 -11 L4 -12 L2 -11 L1 -9 L-1 -1 L-4 8 L-7 15 L-8 18 L-8 20 L-7 21 L-5 20 L-4 17 L-3 8 L-2 9 L0 9 L2 8 L3 7 L5 4","-6 9 M3 3 L2 1 L0 0 L-2 0 L-4 1 L-5 2 L-6 4 L-6 6 L-5 8 L-3 9 L-1 9 L1 8 L2 7 M4 0 L2 7 L-2 18 L-3 20 L-5 21 L-6 20 L-6 18 L-5 15 L-2 12 L1 10 L3 9 L6 7 L9 4","-5 10 M-5 4 L-3 1 L0 -4 L1 -6 L2 -9 L2 -11 L1 -12 L-1 -11 L-2 -9 L-3 -5 L-4 1 L-5 9 M-5 9 L-4 6 L-3 4 L-1 1 L1 0 L3 0 L4 1 L4 3 L3 6 L3 8 L4 9 L5 9 L7 8 L8 7 L10 4","-2 5 M1 -5 L1 -4 L2 -4 L2 -5 L1 -5 M-2 4 L0 0 L-2 6 L-2 8 L-1 9 L0 9 L2 8 L3 7 L5 4","-2 5 M1 -5 L1 -4 L2 -4 L2 -5 L1 -5 M-2 4 L0 0 L-6 18 L-7 20 L-9 21 L-10 20 L-10 18 L-9 15 L-6 12 L-3 10 L-1 9 L2 7 L5 4","-5 9 M-5 4 L-3 1 L0 -4 L1 -6 L2 -9 L2 -11 L1 -12 L-1 -11 L-2 -9 L-3 -5 L-4 1 L-5 9 M-5 9 L-4 6 L-3 4 L-1 1 L1 0 L3 0 L4 1 L4 3 L2 4 L-1 4 M-1 4 L1 5 L2 8 L3 9 L4 9 L6 8 L7 7 L9 4","-3 5 M-3 4 L-1 1 L2 -4 L3 -6 L4 -9 L4 -11 L3 -12 L1 -11 L0 -9 L-1 -5 L-2 2 L-2 8 L-1 9 L0 9 L2 8 L3 7 L5 4","-13 12 M-13 4 L-11 1 L-9 0 L-8 1 L-8 2 L-9 6 L-10 9 M-9 6 L-8 4 L-6 1 L-4 0 L-2 0 L-1 1 L-1 2 L-2 6 L-3 9 M-2 6 L-1 4 L1 1 L3 0 L5 0 L6 1 L6 3 L5 6 L5 8 L6 9 L7 9 L9 8 L10 7 L12 4","-8 10 M-8 4 L-6 1 L-4 0 L-3 1 L-3 2 L-4 6 L-5 9 M-4 6 L-3 4 L-1 1 L1 0 L3 0 L4 1 L4 3 L3 6 L3 8 L4 9 L5 9 L7 8 L8 7 L10 4","-6 8 M0 0 L-2 0 L-4 1 L-5 2 L-6 4 L-6 6 L-5 8 L-3 9 L-1 9 L1 8 L2 7 L3 5 L3 3 L2 1 L0 0 L-1 1 L-1 3 L0 5 L2 6 L5 6 L7 5 L8 4","-7 8 M-7 4 L-5 1 L-4 -1 L-5 3 L-11 21 M-5 3 L-4 1 L-2 0 L0 0 L2 1 L3 3 L3 5 L2 7 L1 8 L-1 9 M-5 8 L-3 9 L0 9 L3 8 L5 7 L8 4","-6 9 M3 3 L2 1 L0 0 L-2 0 L-4 1 L-5 2 L-6 4 L-6 6 L-5 8 L-3 9 L-1 9 L1 8 M4 0 L3 3 L1 8 L-2 15 L-3 18 L-3 20 L-2 21 L0 20 L1 17 L1 10 L3 9 L6 7 L9 4","-5 8 M-5 4 L-3 1 L-2 -1 L-2 1 L1 1 L2 2 L2 4 L1 7 L1 8 L2 9 L3 9 L5 8 L6 7 L8 4","-4 7 M-4 4 L-2 1 L-1 -1 L-1 1 L1 4 L2 6 L2 8 L0 9 M-4 8 L-2 9 L2 9 L4 8 L5 7 L7 4","-3 6 M-3 4 L-1 1 L1 -3 M4 -12 L-2 6 L-2 8 L-1 9 L1 9 L3 8 L4 7 L6 4 M-2 -4 L5 -4","-6 9 M-6 4 L-4 0 L-6 6 L-6 8 L-5 9 L-3 9 L-1 8 L1 6 L3 3 M4 0 L2 6 L2 8 L3 9 L4 9 L6 8 L7 7 L9 4","-6 9 M-6 4 L-4 0 L-5 5 L-5 8 L-4 9 L-3 9 L0 8 L2 6 L3 3 L3 0 M3 0 L4 4 L5 5 L7 5 L9 4","-9 12 M-6 0 L-8 2 L-9 5 L-9 7 L-8 9 L-6 9 L-4 8 L-2 6 M0 0 L-2 6 L-2 8 L-1 9 L1 9 L3 8 L5 6 L6 3 L6 0 M6 0 L7 4 L8 5 L10 5 L12 4","-8 8 M-8 4 L-6 1 L-4 0 L-2 0 L-1 1 L-1 8 L0 9 L3 9 L6 7 L8 4 M5 1 L4 0 L2 0 L1 1 L-3 8 L-4 9 L-6 9 L-7 8","-6 9 M-6 4 L-4 0 L-6 6 L-6 8 L-5 9 L-3 9 L-1 8 L1 6 L3 3 M4 0 L-2 18 L-3 20 L-5 21 L-6 20 L-6 18 L-5 15 L-2 12 L1 10 L3 9 L6 7 L9 4","-6 8 M-6 4 L-4 1 L-2 0 L0 0 L2 2 L2 4 L1 6 L-1 8 L-4 9 L-2 10 L-1 12 L-1 15 L-2 18 L-3 20 L-5 21 L-6 20 L-6 18 L-5 15 L-2 12 L1 10 L5 7 L8 4","-7 7 M2 -16 L0 -15 L-1 -14 L-2 -12 L-2 -10 L-1 -8 L0 -7 L1 -5 L1 -3 L-1 -1 M0 -15 L-1 -13 L-1 -11 L0 -9 L1 -8 L2 -6 L2 -4 L1 -2 L-3 0 L1 2 L2 4 L2 6 L1 8 L0 9 L-1 11 L-1 13 L0 15 M-1 1 L1 3 L1 5 L0 7 L-1 8 L-2 10 L-2 12 L-1 14 L0 15 L2 16","-4 4 M0 -16 L0 16","-7 7 M-2 -16 L0 -15 L1 -14 L2 -12 L2 -10 L1 -8 L0 -7 L-1 -5 L-1 -3 L1 -1 M0 -15 L1 -13 L1 -11 L0 -9 L-1 -8 L-2 -6 L-2 -4 L-1 -2 L3 0 L-1 2 L-2 4 L-2 6 L-1 8 L0 9 L1 11 L1 13 L0 15 M1 1 L-1 3 L-1 5 L0 7 L1 8 L2 10 L2 12 L1 14 L0 15 L-2 16","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3","-8 8 M-8 -12 L-8 9 L-7 9 L-7 -12 L-6 -12 L-6 9 L-5 9 L-5 -12 L-4 -12 L-4 9 L-3 9 L-3 -12 L-2 -12 L-2 9 L-1 9 L-1 -12 L0 -12 L0 9 L1 9 L1 -12 L2 -12 L2 9 L3 9 L3 -12 L4 -12 L4 9 L5 9 L5 -12 L6 -12 L6 9 L7 9 L7 -12 L8 -12 L8 9"],
    :cyrillic => ["-8 8","-5 5 M0 -12 L-1 -10 L0 2 L1 -10 L0 -12 M0 -10 L0 -4 M0 7 L-1 8 L0 9 L1 8 L0 7","-8 8 M-4 -12 L-5 -5 M-3 -12 L-5 -5 M4 -12 L3 -5 M5 -12 L3 -5","-10 11 M1 -16 L-6 16 M7 -16 L0 16 M-6 -3 L8 -3 M-7 3 L7 3","-15 15 M-10 -12 L-10 9 M-9 -12 L-9 9 M-13 -12 L-6 -12 M-9 -2 L-2 -2 L1 -1 L2 0 L3 2 L3 5 L2 7 L1 8 L-2 9 L-13 9 M-2 -2 L0 -1 L1 0 L2 2 L2 5 L1 7 L0 8 L-2 9 M9 -12 L9 9 M10 -12 L10 9 M6 -12 L13 -12 M6 9 L13 9","-11 11 M-6 -5 L-6 9 M-5 -5 L-5 9 M5 -5 L5 9 M6 -5 L6 9 M-9 -5 L-2 -5 M2 -5 L9 -5 M-9 9 L9 9 L9 14 L8 9","-13 13 M-8 -5 L-8 9 M-7 -5 L-7 9 M-11 -5 L-4 -5 M-7 2 L-3 2 L0 3 L1 5 L1 6 L0 8 L-3 9 L-11 9 M-3 2 L-1 3 L0 5 L0 6 L-1 8 L-3 9 M7 -5 L7 9 M8 -5 L8 9 M4 -5 L11 -5 M4 9 L11 9","-4 4 M0 -12 L-1 -5 M1 -12 L-1 -5","-7 7 M3 -16 L1 -14 L-1 -11 L-3 -7 L-4 -2 L-4 2 L-3 7 L-1 11 L1 14 L3 16 L4 16 M3 -16 L4 -16 L2 -14 L0 -11 L-2 -7 L-3 -2 L-3 2 L-2 7 L0 11 L2 14 L4 16","-7 7 M-4 -16 L-2 -14 L0 -11 L2 -7 L3 -2 L3 2 L2 7 L0 11 L-2 14 L-4 16 L-3 16 M-4 -16 L-3 -16 L-1 -14 L1 -11 L3 -7 L4 -2 L4 2 L3 7 L1 11 L-1 14 L-3 16","-8 8 M0 -6 L0 6 M-5 -3 L5 3 M5 -3 L-5 3","-13 13 M0 -9 L0 9 M-9 0 L9 0","-4 4 M1 5 L0 6 L-1 5 L0 4 L1 5 L1 7 L-1 9","-13 13 M-9 0 L9 0","-4 4 M0 4 L-1 5 L0 6 L1 5 L0 4","-11 11 M9 -16 L-9 16","-10 10 M-1 -12 L-4 -11 L-6 -8 L-7 -3 L-7 0 L-6 5 L-4 8 L-1 9 L1 9 L4 8 L6 5 L7 0 L7 -3 L6 -8 L4 -11 L1 -12 L-1 -12 M-1 -12 L-3 -11 L-4 -10 L-5 -8 L-6 -3 L-6 0 L-5 5 L-4 7 L-3 8 L-1 9 M1 9 L3 8 L4 7 L5 5 L6 0 L6 -3 L5 -8 L4 -10 L3 -11 L1 -12","-10 10 M-4 -8 L-2 -9 L1 -12 L1 9 M0 -11 L0 9 M-4 9 L5 9","-10 10 M-6 -8 L-5 -7 L-6 -6 L-7 -7 L-7 -8 L-6 -10 L-5 -11 L-2 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -6 L6 -4 L3 -2 L-2 0 L-4 1 L-6 3 L-7 6 L-7 9 M2 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L2 -2 L-2 0 M-7 7 L-6 6 L-4 6 L1 8 L4 8 L6 7 L7 6 M-4 6 L1 9 L5 9 L6 8 L7 6 L7 4","-10 10 M-6 -8 L-5 -7 L-6 -6 L-7 -7 L-7 -8 L-6 -10 L-5 -11 L-2 -12 L2 -12 L5 -11 L6 -9 L6 -6 L5 -4 L2 -3 L-1 -3 M2 -12 L4 -11 L5 -9 L5 -6 L4 -4 L2 -3 M2 -3 L4 -2 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 4 L-6 3 L-5 4 L-6 5 M5 -1 L6 2 L6 5 L5 7 L4 8 L2 9","-10 10 M2 -10 L2 9 M3 -12 L3 9 M3 -12 L-8 3 L8 3 M-1 9 L6 9","-10 10 M-5 -12 L-7 -2 M-7 -2 L-5 -4 L-2 -5 L1 -5 L4 -4 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 4 L-6 3 L-5 4 L-6 5 M1 -5 L3 -4 L5 -2 L6 1 L6 3 L5 6 L3 8 L1 9 M-5 -12 L5 -12 M-5 -11 L0 -11 L5 -12","-10 10 M5 -9 L4 -8 L5 -7 L6 -8 L6 -9 L5 -11 L3 -12 L0 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -3 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 3 L7 2 L6 -1 L4 -3 L1 -4 L0 -4 L-3 -3 L-5 -1 L-6 2 M0 -12 L-2 -11 L-4 -9 L-5 -7 L-6 -3 L-6 3 L-5 6 L-3 8 L-1 9 M1 9 L3 8 L5 6 L6 3 L6 2 L5 -1 L3 -3 L1 -4","-10 10 M-7 -12 L-7 -6 M-7 -8 L-6 -10 L-4 -12 L-2 -12 L3 -9 L5 -9 L6 -10 L7 -12 M-6 -10 L-4 -11 L-2 -11 L3 -9 M7 -12 L7 -9 L6 -6 L2 -1 L1 1 L0 4 L0 9 M6 -6 L1 -1 L0 1 L-1 4 L-1 9","-10 10 M-2 -12 L-5 -11 L-6 -9 L-6 -6 L-5 -4 L-2 -3 L2 -3 L5 -4 L6 -6 L6 -9 L5 -11 L2 -12 L-2 -12 M-2 -12 L-4 -11 L-5 -9 L-5 -6 L-4 -4 L-2 -3 M2 -3 L4 -4 L5 -6 L5 -9 L4 -11 L2 -12 M-2 -3 L-5 -2 L-6 -1 L-7 1 L-7 5 L-6 7 L-5 8 L-2 9 L2 9 L5 8 L6 7 L7 5 L7 1 L6 -1 L5 -2 L2 -3 M-2 -3 L-4 -2 L-5 -1 L-6 1 L-6 5 L-5 7 L-4 8 L-2 9 M2 9 L4 8 L5 7 L6 5 L6 1 L5 -1 L4 -2 L2 -3","-10 10 M6 -5 L5 -2 L3 0 L0 1 L-1 1 L-4 0 L-6 -2 L-7 -5 L-7 -6 L-6 -9 L-4 -11 L-1 -12 L1 -12 L4 -11 L6 -9 L7 -6 L7 0 L6 4 L5 6 L3 8 L0 9 L-3 9 L-5 8 L-6 6 L-6 5 L-5 4 L-4 5 L-5 6 M-1 1 L-3 0 L-5 -2 L-6 -5 L-6 -6 L-5 -9 L-3 -11 L-1 -12 M1 -12 L3 -11 L5 -9 L6 -6 L6 0 L5 4 L4 6 L2 8 L0 9","-4 4 M0 -3 L-1 -2 L0 -1 L1 -2 L0 -3 M0 4 L-1 5 L0 6 L1 5 L0 4","-4 4 M0 -3 L-1 -2 L0 -1 L1 -2 L0 -3 M1 5 L0 6 L-1 5 L0 4 L1 5 L1 7 L-1 9","-12 12 M8 -9 L-8 0 L8 9","-13 13 M-9 -3 L9 -3 M-9 3 L9 3","-12 12 M-8 -9 L8 0 L-8 9","-9 9 M-5 -8 L-4 -7 L-5 -6 L-6 -7 L-6 -8 L-5 -10 L-4 -11 L-2 -12 L1 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L4 -3 L0 -1 L0 2 M1 -12 L3 -11 L4 -10 L5 -8 L5 -6 L4 -4 L2 -2 M0 7 L-1 8 L0 9 L1 8 L0 7","-13 14 M5 -4 L4 -6 L2 -7 L-1 -7 L-3 -6 L-4 -5 L-5 -2 L-5 1 L-4 3 L-2 4 L1 4 L3 3 L4 1 M-1 -7 L-3 -5 L-4 -2 L-4 1 L-3 3 L-2 4 M5 -7 L4 1 L4 3 L6 4 L8 4 L10 2 L11 -1 L11 -3 L10 -6 L9 -8 L7 -10 L5 -11 L2 -12 L-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L2 9 L5 8 L7 7 L8 6 M6 -7 L5 1 L5 3 L6 4","-10 10 M0 -12 L-7 9 M0 -12 L7 9 M0 -9 L6 9 M-5 3 L4 3 M-9 9 L-3 9 M3 9 L9 9","-11 11 M-6 -12 L-6 9 M-5 -12 L-5 9 M-9 -12 L7 -12 L7 -6 L6 -12 M-5 -2 L3 -2 L6 -1 L7 0 L8 2 L8 5 L7 7 L6 8 L3 9 L-9 9 M3 -2 L5 -1 L6 0 L7 2 L7 5 L6 7 L5 8 L3 9","-10 11 M-6 -9 L-7 -12 L-7 -6 L-6 -9 L-4 -11 L-1 -12 L1 -12 L4 -11 L6 -9 L7 -7 L8 -4 L8 1 L7 4 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 4 L-6 3 L-5 4 L-6 5 M1 -12 L3 -11 L5 -9 L6 -7 L7 -4 L7 1 L6 4 L5 6 L3 8 L1 9 M-2 -2 L7 -2","-12 12 M-4 -12 L-4 -6 L-5 2 L-6 6 L-7 8 L-8 9 M6 -12 L6 9 M7 -12 L7 9 M-7 -12 L10 -12 M-11 9 L10 9 M-11 9 L-11 16 M-10 9 L-11 16 M9 9 L10 16 M10 9 L10 16","-12 12 M-7 -12 L-7 9 M-6 -12 L-6 9 M6 -12 L6 9 M7 -12 L7 9 M-10 -12 L-3 -12 M3 -12 L10 -12 M6 -10 L-6 7 M-10 9 L-3 9 M3 9 L10 9","-12 13 M0 -12 L0 9 M1 -12 L1 9 M-3 -12 L4 -12 M-2 -9 L-6 -8 L-8 -6 L-9 -3 L-9 0 L-8 3 L-6 5 L-2 6 L3 6 L7 5 L9 3 L10 0 L10 -3 L9 -6 L7 -8 L3 -9 L-2 -9 M-2 -9 L-5 -8 L-7 -6 L-8 -3 L-8 0 L-7 3 L-5 5 L-2 6 M3 6 L6 5 L8 3 L9 0 L9 -3 L8 -6 L6 -8 L3 -9 M-3 9 L4 9","-9 9 M-4 -12 L-4 9 M-3 -12 L-3 9 M-7 -12 L8 -12 L8 -6 L7 -12 M-7 9 L0 9","-15 16 M0 -12 L0 9 M1 -12 L1 9 M-3 -12 L4 -12 M-11 -11 L-10 -10 L-11 -9 L-12 -10 L-12 -11 L-11 -12 L-10 -12 L-9 -11 L-8 -9 L-7 -5 L-6 -3 L-4 -2 L5 -2 L7 -3 L8 -5 L9 -9 L10 -11 L11 -12 L12 -12 L13 -11 L13 -10 L12 -9 L11 -10 L12 -11 M-4 -2 L-6 -1 L-7 1 L-8 6 L-9 8 L-10 9 M-4 -2 L-5 -1 L-6 1 L-7 6 L-8 8 L-9 9 L-11 9 L-12 8 L-13 6 M5 -2 L7 -1 L8 1 L9 6 L10 8 L11 9 M5 -2 L6 -1 L7 1 L8 6 L9 8 L10 9 L12 9 L13 8 L14 6 M-3 9 L4 9","-12 12 M-7 -12 L-7 9 M-6 -12 L-6 9 M6 -12 L6 9 M7 -12 L7 9 M-10 -12 L-3 -12 M3 -12 L10 -12 M6 -10 L-6 7 M-10 9 L-3 9 M3 9 L10 9","-12 11 M-7 -12 L-7 -1 L-6 1 L-3 2 L0 2 L3 1 L5 -1 M-6 -12 L-6 -1 L-5 1 L-3 2 M5 -12 L5 9 M6 -12 L6 9 M-10 -12 L-3 -12 M2 -12 L9 -12 M2 9 L9 9","-12 12 M-7 -12 L-7 9 M-6 -12 L-6 9 M-10 -12 L-3 -12 M-6 -2 L1 -2 L3 -3 L4 -5 L5 -9 L6 -11 L7 -12 L8 -12 L9 -11 L9 -10 L8 -9 L7 -10 L8 -11 M1 -2 L3 -1 L4 1 L5 6 L6 8 L7 9 M1 -2 L2 -1 L3 1 L4 6 L5 8 L6 9 L8 9 L9 8 L10 6 M-10 9 L-3 9","-13 12 M-5 -12 L-5 -6 L-6 2 L-7 6 L-8 8 L-9 9 L-10 9 L-11 8 L-11 7 L-10 6 L-9 7 L-10 8 M6 -12 L6 9 M7 -12 L7 9 M-8 -12 L10 -12 M3 9 L10 9","-12 13 M-7 -12 L-7 9 M-6 -12 L0 6 M-7 -12 L0 9 M7 -12 L0 9 M7 -12 L7 9 M8 -12 L8 9 M-10 -12 L-6 -12 M7 -12 L11 -12 M-10 9 L-4 9 M4 9 L11 9","-12 12 M-7 -12 L-7 9 M-6 -12 L-6 9 M6 -12 L6 9 M7 -12 L7 9 M-10 -12 L-3 -12 M3 -12 L10 -12 M-6 -2 L6 -2 M-10 9 L-3 9 M3 9 L10 9","-11 11 M-1 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -3 L-8 0 L-7 4 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 4 L8 0 L8 -3 L7 -7 L6 -9 L4 -11 L1 -12 L-1 -12 M-1 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -3 L-7 0 L-6 4 L-5 6 L-3 8 L-1 9 M1 9 L3 8 L5 6 L6 4 L7 0 L7 -3 L6 -7 L5 -9 L3 -11 L1 -12","-12 12 M-7 -12 L-7 9 M-6 -12 L-6 9 M6 -12 L6 9 M7 -12 L7 9 M-10 -12 L10 -12 M-10 9 L-3 9 M3 9 L10 9","-16 17 M-11 -12 L-11 9 M-10 -12 L-10 9 M0 -12 L0 9 M1 -12 L1 9 M11 -12 L11 9 M12 -12 L12 9 M-14 -12 L-7 -12 M-3 -12 L4 -12 M8 -12 L15 -12 M-14 9 L15 9","-11 11 M-6 -12 L-6 9 M-5 -12 L-5 9 M-9 -12 L3 -12 L6 -11 L7 -10 L8 -8 L8 -5 L7 -3 L6 -2 L3 -1 L-5 -1 M3 -12 L5 -11 L6 -10 L7 -8 L7 -5 L6 -3 L5 -2 L3 -1 M-9 9 L-2 9","-11 10 M6 -9 L7 -6 L7 -12 L6 -9 L4 -11 L1 -12 L-1 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 4 M-1 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -4 L-7 1 L-6 4 L-5 6 L-3 8 L-1 9","-9 10 M0 -12 L0 9 M1 -12 L1 9 M-6 -12 L-7 -6 L-7 -12 L8 -12 L8 -6 L7 -12 M-3 9 L4 9","-15 16 M-10 -12 L-10 9 M-9 -12 L-9 9 M-13 -12 L-6 -12 M-13 9 L-6 9 M4 -12 L1 -11 L-1 -9 L-2 -7 L-3 -3 L-3 0 L-2 4 L-1 6 L1 8 L4 9 L6 9 L9 8 L11 6 L12 4 L13 0 L13 -3 L12 -7 L11 -9 L9 -11 L6 -12 L4 -12 M4 -12 L2 -11 L0 -9 L-1 -7 L-2 -3 L-2 0 L-1 4 L0 6 L2 8 L4 9 M6 9 L8 8 L10 6 L11 4 L12 0 L12 -3 L11 -7 L10 -9 L8 -11 L6 -12 M-9 -2 L-3 -2","-11 11 M-6 -12 L-6 9 M-5 -12 L-5 9 M-9 -12 L3 -12 L6 -11 L7 -10 L8 -8 L8 -6 L7 -4 L6 -3 L3 -2 M3 -12 L5 -11 L6 -10 L7 -8 L7 -6 L6 -4 L5 -3 L3 -2 M-5 -2 L3 -2 L6 -1 L7 0 L8 2 L8 5 L7 7 L6 8 L3 9 L-9 9 M3 -2 L5 -1 L6 0 L7 2 L7 5 L6 7 L5 8 L3 9","-16 17 M-11 -12 L-11 9 M-10 -12 L-10 9 M0 -12 L0 9 M1 -12 L1 9 M11 -12 L11 9 M12 -12 L12 9 M-14 -12 L-7 -12 M-3 -12 L4 -12 M8 -12 L15 -12 M-14 9 L15 9 M14 9 L15 16 M15 9 L15 16","-10 10 M-7 -12 L6 9 M-6 -12 L7 9 M7 -12 L-7 9 M-9 -12 L-3 -12 M3 -12 L9 -12 M-9 9 L-3 9 M3 9 L9 9","-10 11 M-7 -12 L0 4 M-6 -12 L1 4 M8 -12 L1 4 L-1 7 L-2 8 L-4 9 L-5 9 L-6 8 L-6 7 L-5 6 L-4 7 L-5 8 M-9 -12 L-3 -12 M4 -12 L10 -12","-10 10 M-6 -9 L-7 -12 L-7 -6 L-6 -9 L-4 -11 L-2 -12 L2 -12 L5 -11 L6 -9 L6 -6 L5 -4 L2 -3 L-1 -3 M2 -12 L4 -11 L5 -9 L5 -6 L4 -4 L2 -3 M2 -3 L4 -2 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-3 9 L-5 8 L-6 7 L-7 5 L-7 4 L-6 3 L-5 4 L-6 5 M5 -1 L6 2 L6 5 L5 7 L4 8 L2 9","-11 10 M-6 -12 L-6 9 M-5 -12 L-5 9 M1 -6 L1 2 M-9 -12 L7 -12 L7 -6 L6 -12 M-5 -2 L1 -2 M-9 9 L7 9 L7 3 L6 9","-7 7 M-7 -12 L7 12","-12 14 M-2 -12 L-2 9 M-1 -12 L-1 9 M-9 -12 L-10 -6 L-10 -12 L2 -12 M-1 -2 L6 -2 L9 -1 L10 0 L11 2 L11 5 L10 7 L9 8 L6 9 L-5 9 M6 -2 L8 -1 L9 0 L10 2 L10 5 L9 7 L8 8 L6 9","-11 11 M5 -12 L5 9 M6 -12 L6 9 M9 -12 L-3 -12 L-6 -11 L-7 -10 L-8 -8 L-8 -6 L-7 -4 L-6 -3 L-3 -2 L5 -2 M-3 -12 L-5 -11 L-6 -10 L-7 -8 L-7 -6 L-6 -4 L-5 -3 L-3 -2 M0 -2 L-2 -1 L-3 0 L-6 7 L-7 8 L-8 8 L-9 7 M-2 -1 L-3 1 L-5 8 L-6 9 L-8 9 L-9 7 L-9 6 M2 9 L9 9","-10 11 M-5 -12 L-5 9 M-4 -12 L-4 9 M-8 -12 L-1 -12 M-4 -2 L3 -2 L6 -1 L7 0 L8 2 L8 5 L7 7 L6 8 L3 9 L-8 9 M3 -2 L5 -1 L6 0 L7 2 L7 5 L6 7 L5 8 L3 9","-12 12 M-7 -12 L-7 9 M-6 -12 L-6 9 M6 -12 L6 9 M7 -12 L7 9 M-10 -12 L-3 -12 M3 -12 L10 -12 M-10 9 L10 9 M9 9 L10 16 M10 9 L10 16","-9 11 M-4 -3 L-4 -2 L-5 -2 L-5 -3 L-4 -4 L-2 -5 L2 -5 L4 -4 L5 -3 L6 -1 L6 6 L7 8 L8 9 M5 -3 L5 6 L6 8 L8 9 L9 9 M5 -1 L4 0 L-2 1 L-5 2 L-6 4 L-6 6 L-5 8 L-2 9 L1 9 L3 8 L5 6 M-2 1 L-4 2 L-5 4 L-5 6 L-4 8 L-2 9","-10 10 M6 -12 L5 -11 L-1 -9 L-4 -7 L-6 -4 L-7 -1 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 3 L7 1 L6 -2 L4 -4 L1 -5 L-1 -5 L-4 -4 L-6 -2 L-7 1 M6 -12 L5 -10 L3 -9 L-1 -8 L-4 -6 L-6 -4 M-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 M1 9 L3 8 L5 6 L6 3 L6 1 L5 -2 L3 -4 L1 -5","-10 11 M-6 -9 L-7 -12 L-7 -6 L-6 -9 L-4 -11 L-1 -12 L1 -12 L4 -11 L6 -9 L7 -7 L8 -4 L8 1 L7 4 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 4 L-6 3 L-5 4 L-6 5 M1 -12 L3 -11 L5 -9 L6 -7 L7 -4 L7 1 L6 4 L5 6 L3 8 L1 9 M-2 -2 L7 -2","-12 11 M-4 -5 L-4 -1 L-5 5 L-6 8 L-7 9 M5 -5 L5 9 M6 -5 L6 9 M-7 -5 L9 -5 M-9 9 L-10 14 L-10 9 L9 9 L9 14 L8 9","-11 11 M-6 -5 L-6 9 M-5 -5 L-5 9 M5 -5 L5 9 M6 -5 L6 9 M-9 -5 L-2 -5 M2 -5 L9 -5 M-9 9 L-2 9 M2 9 L9 9 M5 -4 L-5 8 M-3 -11 L-3 -12 L-4 -12 L-4 -11 L-3 -9 L-1 -8 L1 -8 L3 -9 L4 -11","-10 11 M0 -12 L0 16 M1 -12 L1 16 M-3 -12 L1 -12 M0 -2 L-1 -4 L-2 -5 L-4 -5 L-6 -4 L-7 -1 L-7 5 L-6 8 L-4 9 L-2 9 L-1 8 L0 6 M-4 -5 L-5 -4 L-6 -1 L-6 5 L-5 8 L-4 9 M5 -5 L6 -4 L7 -1 L7 5 L6 8 L5 9 M1 -2 L2 -4 L3 -5 L5 -5 L7 -4 L8 -1 L8 5 L7 8 L5 9 L3 9 L2 8 L1 6 M-3 16 L4 16","-10 8 M-5 -5 L-5 9 M-4 -5 L-4 9 M-8 -5 L6 -5 L6 0 L5 -5 M-8 9 L-1 9","-13 14 M0 -5 L0 9 M1 -5 L1 9 M-3 -5 L4 -5 M-8 -4 L-9 -3 L-10 -4 L-9 -5 L-8 -5 L-7 -4 L-5 0 L-4 1 L-2 2 L3 2 L5 1 L6 0 L8 -4 L9 -5 L10 -5 L11 -4 L10 -3 L9 -4 M-2 2 L-4 3 L-5 4 L-7 8 L-8 9 M-2 2 L-4 4 L-6 8 L-7 9 L-9 9 L-10 8 L-11 6 M3 2 L5 3 L6 4 L8 8 L9 9 M3 2 L5 4 L7 8 L8 9 L10 9 L11 8 L12 6 M-3 9 L4 9","-11 11 M-6 -5 L-6 9 M-5 -5 L-5 9 M5 -5 L5 9 M6 -5 L6 9 M-9 -5 L-2 -5 M2 -5 L9 -5 M-9 9 L-2 9 M2 9 L9 9 M5 -4 L-5 8","-11 11 M-6 -5 L-6 2 L-5 4 L-2 5 L0 5 L3 4 L5 2 M-5 -5 L-5 2 L-4 4 L-2 5 M5 -5 L5 9 M6 -5 L6 9 M-9 -5 L-2 -5 M2 -5 L9 -5 M2 9 L9 9","-10 10 M-5 -5 L-5 9 M-4 -5 L-4 9 M-8 -5 L-1 -5 M-4 2 L-2 2 L1 1 L2 0 L4 -4 L5 -5 L6 -5 L7 -4 L6 -3 L5 -4 M-2 2 L1 3 L2 4 L4 8 L5 9 M-2 2 L0 3 L1 4 L3 8 L4 9 L6 9 L7 8 L8 6 M-8 9 L-1 9","-11 11 M-4 -5 L-4 -1 L-5 5 L-6 8 L-7 9 L-8 9 L-9 8 L-8 7 L-7 8 M5 -5 L5 9 M6 -5 L6 9 M-7 -5 L9 -5 M2 9 L9 9","-11 12 M-6 -5 L-6 9 M-6 -5 L0 9 M-5 -5 L0 7 M6 -5 L0 9 M6 -5 L6 9 M7 -5 L7 9 M-9 -5 L-5 -5 M6 -5 L10 -5 M-9 9 L-3 9 M3 9 L10 9","-11 11 M-6 -5 L-6 9 M-5 -5 L-5 9 M5 -5 L5 9 M6 -5 L6 9 M-9 -5 L-2 -5 M2 -5 L9 -5 M-5 2 L5 2 M-9 9 L-2 9 M2 9 L9 9","-10 10 M-1 -5 L-4 -4 L-6 -2 L-7 1 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 3 L7 1 L6 -2 L4 -4 L1 -5 L-1 -5 M-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 M1 9 L3 8 L5 6 L6 3 L6 1 L5 -2 L3 -4 L1 -5","-11 11 M-6 -5 L-6 9 M-5 -5 L-5 9 M5 -5 L5 9 M6 -5 L6 9 M-9 -5 L9 -5 M-9 9 L-2 9 M2 9 L9 9","-15 16 M-10 -5 L-10 9 M-9 -5 L-9 9 M0 -5 L0 9 M1 -5 L1 9 M10 -5 L10 9 M11 -5 L11 9 M-13 -5 L-6 -5 M-3 -5 L4 -5 M7 -5 L14 -5 M-13 9 L14 9","-11 10 M-6 -5 L-6 16 M-5 -5 L-5 16 M-5 -2 L-3 -4 L-1 -5 L1 -5 L4 -4 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-1 9 L-3 8 L-5 6 M1 -5 L3 -4 L5 -2 L6 1 L6 3 L5 6 L3 8 L1 9 M-9 -5 L-5 -5 M-9 16 L-2 16","-10 9 M5 -2 L4 -1 L5 0 L6 -1 L6 -2 L4 -4 L2 -5 L-1 -5 L-4 -4 L-6 -2 L-7 1 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 M-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9","-9 10 M0 -5 L0 9 M1 -5 L1 9 M-5 -5 L-6 0 L-6 -5 L7 -5 L7 0 L6 -5 M-3 9 L4 9","-14 15 M-9 -5 L-9 9 M-8 -5 L-8 9 M-12 -5 L-5 -5 M-12 9 L-5 9 M4 -5 L1 -4 L-1 -2 L-2 1 L-2 3 L-1 6 L1 8 L4 9 L6 9 L9 8 L11 6 L12 3 L12 1 L11 -2 L9 -4 L6 -5 L4 -5 M4 -5 L2 -4 L0 -2 L-1 1 L-1 3 L0 6 L2 8 L4 9 M6 9 L8 8 L10 6 L11 3 L11 1 L10 -2 L8 -4 L6 -5 M-8 2 L-2 2","-10 10 M-5 -5 L-5 9 M-4 -5 L-4 9 M-8 -5 L3 -5 L6 -4 L7 -2 L7 -1 L6 1 L3 2 M3 -5 L5 -4 L6 -2 L6 -1 L5 1 L3 2 M-4 2 L3 2 L6 3 L7 5 L7 6 L6 8 L3 9 L-8 9 M3 2 L5 3 L6 5 L6 6 L5 8 L3 9","-15 16 M-10 -5 L-10 9 M-9 -5 L-9 9 M0 -5 L0 9 M1 -5 L1 9 M10 -5 L10 9 M11 -5 L11 9 M-13 -5 L-6 -5 M-3 -5 L4 -5 M7 -5 L14 -5 M-13 9 L14 9 L14 14 L13 9","-10 10 M-6 -5 L5 9 M-5 -5 L6 9 M6 -5 L-6 9 M-8 -5 L-2 -5 M2 -5 L8 -5 M-8 9 L-2 9 M2 9 L8 9","-9 9 M-6 -5 L0 9 M-5 -5 L0 7 M6 -5 L0 9 L-2 13 L-4 15 L-6 16 L-7 16 L-8 15 L-7 14 L-6 15 M-8 -5 L-2 -5 M2 -5 L8 -5","-9 9 M-5 -3 L-6 -5 L-6 -1 L-5 -3 L-4 -4 L-2 -5 L2 -5 L5 -4 L6 -2 L6 -1 L5 1 L2 2 M2 -5 L4 -4 L5 -2 L5 -1 L4 1 L2 2 M-1 2 L2 2 L5 3 L6 5 L6 6 L5 8 L2 9 L-2 9 L-5 8 L-6 6 L-6 5 L-5 4 L-4 5 L-5 6 M2 2 L4 3 L5 5 L5 6 L4 8 L2 9","-10 9 M-6 1 L6 1 L6 -1 L5 -3 L4 -4 L2 -5 L-1 -5 L-4 -4 L-6 -2 L-7 1 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 M5 1 L5 -2 L4 -4 M-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9","-10 11 M-1 -5 L-1 9 M0 -5 L0 9 M-6 -5 L-7 0 L-7 -5 L3 -5 M0 2 L4 2 L7 3 L8 5 L8 6 L7 8 L4 9 L-4 9 M4 2 L6 3 L7 5 L7 6 L6 8 L4 9","-11 10 M4 -5 L4 9 M5 -5 L5 9 M8 -5 L-3 -5 L-6 -4 L-7 -2 L-7 -1 L-6 1 L-3 2 L4 2 M-3 -5 L-5 -4 L-6 -2 L-6 -1 L-5 1 L-3 2 M2 2 L-1 3 L-2 4 L-4 8 L-5 9 M2 2 L0 3 L-1 4 L-3 8 L-4 9 L-6 9 L-7 8 L-8 6 M1 9 L8 9","-8 9 M-3 -5 L-3 9 M-2 -5 L-2 9 M-6 -5 L1 -5 M-2 2 L2 2 L5 3 L6 5 L6 6 L5 8 L2 9 L-6 9 M2 2 L4 3 L5 5 L5 6 L4 8 L2 9","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3"],
    :futural => ["-8 8","-5 5 M0 -12 L0 2 M0 7 L-1 8 L0 9 L1 8 L0 7","-8 8 M-4 -12 L-4 -5 M4 -12 L4 -5","-10 11 M1 -16 L-6 16 M7 -16 L0 16 M-6 -3 L8 -3 M-7 3 L7 3","-10 10 M-2 -16 L-2 13 M2 -16 L2 13 M7 -9 L5 -11 L2 -12 L-2 -12 L-5 -11 L-7 -9 L-7 -7 L-6 -5 L-5 -4 L-3 -3 L3 -1 L5 0 L6 1 L7 3 L7 6 L5 8 L2 9 L-2 9 L-5 8 L-7 6","-12 12 M9 -12 L-9 9 M-4 -12 L-2 -10 L-2 -8 L-3 -6 L-5 -5 L-7 -5 L-9 -7 L-9 -9 L-8 -11 L-6 -12 L-4 -12 L-2 -11 L1 -10 L4 -10 L7 -11 L9 -12 M5 2 L3 3 L2 5 L2 7 L4 9 L6 9 L8 8 L9 6 L9 4 L7 2 L5 2","-13 13 M10 -3 L10 -4 L9 -5 L8 -5 L7 -4 L6 -2 L4 3 L2 6 L0 8 L-2 9 L-6 9 L-8 8 L-9 7 L-10 5 L-10 3 L-9 1 L-8 0 L-1 -4 L0 -5 L1 -7 L1 -9 L0 -11 L-2 -12 L-4 -11 L-5 -9 L-5 -7 L-4 -4 L-2 -1 L3 6 L5 8 L7 9 L9 9 L10 8 L10 7","-5 5 M0 -10 L-1 -11 L0 -12 L1 -11 L1 -9 L0 -7 L-1 -6","-7 7 M4 -16 L2 -14 L0 -11 L-2 -7 L-3 -2 L-3 2 L-2 7 L0 11 L2 14 L4 16","-7 7 M-4 -16 L-2 -14 L0 -11 L2 -7 L3 -2 L3 2 L2 7 L0 11 L-2 14 L-4 16","-8 8 M0 -6 L0 6 M-5 -3 L5 3 M5 -3 L-5 3","-13 13 M0 -9 L0 9 M-9 0 L9 0","-4 4 M1 5 L0 6 L-1 5 L0 4 L1 5 L1 7 L-1 9","-13 13 M-9 0 L9 0","-4 4 M0 4 L-1 5 L0 6 L1 5 L0 4","-11 11 M9 -16 L-9 16","-10 10 M-1 -12 L-4 -11 L-6 -8 L-7 -3 L-7 0 L-6 5 L-4 8 L-1 9 L1 9 L4 8 L6 5 L7 0 L7 -3 L6 -8 L4 -11 L1 -12 L-1 -12","-10 10 M-4 -8 L-2 -9 L1 -12 L1 9","-10 10 M-6 -7 L-6 -8 L-5 -10 L-4 -11 L-2 -12 L2 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L3 -1 L-7 9 L7 9","-10 10 M-5 -12 L6 -12 L0 -4 L3 -4 L5 -3 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5","-10 10 M3 -12 L-7 2 L8 2 M3 -12 L3 9","-10 10 M5 -12 L-5 -12 L-6 -3 L-5 -4 L-2 -5 L1 -5 L4 -4 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5","-10 10 M6 -9 L5 -11 L2 -12 L0 -12 L-3 -11 L-5 -8 L-6 -3 L-6 2 L-5 6 L-3 8 L0 9 L1 9 L4 8 L6 6 L7 3 L7 2 L6 -1 L4 -3 L1 -4 L0 -4 L-3 -3 L-5 -1 L-6 2","-10 10 M7 -12 L-3 9 M-7 -12 L7 -12","-10 10 M-2 -12 L-5 -11 L-6 -9 L-6 -7 L-5 -5 L-3 -4 L1 -3 L4 -2 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 2 L-6 0 L-4 -2 L-1 -3 L3 -4 L5 -5 L6 -7 L6 -9 L5 -11 L2 -12 L-2 -12","-10 10 M6 -5 L5 -2 L3 0 L0 1 L-1 1 L-4 0 L-6 -2 L-7 -5 L-7 -6 L-6 -9 L-4 -11 L-1 -12 L0 -12 L3 -11 L5 -9 L6 -5 L6 0 L5 5 L3 8 L0 9 L-2 9 L-5 8 L-6 6","-4 4 M0 -3 L-1 -2 L0 -1 L1 -2 L0 -3 M0 4 L-1 5 L0 6 L1 5 L0 4","-4 4 M0 -3 L-1 -2 L0 -1 L1 -2 L0 -3 M1 5 L0 6 L-1 5 L0 4 L1 5 L1 7 L-1 9","-12 12 M8 -9 L-8 0 L8 9","-13 13 M-9 -3 L9 -3 M-9 3 L9 3","-12 12 M-8 -9 L8 0 L-8 9","-9 9 M-6 -7 L-6 -8 L-5 -10 L-4 -11 L-2 -12 L2 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L4 -3 L0 -1 L0 2 M0 7 L-1 8 L0 9 L1 8 L0 7","-13 14 M5 -4 L4 -6 L2 -7 L-1 -7 L-3 -6 L-4 -5 L-5 -2 L-5 1 L-4 3 L-2 4 L1 4 L3 3 L4 1 M-1 -7 L-3 -5 L-4 -2 L-4 1 L-3 3 L-2 4 M5 -7 L4 1 L4 3 L6 4 L8 4 L10 2 L11 -1 L11 -3 L10 -6 L9 -8 L7 -10 L5 -11 L2 -12 L-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L2 9 L5 8 L7 7 L8 6 M6 -7 L5 1 L5 3 L6 4","-9 9 M0 -12 L-8 9 M0 -12 L8 9 M-5 2 L5 2","-11 10 M-7 -12 L-7 9 M-7 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -6 L6 -4 L5 -3 L2 -2 M-7 -2 L2 -2 L5 -1 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-7 9","-10 11 M8 -7 L7 -9 L5 -11 L3 -12 L-1 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -4 L-7 1 L-6 4 L-5 6 L-3 8 L-1 9 L3 9 L5 8 L7 6 L8 4","-11 10 M-7 -12 L-7 9 M-7 -12 L0 -12 L3 -11 L5 -9 L6 -7 L7 -4 L7 1 L6 4 L5 6 L3 8 L0 9 L-7 9","-10 9 M-6 -12 L-6 9 M-6 -12 L7 -12 M-6 -2 L2 -2 M-6 9 L7 9","-10 8 M-6 -12 L-6 9 M-6 -12 L7 -12 M-6 -2 L2 -2","-10 11 M8 -7 L7 -9 L5 -11 L3 -12 L-1 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -4 L-7 1 L-6 4 L-5 6 L-3 8 L-1 9 L3 9 L5 8 L7 6 L8 4 L8 1 M3 1 L8 1","-11 11 M-7 -12 L-7 9 M7 -12 L7 9 M-7 -2 L7 -2","-4 4 M0 -12 L0 9","-8 8 M4 -12 L4 4 L3 7 L2 8 L0 9 L-2 9 L-4 8 L-5 7 L-6 4 L-6 2","-11 10 M-7 -12 L-7 9 M7 -12 L-7 2 M-2 -3 L7 9","-10 7 M-6 -12 L-6 9 M-6 9 L6 9","-12 12 M-8 -12 L-8 9 M-8 -12 L0 9 M8 -12 L0 9 M8 -12 L8 9","-11 11 M-7 -12 L-7 9 M-7 -12 L7 9 M7 -12 L7 9","-11 11 M-2 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 L-2 9 L2 9 L4 8 L6 6 L7 4 L8 1 L8 -4 L7 -7 L6 -9 L4 -11 L2 -12 L-2 -12","-11 10 M-7 -12 L-7 9 M-7 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -5 L6 -3 L5 -2 L2 -1 L-7 -1","-11 11 M-2 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 L-2 9 L2 9 L4 8 L6 6 L7 4 L8 1 L8 -4 L7 -7 L6 -9 L4 -11 L2 -12 L-2 -12 M1 5 L7 11","-11 10 M-7 -12 L-7 9 M-7 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -6 L6 -4 L5 -3 L2 -2 L-7 -2 M0 -2 L7 9","-10 10 M7 -9 L5 -11 L2 -12 L-2 -12 L-5 -11 L-7 -9 L-7 -7 L-6 -5 L-5 -4 L-3 -3 L3 -1 L5 0 L6 1 L7 3 L7 6 L5 8 L2 9 L-2 9 L-5 8 L-7 6","-8 8 M0 -12 L0 9 M-7 -12 L7 -12","-11 11 M-7 -12 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 3 L7 -12","-9 9 M-8 -12 L0 9 M8 -12 L0 9","-12 12 M-10 -12 L-5 9 M0 -12 L-5 9 M0 -12 L5 9 M10 -12 L5 9","-10 10 M-7 -12 L7 9 M7 -12 L-7 9","-9 9 M-8 -12 L0 -2 L0 9 M8 -12 L0 -2","-10 10 M7 -12 L-7 9 M-7 -12 L7 -12 M-7 9 L7 9","-7 7 M-3 -16 L-3 16 M-2 -16 L-2 16 M-3 -16 L4 -16 M-3 16 L4 16","-7 7 M-7 -12 L7 12","-7 7 M2 -16 L2 16 M3 -16 L3 16 M-4 -16 L3 -16 M-4 16 L3 16","-8 8 M0 -14 L-8 0 M0 -14 L8 0","-9 9 M-9 16 L9 16","-4 4 M1 -7 L-1 -5 L-1 -3 L0 -2 L1 -3 L0 -4 L-1 -3","-9 10 M6 -5 L6 9 M6 -2 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6","-10 9 M-6 -12 L-6 9 M-6 -2 L-4 -4 L-2 -5 L1 -5 L3 -4 L5 -2 L6 1 L6 3 L5 6 L3 8 L1 9 L-2 9 L-4 8 L-6 6","-9 9 M6 -2 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6","-9 10 M6 -12 L6 9 M6 -2 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6","-9 9 M-6 1 L6 1 L6 -1 L5 -3 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6","-5 7 M5 -12 L3 -12 L1 -11 L0 -8 L0 9 M-3 -5 L4 -5","-9 10 M6 -5 L6 11 L5 14 L4 15 L2 16 L-1 16 L-3 15 M6 -2 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6","-9 10 M-5 -12 L-5 9 M-5 -1 L-2 -4 L0 -5 L3 -5 L5 -4 L6 -1 L6 9","-4 4 M-1 -12 L0 -11 L1 -12 L0 -13 L-1 -12 M0 -5 L0 9","-5 5 M0 -12 L1 -11 L2 -12 L1 -13 L0 -12 M1 -5 L1 12 L0 15 L-2 16 L-4 16","-9 8 M-5 -12 L-5 9 M5 -5 L-5 5 M-1 1 L6 9","-4 4 M0 -12 L0 9","-15 15 M-11 -5 L-11 9 M-11 -1 L-8 -4 L-6 -5 L-3 -5 L-1 -4 L0 -1 L0 9 M0 -1 L3 -4 L5 -5 L8 -5 L10 -4 L11 -1 L11 9","-9 10 M-5 -5 L-5 9 M-5 -1 L-2 -4 L0 -5 L3 -5 L5 -4 L6 -1 L6 9","-9 10 M-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6 L7 3 L7 1 L6 -2 L4 -4 L2 -5 L-1 -5","-10 9 M-6 -5 L-6 16 M-6 -2 L-4 -4 L-2 -5 L1 -5 L3 -4 L5 -2 L6 1 L6 3 L5 6 L3 8 L1 9 L-2 9 L-4 8 L-6 6","-9 10 M6 -5 L6 16 M6 -2 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6","-7 6 M-3 -5 L-3 9 M-3 1 L-2 -2 L0 -4 L2 -5 L5 -5","-8 9 M6 -2 L5 -4 L2 -5 L-1 -5 L-4 -4 L-5 -2 L-4 0 L-2 1 L3 2 L5 3 L6 5 L6 6 L5 8 L2 9 L-1 9 L-4 8 L-5 6","-5 7 M0 -12 L0 5 L1 8 L3 9 L5 9 M-3 -5 L4 -5","-9 10 M-5 -5 L-5 5 L-4 8 L-2 9 L1 9 L3 8 L6 5 M6 -5 L6 9","-8 8 M-6 -5 L0 9 M6 -5 L0 9","-11 11 M-8 -5 L-4 9 M0 -5 L-4 9 M0 -5 L4 9 M8 -5 L4 9","-8 9 M-5 -5 L6 9 M6 -5 L-5 9","-8 8 M-6 -5 L0 9 M6 -5 L0 9 L-2 13 L-4 15 L-6 16 L-7 16","-8 9 M6 -5 L-5 9 M-5 -5 L6 -5 M-5 9 L6 9","-7 7 M2 -16 L0 -15 L-1 -14 L-2 -12 L-2 -10 L-1 -8 L0 -7 L1 -5 L1 -3 L-1 -1 M0 -15 L-1 -13 L-1 -11 L0 -9 L1 -8 L2 -6 L2 -4 L1 -2 L-3 0 L1 2 L2 4 L2 6 L1 8 L0 9 L-1 11 L-1 13 L0 15 M-1 1 L1 3 L1 5 L0 7 L-1 8 L-2 10 L-2 12 L-1 14 L0 15 L2 16","-4 4 M0 -16 L0 16","-7 7 M-2 -16 L0 -15 L1 -14 L2 -12 L2 -10 L1 -8 L0 -7 L-1 -5 L-1 -3 L1 -1 M0 -15 L1 -13 L1 -11 L0 -9 L-1 -8 L-2 -6 L-2 -4 L-1 -2 L3 0 L-1 2 L-2 4 L-2 6 L-1 8 L0 9 L1 11 L1 13 L0 15 M1 1 L-1 3 L-1 5 L0 7 L1 8 L2 10 L2 12 L1 14 L0 15 L-2 16","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3","-8 8 M-8 -12 L-8 9 L-7 9 L-7 -12 L-6 -12 L-6 9 L-5 9 L-5 -12 L-4 -12 L-4 9 L-3 9 L-3 -12 L-2 -12 L-2 9 L-1 9 L-1 -12 L0 -12 L0 9 L1 9 L1 -12 L2 -12 L2 9 L3 9 L3 -12 L4 -12 L4 9 L5 9 L5 -12 L6 -12 L6 9 L7 9 L7 -12 L8 -12 L8 9"],
    :futuram => ["-8 8","-5 6 M0 -12 L0 2 L1 2 M0 -12 L1 -12 L1 2 M0 6 L-1 7 L-1 8 L0 9 L1 9 L2 8 L2 7 L1 6 L0 6 M0 7 L0 8 L1 8 L1 7 L0 7","-9 9 M-4 -12 L-5 -11 L-5 -5 M-4 -11 L-5 -5 M-4 -12 L-3 -11 L-5 -5 M5 -12 L4 -11 L4 -5 M5 -11 L4 -5 M5 -12 L6 -11 L4 -5","-10 11 M1 -16 L-6 16 M7 -16 L0 16 M-6 -3 L8 -3 M-7 3 L7 3","-9 10 M0 -16 L0 13 L1 13 M0 -16 L1 -16 L1 13 M5 -9 L7 -9 L5 -11 L2 -12 L-1 -12 L-4 -11 L-6 -9 L-6 -7 L-5 -5 L-4 -4 L4 0 L5 1 L6 3 L6 5 L5 7 L2 8 L-1 8 L-3 7 L-4 6 M5 -9 L4 -10 L2 -11 L-1 -11 L-4 -10 L-5 -9 L-5 -7 L-4 -5 L4 -1 L6 1 L7 3 L7 5 L6 7 L5 8 L2 9 L-1 9 L-4 8 L-6 6 L-4 6 M6 6 L3 8","-12 12 M9 -12 L-9 9 M-4 -12 L-2 -10 L-2 -8 L-3 -6 L-5 -5 L-7 -5 L-9 -7 L-9 -9 L-8 -11 L-6 -12 L-4 -12 L-2 -11 L1 -10 L4 -10 L7 -11 L9 -12 M5 2 L3 3 L2 5 L2 7 L4 9 L6 9 L8 8 L9 6 L9 4 L7 2 L5 2","-12 13 M9 -4 L8 -3 L9 -2 L10 -3 L10 -4 L9 -5 L8 -5 L7 -4 L6 -2 L4 3 L2 6 L0 8 L-2 9 L-5 9 L-8 8 L-9 6 L-9 3 L-8 1 L-2 -3 L0 -5 L1 -7 L1 -9 L0 -11 L-2 -12 L-4 -11 L-5 -9 L-5 -7 L-4 -4 L-2 -1 L3 6 L5 8 L8 9 L9 9 L10 8 L10 7 M-5 9 L-7 8 L-8 6 L-8 3 L-7 1 L-5 -1 M-5 -7 L-4 -5 L4 6 L6 8 L8 9","-4 5 M1 -12 L0 -11 L0 -5 M1 -11 L0 -5 M1 -12 L2 -11 L0 -5","-7 7 M4 -16 L2 -14 L0 -11 L-2 -7 L-3 -2 L-3 2 L-2 7 L0 11 L2 14 L4 16 M2 -14 L0 -10 L-1 -7 L-2 -2 L-2 2 L-1 7 L0 10 L2 14","-7 7 M-4 -16 L-2 -14 L0 -11 L2 -7 L3 -2 L3 2 L2 7 L0 11 L-2 14 L-4 16 M-2 -14 L0 -10 L1 -7 L2 -2 L2 2 L1 7 L0 10 L-2 14","-8 8 M0 -12 L-1 -11 L1 -1 L0 0 M0 -12 L0 0 M0 -12 L1 -11 L-1 -1 L0 0 M-5 -9 L-4 -9 L4 -3 L5 -3 M-5 -9 L5 -3 M-5 -9 L-5 -8 L5 -4 L5 -3 M5 -9 L4 -9 L-4 -3 L-5 -3 M5 -9 L-5 -3 M5 -9 L5 -8 L-5 -4 L-5 -3","-12 13 M0 -9 L0 8 L1 8 M0 -9 L1 -9 L1 8 M-8 -1 L9 -1 L9 0 M-8 -1 L-8 0 L9 0","-5 6 M2 8 L1 9 L0 9 L-1 8 L-1 7 L0 6 L1 6 L2 7 L2 10 L1 12 L-1 13 M0 7 L0 8 L1 8 L1 7 L0 7 M1 9 L2 10 M2 8 L1 12","-13 13 M-9 0 L9 0","-5 6 M0 6 L-1 7 L-1 8 L0 9 L1 9 L2 8 L2 7 L1 6 L0 6 M0 7 L0 8 L1 8 L1 7 L0 7","-11 12 M9 -16 L-9 16 L-8 16 M9 -16 L10 -16 L-8 16","-10 10 M-1 -12 L-4 -11 L-6 -8 L-7 -3 L-7 0 L-6 5 L-4 8 L-1 9 L1 9 L4 8 L6 5 L7 0 L7 -3 L6 -8 L4 -11 L1 -12 L-1 -12 M-3 -11 L-5 -8 L-6 -3 L-6 0 L-5 5 L-3 8 M-4 7 L-1 8 L1 8 L4 7 M3 8 L5 5 L6 0 L6 -3 L5 -8 L3 -11 M4 -10 L1 -11 L-1 -11 L-4 -10","-10 10 M-4 -8 L-2 -9 L1 -12 L1 9 M-4 -8 L-4 -7 L-2 -8 L0 -10 L0 9 L1 9","-10 10 M-6 -7 L-6 -8 L-5 -10 L-4 -11 L-2 -12 L2 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L3 -1 L-6 9 M-6 -7 L-5 -7 L-5 -8 L-4 -10 L-2 -11 L2 -11 L4 -10 L5 -8 L5 -6 L4 -4 L2 -1 L-7 9 M-6 8 L7 8 L7 9 M-7 9 L7 9","-10 10 M-5 -12 L6 -12 L-1 -3 M-5 -12 L-5 -11 L5 -11 M5 -12 L-2 -3 M-1 -4 L1 -4 L4 -3 L6 -1 L7 2 L7 3 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5 L-6 5 M-2 -3 L1 -3 L4 -2 L6 1 M2 -3 L5 -1 L6 2 L6 3 L5 6 L2 8 M6 4 L4 7 L1 8 L-2 8 L-5 7 L-6 5 M-3 8 L-6 6","-10 10 M3 -9 L3 9 L4 9 M4 -12 L4 9 M4 -12 L-7 4 L8 4 M3 -9 L-6 4 M-6 3 L8 3 L8 4","-10 10 M-5 -12 L-6 -3 M-4 -11 L-5 -4 M-5 -12 L5 -12 L5 -11 M-4 -11 L5 -11 M-5 -4 L-2 -5 L1 -5 L4 -4 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5 L-6 5 M-6 -3 L-5 -3 L-3 -4 L1 -4 L4 -3 L6 0 M2 -4 L5 -2 L6 1 L6 3 L5 6 L2 8 M6 4 L4 7 L1 8 L-2 8 L-5 7 L-6 5 M-3 8 L-6 6","-10 10 M4 -11 L5 -9 L6 -9 L5 -11 L2 -12 L0 -12 L-3 -11 L-5 -8 L-6 -3 L-6 2 L-5 6 L-3 8 L0 9 L1 9 L4 8 L6 6 L7 3 L7 2 L6 -1 L4 -3 L1 -4 L0 -4 L-3 -3 L-5 -1 M5 -10 L2 -11 L0 -11 L-3 -10 M-2 -11 L-4 -8 L-5 -3 L-5 2 L-4 6 L-1 8 M-5 4 L-3 7 L0 8 L1 8 L4 7 L6 4 M2 8 L5 6 L6 3 L6 2 L5 -1 L2 -3 M6 1 L4 -2 L1 -3 L0 -3 L-3 -2 L-5 1 M-1 -3 L-4 -1 L-5 2","-10 10 M-7 -12 L7 -12 L-3 9 M-7 -12 L-7 -11 L6 -11 M6 -12 L-4 9 L-3 9","-10 10 M-2 -12 L-5 -11 L-6 -9 L-6 -7 L-5 -5 L-4 -4 L-2 -3 L2 -2 L4 -1 L5 0 L6 2 L6 5 L5 7 L2 8 L-2 8 L-5 7 L-6 5 L-6 2 L-5 0 L-4 -1 L-2 -2 L2 -3 L4 -4 L5 -5 L6 -7 L6 -9 L5 -11 L2 -12 L-2 -12 M-4 -11 L-5 -9 L-5 -7 L-4 -5 L-2 -4 L2 -3 L4 -2 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 2 L-6 0 L-4 -2 L-2 -3 L2 -4 L4 -5 L5 -7 L5 -9 L4 -11 M5 -10 L2 -11 L-2 -11 L-5 -10 M-6 6 L-3 8 M3 8 L6 6","-10 10 M5 -2 L3 0 L0 1 L-1 1 L-4 0 L-6 -2 L-7 -5 L-7 -6 L-6 -9 L-4 -11 L-1 -12 L0 -12 L3 -11 L5 -9 L6 -5 L6 0 L5 5 L3 8 L0 9 L-2 9 L-5 8 L-6 6 L-5 6 L-4 8 M5 -5 L4 -2 L1 0 M5 -4 L3 -1 L0 0 L-1 0 L-4 -1 L-6 -4 M-2 0 L-5 -2 L-6 -5 L-6 -6 L-5 -9 L-2 -11 M-6 -7 L-4 -10 L-1 -11 L0 -11 L3 -10 L5 -7 M1 -11 L4 -9 L5 -5 L5 0 L4 5 L2 8 M3 7 L0 8 L-2 8 L-5 7","-5 6 M0 -5 L-1 -4 L-1 -3 L0 -2 L1 -2 L2 -3 L2 -4 L1 -5 L0 -5 M0 -4 L0 -3 L1 -3 L1 -4 L0 -4 M0 6 L-1 7 L-1 8 L0 9 L1 9 L2 8 L2 7 L1 6 L0 6 M0 7 L0 8 L1 8 L1 7 L0 7","-5 6 M0 -5 L-1 -4 L-1 -3 L0 -2 L1 -2 L2 -3 L2 -4 L1 -5 L0 -5 M0 -4 L0 -3 L1 -3 L1 -4 L0 -4 M2 8 L1 9 L0 9 L-1 8 L-1 7 L0 6 L1 6 L2 7 L2 10 L1 12 L-1 13 M0 7 L0 8 L1 8 L1 7 L0 7 M1 9 L2 10 M2 8 L1 12","-12 12 M8 -9 L-8 0 L8 9","-12 13 M-8 -5 L9 -5 L9 -4 M-8 -5 L-8 -4 L9 -4 M-8 3 L9 3 L9 4 M-8 3 L-8 4 L9 4","-12 12 M-8 -9 L8 0 L-8 9","-9 10 M-6 -7 L-6 -8 L-5 -10 L-4 -11 L-1 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -6 L6 -4 L5 -3 L3 -2 L0 -1 M-6 -7 L-5 -7 L-5 -8 L-4 -10 L-1 -11 L2 -11 L5 -10 L6 -8 L6 -6 L5 -4 L3 -3 L0 -2 M-5 -9 L-2 -11 M3 -11 L6 -9 M6 -5 L2 -2 M0 -2 L0 2 L1 2 L1 -2 M0 6 L-1 7 L-1 8 L0 9 L1 9 L2 8 L2 7 L1 6 L0 6 M0 7 L0 8 L1 8 L1 7 L0 7","-13 14 M5 -4 L4 -6 L2 -7 L-1 -7 L-3 -6 L-4 -5 L-5 -2 L-5 1 L-4 3 L-2 4 L1 4 L3 3 L4 1 M-1 -7 L-3 -5 L-4 -2 L-4 1 L-3 3 L-2 4 M5 -7 L4 1 L4 3 L6 4 L8 4 L10 2 L11 -1 L11 -3 L10 -6 L9 -8 L7 -10 L5 -11 L2 -12 L-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L2 9 L5 8 L7 7 L8 6 M6 -7 L5 1 L5 3 L6 4","-10 10 M0 -12 L-8 9 M0 -9 L-7 9 L-8 9 M0 -9 L7 9 L8 9 M0 -12 L8 9 M-5 3 L5 3 M-6 4 L6 4","-10 10 M-6 -12 L-6 9 M-5 -11 L-5 8 M-6 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -5 L6 -3 L5 -2 L2 -1 M-5 -11 L2 -11 L5 -10 L6 -8 L6 -5 L5 -3 L2 -2 M-5 -2 L2 -2 L5 -1 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-6 9 M-5 -1 L2 -1 L5 0 L6 2 L6 5 L5 7 L2 8 L-5 8","-10 11 M8 -7 L7 -9 L5 -11 L3 -12 L-1 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -4 L-7 1 L-6 4 L-5 6 L-3 8 L-1 9 L3 9 L5 8 L7 6 L8 4 M8 -7 L7 -7 L6 -9 L5 -10 L3 -11 L-1 -11 L-3 -10 L-5 -7 L-6 -4 L-6 1 L-5 4 L-3 7 L-1 8 L3 8 L5 7 L6 6 L7 4 L8 4","-10 11 M-6 -12 L-6 9 M-5 -11 L-5 8 M-6 -12 L1 -12 L4 -11 L6 -9 L7 -7 L8 -4 L8 1 L7 4 L6 6 L4 8 L1 9 L-6 9 M-5 -11 L1 -11 L4 -10 L5 -9 L6 -7 L7 -4 L7 1 L6 4 L5 6 L4 7 L1 8 L-5 8","-9 10 M-5 -12 L-5 9 M-4 -11 L-4 8 M-5 -12 L7 -12 M-4 -11 L7 -11 L7 -12 M-4 -2 L2 -2 L2 -1 M-4 -1 L2 -1 M-4 8 L7 8 L7 9 M-5 9 L7 9","-9 9 M-5 -12 L-5 9 M-4 -11 L-4 9 L-5 9 M-5 -12 L7 -12 M-4 -11 L7 -11 L7 -12 M-4 -2 L2 -2 L2 -1 M-4 -1 L2 -1","-10 11 M8 -7 L7 -9 L5 -11 L3 -12 L-1 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -4 L-7 1 L-6 4 L-5 6 L-3 8 L-1 9 L3 9 L5 8 L7 6 L8 4 L8 0 L3 0 M8 -7 L7 -7 L6 -9 L5 -10 L3 -11 L-1 -11 L-3 -10 L-4 -9 L-5 -7 L-6 -4 L-6 1 L-5 4 L-4 6 L-3 7 L-1 8 L3 8 L5 7 L6 6 L7 4 L7 1 L3 1 L3 0","-11 11 M-7 -12 L-7 9 M-7 -12 L-6 -12 L-6 9 L-7 9 M7 -12 L6 -12 L6 9 L7 9 M7 -12 L7 9 M-6 -2 L6 -2 M-6 -1 L6 -1","-4 5 M0 -12 L0 9 L1 9 M0 -12 L1 -12 L1 9","-8 9 M4 -12 L4 4 L3 7 L1 8 L-1 8 L-3 7 L-4 4 L-5 4 M4 -12 L5 -12 L5 4 L4 7 L3 8 L1 9 L-1 9 L-3 8 L-4 7 L-5 4","-10 11 M-6 -12 L-6 9 L-5 9 M-6 -12 L-5 -12 L-5 9 M8 -12 L7 -12 L-5 0 M8 -12 L-5 1 M-2 -3 L7 9 L8 9 M-1 -3 L8 9","-9 8 M-5 -12 L-5 9 M-5 -12 L-4 -12 L-4 8 M-4 8 L7 8 L7 9 M-5 9 L7 9","-12 12 M-8 -12 L-8 9 M-7 -7 L-7 9 L-8 9 M-7 -7 L0 9 M-8 -12 L0 6 M8 -12 L0 6 M7 -7 L0 9 M7 -7 L7 9 L8 9 M8 -12 L8 9","-11 11 M-7 -12 L-7 9 M-6 -9 L-6 9 L-7 9 M-6 -9 L7 9 M-7 -12 L6 6 M6 -12 L6 6 M6 -12 L7 -12 L7 9","-11 11 M-2 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 L-2 9 L2 9 L4 8 L6 6 L7 4 L8 1 L8 -4 L7 -7 L6 -9 L4 -11 L2 -12 L-2 -12 M-1 -11 L-4 -10 L-6 -7 L-7 -4 L-7 1 L-6 4 L-4 7 L-1 8 L1 8 L4 7 L6 4 L7 1 L7 -4 L6 -7 L4 -10 L1 -11 L-1 -11","-10 10 M-6 -12 L-6 9 M-5 -11 L-5 9 L-6 9 M-6 -12 L3 -12 L5 -11 L6 -10 L7 -8 L7 -5 L6 -3 L5 -2 L3 -1 L-5 -1 M-5 -11 L3 -11 L5 -10 L6 -8 L6 -5 L5 -3 L3 -2 L-5 -2","-11 11 M-2 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 L-2 9 L2 9 L4 8 L6 6 L7 4 L8 1 L8 -4 L7 -7 L6 -9 L4 -11 L2 -12 L-2 -12 M-1 -11 L-4 -10 L-6 -7 L-7 -4 L-7 1 L-6 4 L-4 7 L-1 8 L1 8 L4 7 L6 4 L7 1 L7 -4 L6 -7 L4 -10 L1 -11 L-1 -11 M1 6 L6 11 L7 11 M1 6 L2 6 L7 11","-10 10 M-6 -12 L-6 9 M-5 -11 L-5 9 L-6 9 M-6 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -5 L6 -3 L5 -2 L2 -1 L-5 -1 M-5 -11 L2 -11 L5 -10 L6 -8 L6 -5 L5 -3 L2 -2 L-5 -2 M0 -1 L6 9 L7 9 M1 -1 L7 9","-10 10 M7 -9 L5 -11 L2 -12 L-2 -12 L-5 -11 L-7 -9 L-7 -7 L-6 -5 L-5 -4 L-3 -3 L2 -1 L4 0 L5 1 L6 3 L6 6 L5 7 L2 8 L-2 8 L-4 7 L-5 6 L-7 6 M7 -9 L5 -9 L4 -10 L2 -11 L-2 -11 L-5 -10 L-6 -9 L-6 -7 L-5 -5 L-3 -4 L2 -2 L4 -1 L6 1 L7 3 L7 6 L5 8 L2 9 L-2 9 L-5 8 L-7 6","-8 9 M0 -11 L0 9 M1 -11 L1 9 L0 9 M-6 -12 L7 -12 L7 -11 M-6 -12 L-6 -11 L7 -11","-11 11 M-7 -12 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 3 L7 -12 M-7 -12 L-6 -12 L-6 3 L-5 6 L-4 7 L-1 8 L1 8 L4 7 L5 6 L6 3 L6 -12 L7 -12","-10 10 M-8 -12 L0 9 M-8 -12 L-7 -12 L0 6 M8 -12 L7 -12 L0 6 M8 -12 L0 9","-13 13 M-11 -12 L-5 9 M-11 -12 L-10 -12 L-5 6 M0 -12 L-5 6 M0 -9 L-5 9 M0 -9 L5 9 M0 -12 L5 6 M11 -12 L10 -12 L5 6 M11 -12 L5 9","-10 10 M-7 -12 L6 9 L7 9 M-7 -12 L-6 -12 L7 9 M7 -12 L6 -12 L-7 9 M7 -12 L-6 9 L-7 9","-9 10 M-7 -12 L0 -2 L0 9 L1 9 M-7 -12 L-6 -12 L1 -2 M8 -12 L7 -12 L0 -2 M8 -12 L1 -2 L1 9","-10 10 M6 -12 L-7 9 M7 -12 L-6 9 M-7 -12 L7 -12 M-7 -12 L-7 -11 L6 -11 M-6 8 L7 8 L7 9 M-7 9 L7 9","-7 7 M-3 -16 L-3 16 M-2 -16 L-2 16 M-3 -16 L4 -16 M-3 16 L4 16","-7 7 M-7 -12 L7 12","-7 7 M2 -16 L2 16 M3 -16 L3 16 M-4 -16 L3 -16 M-4 16 L3 16","-11 11 M-8 2 L0 -3 L8 2 M-8 2 L0 -2 L8 2","-10 10 M-10 16 L10 16","-6 6 M-2 -12 L3 -6 M-2 -12 L-3 -11 L3 -6","-10 10 M5 -5 L5 9 L6 9 M5 -5 L6 -5 L6 9 M5 -2 L3 -4 L1 -5 L-2 -5 L-4 -4 L-6 -2 L-7 1 L-7 3 L-6 6 L-4 8 L-2 9 L1 9 L3 8 L5 6 M5 -2 L1 -4 L-2 -4 L-4 -3 L-5 -2 L-6 1 L-6 3 L-5 6 L-4 7 L-2 8 L1 8 L5 6","-10 10 M-6 -12 L-6 9 L-5 9 M-6 -12 L-5 -12 L-5 9 M-5 -2 L-3 -4 L-1 -5 L2 -5 L4 -4 L6 -2 L7 1 L7 3 L6 6 L4 8 L2 9 L-1 9 L-3 8 L-5 6 M-5 -2 L-1 -4 L2 -4 L4 -3 L5 -2 L6 1 L6 3 L5 6 L4 7 L2 8 L-1 8 L-5 6","-9 9 M6 -2 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6 M6 -2 L5 -1 L4 -3 L2 -4 L-1 -4 L-3 -3 L-4 -2 L-5 1 L-5 3 L-4 6 L-3 7 L-1 8 L2 8 L4 7 L5 5 L6 6","-10 10 M5 -12 L5 9 L6 9 M5 -12 L6 -12 L6 9 M5 -2 L3 -4 L1 -5 L-2 -5 L-4 -4 L-6 -2 L-7 1 L-7 3 L-6 6 L-4 8 L-2 9 L1 9 L3 8 L5 6 M5 -2 L1 -4 L-2 -4 L-4 -3 L-5 -2 L-6 1 L-6 3 L-5 6 L-4 7 L-2 8 L1 8 L5 6","-9 9 M-5 2 L6 2 L6 -1 L5 -3 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6 M-5 1 L5 1 L5 -1 L4 -3 L2 -4 L-1 -4 L-3 -3 L-4 -2 L-5 1 L-5 3 L-4 6 L-3 7 L-1 8 L2 8 L4 7 L5 5 L6 6","-6 8 M5 -12 L3 -12 L1 -11 L0 -8 L0 9 L1 9 M5 -12 L5 -11 L3 -11 L1 -10 M2 -11 L1 -8 L1 9 M-3 -5 L4 -5 L4 -4 M-3 -5 L-3 -4 L4 -4","-10 10 M6 -5 L5 -5 L5 10 L4 13 L3 14 L1 15 L-1 15 L-3 14 L-4 13 L-6 13 M6 -5 L6 10 L5 13 L3 15 L1 16 L-2 16 L-4 15 L-6 13 M5 -2 L3 -4 L1 -5 L-2 -5 L-4 -4 L-6 -2 L-7 1 L-7 3 L-6 6 L-4 8 L-2 9 L1 9 L3 8 L5 6 M5 -2 L1 -4 L-2 -4 L-4 -3 L-5 -2 L-6 1 L-6 3 L-5 6 L-4 7 L-2 8 L1 8 L5 6","-10 10 M-6 -12 L-6 9 L-5 9 M-6 -12 L-5 -12 L-5 9 M-5 -1 L-2 -4 L0 -5 L3 -5 L5 -4 L6 -1 L6 9 M-5 -1 L-2 -3 L0 -4 L2 -4 L4 -3 L5 -1 L5 9 L6 9","-4 5 M0 -12 L-1 -11 L-1 -10 L0 -9 L1 -9 L2 -10 L2 -11 L1 -12 L0 -12 M0 -11 L0 -10 L1 -10 L1 -11 L0 -11 M0 -5 L0 9 L1 9 M0 -5 L1 -5 L1 9","-4 5 M0 -12 L-1 -11 L-1 -10 L0 -9 L1 -9 L2 -10 L2 -11 L1 -12 L0 -12 M0 -11 L0 -10 L1 -10 L1 -11 L0 -11 M0 -5 L0 16 L1 16 M0 -5 L1 -5 L1 16","-10 9 M-6 -12 L-6 9 L-5 9 M-6 -12 L-5 -12 L-5 9 M6 -5 L5 -5 L-5 5 M6 -5 L-5 6 M-2 2 L4 9 L6 9 M-1 1 L6 9","-4 5 M0 -12 L0 9 L1 9 M0 -12 L1 -12 L1 9","-15 16 M-11 -5 L-11 9 L-10 9 M-11 -5 L-10 -5 L-10 9 M-10 -1 L-7 -4 L-5 -5 L-2 -5 L0 -4 L1 -1 L1 9 M-10 -1 L-7 -3 L-5 -4 L-3 -4 L-1 -3 L0 -1 L0 9 L1 9 M1 -1 L4 -4 L6 -5 L9 -5 L11 -4 L12 -1 L12 9 M1 -1 L4 -3 L6 -4 L8 -4 L10 -3 L11 -1 L11 9 L12 9","-10 10 M-6 -5 L-6 9 L-5 9 M-6 -5 L-5 -5 L-5 9 M-5 -1 L-2 -4 L0 -5 L3 -5 L5 -4 L6 -1 L6 9 M-5 -1 L-2 -3 L0 -4 L2 -4 L4 -3 L5 -1 L5 9 L6 9","-9 10 M-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6 L7 3 L7 1 L6 -2 L4 -4 L2 -5 L-1 -5 M-1 -4 L-3 -3 L-4 -2 L-5 1 L-5 3 L-4 6 L-3 7 L-1 8 L2 8 L4 7 L5 6 L6 3 L6 1 L5 -2 L4 -3 L2 -4 L-1 -4","-10 10 M-6 -5 L-6 16 L-5 16 M-6 -5 L-5 -5 L-5 16 M-5 -2 L-3 -4 L-1 -5 L2 -5 L4 -4 L6 -2 L7 1 L7 3 L6 6 L4 8 L2 9 L-1 9 L-3 8 L-5 6 M-5 -2 L-1 -4 L2 -4 L4 -3 L5 -2 L6 1 L6 3 L5 6 L4 7 L2 8 L-1 8 L-5 6","-10 10 M5 -5 L5 16 L6 16 M5 -5 L6 -5 L6 16 M5 -2 L3 -4 L1 -5 L-2 -5 L-4 -4 L-6 -2 L-7 1 L-7 3 L-6 6 L-4 8 L-2 9 L1 9 L3 8 L5 6 M5 -2 L1 -4 L-2 -4 L-4 -3 L-5 -2 L-6 1 L-6 3 L-5 6 L-4 7 L-2 8 L1 8 L5 6","-7 7 M-3 -5 L-3 9 L-2 9 M-3 -5 L-2 -5 L-2 9 M-2 1 L-1 -2 L1 -4 L3 -5 L6 -5 M-2 1 L-1 -1 L1 -3 L3 -4 L6 -4 L6 -5","-8 9 M6 -2 L5 -4 L2 -5 L-1 -5 L-4 -4 L-5 -2 L-4 0 L-2 1 L3 3 L5 4 M4 3 L5 5 L5 6 L4 8 M5 7 L2 8 L-1 8 L-4 7 M-3 8 L-4 6 L-5 6 M6 -2 L5 -2 L4 -4 M5 -3 L2 -4 L-1 -4 L-4 -3 M-3 -4 L-4 -2 L-3 0 M-4 -1 L-2 0 L3 2 L5 3 L6 5 L6 6 L5 8 L2 9 L-1 9 L-4 8 L-5 6","-5 6 M0 -12 L0 9 L1 9 M0 -12 L1 -12 L1 9 M-3 -5 L4 -5 L4 -4 M-3 -5 L-3 -4 L4 -4","-10 10 M-6 -5 L-6 5 L-5 8 L-3 9 L0 9 L2 8 L5 5 M-6 -5 L-5 -5 L-5 5 L-4 7 L-2 8 L0 8 L2 7 L5 5 M5 -5 L5 9 L6 9 M5 -5 L6 -5 L6 9","-8 8 M-6 -5 L0 9 M-6 -5 L-5 -5 L0 7 M6 -5 L5 -5 L0 7 M6 -5 L0 9","-12 12 M-9 -5 L-4 9 M-9 -5 L-8 -5 L-4 6 M0 -5 L-4 6 M0 -2 L-4 9 M0 -2 L4 9 M0 -5 L4 6 M9 -5 L8 -5 L4 6 M9 -5 L4 9","-9 9 M-6 -5 L5 9 L6 9 M-6 -5 L-5 -5 L6 9 M6 -5 L5 -5 L-6 9 M6 -5 L-5 9 L-6 9","-8 8 M-6 -5 L0 9 M-6 -5 L-5 -5 L0 7 M6 -5 L5 -5 L0 7 L-4 16 M6 -5 L0 9 L-3 16 L-4 16","-9 9 M4 -4 L-6 9 M6 -5 L-4 8 M-6 -5 L6 -5 M-6 -5 L-6 -4 L4 -4 M-4 8 L6 8 L6 9 M-6 9 L6 9","-7 7 M3 -16 L-4 0 L3 16","-4 4 M0 -16 L0 16","-7 7 M-3 -16 L4 0 L-3 16","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3","-8 8 M-8 -12 L-8 9 L-7 9 L-7 -12 L-6 -12 L-6 9 L-5 9 L-5 -12 L-4 -12 L-4 9 L-3 9 L-3 -12 L-2 -12 L-2 9 L-1 9 L-1 -12 L0 -12 L0 9 L1 9 L1 -12 L2 -12 L2 9 L3 9 L3 -12 L4 -12 L4 9 L5 9 L5 -12 L6 -12 L6 9 L7 9 L7 -12 L8 -12 L8 9"],
    :gothiceng => ["-8 8","-6 6 M0 -12 L-1 -11 L-3 -10 L-1 -9 L0 2 M0 -9 L1 -10 L0 -11 L-1 -10 L0 -9 L0 2 M0 -12 L1 -11 L3 -10 L1 -9 L0 2 M0 6 L-2 8 L0 9 L2 8 L0 6 M0 7 L-1 8 L1 8 L0 7","-9 9 M-4 -12 L-5 -11 L-5 -5 M-4 -11 L-5 -5 M-4 -12 L-3 -11 L-5 -5 M5 -12 L4 -11 L4 -5 M5 -11 L4 -5 M5 -12 L6 -11 L4 -5","-10 11 M1 -16 L-6 16 M7 -16 L0 16 M-6 -3 L8 -3 M-7 3 L7 3","-10 10 M-2 -16 L-2 13 M2 -16 L2 13 M2 -12 L4 -11 L5 -9 L5 -7 L7 -8 L6 -10 L5 -11 L2 -12 L-2 -12 L-5 -11 L-7 -9 L-7 -6 L-6 -4 L-3 -2 L3 0 L5 1 L6 3 L6 6 L5 8 M6 -8 L5 -10 M-6 -6 L-5 -4 L-3 -3 L3 -1 L5 0 L6 2 M-5 7 L-6 5 M-5 -11 L-6 -9 L-6 -7 L-5 -5 L-3 -4 L3 -2 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-2 9 L-5 8 L-6 7 L-7 5 L-5 4 L-5 6 L-4 8 L-2 9","-12 12 M9 -12 L-9 9 M-4 -12 L-2 -10 L-2 -8 L-3 -6 L-5 -5 L-7 -5 L-9 -7 L-9 -9 L-8 -11 L-6 -12 L-4 -12 L-2 -11 L1 -10 L4 -10 L7 -11 L9 -12 M5 2 L3 3 L2 5 L2 7 L4 9 L6 9 L8 8 L9 6 L9 4 L7 2 L5 2","-13 13 M7 -4 L8 -3 L9 -3 L10 -4 M6 -3 L7 -2 L9 -2 M6 -2 L7 -1 L8 -1 L9 -2 L10 -4 M7 -4 L1 2 M0 3 L-6 9 L-10 4 L-4 -2 M-3 -3 L1 -7 L-3 -12 L-8 -6 L-2 0 L2 6 L4 8 L6 9 L8 9 L9 8 L10 6 M-6 8 L-9 4 M0 -7 L-3 -11 M-7 -6 L-2 -1 L2 5 L4 7 L6 8 L9 8 M-5 8 L-9 3 M0 -6 L-4 -11 M-7 -7 L-1 -1 L3 5 L4 6 L6 7 L9 7 L10 6","-4 5 M1 -12 L0 -11 L0 -5 M1 -11 L0 -5 M1 -12 L2 -11 L0 -5","-7 7 M3 -16 L1 -14 L-1 -11 L-3 -7 L-4 -2 L-4 2 L-3 7 L-1 11 L1 14 L3 16 M-1 -10 L-2 -7 L-3 -3 L-3 3 L-2 7 L-1 10 M1 -14 L0 -12 L-1 -9 L-2 -3 L-2 3 L-1 9 L0 12 L1 14","-7 7 M-3 -16 L-1 -14 L1 -11 L3 -7 L4 -2 L4 2 L3 7 L1 11 L-1 14 L-3 16 M1 -10 L2 -7 L3 -3 L3 3 L2 7 L1 10 M-1 -14 L0 -12 L1 -9 L2 -3 L2 3 L1 9 L0 12 L-1 14","-8 8 M0 -12 L-1 -11 L1 -1 L0 0 M0 -12 L0 0 M0 -12 L1 -11 L-1 -1 L0 0 M-5 -9 L-4 -9 L4 -3 L5 -3 M-5 -9 L5 -3 M-5 -9 L-5 -8 L5 -4 L5 -3 M5 -9 L4 -9 L-4 -3 L-5 -3 M5 -9 L-5 -3 M5 -9 L5 -8 L-5 -4 L-5 -3","-12 13 M0 -9 L0 8 L1 8 M0 -9 L1 -9 L1 8 M-8 -1 L9 -1 L9 0 M-8 -1 L-8 0 L9 0","-6 6 M0 12 L0 10 L-2 8 L0 6 L1 8 L1 10 L0 12 L-2 13 M0 7 L-1 8 L0 9 L0 7","-13 13 M-9 0 L9 0","-6 6 M0 6 L-2 8 L0 9 L2 8 L0 6 M0 7 L-1 8 L1 8 L0 7","-11 12 M9 -16 L-9 16 L-8 16 M9 -16 L10 -16 L-8 16","-10 10 M-6 -10 L-6 6 L-8 7 M-5 -9 L-5 6 L-2 8 M-4 -10 L-4 6 L-2 7 L-1 8 M-6 -10 L-4 -10 L1 -11 L3 -12 M1 -11 L2 -10 L4 -9 L4 7 M2 -11 L5 -9 L5 6 M3 -12 L4 -11 L6 -10 L8 -10 L6 -9 L6 7 M-8 7 L-6 7 L-4 8 L-3 9 L-1 8 L4 7 L6 7","-10 10 M-3 -10 L-2 -9 L-1 -7 L-1 6 L-3 7 M-1 -9 L-2 -10 L-1 -11 L0 -9 L0 7 L2 8 M-3 -10 L0 -12 L1 -10 L1 6 L3 7 L4 7 M-3 7 L-2 7 L0 8 L1 9 L2 8 L4 7","-10 10 M-6 -10 L-4 -10 L-2 -11 L-1 -12 L1 -11 L4 -10 L6 -10 M-2 -10 L0 -11 M-6 -10 L-4 -9 L-2 -9 L0 -10 L1 -11 M4 -10 L4 -2 M5 -9 L5 -3 M6 -10 L6 -2 L-1 -2 L-4 -1 L-6 1 L-7 4 L-7 9 M-7 9 L-3 7 L1 6 L4 6 L8 7 M-4 8 L-1 7 L4 7 L7 8 M-7 9 L-2 8 L3 8 L6 9 L8 7","-10 10 M-6 -10 L-5 -10 L-3 -11 L-2 -12 L0 -11 L4 -10 L6 -10 M-3 -10 L-1 -11 M-6 -10 L-4 -9 L-2 -9 L0 -11 M4 -10 L4 -3 M5 -9 L5 -4 M6 -10 L6 -3 L4 -3 L1 -2 L-1 -1 M-1 -2 L1 -1 L4 0 L6 0 L6 7 M5 1 L5 6 M4 0 L4 7 M-7 7 L-5 6 L-3 6 L-1 7 L0 8 M-3 7 L-1 8 M-7 7 L-5 7 L-3 8 L-2 9 L0 8 L4 7 L6 7","-10 10 M3 -12 L-7 -2 L-7 3 L2 3 M4 3 L8 3 L9 4 L9 2 L8 3 M-6 -2 L-6 2 M-5 -4 L-5 3 M2 -11 L2 6 L0 7 M3 -8 L4 -10 L3 -11 L3 7 L5 8 M3 -12 L5 -10 L4 -8 L4 6 L6 7 L7 7 M0 7 L1 7 L3 8 L4 9 L5 8 L7 7","-10 10 M-6 -12 L-6 -3 M-6 -12 L6 -12 M-5 -11 L4 -11 M-6 -10 L3 -10 L5 -11 L6 -12 M4 -6 L3 -5 L1 -4 L-3 -3 L-6 -3 M1 -4 L2 -4 L4 -3 L4 7 M3 -5 L5 -4 L5 6 M4 -6 L5 -5 L7 -4 L8 -4 L6 -3 L6 7 M-7 7 L-5 6 L-3 6 L-1 7 L0 8 M-3 7 L-1 8 M-7 7 L-5 7 L-3 8 L-2 9 L0 8 L4 7 L6 7","-10 10 M-6 -10 L-6 6 L-8 7 M-5 -9 L-5 6 L-2 8 M-4 -10 L-4 6 L-2 7 L-1 8 M-6 -10 L-4 -10 L0 -11 L2 -12 L3 -11 L5 -10 L6 -10 M1 -11 L3 -10 M0 -11 L2 -9 L4 -9 L6 -10 M-4 -2 L-3 -2 L1 -3 L3 -4 L4 -5 M1 -3 L2 -3 L4 -2 L4 7 M3 -4 L5 -2 L5 6 M4 -5 L5 -4 L7 -3 L8 -3 L6 -2 L6 7 M-8 7 L-6 7 L-4 8 L-3 9 L-1 8 L4 7 L6 7","-10 10 M-7 -10 L-5 -12 L-2 -11 L3 -11 L8 -12 M-6 -11 L-3 -10 L2 -10 L5 -11 M-7 -10 L-3 -9 L0 -9 L4 -10 L8 -12 M8 -12 L7 -10 L5 -7 L1 -3 L-1 0 L-2 3 L-2 6 L-1 9 M0 -1 L-1 2 L-1 5 L0 8 M3 -5 L1 -2 L0 1 L0 4 L1 7 L-1 9","-10 10 M-6 -9 L-6 -3 M-5 -8 L-5 -4 M-4 -9 L-4 -3 M-6 -9 L-4 -9 L1 -10 L3 -11 L4 -12 M1 -10 L2 -10 L4 -9 L4 -3 M3 -11 L5 -10 L5 -4 M4 -12 L5 -11 L7 -10 L8 -10 L6 -9 L6 -3 M-6 -3 L-4 -3 L4 0 L6 0 M6 -3 L4 -3 L-4 0 L-6 0 M-6 0 L-6 6 L-8 7 M-5 1 L-5 6 L-2 8 M-4 0 L-4 6 L-2 7 L-1 8 M4 0 L4 7 M5 1 L5 6 M6 0 L6 7 M-8 7 L-6 7 L-4 8 L-3 9 L-1 8 L4 7 L6 7","-10 10 M-6 -10 L-6 -1 L-8 0 M-5 -9 L-5 0 L-3 1 M-4 -10 L-4 -1 L-2 0 L-1 0 M-6 -10 L-4 -10 L1 -11 L3 -12 M1 -11 L2 -10 L4 -9 L4 7 M2 -11 L5 -9 L5 6 M3 -12 L4 -11 L6 -10 L8 -10 L6 -9 L6 7 M-8 0 L-7 0 L-5 1 L-4 2 L-3 1 L-1 0 L3 -1 L4 -1 M-7 7 L-5 6 L-3 6 L-1 7 L0 8 M-3 7 L-1 8 M-7 7 L-5 7 L-3 8 L-2 9 L0 8 L4 7 L6 7","-6 6 M0 -5 L-2 -3 L0 -2 L2 -3 L0 -5 M0 -4 L-1 -3 L1 -3 L0 -4 M0 6 L-2 8 L0 9 L2 8 L0 6 M0 7 L-1 8 L1 8 L0 7","-6 6 M0 -5 L-2 -3 L0 -2 L2 -3 L0 -5 M0 -4 L-1 -3 L1 -3 L0 -4 M0 12 L0 10 L-2 8 L0 6 L1 8 L1 10 L0 12 L-2 13 M0 7 L-1 8 L0 9 L0 7","-12 12 M8 -9 L-8 0 L8 9","-12 13 M-8 -5 L9 -5 L9 -4 M-8 -5 L-8 -4 L9 -4 M-8 3 L9 3 L9 4 M-8 3 L-8 4 L9 4","-12 12 M-8 -9 L8 0 L-8 9","-9 9 M-6 -8 L-5 -10 L-4 -11 L-1 -12 L1 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L3 -2 L1 -1 M-5 -8 L-4 -10 M4 -10 L5 -9 L5 -5 L4 -4 M-6 -8 L-4 -7 L-4 -9 L-3 -11 L-1 -12 M1 -12 L3 -11 L4 -9 L4 -5 L3 -3 L1 -1 M0 -1 L0 2 L1 -1 L-1 -1 L0 2 M0 6 L-2 8 L0 9 L2 8 L0 6 M0 7 L-1 8 L1 8 L0 7","-13 14 M5 -4 L4 -6 L2 -7 L-1 -7 L-3 -6 L-4 -5 L-5 -2 L-5 1 L-4 3 L-2 4 L1 4 L3 3 L4 1 M-1 -7 L-3 -5 L-4 -2 L-4 1 L-3 3 L-2 4 M5 -7 L4 1 L4 3 L6 4 L8 4 L10 2 L11 -1 L11 -3 L10 -6 L9 -8 L7 -10 L5 -11 L2 -12 L-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L2 9 L5 8 L7 7 L8 6 M6 -7 L5 1 L5 3 L6 4","-11 11 M-6 -9 L-4 -11 L-2 -12 L0 -12 L1 -11 L8 5 L9 6 L11 6 M-1 -11 L0 -10 L7 6 L8 8 L9 7 L7 6 M-4 -11 L-2 -11 L-1 -10 L6 6 L7 8 L8 9 L9 9 L11 6 M-6 -5 L-5 -6 L-3 -7 L-2 -7 L-1 -6 M-2 -6 L-2 -5 M-5 -6 L-3 -6 L-2 -4 M-11 9 L-9 7 L-7 6 L-4 6 L-2 7 M-8 7 L-4 7 L-3 8 M-11 9 L-8 8 L-5 8 L-4 9 L-2 7 M0 -8 L-6 6 M-4 1 L4 1","-12 12 M-10 -10 L-8 -12 L-5 -12 L-3 -11 L-1 -12 M-7 -11 L-4 -11 M-10 -10 L-8 -11 L-6 -10 L-3 -10 L-1 -12 M-5 -7 L-6 -6 L-7 -4 L-7 -3 L-9 -3 L-10 -2 L-10 0 L-9 -1 L-7 -1 L-7 5 M-6 -5 L-6 3 M-9 -2 L-6 -2 M-5 -7 L-5 2 L-6 4 L-7 5 M0 -9 L-1 -8 L-2 -6 L-2 3 M-1 -7 L-1 1 M0 -9 L0 0 L-1 2 L-2 3 M0 -9 L6 -12 L8 -11 L9 -9 L9 -7 L7 -5 L3 -3 M6 -11 L8 -9 L8 -7 M4 -11 L6 -10 L7 -9 L7 -6 L5 -4 M5 -4 L8 -2 L9 0 L9 6 M7 -2 L8 0 L8 5 M5 -4 L6 -3 L7 -1 L7 6 M-8 9 L-5 7 L-2 6 L2 6 L5 7 M-6 8 L-3 7 L2 7 L4 8 M-8 9 L-4 8 L1 8 L3 9 L5 7 L7 6 L9 6 M3 -3 L3 6 M3 0 L7 0 M3 3 L7 3","-13 11 M-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 1 L-9 4 L-8 6 L-5 8 L-2 9 L1 9 L4 8 L6 7 L8 5 L9 3 M-8 -7 L-9 -4 L-9 1 L-7 5 L-4 7 L-1 8 L2 8 L5 7 M-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 0 L-7 3 L-4 6 L-1 7 L2 7 L5 6 L7 5 L9 3 M-2 -8 L-2 4 M-1 -8 L-1 2 M0 -9 L0 1 L-1 3 L-2 4 M-2 -8 L0 -9 L3 -12 L5 -11 L7 -11 L8 -12 M2 -11 L4 -10 L6 -10 M1 -10 L3 -9 L5 -9 L7 -10 L8 -12 M5 -9 L5 6","-11 12 M-9 -12 L5 -12 L7 -11 L8 -9 L8 6 M-7 -11 L5 -11 L7 -9 L7 5 M-9 -12 L-8 -11 L-6 -10 L5 -10 L6 -9 L6 6 M-3 -7 L-4 -6 L-5 -4 L-5 -3 L-7 -3 L-8 -2 L-8 0 L-7 -1 L-5 -1 L-5 4 M-4 -5 L-4 2 M-7 -2 L-4 -2 M-3 -7 L-3 1 L-4 3 L-5 4 M-9 9 L-6 7 L-3 6 L1 6 L4 7 M-7 8 L-4 7 L1 7 L3 8 M-9 9 L-5 8 L0 8 L2 9 L4 7 L6 6 L8 6 M0 -10 L0 6 M0 -5 L2 -4 L4 -4 L6 -5 M0 1 L2 0 L4 0 L6 1","-11 11 M-9 -10 L-7 -12 L-5 -12 L-3 -11 L-1 -12 M-6 -11 L-4 -11 M-9 -10 L-7 -11 L-5 -10 L-3 -10 L-1 -12 M-4 -7 L-5 -6 L-6 -4 L-6 -3 L-8 -3 L-9 -2 L-9 0 L-8 -1 L-6 -1 L-6 5 M-5 -5 L-5 3 M-8 -2 L-5 -2 M-4 -7 L-4 2 L-5 4 L-6 5 M-1 -5 L0 -8 L1 -10 L2 -11 L4 -12 L6 -12 L9 -11 M2 -10 L4 -11 L6 -11 L8 -10 M0 -8 L1 -9 L3 -10 L5 -10 L7 -9 L9 -11 M-1 3 L0 0 L1 -2 L2 -3 L4 -3 L6 -2 M2 -2 L4 -2 L5 -1 M0 0 L1 -1 L3 -1 L4 0 L6 -2 M-7 9 L-4 7 L0 6 L5 6 L9 7 M-5 8 L-2 7 L5 7 L8 8 M-7 9 L-3 8 L4 8 L7 9 L9 7 M-1 -5 L-1 6","-12 11 M-8 -10 L-6 -12 L-3 -12 L-1 -11 L1 -12 M-5 -11 L-2 -11 M-8 -10 L-6 -11 L-4 -10 L-1 -10 L1 -12 M-2 -7 L-3 -6 L-4 -4 L-4 -3 L-6 -3 L-7 -2 L-7 0 L-6 -1 L-4 -1 L-4 4 M-3 -5 L-3 2 M-6 -2 L-3 -2 M-2 -7 L-2 1 L-3 3 L-4 4 M1 -8 L1 7 L0 8 L-1 8 L-5 6 L-7 6 L-9 7 L-11 9 M2 -8 L2 6 M2 -2 L6 -2 M-2 8 L-3 8 L-5 7 L-8 7 M3 -9 L3 -3 L6 -3 M6 -1 L3 -1 L3 5 L2 7 L-2 9 L-4 9 L-6 8 L-8 8 L-11 9 M1 -8 L3 -9 L6 -12 L8 -11 L10 -11 L11 -12 M5 -11 L7 -10 L9 -10 M4 -10 L6 -9 L8 -9 L10 -10 L11 -12 M6 -9 L6 5","-13 12 M-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L3 9 L6 8 L8 6 L9 4 L9 1 L8 -1 L7 -2 L5 -3 L3 -3 M-8 -7 L-9 -4 L-9 1 L-8 4 M-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 M7 6 L8 5 L8 1 L7 -1 M3 9 L5 8 L6 7 L7 5 L7 1 L6 -1 L5 -2 L3 -3 M-2 -8 L-2 5 M-1 -8 L-1 3 M0 -9 L0 2 L-1 4 L-2 5 M-2 -8 L0 -9 L3 -12 L5 -11 L7 -11 L8 -12 M2 -11 L4 -10 L6 -10 M1 -10 L3 -9 L5 -9 L7 -10 L8 -12 M7 -10 L3 -3 L3 9 M3 1 L7 1 M3 4 L7 4","-12 12 M-10 -10 L-8 -12 L-5 -12 L-3 -11 L-1 -12 M-7 -11 L-4 -11 M-10 -10 L-8 -11 L-6 -10 L-3 -10 L-1 -12 M-5 -7 L-6 -6 L-7 -4 L-7 -3 L-9 -3 L-10 -2 L-10 0 L-9 -1 L-7 -1 L-7 5 M-6 -5 L-6 3 M-9 -2 L-6 -2 M-5 -7 L-5 2 L-6 4 L-7 5 M-8 9 L-5 7 L-2 6 L1 6 L3 7 M-6 8 L-3 7 L0 7 L2 8 M-8 9 L-4 8 L-1 8 L1 9 L3 7 M0 -9 L-1 -8 L-2 -6 L-2 3 M-1 -7 L-1 1 M0 -9 L0 0 L-1 2 L-2 3 M0 -9 L2 -11 L4 -12 L6 -12 L8 -11 M5 -11 L6 -11 L7 -10 M2 -11 L4 -11 L6 -9 L8 -11 M3 -3 L5 -4 L7 -6 L8 -5 L9 -2 L9 2 L8 6 L6 9 M6 -5 L7 -4 L8 -2 L8 3 L7 6 M5 -4 L6 -4 L7 -2 L7 3 L6 9 M3 -3 L3 7 M3 0 L7 0 M3 3 L7 3","-9 10 M-6 -10 L-4 -12 L-1 -12 L2 -11 L4 -12 M-3 -11 L1 -11 M-6 -10 L-4 -11 L-1 -10 L2 -10 L4 -12 M1 -7 L0 -6 L-1 -4 L-1 -3 L-3 -3 L-4 -2 L-4 0 L-3 -1 L-1 -1 L-1 4 M0 -5 L0 2 M-3 -2 L0 -2 M1 -7 L1 1 L0 3 L-1 4 M7 -10 L5 -8 L4 -5 L4 6 L3 8 L1 8 L-3 6 L-5 6 L-7 7 L-9 9 M5 -7 L5 5 M0 8 L-1 8 L-3 7 L-6 7 M7 -10 L6 -8 L6 4 L5 6 L3 8 L1 9 L-2 9 L-4 8 L-7 8 L-9 9","-10 10 M-6 -10 L-4 -12 L-1 -12 L2 -11 L4 -12 M-3 -11 L1 -11 M-6 -10 L-4 -11 L-1 -10 L2 -10 L4 -12 M1 -7 L0 -6 L-1 -4 L-1 -3 L-3 -3 L-4 -2 L-4 0 L-3 -1 L-1 -1 L-1 4 M0 -5 L0 2 M-3 -2 L0 -2 M1 -7 L1 1 L0 3 L-1 4 M7 -10 L5 -8 L4 -5 L4 6 L3 8 M5 -7 L5 5 M7 -10 L6 -8 L6 4 L5 6 L3 8 L0 9 L-3 9 L-6 8 L-8 6 L-8 4 L-7 3 L-6 3 L-5 4 L-6 5 L-7 5 M-8 4 L-5 4","-12 12 M-10 -10 L-8 -12 L-5 -12 L-3 -11 L-1 -12 M-7 -11 L-4 -11 M-10 -10 L-8 -11 L-6 -10 L-3 -10 L-1 -12 M-5 -7 L-6 -6 L-7 -4 L-7 -3 L-9 -3 L-10 -2 L-10 0 L-9 -1 L-7 -1 L-7 5 M-6 -5 L-6 3 M-9 -2 L-6 -2 M-5 -7 L-5 2 L-6 4 L-7 5 M-8 9 L-5 7 L-2 6 L1 6 L3 7 M-6 8 L-4 7 L0 7 L2 8 M-8 9 L-4 8 L-1 8 L1 9 L3 7 M0 -9 L-1 -8 L-2 -6 L-2 3 M-1 -7 L-1 1 M0 -9 L0 0 L-1 2 L-2 3 M0 -9 L2 -11 L4 -12 L6 -12 L8 -11 M5 -11 L6 -11 L7 -10 M2 -11 L4 -11 L6 -9 L8 -11 M3 -3 L6 -6 L7 -5 L9 -4 M5 -5 L7 -4 L9 -4 M9 -4 L7 -1 L5 1 L3 3 M5 1 L7 2 L8 6 L9 8 L10 8 M7 4 L8 8 M5 1 L6 2 L7 8 L8 9 L9 9 L10 8 M3 -3 L3 7","-11 11 M-9 -10 L-7 -12 L-4 -12 L-2 -11 L0 -12 M-6 -11 L-3 -11 M-9 -10 L-7 -11 L-5 -10 L-2 -10 L0 -12 M-4 -7 L-5 -6 L-6 -4 L-6 -3 L-8 -3 L-9 -2 L-9 0 L-8 -1 L-6 -1 L-6 5 M-5 -5 L-5 3 M-8 -2 L-5 -2 M-4 -7 L-4 2 L-5 4 L-6 5 M-7 9 L-4 7 L0 6 L5 6 L9 7 M-5 8 L-2 7 L5 7 L8 8 M-7 9 L-3 8 L4 8 L7 9 L9 7 M1 -9 L0 -8 L-1 -6 L-1 3 M0 -7 L0 1 M1 -9 L1 0 L0 2 L-1 3 M1 -9 L3 -11 L5 -12 L7 -12 L9 -11 M6 -11 L7 -11 L8 -10 M3 -11 L5 -11 L7 -9 L9 -11 M5 -11 L5 6","-14 14 M-6 -8 L-7 -7 L-8 -5 L-8 -3 L-10 -3 L-11 -2 L-11 0 L-10 -1 L-8 -1 L-8 3 M-7 -6 L-7 1 M-10 -2 L-7 -2 M-6 -8 L-6 0 L-7 2 L-8 3 M-13 9 L-11 7 L-9 6 L-7 6 L-5 7 L-4 7 L-3 6 M-10 7 L-7 7 L-5 8 M-13 9 L-11 8 L-8 8 L-6 9 L-5 9 L-4 8 L-3 6 M-6 -8 L-2 -12 L2 -8 L2 5 L3 7 L4 7 M-2 -11 L1 -8 L1 6 L0 7 L1 8 L2 7 L1 6 M-2 -2 L1 -2 M-4 -10 L-3 -10 L0 -7 L0 -3 L-3 -3 M-3 -1 L0 -1 L0 6 L-1 7 L1 9 L4 7 L5 6 M2 -8 L6 -12 L10 -8 L10 5 L11 7 L12 7 M6 -11 L9 -8 L9 6 L11 8 M6 -2 L9 -2 M4 -10 L5 -10 L8 -7 L8 -3 L5 -3 M5 -1 L8 -1 L8 7 L10 9 L12 7 M-3 -10 L-3 6 M5 -10 L5 6","-13 12 M-11 -9 L-9 -11 L-7 -12 L-5 -12 L-3 -11 L-1 -8 L4 3 L6 6 L7 7 M-5 -11 L-3 -9 L-2 -7 L4 5 L7 8 M-9 -11 L-7 -11 L-5 -10 L-3 -7 L2 4 L4 7 L5 8 L7 9 M4 -10 L6 -9 L8 -9 L10 -10 L11 -12 M5 -11 L7 -10 L9 -10 M4 -10 L6 -12 L8 -11 L10 -11 L11 -12 M-7 -3 L-9 -3 L-10 -2 L-10 0 L-9 -1 L-7 -1 M-9 -2 L-7 -2 M-11 9 L-9 7 L-7 6 L-4 6 L-2 7 M-8 7 L-5 7 L-3 8 M-11 9 L-8 8 L-5 8 L-4 9 L-2 7 M-7 -11 L-7 6 M7 -9 L7 9 M0 -6 L1 -5 L3 -4 L5 -4 L7 -5 M-7 2 L-5 1 L-1 1 L1 2","-13 13 M-4 -12 L-6 -11 L-8 -9 L-9 -7 L-10 -4 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L1 9 L4 8 L6 7 L8 5 L9 3 L10 0 L10 -4 L9 -7 L8 -9 L6 -11 L4 -12 L3 -11 L0 -9 L-3 -8 M-8 -8 L-9 -5 L-9 1 L-8 4 M-4 -12 L-6 -10 L-7 -8 L-8 -5 L-8 1 L-7 4 L-6 6 L-4 8 M8 4 L9 1 L9 -5 L7 -9 L6 -10 M4 8 L6 6 L7 4 L8 1 L8 -5 L7 -7 L5 -10 L3 -11 M-3 -8 L-3 5 M-2 -8 L-2 3 M-1 -8 L-1 2 L-2 4 L-3 5 M3 -11 L3 8 M3 -5 L5 -4 L6 -4 L8 -5 M3 1 L5 0 L6 0 L8 1","-10 12 M-7 -12 L-6 -11 L-5 -9 L-5 -3 L-7 -3 L-8 -2 L-8 0 L-7 -1 L-5 -1 L-5 7 L-8 9 L-5 8 L-5 16 L-3 14 M-5 -10 L-4 -8 L-4 14 M-7 -2 L-4 -2 M-7 -12 L-5 -11 L-4 -10 L-3 -8 L-3 14 M-3 -7 L0 -9 L4 -12 L8 -8 L8 6 M4 -11 L7 -8 L7 6 M2 -10 L3 -10 L6 -7 L6 7 M0 6 L3 6 L6 7 M1 7 L3 7 L5 8 M0 8 L2 8 L4 9 L6 7 L8 6 M0 -9 L0 13 M0 -5 L2 -4 L4 -4 L6 -5 M0 1 L2 0 L4 0 L6 1","-13 13 M-4 -12 L-6 -11 L-8 -9 L-9 -7 L-10 -4 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-2 9 L2 9 L4 8 L6 7 L8 5 L9 3 L10 0 L10 -4 L9 -7 L8 -9 L6 -11 L4 -12 L3 -11 L0 -9 L-3 -8 M-8 -8 L-9 -5 L-9 1 L-8 4 M-4 -12 L-6 -10 L-7 -8 L-8 -5 L-8 1 L-7 4 L-6 6 L-4 8 M8 4 L9 1 L9 -5 L7 -9 L6 -10 M4 8 L6 6 L7 4 L8 1 L8 -5 L7 -7 L5 -10 L3 -11 M-3 -8 L-3 5 M-2 -8 L-2 3 M-1 -8 L-1 2 L-2 4 L-3 5 M3 -11 L3 8 M3 -5 L5 -4 L6 -4 L8 -5 M3 1 L5 0 L6 0 L8 1 M-2 9 L-1 8 L0 8 L2 9 L6 14 L8 15 L9 15 M2 10 L4 13 L6 15 L7 15 M0 8 L1 9 L4 15 L6 16 L8 16 L9 15","-12 12 M-10 -10 L-8 -12 L-5 -12 L-3 -11 L-1 -12 M-7 -11 L-4 -11 M-10 -10 L-8 -11 L-6 -10 L-3 -10 L-1 -12 M-5 -7 L-6 -6 L-7 -4 L-7 -3 L-9 -3 L-10 -2 L-10 0 L-9 -1 L-7 -1 L-7 5 M-6 -5 L-6 3 M-9 -2 L-6 -2 M-5 -7 L-5 2 L-6 4 L-7 5 M-8 9 L-5 7 L-2 6 L0 6 L3 7 M-6 8 L-4 7 L0 7 L2 8 M-8 9 L-4 8 L-1 8 L1 9 L3 7 M0 -9 L-1 -8 L-2 -6 L-2 3 M-1 -7 L-1 1 M0 -9 L0 0 L-1 2 L-2 3 M0 -9 L3 -11 L5 -12 L7 -11 L8 -9 L8 -6 L7 -4 L6 -3 L2 -1 L0 0 M5 -11 L6 -11 L7 -9 L7 -5 L6 -4 M3 -11 L5 -10 L6 -8 L6 -5 L5 -3 L2 -1 M2 -1 L4 0 L5 1 L8 6 L9 7 L10 7 M5 2 L7 6 L9 8 M2 -1 L4 1 L6 7 L8 9 L10 7","-11 12 M3 -9 L2 -10 L0 -11 L-3 -12 M4 -10 L2 -11 M5 -11 L1 -12 L-3 -12 L-6 -11 L-7 -10 L-8 -8 L-7 -6 L-6 -5 L-3 -4 L5 -4 L7 -3 L8 -2 L8 0 L7 3 M-7 -7 L-6 -6 L-3 -5 L6 -5 L8 -4 L9 -3 L9 -1 L8 1 M-7 -10 L-7 -8 L-6 -7 L-3 -6 L7 -6 L9 -5 L10 -3 L10 -1 L7 3 L3 9 M-9 -3 L-8 -2 L-6 -1 L3 -1 L4 0 L4 1 L3 3 M-8 -1 L-6 0 L2 0 L3 1 M-9 -3 L-9 -2 L-8 0 L-6 1 L1 1 L3 2 L3 3 M-9 9 L-6 7 L-2 6 L1 6 L4 7 M-7 8 L-4 7 L0 7 L3 8 M-9 9 L-5 8 L0 8 L3 9 M5 -11 L3 -9 L1 -6 M0 -4 L-2 -1 M-3 1 L-5 3 L-7 4 L-8 4 L-8 3 L-7 4","-13 11 M-8 -8 L-9 -6 L-10 -3 L-10 1 L-9 4 L-7 7 L-5 8 L-2 9 L1 9 L4 8 L6 7 L8 5 L9 3 M-9 1 L-8 4 L-6 6 L-4 7 L-1 8 L2 8 L5 7 M-8 -8 L-9 -5 L-9 -1 L-8 2 L-6 5 L-4 6 L-1 7 L2 7 L5 6 L7 5 L9 3 M-10 -9 L-9 -11 L-7 -12 L-3 -12 L3 -11 L7 -11 L9 -12 M-2 -11 L2 -10 L6 -10 M-10 -9 L-9 -10 L-7 -11 L-4 -11 L2 -9 L5 -9 L7 -10 L9 -12 M1 -9 L0 -8 L-2 -7 L-2 4 M-1 -7 L-1 2 M0 -8 L0 1 L-1 3 L-2 4 M5 -9 L5 6","-12 12 M-10 -10 L-8 -12 L-6 -12 L-3 -11 L-1 -12 M-7 -11 L-4 -11 M-10 -10 L-8 -11 L-5 -10 L-3 -10 L-1 -12 M-7 -8 L-8 -6 L-9 -3 L-9 1 L-8 4 L-7 6 L-5 8 L-2 9 L1 9 L4 8 L6 7 L8 9 L10 7 M-8 1 L-7 4 L-4 7 L-1 8 L2 8 M-7 -8 L-8 -4 L-8 -1 L-7 2 L-6 4 L-4 6 L-1 7 L3 7 L6 6 M3 -9 L-1 -8 L-2 -6 L-2 4 M-1 -7 L-1 2 M0 -8 L0 1 L-1 3 L-2 4 M3 -9 L5 -10 L7 -12 L8 -11 L10 -10 L8 -9 L8 5 L9 7 L10 7 M7 -9 L8 -10 L7 -11 L6 -10 L7 -9 L7 6 L9 8 M5 -10 L6 -9 L6 6 M3 -9 L3 7 M3 -4 L6 -4 M3 0 L6 0","-11 12 M-8 -12 L-7 -11 L-6 -9 L-6 -3 L-8 -3 L-9 -2 L-9 0 L-8 -1 L-6 -1 L-6 6 L-8 7 M-6 -10 L-5 -8 L-5 6 M-8 -2 L-5 -2 M-4 7 L-1 7 L1 8 M-8 -12 L-6 -11 L-5 -10 L-4 -8 L-4 6 L0 6 L3 7 M-8 7 L-5 7 L-2 8 L0 9 L3 7 L6 6 L8 6 M0 -8 L3 -9 L5 -10 L7 -12 L8 -11 L10 -10 L8 -9 L8 6 M7 -9 L8 -10 L7 -11 L6 -10 L7 -9 L7 5 M5 -10 L6 -9 L6 6 M0 -8 L0 6 M0 -5 L2 -4 L4 -4 L6 -5 M0 1 L2 0 L4 0 L6 1","-13 14 M-10 -12 L-9 -11 L-8 -9 L-8 -3 L-10 -3 L-11 -2 L-11 0 L-10 -1 L-8 -1 L-8 6 L-10 7 M-8 -10 L-7 -8 L-7 6 M-10 -2 L-7 -2 M-6 7 L-4 7 L-2 8 M-10 -12 L-8 -11 L-7 -10 L-6 -8 L-6 6 L-3 6 L-1 7 M-10 7 L-7 7 L-4 8 L-3 9 L-1 7 L2 6 L4 7 L5 9 L7 7 L10 6 M-3 -10 L0 -12 L2 -10 L2 6 L5 6 L7 7 M0 -11 L1 -10 L1 6 M-3 -10 L-1 -10 L0 -9 L0 6 L-1 7 M5 7 L6 8 M5 -10 L8 -12 L10 -10 L10 6 M8 -11 L9 -10 L9 6 M5 -10 L7 -10 L8 -9 L8 6 L7 7 M-3 -10 L-3 6 M5 -10 L5 6 M-3 -4 L0 -4 M-3 0 L0 0 M5 -4 L8 -4 M5 0 L8 0","-11 11 M-10 -9 L-8 -11 L-6 -12 L-4 -12 L-3 -11 L5 7 L6 8 L8 8 M-5 -11 L-4 -10 L4 7 L5 8 M-8 -11 L-6 -11 L-5 -10 L3 8 L4 9 L6 9 L8 8 L10 6 M5 -12 L7 -11 L9 -11 L10 -12 M5 -11 L6 -10 L8 -10 M4 -10 L5 -9 L7 -9 L9 -10 L10 -12 M-10 9 L-9 7 L-7 6 L-5 6 L-4 7 M-8 7 L-6 7 L-5 8 M-10 9 L-9 8 L-7 8 L-5 9 M5 -12 L1 -3 M-1 0 L-5 9 M-6 -2 L-2 -2 M1 -2 L6 -2","-11 12 M-8 -12 L-7 -11 L-6 -9 L-6 -3 L-8 -3 L-9 -2 L-9 0 L-8 -1 L-6 -1 L-6 6 L-8 7 M-6 -10 L-5 -8 L-5 6 M-8 -2 L-5 -2 M-4 7 L-1 7 L1 8 M-8 -12 L-6 -11 L-5 -10 L-4 -8 L-4 6 L0 6 L3 7 M-8 7 L-5 7 L-2 8 L0 9 L3 7 L6 6 M0 -8 L3 -9 L5 -10 L7 -12 L8 -11 L10 -10 L8 -9 L8 12 L7 14 L5 16 L3 15 L-1 14 L-6 14 M7 -9 L8 -10 L7 -11 L6 -10 L7 -9 L7 7 M5 -10 L6 -9 L6 6 L8 9 M6 15 L4 14 L1 14 M7 14 L4 13 L-2 13 L-6 14 M0 -8 L0 6 M0 -5 L2 -4 L4 -4 L6 -5 M0 1 L2 0 L4 0 L6 1","-10 10 M6 -11 L5 -9 L0 -3 L-3 1 L-5 5 L-8 9 M4 -7 L-4 4 M8 -12 L5 -8 L3 -4 L0 0 L-5 6 L-6 8 M-8 -10 L-6 -12 L-3 -11 L3 -11 L8 -12 M-7 -11 L-3 -10 L1 -10 L5 -11 M-8 -10 L-4 -9 L0 -9 L4 -10 L6 -11 M-6 8 L-4 7 L0 6 L4 6 L8 7 M-5 8 L-1 7 L3 7 L7 8 M-8 9 L-3 8 L3 8 L6 9 L8 7 M-5 -2 L-1 -2 M2 -2 L6 -2","-7 7 M-3 -16 L-3 16 M-2 -16 L-2 16 M-3 -16 L4 -16 M-3 16 L4 16","-7 7 M-7 -12 L7 12","-7 7 M2 -16 L2 16 M3 -16 L3 16 M-4 -16 L3 -16 M-4 16 L3 16","-11 11 M-8 2 L0 -3 L8 2 M-8 2 L0 -2 L8 2","-11 11 M-11 16 L11 16","-6 6 M-2 -12 L3 -6 M-2 -12 L-3 -11 L3 -6","-8 9 M-2 0 L-4 2 L-5 4 L-5 6 L-4 8 L-2 9 L0 7 L3 6 M-5 4 L-4 6 L-3 7 L-1 8 M-4 2 L-4 4 L-3 6 L-1 7 L0 7 M-4 -2 L-2 -2 L1 -3 L3 -4 L4 -5 L6 -3 L5 -2 L5 6 L6 7 L7 7 M-3 -4 L-4 -3 L-1 -3 M2 -3 L5 -3 L4 -4 L4 7 L5 8 M-5 -3 L-3 -5 L-2 -4 L0 -3 L3 -2 L3 7 L5 9 L7 7 M-5 -3 L0 2","-9 9 M-6 -10 L-5 -8 L-5 6 L-7 7 M-4 -8 L-5 -10 L-4 -11 L-4 6 L-1 8 M-6 -10 L-3 -12 L-3 6 L-1 7 L0 8 M-7 7 L-5 7 L-3 8 L-2 9 L0 8 L3 7 L5 7 M-3 -2 L0 -3 L2 -4 L3 -5 L4 -4 L6 -3 L7 -3 L5 -2 L5 7 M2 -4 L4 -3 L4 6 M0 -3 L1 -3 L3 -2 L3 7","-8 6 M-4 -3 L-4 6 L-6 7 L-5 7 L-3 8 L-2 9 M-3 -3 L-3 7 L-1 8 M-2 -3 L-2 6 L0 7 L1 7 L-1 8 L-2 9 M-4 -3 L0 -4 L2 -5 L3 -4 L5 -3 L6 -3 M1 -4 L2 -3 L4 -3 M-2 -3 L0 -4 L2 -2 L4 -2 L6 -3","-9 8 M0 -5 L-2 -4 L-5 -3 L-5 6 L-7 7 M-4 -3 L-4 6 L-1 8 M0 -5 L-3 -3 L-3 6 L-1 7 L0 8 M-7 7 L-5 7 L-3 8 L-2 9 L0 8 L3 7 L5 7 M-5 -10 L-2 -12 L-1 -9 L5 -3 L5 7 M-2 -9 L-4 -10 L-3 -11 L-2 -9 L4 -3 L4 6 M-5 -10 L3 -2 L3 7","-8 6 M-4 -3 L-4 6 L-6 7 L-5 7 L-3 8 L-2 9 M-3 -3 L-3 7 L-1 8 M-2 -3 L-2 6 L0 7 L1 7 L-1 8 L-2 9 M-4 -3 L0 -4 L2 -5 L5 -1 L3 0 L-2 3 M1 -4 L4 -1 M-2 -3 L0 -4 L3 0","-8 5 M-4 -10 L-4 6 L-6 7 L-5 7 L-3 8 L-2 9 M-3 -10 L-3 7 L-1 8 M-2 -10 L-2 6 L0 7 L1 7 L-1 8 L-2 9 M-4 -10 L-1 -11 L1 -12 L2 -11 L4 -10 L5 -10 M0 -11 L1 -10 L3 -10 M-2 -10 L-1 -11 L1 -9 L3 -9 L5 -10 M-7 -5 L-4 -5 M-2 -5 L2 -5","-9 9 M-5 -3 L-5 6 L-7 7 L-6 7 L-4 8 L-3 9 L-2 8 L0 7 L3 6 M-4 -2 L-4 7 L-2 8 M-3 -3 L-3 6 L-1 7 L0 7 M-5 -3 L-3 -3 L0 -4 L2 -5 L3 -4 L5 -3 L7 -3 L5 -2 L5 10 L4 13 L2 15 L0 16 L-1 15 L-3 14 L-5 14 M1 -4 L4 -2 L4 10 M1 15 L-1 14 L-2 14 M0 -4 L1 -3 L3 -2 L3 8 L4 11 L4 13 M2 15 L1 14 L-1 13 L-3 13 L-5 14","-9 9 M-6 -10 L-5 -8 L-5 6 L-7 7 L-6 7 L-4 8 L-3 9 M-4 -8 L-5 -10 L-4 -11 L-4 7 L-2 8 M-6 -10 L-3 -12 L-3 6 L-1 7 L-3 9 M-3 -2 L0 -3 L2 -4 L3 -5 L4 -4 L6 -3 L7 -3 L5 -2 L5 7 L3 9 L2 11 M2 -4 L4 -3 L4 7 L3 9 M0 -3 L1 -3 L3 -2 L3 7 L2 11 L2 14 L3 16 L4 16 L2 14","-5 5 M0 -12 L-2 -10 L0 -9 L2 -10 L0 -12 M0 -11 L-1 -10 L1 -10 L0 -11 M0 -5 L-1 -4 L-3 -3 L-1 -2 L-1 7 L1 9 L3 7 M0 -2 L1 -3 L0 -4 L-1 -3 L0 -2 L0 7 L1 8 M0 -5 L1 -4 L3 -3 L1 -2 L1 6 L2 7 L3 7","-5 5 M0 -12 L-2 -10 L0 -9 L2 -10 L0 -12 M0 -11 L-1 -10 L1 -10 L0 -11 M0 -5 L-1 -4 L-3 -3 L-1 -2 L-1 7 L1 9 L2 11 M0 -2 L1 -3 L0 -4 L-1 -3 L0 -2 L0 7 L1 9 M0 -5 L1 -4 L3 -3 L1 -2 L1 7 L2 11 L2 14 L0 16 L-2 16 L-2 15 L0 16","-9 8 M-6 -10 L-5 -8 L-5 6 L-7 7 L-6 7 L-4 8 L-3 9 M-4 -8 L-5 -10 L-4 -11 L-4 7 L-2 8 M-6 -10 L-3 -12 L-3 6 L-1 7 L-3 9 M-3 -2 L0 -4 L2 -5 L4 -2 L1 0 L-3 3 M1 -4 L3 -2 M0 -4 L2 -1 M1 0 L2 1 L4 6 L5 7 L6 7 M1 1 L2 2 L3 7 L4 8 M0 1 L1 2 L2 7 L4 9 L6 7","-5 5 M-2 -10 L-1 -8 L-1 6 L-3 7 L-2 7 L0 8 L1 9 M0 -8 L-1 -10 L0 -11 L0 7 L2 8 M-2 -10 L1 -12 L1 6 L3 7 L4 7 L2 8 L1 9","-13 13 M-11 -3 L-10 -3 L-9 -2 L-9 6 L-11 7 L-10 7 L-8 8 L-7 9 M-9 -4 L-8 -3 L-8 7 L-6 8 M-11 -3 L-9 -5 L-7 -3 L-7 6 L-5 7 L-7 9 M-7 -2 L-4 -3 L-2 -4 L-1 -5 L1 -3 L1 6 L3 7 L1 9 M-2 -4 L0 -3 L0 7 L2 8 M-4 -3 L-3 -3 L-1 -2 L-1 6 L-2 7 L0 8 L1 9 M1 -2 L4 -3 L6 -4 L7 -5 L8 -4 L10 -3 L11 -3 L9 -2 L9 6 L10 7 L11 7 M6 -4 L8 -3 L8 7 L9 8 M4 -3 L5 -3 L7 -2 L7 7 L9 9 L11 7","-9 9 M-7 -3 L-6 -3 L-5 -2 L-5 6 L-7 7 L-6 7 L-4 8 L-3 9 M-5 -4 L-4 -3 L-4 7 L-2 8 M-7 -3 L-5 -5 L-3 -3 L-3 6 L-1 7 L-3 9 M-3 -2 L0 -3 L2 -4 L3 -5 L4 -4 L6 -3 L7 -3 L5 -2 L5 6 L6 7 L7 7 M2 -4 L4 -3 L4 7 L5 8 M0 -3 L1 -3 L3 -2 L3 7 L5 9 L7 7","-9 9 M-5 -3 L-5 6 L-7 7 M-4 -2 L-4 6 L-1 8 M-3 -3 L-3 6 L-1 7 L0 8 M-7 7 L-5 7 L-3 8 L-2 9 L0 8 L3 7 L5 7 M-5 -3 L-3 -3 L0 -4 L2 -5 L3 -4 L5 -3 L7 -3 L5 -2 L5 7 M1 -4 L4 -2 L4 6 M0 -4 L1 -3 L3 -2 L3 7","-9 9 M-6 -5 L-5 -3 L-5 6 L-7 7 L-5 7 L-5 16 M-5 -4 L-4 -3 L-4 15 L-3 14 L-4 12 M-4 7 L-3 7 L-1 8 M-6 -5 L-4 -4 L-3 -3 L-3 6 L-1 7 L0 8 M-3 8 L-2 9 L0 8 L3 7 L5 7 M-3 8 L-3 12 L-2 14 L-5 16 M-3 -2 L0 -3 L2 -4 L3 -5 L4 -4 L6 -3 L7 -3 L5 -2 L5 7 M2 -4 L4 -3 L4 6 M0 -3 L1 -3 L3 -2 L3 7","-9 9 M-5 -3 L-5 6 L-7 7 M-4 -2 L-4 7 L-2 8 M-3 -3 L-3 6 L-1 7 L0 7 M-7 7 L-6 7 L-4 8 L-3 9 L-2 8 L0 7 L3 6 M-5 -3 L-3 -3 L0 -4 L2 -5 L3 -4 L5 -3 L7 -3 L5 -2 L5 16 M1 -4 L4 -2 L4 15 L3 14 L4 12 M0 -4 L1 -3 L3 -2 L3 12 L2 14 L5 16","-8 6 M-6 -3 L-5 -3 L-4 -2 L-4 6 L-6 7 L-5 7 L-3 8 L-2 9 M-5 -4 L-3 -3 L-3 7 L-1 8 M-6 -3 L-4 -5 L-2 -3 L-2 6 L0 7 L1 7 L-1 8 L-2 9 M-2 -3 L2 -5 L3 -4 L5 -3 L6 -3 M1 -4 L2 -3 L4 -3 M0 -4 L2 -2 L4 -2 L6 -3","-8 8 M-5 -3 L-5 1 L-3 2 L3 2 L5 3 L5 7 M-4 -3 L-4 1 M4 3 L4 7 M-2 -4 L-3 -3 L-3 1 L-1 2 M1 2 L3 3 L3 7 L2 8 M-5 -3 L-2 -4 L0 -5 L2 -4 L4 -4 L5 -5 M-1 -4 L1 -4 M-2 -4 L0 -3 L2 -3 L4 -4 M5 7 L2 8 L0 9 L-2 8 L-4 8 L-6 9 M1 8 L-1 8 M2 8 L0 7 L-3 7 L-6 9 M5 -5 L4 -3 L2 0 L-3 5 L-6 9","-5 5 M-2 -10 L-1 -8 L-1 6 L-3 7 L-2 7 L0 8 L1 9 M0 -8 L-1 -10 L0 -11 L0 7 L2 8 M-2 -10 L1 -12 L1 6 L3 7 L4 7 L2 8 L1 9 M-4 -5 L-1 -5 M1 -5 L4 -5","-9 9 M-7 -3 L-6 -3 L-5 -2 L-5 6 L-7 7 M-6 -4 L-4 -3 L-4 7 L-2 8 M-7 -3 L-5 -5 L-3 -3 L-3 6 L-1 7 L0 7 M-7 7 L-6 7 L-4 8 L-3 9 L-2 8 L0 7 L3 6 M3 -5 L4 -4 L6 -3 L7 -3 L5 -2 L5 6 L6 7 L7 7 M2 -4 L4 -3 L4 7 L5 8 M3 -5 L1 -3 L3 -2 L3 7 L5 9 L7 7","-9 9 M-6 -5 L-5 -3 L-5 6 L-2 9 L0 7 L3 6 L5 6 M-5 -4 L-4 -3 L-4 6 L-1 8 M-6 -5 L-4 -4 L-3 -3 L-3 5 L-2 6 L0 7 M3 -5 L4 -4 L6 -3 L7 -3 L5 -2 L5 6 M2 -4 L4 -3 L4 5 M3 -5 L1 -3 L3 -2 L3 6","-13 13 M-10 -5 L-9 -3 L-9 6 L-6 9 L-4 7 L-1 6 M-9 -4 L-8 -3 L-8 6 L-5 8 M-10 -5 L-8 -4 L-7 -3 L-7 5 L-6 6 L-4 7 M-1 -5 L-3 -3 L-1 -2 L-1 6 L2 9 L4 7 L7 6 L9 6 M-2 -4 L0 -3 L0 6 L3 8 M-1 -5 L0 -4 L2 -3 L1 -2 L1 5 L2 6 L4 7 M7 -5 L8 -4 L10 -3 L11 -3 L9 -2 L9 6 M6 -4 L8 -3 L8 5 M7 -5 L5 -3 L7 -2 L7 6","-10 9 M-7 -3 L-6 -3 L-4 -2 L-3 -1 L1 7 L2 8 L4 9 L6 7 M-5 -4 L-3 -3 L2 7 L4 8 M-7 -3 L-5 -5 L-3 -4 L-2 -3 L2 5 L3 6 L5 7 L6 7 M0 1 L3 -5 L4 -4 L6 -4 L7 -5 M3 -4 L4 -3 L5 -3 M2 -3 L4 -2 L6 -3 L7 -5 M-1 3 L-4 9 L-5 8 L-7 8 L-8 9 M-4 8 L-5 7 L-6 7 M-3 7 L-5 6 L-7 7 L-8 9 M-5 2 L-2 2 M1 2 L4 2","-9 9 M-7 -3 L-6 -3 L-5 -2 L-5 6 L-7 7 M-6 -4 L-4 -3 L-4 7 L-2 8 M-7 -3 L-5 -5 L-3 -3 L-3 6 L-1 7 L0 7 M-7 7 L-6 7 L-4 8 L-3 9 L-2 8 L0 7 L3 6 M3 -5 L4 -4 L6 -3 L7 -3 L5 -2 L5 10 L4 13 L2 15 L0 16 L-1 15 L-3 14 L-5 14 M2 -4 L4 -3 L4 10 M1 15 L-1 14 L-2 14 M3 -5 L1 -3 L3 -2 L3 8 L4 11 L4 13 M2 15 L1 14 L-1 13 L-3 13 L-5 14","-9 9 M6 -5 L-6 9 M-6 -3 L-4 -2 L-1 -2 L2 -3 L6 -5 M-5 -4 L-3 -3 L1 -3 M-6 -3 L-4 -5 L-2 -4 L2 -4 L6 -5 M-6 9 L-2 7 L1 6 L4 6 L6 7 M-1 7 L3 7 L5 8 M-6 9 L-2 8 L2 8 L4 9 L6 7 M-4 2 L4 2","-7 7 M2 -16 L0 -15 L-1 -14 L-2 -12 L-2 -10 L-1 -8 L0 -7 L1 -5 L1 -3 L-1 -1 M0 -15 L-1 -13 L-1 -11 L0 -9 L1 -8 L2 -6 L2 -4 L1 -2 L-3 0 L1 2 L2 4 L2 6 L1 8 L0 9 L-1 11 L-1 13 L0 15 M-1 1 L1 3 L1 5 L0 7 L-1 8 L-2 10 L-2 12 L-1 14 L0 15 L2 16","-4 4 M0 -16 L0 16","-7 7 M-2 -16 L0 -15 L1 -14 L2 -12 L2 -10 L1 -8 L0 -7 L-1 -5 L-1 -3 L1 -1 M0 -15 L1 -13 L1 -11 L0 -9 L-1 -8 L-2 -6 L-2 -4 L-1 -2 L3 0 L-1 2 L-2 4 L-2 6 L-1 8 L0 9 L1 11 L1 13 L0 15 M1 1 L-1 3 L-1 5 L0 7 L1 8 L2 10 L2 12 L1 14 L0 15 L-2 16","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3","-8 8 M-8 -12 L-8 9 L-7 9 L-7 -12 L-6 -12 L-6 9 L-5 9 L-5 -12 L-4 -12 L-4 9 L-3 9 L-3 -12 L-2 -12 L-2 9 L-1 9 L-1 -12 L0 -12 L0 9 L1 9 L1 -12 L2 -12 L2 9 L3 9 L3 -12 L4 -12 L4 9 L5 9 L5 -12 L6 -12 L6 9 L7 9 L7 -12 L8 -12 L8 9"],
    :gothicger => ["-8 8","-6 6 M0 -12 L-1 -11 L-3 -10 L-1 -9 L0 2 M0 -9 L1 -10 L0 -11 L-1 -10 L0 -9 L0 2 M0 -12 L1 -11 L3 -10 L1 -9 L0 2 M0 6 L-2 8 L0 9 L2 8 L0 6 M0 7 L-1 8 L1 8 L0 7","-9 9 M-4 -12 L-5 -11 L-5 -5 M-4 -11 L-5 -5 M-4 -12 L-3 -11 L-5 -5 M5 -12 L4 -11 L4 -5 M5 -11 L4 -5 M5 -12 L6 -11 L4 -5","-10 11 M1 -16 L-6 16 M7 -16 L0 16 M-6 -3 L8 -3 M-7 3 L7 3","-10 10 M-2 -16 L-2 13 M2 -16 L2 13 M2 -12 L4 -11 L5 -9 L5 -7 L7 -8 L6 -10 L5 -11 L2 -12 L-2 -12 L-5 -11 L-7 -9 L-7 -6 L-6 -4 L-3 -2 L3 0 L5 1 L6 3 L6 6 L5 8 M6 -8 L5 -10 M-6 -6 L-5 -4 L-3 -3 L3 -1 L5 0 L6 2 M-5 7 L-6 5 M-5 -11 L-6 -9 L-6 -7 L-5 -5 L-3 -4 L3 -2 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-2 9 L-5 8 L-6 7 L-7 5 L-5 4 L-5 6 L-4 8 L-2 9","-12 12 M9 -12 L-9 9 M-4 -12 L-2 -10 L-2 -8 L-3 -6 L-5 -5 L-7 -5 L-9 -7 L-9 -9 L-8 -11 L-6 -12 L-4 -12 L-2 -11 L1 -10 L4 -10 L7 -11 L9 -12 M5 2 L3 3 L2 5 L2 7 L4 9 L6 9 L8 8 L9 6 L9 4 L7 2 L5 2","-13 13 M7 -4 L8 -3 L9 -3 L10 -4 M6 -3 L7 -2 L9 -2 M6 -2 L7 -1 L8 -1 L9 -2 L10 -4 M7 -4 L1 2 M0 3 L-6 9 L-10 4 L-4 -2 M-3 -3 L1 -7 L-3 -12 L-8 -6 L-2 0 L2 6 L4 8 L6 9 L8 9 L9 8 L10 6 M-6 8 L-9 4 M0 -7 L-3 -11 M-7 -6 L-2 -1 L2 5 L4 7 L6 8 L9 8 M-5 8 L-9 3 M0 -6 L-4 -11 M-7 -7 L-1 -1 L3 5 L4 6 L6 7 L9 7 L10 6","-4 5 M1 -12 L0 -11 L0 -5 M1 -11 L0 -5 M1 -12 L2 -11 L0 -5","-7 7 M3 -16 L1 -14 L-1 -11 L-3 -7 L-4 -2 L-4 2 L-3 7 L-1 11 L1 14 L3 16 M-1 -10 L-2 -7 L-3 -3 L-3 3 L-2 7 L-1 10 M1 -14 L0 -12 L-1 -9 L-2 -3 L-2 3 L-1 9 L0 12 L1 14","-7 7 M-3 -16 L-1 -14 L1 -11 L3 -7 L4 -2 L4 2 L3 7 L1 11 L-1 14 L-3 16 M1 -10 L2 -7 L3 -3 L3 3 L2 7 L1 10 M-1 -14 L0 -12 L1 -9 L2 -3 L2 3 L1 9 L0 12 L-1 14","-8 8 M0 -12 L-1 -11 L1 -1 L0 0 M0 -12 L0 0 M0 -12 L1 -11 L-1 -1 L0 0 M-5 -9 L-4 -9 L4 -3 L5 -3 M-5 -9 L5 -3 M-5 -9 L-5 -8 L5 -4 L5 -3 M5 -9 L4 -9 L-4 -3 L-5 -3 M5 -9 L-5 -3 M5 -9 L5 -8 L-5 -4 L-5 -3","-12 13 M0 -9 L0 8 L1 8 M0 -9 L1 -9 L1 8 M-8 -1 L9 -1 L9 0 M-8 -1 L-8 0 L9 0","-6 6 M0 12 L0 10 L-2 8 L0 6 L1 8 L1 10 L0 12 L-2 13 M0 7 L-1 8 L0 9 L0 7","-13 13 M-9 0 L9 0","-6 6 M0 6 L-2 8 L0 9 L2 8 L0 6 M0 7 L-1 8 L1 8 L0 7","-11 12 M9 -16 L-9 16 L-8 16 M9 -16 L10 -16 L-8 16","-10 10 M-6 -10 L-6 6 L-8 7 M-5 -9 L-5 6 L-2 8 M-4 -10 L-4 6 L-2 7 L-1 8 M-6 -10 L-4 -10 L1 -11 L3 -12 M1 -11 L2 -10 L4 -9 L4 7 M2 -11 L5 -9 L5 6 M3 -12 L4 -11 L6 -10 L8 -10 L6 -9 L6 7 M-8 7 L-6 7 L-4 8 L-3 9 L-1 8 L4 7 L6 7","-10 10 M-3 -10 L-2 -9 L-1 -7 L-1 6 L-3 7 M-1 -9 L-2 -10 L-1 -11 L0 -9 L0 7 L2 8 M-3 -10 L0 -12 L1 -10 L1 6 L3 7 L4 7 M-3 7 L-2 7 L0 8 L1 9 L2 8 L4 7","-10 10 M-6 -10 L-4 -10 L-2 -11 L-1 -12 L1 -11 L4 -10 L6 -10 M-2 -10 L0 -11 M-6 -10 L-4 -9 L-2 -9 L0 -10 L1 -11 M4 -10 L4 -2 M5 -9 L5 -3 M6 -10 L6 -2 L-1 -2 L-4 -1 L-6 1 L-7 4 L-7 9 M-7 9 L-3 7 L1 6 L4 6 L8 7 M-4 8 L-1 7 L4 7 L7 8 M-7 9 L-2 8 L3 8 L6 9 L8 7","-10 10 M-6 -10 L-5 -10 L-3 -11 L-2 -12 L0 -11 L4 -10 L6 -10 M-3 -10 L-1 -11 M-6 -10 L-4 -9 L-2 -9 L0 -11 M4 -10 L4 -3 M5 -9 L5 -4 M6 -10 L6 -3 L4 -3 L1 -2 L-1 -1 M-1 -2 L1 -1 L4 0 L6 0 L6 7 M5 1 L5 6 M4 0 L4 7 M-7 7 L-5 6 L-3 6 L-1 7 L0 8 M-3 7 L-1 8 M-7 7 L-5 7 L-3 8 L-2 9 L0 8 L4 7 L6 7","-10 10 M3 -12 L-7 -2 L-7 3 L2 3 M4 3 L8 3 L9 4 L9 2 L8 3 M-6 -2 L-6 2 M-5 -4 L-5 3 M2 -11 L2 6 L0 7 M3 -8 L4 -10 L3 -11 L3 7 L5 8 M3 -12 L5 -10 L4 -8 L4 6 L6 7 L7 7 M0 7 L1 7 L3 8 L4 9 L5 8 L7 7","-10 10 M-6 -12 L-6 -3 M-6 -12 L6 -12 M-5 -11 L4 -11 M-6 -10 L3 -10 L5 -11 L6 -12 M4 -6 L3 -5 L1 -4 L-3 -3 L-6 -3 M1 -4 L2 -4 L4 -3 L4 7 M3 -5 L5 -4 L5 6 M4 -6 L5 -5 L7 -4 L8 -4 L6 -3 L6 7 M-7 7 L-5 6 L-3 6 L-1 7 L0 8 M-3 7 L-1 8 M-7 7 L-5 7 L-3 8 L-2 9 L0 8 L4 7 L6 7","-10 10 M-6 -10 L-6 6 L-8 7 M-5 -9 L-5 6 L-2 8 M-4 -10 L-4 6 L-2 7 L-1 8 M-6 -10 L-4 -10 L0 -11 L2 -12 L3 -11 L5 -10 L6 -10 M1 -11 L3 -10 M0 -11 L2 -9 L4 -9 L6 -10 M-4 -2 L-3 -2 L1 -3 L3 -4 L4 -5 M1 -3 L2 -3 L4 -2 L4 7 M3 -4 L5 -2 L5 6 M4 -5 L5 -4 L7 -3 L8 -3 L6 -2 L6 7 M-8 7 L-6 7 L-4 8 L-3 9 L-1 8 L4 7 L6 7","-10 10 M-7 -10 L-5 -12 L-2 -11 L3 -11 L8 -12 M-6 -11 L-3 -10 L2 -10 L5 -11 M-7 -10 L-3 -9 L0 -9 L4 -10 L8 -12 M8 -12 L7 -10 L5 -7 L1 -3 L-1 0 L-2 3 L-2 6 L-1 9 M0 -1 L-1 2 L-1 5 L0 8 M3 -5 L1 -2 L0 1 L0 4 L1 7 L-1 9","-10 10 M-6 -9 L-6 -3 M-5 -8 L-5 -4 M-4 -9 L-4 -3 M-6 -9 L-4 -9 L1 -10 L3 -11 L4 -12 M1 -10 L2 -10 L4 -9 L4 -3 M3 -11 L5 -10 L5 -4 M4 -12 L5 -11 L7 -10 L8 -10 L6 -9 L6 -3 M-6 -3 L-4 -3 L4 0 L6 0 M6 -3 L4 -3 L-4 0 L-6 0 M-6 0 L-6 6 L-8 7 M-5 1 L-5 6 L-2 8 M-4 0 L-4 6 L-2 7 L-1 8 M4 0 L4 7 M5 1 L5 6 M6 0 L6 7 M-8 7 L-6 7 L-4 8 L-3 9 L-1 8 L4 7 L6 7","-10 10 M-6 -10 L-6 -1 L-8 0 M-5 -9 L-5 0 L-3 1 M-4 -10 L-4 -1 L-2 0 L-1 0 M-6 -10 L-4 -10 L1 -11 L3 -12 M1 -11 L2 -10 L4 -9 L4 7 M2 -11 L5 -9 L5 6 M3 -12 L4 -11 L6 -10 L8 -10 L6 -9 L6 7 M-8 0 L-7 0 L-5 1 L-4 2 L-3 1 L-1 0 L3 -1 L4 -1 M-7 7 L-5 6 L-3 6 L-1 7 L0 8 M-3 7 L-1 8 M-7 7 L-5 7 L-3 8 L-2 9 L0 8 L4 7 L6 7","-6 6 M0 -5 L-2 -3 L0 -2 L2 -3 L0 -5 M0 -4 L-1 -3 L1 -3 L0 -4 M0 6 L-2 8 L0 9 L2 8 L0 6 M0 7 L-1 8 L1 8 L0 7","-6 6 M0 -5 L-2 -3 L0 -2 L2 -3 L0 -5 M0 -4 L-1 -3 L1 -3 L0 -4 M0 12 L0 10 L-2 8 L0 6 L1 8 L1 10 L0 12 L-2 13 M0 7 L-1 8 L0 9 L0 7","-12 12 M8 -9 L-8 0 L8 9","-12 13 M-8 -5 L9 -5 L9 -4 M-8 -5 L-8 -4 L9 -4 M-8 3 L9 3 L9 4 M-8 3 L-8 4 L9 4","-12 12 M-8 -9 L8 0 L-8 9","-9 9 M-6 -8 L-5 -10 L-4 -11 L-1 -12 L1 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L3 -2 L1 -1 M-5 -8 L-4 -10 M4 -10 L5 -9 L5 -5 L4 -4 M-6 -8 L-4 -7 L-4 -9 L-3 -11 L-1 -12 M1 -12 L3 -11 L4 -9 L4 -5 L3 -3 L1 -1 M0 -1 L0 2 L1 -1 L-1 -1 L0 2 M0 6 L-2 8 L0 9 L2 8 L0 6 M0 7 L-1 8 L1 8 L0 7","-13 14 M5 -4 L4 -6 L2 -7 L-1 -7 L-3 -6 L-4 -5 L-5 -2 L-5 1 L-4 3 L-2 4 L1 4 L3 3 L4 1 M-1 -7 L-3 -5 L-4 -2 L-4 1 L-3 3 L-2 4 M5 -7 L4 1 L4 3 L6 4 L8 4 L10 2 L11 -1 L11 -3 L10 -6 L9 -8 L7 -10 L5 -11 L2 -12 L-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L2 9 L5 8 L7 7 L8 6 M6 -7 L5 1 L5 3 L6 4","-12 12 M-9 -10 L-8 -9 L-9 -8 L-10 -9 L-9 -11 L-7 -12 L-5 -12 L-3 -11 L-2 -10 L-1 -7 L-1 -3 L-2 0 L-4 2 L-6 3 L-9 4 M-3 -10 L-2 -7 L-2 -2 L-3 0 M-5 -12 L-4 -11 L-3 -8 L-3 -2 L-4 1 L-6 3 M-6 4 L-3 7 M-7 4 L-3 8 M-9 4 L-4 9 L3 4 M10 -11 L9 -10 L10 -10 L10 -11 L9 -12 L7 -12 L5 -11 L4 -10 L3 -8 L3 7 L5 9 L9 5 M5 -10 L4 -8 L4 6 L6 8 M7 -12 L6 -11 L5 -8 L5 5 L7 7","-13 13 M-11 -1 L-11 0 L-10 1 L-8 1 L-6 0 L-6 -3 L-7 -5 L-9 -8 L-9 -10 L-7 -12 M-7 -3 L-9 -7 M-8 1 L-7 0 L-7 -2 L-9 -5 L-10 -7 L-10 -9 L-9 -11 L-7 -12 L-4 -12 L-2 -11 L-1 -10 L0 -8 L0 0 L-1 3 L-3 5 M-2 -10 L-1 -8 L-1 2 M-4 -12 L-3 -11 L-2 -8 L-2 3 L-3 5 M0 -9 L1 -11 L3 -12 L5 -12 L7 -11 L8 -10 L9 -8 L10 -7 M7 -10 L8 -8 M5 -12 L6 -11 L7 -8 L8 -7 L10 -7 M10 -7 L0 -2 M7 -5 L9 -3 L10 0 L10 3 L9 6 L7 8 L4 9 L1 9 L-2 8 L-8 5 L-9 5 L-10 6 M6 -4 L7 -4 L9 -2 M4 -4 L7 -3 L9 -1 L10 1 M2 8 L0 8 L-6 5 L-7 5 M8 7 L6 8 L3 8 L0 7 L-4 5 L-7 4 L-9 4 L-10 6 L-10 8 L-9 9 L-8 8 L-9 7","-12 12 M0 -10 L-2 -12 L-4 -12 L-6 -11 L-8 -8 L-9 -4 L-9 0 L-8 4 L-6 7 L-4 8 L-1 9 L2 9 L5 8 L7 7 L9 5 M-6 -10 L-7 -8 L-8 -5 L-8 0 L-7 4 L-5 7 L-2 8 M-4 -12 L-5 -11 L-6 -9 L-7 -5 L-7 -1 L-6 3 L-5 5 L-3 7 L0 8 L3 8 L6 7 L9 5 M3 -12 L0 -10 L-1 -9 L-2 -7 L-2 -6 L-1 -4 L2 -2 L3 0 L3 2 M-1 -7 L-1 -6 L3 -2 L3 -1 M-1 -9 L-1 -8 L0 -6 L3 -4 L4 -2 L4 0 L3 2 L1 3 L0 3 L-2 2 L-3 0 M3 -12 L4 -11 L6 -10 L8 -10 M3 -11 L4 -10 L5 -10 M2 -11 L4 -9 L6 -9 L8 -10 L9 -11","-13 13 M-10 -6 L-10 -7 L-9 -9 L-7 -11 L-4 -12 L0 -12 L3 -11 L5 -10 L7 -8 L9 -5 L10 -1 L10 3 L9 6 L7 8 L4 9 L1 9 L-2 8 L-8 5 L-9 5 L-10 6 M-7 -10 L-5 -11 L0 -11 L3 -10 L5 -9 L7 -7 L9 -4 M2 8 L0 8 L-6 5 L-7 5 M-10 -7 L-8 -9 L-5 -10 L0 -10 L3 -9 L5 -8 L7 -6 L9 -3 L10 0 M8 7 L6 8 L3 8 L0 7 L-4 5 L-7 4 L-9 4 L-10 6 L-10 8 L-9 9 L-8 8 L-9 7 M-2 -10 L-5 -7 L-6 -5 L-6 -3 L-4 1 L-4 3 M-5 -4 L-5 -3 L-4 -1 L-4 0 M-5 -7 L-5 -5 L-3 -1 L-3 1 L-4 3 L-5 4 L-7 4 L-8 3 L-8 2","-12 12 M0 -10 L-2 -12 L-4 -12 L-6 -11 L-8 -8 L-9 -4 L-9 0 L-8 4 L-6 7 L-4 8 L-1 9 L2 9 L5 8 L7 7 L9 5 M-6 -10 L-7 -8 L-8 -5 L-8 0 L-7 4 L-5 7 L-2 8 M-4 -12 L-5 -11 L-6 -9 L-7 -5 L-7 -1 L-6 3 L-5 5 L-3 7 L0 8 L3 8 L6 7 L9 5 M3 -12 L0 -10 L-1 -9 L-2 -7 L-2 -6 L-1 -4 L2 -2 L3 0 L3 2 M-1 -7 L-1 -6 L3 -2 L3 -1 M-1 -9 L-1 -8 L0 -6 L3 -4 L4 -2 L4 0 L3 2 L1 3 L0 3 L-2 2 L-3 0 M3 -12 L4 -11 L6 -10 L8 -10 M3 -11 L4 -10 L5 -10 M2 -11 L4 -9 L6 -9 L8 -10 L9 -11 M3 -4 L7 -7 M7 -7 L8 -6 L10 -6 M6 -6 L7 -5 L8 -5 M5 -5 L6 -4 L8 -4 L10 -6","-12 12 M-5 -4 L-7 -5 L-8 -7 L-8 -9 L-7 -11 L-4 -12 L-1 -12 L2 -11 L6 -9 M-7 -10 L-5 -11 L0 -11 L3 -10 M-8 -7 L-7 -9 L-5 -10 L0 -10 L6 -9 L8 -9 L9 -10 L9 -11 L8 -12 L7 -12 M1 -10 L0 -9 L-1 -7 L-1 -5 L0 -3 L4 1 L5 4 L5 7 L4 10 L3 11 L1 12 M2 -2 L5 1 L6 4 L6 7 L5 9 M-1 -5 L1 -3 L4 -1 L6 1 L7 4 L7 7 L6 9 L4 11 L1 12 L-3 12 L-6 11 L-7 10 L-8 8 L-8 5 L-6 2 L-6 0 L-7 -1 M-6 10 L-7 9 L-7 5 L-6 3 M-3 12 L-5 11 L-6 9 L-6 5 L-5 2 L-5 0 L-6 -1 L-8 -1 L-9 0 L-9 1 M3 -2 L7 -6 M7 -6 L8 -5 L10 -5 M6 -5 L7 -4 L8 -4 M5 -4 L6 -3 L8 -3 L10 -5","-13 13 M3 -8 L2 -10 L1 -11 L-1 -12 L-4 -12 L-7 -11 L-9 -8 L-10 -4 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L2 9 L5 8 L7 7 L9 5 L10 2 L10 -1 L9 -4 L7 -6 M-7 -10 L-8 -8 L-9 -5 L-9 0 L-8 3 L-7 5 M8 5 L9 3 L9 -1 L8 -4 L7 -5 M-4 -12 L-6 -11 L-7 -9 L-8 -5 L-8 0 L-7 4 L-6 6 L-4 8 M5 8 L7 6 L8 3 L8 -1 L7 -3 L5 -5 M3 -12 L0 -10 L-2 -8 L-3 -6 L-3 -5 L-2 -3 L1 -1 L2 1 L2 3 M-2 -6 L-2 -5 L2 -1 L2 0 M-2 -8 L-2 -7 L-1 -5 L2 -3 L3 -1 L3 1 L2 3 L0 4 L-1 4 L-3 3 L-4 1 M2 -3 L7 -6 L8 -8 M10 -12 L8 -8 M7 -11 L11 -9 M10 -12 L9 -11 L7 -11 L8 -10 L8 -8 L9 -9 L11 -9 L10 -10 L10 -12","-12 13 M0 -12 L-2 -11 L-4 -9 L-5 -7 L-5 -5 L-4 -3 L-2 -1 L-1 1 L-1 3 M-4 -6 L-4 -5 L-1 -1 L-1 0 M-4 -9 L-4 -7 L-3 -5 L-1 -3 L0 -1 L0 1 L-1 3 L-2 4 L-4 5 L-6 5 L-8 4 L-9 3 L-10 1 L-10 -1 L-9 -2 L-8 -1 L-9 0 M0 -12 L2 -10 L4 -10 L6 -11 M-1 -11 L1 -10 M-2 -11 L-1 -10 L1 -9 L3 -9 L6 -11 M0 -2 L7 -7 M7 -7 L9 -4 L10 -1 L10 2 L9 5 L7 7 L4 8 L0 9 M6 -6 L8 -4 L9 -1 L9 3 L8 5 M4 -5 L5 -5 L7 -3 L8 0 L8 4 L7 6 L6 7 L4 8 M4 8 L2 8 L0 7 L-2 7 L-4 8 L-5 10 L-4 12 L-2 13 L0 13 L2 12 M1 8 L-1 8 M0 9 L-2 8 L-4 8","-12 13 M-2 -2 L-4 -2 L-6 -3 L-7 -4 L-8 -6 L-8 -8 L-7 -10 L-6 -11 L-3 -12 L-1 -12 L2 -11 L5 -8 L7 -7 M-6 -10 L-4 -11 L0 -11 L2 -10 L3 -9 M-8 -8 L-7 -9 L-5 -10 L-1 -10 L2 -9 L4 -8 L7 -7 L9 -7 L10 -8 L10 -10 L9 -11 L7 -11 M-8 6 L-7 7 L-8 8 L-9 7 L-9 5 L-8 4 L-6 4 L-4 5 L-2 7 L0 10 L2 12 M-4 6 L-3 7 L-1 10 L0 11 M-6 4 L-5 5 L-4 7 L-2 10 L-1 11 L1 12 L4 12 L6 11 L7 10 L8 8 L8 5 L7 3 L5 0 L4 -2 L4 -3 M7 6 L7 5 L4 0 L4 -1 M6 11 L7 9 L7 7 L6 5 L4 2 L3 0 L3 -2 L5 -4 L7 -4 L8 -3 L8 -2","-12 13 M-2 -2 L-4 -2 L-6 -3 L-7 -4 L-8 -6 L-8 -8 L-7 -10 L-6 -11 L-3 -12 L-1 -12 L2 -11 L5 -8 L7 -7 M-6 -10 L-4 -11 L0 -11 L2 -10 L3 -9 M-8 -8 L-7 -9 L-5 -10 L-1 -10 L2 -9 L4 -8 L7 -7 L9 -7 L10 -8 L10 -10 L9 -11 L7 -11 M-8 6 L-7 7 L-8 8 L-9 7 L-9 5 L-8 4 L-6 4 L-4 5 L-2 7 L0 10 L2 12 M-4 6 L-3 7 L-1 10 L0 11 M-6 4 L-5 5 L-4 7 L-2 10 L-1 11 L1 12 L4 12 L6 11 L7 10 L8 8 L8 5 L7 3 L5 0 L4 -2 L4 -3 M7 6 L7 5 L4 0 L4 -1 M6 11 L7 9 L7 7 L6 5 L4 2 L3 0 L3 -2 L5 -4 L7 -4 L8 -3 L8 -2","-13 13 M9 -7 L8 -9 L6 -11 L3 -12 L0 -12 L-3 -11 L-5 -9 L-6 -7 L-6 -4 L-5 -1 L-2 5 L-2 7 L-4 9 M-5 -4 L-5 -3 L-2 3 L-2 4 M-4 -10 L-5 -8 L-5 -5 L-4 -3 L-2 1 L-1 4 L-1 6 L-2 8 L-4 9 L-6 9 L-8 8 M-10 4 L-8 8 M-11 7 L-7 5 M-10 4 L-10 6 L-11 7 L-9 7 L-8 8 L-8 6 L-7 5 L-9 5 L-10 4 M-4 -3 L-4 -5 L-3 -7 L-1 -8 L2 -8 L4 -7 L6 -5 L7 -5 M3 -7 L5 -5 M0 -8 L2 -7 L3 -6 L4 -4 M7 -5 L-2 -1 M3 -3 L7 6 L8 7 L9 7 M2 -2 L6 6 L8 8 M1 -2 L5 7 L7 9 L10 6","-11 12 M8 1 L7 2 L4 2 L3 1 L3 -1 L4 -3 L6 -6 L7 -8 L7 -10 M4 -1 L4 -2 L7 -6 L7 -7 M5 2 L4 1 L4 0 L5 -2 L7 -4 L8 -6 L8 -8 L7 -10 L6 -11 L3 -12 L-2 -12 L-5 -11 L-6 -10 L-7 -8 L-7 -6 L-6 -4 L-4 -1 L-3 1 L-3 2 L-4 4 M-6 -7 L-6 -6 L-3 -1 L-3 0 M-6 -10 L-6 -8 L-5 -6 L-3 -3 L-2 -1 L-2 1 L-3 3 L-5 5 L-8 7 M-5 5 L-3 5 L0 7 L3 8 L6 8 L8 7 M-4 6 L-3 6 L1 8 L2 8 M-8 7 L-6 6 L-5 6 L-1 8 L2 9 L4 9 L7 8 L8 7 L9 5","-16 16 M-13 -1 L-13 0 L-12 1 L-10 1 L-8 0 L-8 -3 L-9 -5 L-11 -8 L-11 -10 L-9 -12 M-9 -3 L-11 -7 M-10 1 L-9 0 L-9 -2 L-11 -5 L-12 -7 L-12 -9 L-11 -11 L-9 -12 L-7 -12 L-5 -11 L-3 -9 L-2 -6 L-2 0 L-3 3 L-4 5 L-6 7 L-9 9 L-10 8 L-11 8 M-4 -9 L-3 -6 L-3 0 L-4 3 L-5 5 M-8 8 L-9 7 L-10 7 M-7 -12 L-5 -10 L-4 -7 L-4 0 L-5 4 L-6 6 L-7 7 L-8 6 L-9 6 L-12 9 M-4 -11 L-2 -12 L0 -12 L2 -11 L4 -9 L5 -6 L5 0 L4 3 L3 5 L1 7 L-1 9 L-2 8 L-3 8 M3 -9 L4 -6 L4 0 L3 4 M0 8 L-1 7 L-2 7 M0 -12 L2 -10 L3 -7 L3 1 L2 5 L1 7 L0 6 L-1 6 L-4 9 M3 -10 L4 -11 L6 -12 L8 -12 L10 -11 L11 -10 L12 -8 L13 -7 M10 -10 L11 -8 M8 -12 L9 -11 L10 -8 L11 -7 L13 -7 M13 -7 L10 -5 L9 -4 L8 -1 L8 2 L9 6 L11 9 L14 6 M10 -4 L9 -2 L9 2 L10 5 L12 8 M13 -7 L11 -5 L10 -3 L10 1 L11 5 L13 7","-14 14 M-11 -1 L-11 0 L-10 1 L-8 1 L-6 0 L-6 -3 L-7 -5 L-9 -8 L-9 -10 L-7 -12 M-7 -3 L-9 -7 M-8 1 L-7 0 L-7 -2 L-9 -5 L-10 -7 L-10 -9 L-9 -11 L-7 -12 L-4 -12 L-2 -11 L0 -9 L1 -6 L1 0 L0 3 L-1 5 L-3 7 L-6 9 L-7 8 L-9 8 L-11 9 M-1 -9 L0 -7 L0 0 L-1 3 L-2 5 L-3 6 M-5 8 L-7 7 L-9 7 M-4 -12 L-2 -10 L-1 -7 L-1 0 L-2 4 L-4 7 L-6 6 L-8 6 L-11 9 M0 -10 L1 -11 L3 -12 L5 -12 L7 -11 L8 -10 L9 -8 L10 -7 M7 -10 L8 -8 M5 -12 L6 -11 L7 -8 L8 -7 L10 -7 M10 -7 L7 -5 L6 -4 L5 -1 L5 2 L6 6 L8 9 L11 6 M7 -4 L6 -2 L6 2 L7 5 L9 8 M10 -7 L8 -5 L7 -3 L7 1 L8 5 L10 7","-14 14 M-2 -12 L-4 -11 L-6 -9 L-7 -7 L-7 -5 L-5 -1 L-5 1 M-6 -6 L-6 -5 L-5 -3 L-5 -2 M-6 -9 L-6 -7 L-4 -3 L-4 -1 L-5 1 L-6 2 L-8 2 L-9 1 L-9 0 M-2 -12 L-1 -11 L5 -9 L8 -7 L9 -5 L10 -2 L10 1 L9 4 L8 6 L6 8 L3 9 L0 9 L-3 8 L-9 5 L-10 5 L-11 6 M-2 -11 L-1 -10 L5 -8 L7 -7 L8 -6 M-2 -12 L-2 -10 L-1 -9 L5 -7 L7 -6 L9 -4 L10 -2 M1 8 L-1 8 L-7 5 L-8 5 M7 7 L5 8 L2 8 L-1 7 L-5 5 L-8 4 L-10 4 L-11 6 L-11 8 L-10 9 L-9 8 L-10 7","-13 14 M-10 -1 L-10 0 L-9 1 L-7 1 L-5 0 L-5 -3 L-6 -5 L-8 -8 L-8 -10 L-6 -12 M-6 -3 L-8 -7 M-7 1 L-6 0 L-6 -2 L-8 -5 L-9 -7 L-9 -9 L-8 -11 L-6 -12 L-3 -12 L-1 -11 L0 -10 L1 -8 L1 3 M1 5 L1 10 L0 12 L-2 13 L-5 13 L-6 12 L-6 10 L-5 9 L-4 10 L-5 11 M-1 -10 L0 -8 L0 10 L-1 12 M-3 -12 L-2 -11 L-1 -8 L-1 3 M-1 5 L-1 10 L-2 12 L-3 13 M1 -8 L6 -12 M6 -12 L8 -9 L9 -7 L10 -3 L10 0 L9 3 L7 6 L4 9 M5 -11 L8 -7 L9 -4 L9 -3 M4 -10 L6 -8 L8 -5 L9 -2 L9 1 L8 4 L7 6 M5 7 L3 4 L1 3 M-1 3 L-3 4 L-5 6 M5 8 L3 5 L1 4 L-2 4 M4 9 L2 6 L1 5 M-1 5 L-3 5 L-5 6","-14 14 M-2 -12 L-4 -11 L-6 -9 L-7 -7 L-7 -5 L-5 -1 L-5 1 M-6 -6 L-6 -5 L-5 -3 L-5 -2 M-6 -9 L-6 -7 L-4 -3 L-4 -1 L-5 1 L-6 2 L-8 2 L-9 1 L-9 0 M-2 -12 L-1 -11 L5 -9 L8 -7 L9 -5 L10 -2 L10 1 L9 4 L8 6 M6 8 L3 9 L0 9 L-3 8 L-9 5 L-10 5 L-11 6 M-2 -11 L-1 -10 L5 -8 L7 -7 L8 -6 M-2 -12 L-2 -10 L-1 -9 L5 -7 L7 -6 L9 -4 L10 -2 M1 8 L-1 8 L-7 5 L-8 5 M6 8 L2 8 L-1 7 L-5 5 L-8 4 L-10 4 L-11 6 L-11 8 L-10 9 L-9 8 L-10 7 M2 6 L4 4 L6 4 L10 8 L11 8 M5 5 L6 5 L9 8 M3 5 L4 5 L8 9 L10 9 L12 7","-14 14 M-11 -1 L-11 0 L-10 1 L-8 1 L-6 0 L-6 -3 L-7 -5 L-9 -8 L-9 -10 L-7 -12 M-7 -3 L-9 -7 M-8 1 L-7 0 L-7 -2 L-9 -5 L-10 -7 L-10 -9 L-9 -11 L-7 -12 L-4 -12 L-2 -11 L-1 -10 L0 -8 L0 4 L-1 6 L-3 8 L-5 9 L-7 9 L-9 8 M-2 -10 L-1 -8 L-1 4 L-2 6 M-4 -12 L-3 -11 L-2 -8 L-2 4 L-3 7 L-5 9 M-11 4 L-9 8 M-12 7 L-8 5 M-11 4 L-11 6 L-12 7 L-10 7 L-9 8 L-9 6 L-8 5 L-10 5 L-11 4 M0 -9 L1 -11 L3 -12 L5 -12 L7 -11 L8 -10 L9 -8 L10 -7 M7 -10 L8 -8 M5 -12 L6 -11 L7 -8 L8 -7 L10 -7 M10 -7 L0 -2 M2 -3 L6 7 L8 9 L11 6 M3 -3 L7 6 L9 8 M4 -4 L8 6 L9 7 L10 7","-13 14 M10 -10 L9 -11 L10 -12 L11 -11 L11 -9 L10 -7 L8 -7 L4 -9 L1 -10 L-3 -10 L-7 -9 L-9 -7 M7 -8 L4 -10 L1 -11 L-3 -11 L-6 -10 M11 -9 L10 -8 L8 -8 L4 -11 L1 -12 L-3 -12 L-6 -11 L-8 -9 L-9 -7 L-10 -4 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L3 9 L6 8 L8 7 L10 5 L11 2 L11 -1 L10 -3 L8 -4 L5 -4 L3 -3 L1 0 L-1 1 L-3 1 M-6 6 L-4 7 L-1 8 L3 8 L7 7 M-9 3 L-7 5 L-5 6 L-2 7 L3 7 L7 6 L9 5 L10 4 L11 2 M6 -3 L5 -3 L1 1 L0 1 M11 -1 L9 -3 L7 -3 L5 -2 L3 1 L1 2 L-1 2 L-3 1 L-4 -1 L-4 -3 L-3 -5 L-1 -6","-12 13 M-6 -4 L-8 -5 L-9 -7 L-9 -9 L-8 -11 L-5 -12 L0 -12 L3 -11 L7 -8 L9 -8 L10 -9 M-8 -10 L-6 -11 L0 -11 L3 -10 L6 -8 M-9 -7 L-8 -9 L-6 -10 L0 -10 L3 -9 L7 -7 L9 -7 L10 -9 L10 -11 L9 -12 L8 -11 L9 -10 M3 -9 L0 -6 L-1 -4 L-1 -2 L1 2 L1 4 M0 -3 L0 -2 L1 0 L1 1 M0 -6 L0 -4 L2 0 L2 2 L1 4 L0 5 L-2 5 L-3 4 L-3 2 M-8 7 L-7 8 L-8 9 L-9 8 L-9 6 L-8 4 L-6 4 L-3 5 L1 7 L4 8 L7 8 L9 7 M-6 5 L-5 5 L1 8 L3 8 M-9 6 L-8 5 L-7 5 L-5 6 L-1 8 L2 9 L5 9 L8 8 L10 6","-11 11 M-8 -10 L-7 -10 L-6 -9 L-6 5 L-8 6 M-7 -11 L-5 -10 L-5 6 L-2 8 M-9 -9 L-6 -12 L-4 -10 L-4 5 L-2 7 L0 7 M-8 6 L-7 6 L-5 7 L-3 9 L0 7 L4 4 M2 -10 L3 -10 L4 -9 L4 7 L6 9 L9 6 M3 -11 L5 -10 L5 7 L7 8 M1 -9 L4 -12 L7 -10 L6 -9 L6 6 L7 7 L8 7","-14 14 M-11 -1 L-11 0 L-10 1 L-8 1 L-6 0 L-6 -3 L-7 -5 L-9 -8 L-9 -10 L-7 -12 M-7 -3 L-9 -7 M-8 1 L-7 0 L-7 -2 L-9 -5 L-10 -7 L-10 -9 L-9 -11 L-7 -12 L-4 -12 L-2 -11 L-1 -10 L0 -8 L0 0 L-1 3 L-3 5 M-2 -10 L-1 -8 L-1 2 M-4 -12 L-3 -11 L-2 -8 L-2 3 L-3 5 M0 -9 L1 -11 L3 -12 L5 -12 L7 -11 L9 -8 L10 -7 M7 -10 L8 -8 M5 -12 L6 -11 L7 -8 L8 -7 L10 -7 M8 -7 L6 -7 L5 -6 L5 -4 L6 -2 L9 0 L10 2 M6 -3 L9 -1 M5 -5 L6 -4 L9 -2 L10 0 L10 4 L9 6 L7 8 L5 9 L1 9 L-2 8 L-8 5 L-9 5 L-10 6 M2 8 L0 8 L-6 5 L-7 5 M8 7 L6 8 L3 8 L0 7 L-4 5 L-7 4 L-9 4 L-10 6 L-10 8 L-9 9 L-8 8 L-9 7","-16 17 M-13 -1 L-13 0 L-12 1 L-10 1 L-8 0 L-8 -3 L-9 -5 L-11 -8 L-11 -10 L-9 -12 M-9 -3 L-11 -7 M-10 1 L-9 0 L-9 -2 L-11 -5 L-12 -7 L-12 -9 L-11 -11 L-9 -12 L-6 -12 L-4 -11 L-3 -10 L-2 -8 L-2 -4 L-3 -1 L-5 2 L-7 4 M-4 -10 L-3 -8 L-3 -3 L-4 0 M-6 -12 L-5 -11 L-4 -8 L-4 -3 L-5 1 L-7 4 M-4 -11 L-2 -12 L1 -12 L3 -11 M5 -12 L2 -11 L1 -9 L1 -5 L2 -2 L4 1 L5 3 L5 5 L4 7 M2 -5 L2 -4 L5 1 L5 2 M5 -12 L3 -11 L2 -9 L2 -6 L3 -4 L5 -1 L6 2 L6 4 L5 6 L3 8 L1 9 L-3 9 L-5 8 L-7 6 L-9 5 L-11 5 L-12 6 M-4 8 L-7 5 L-8 5 M-1 9 L-3 8 L-6 5 L-8 4 L-11 4 L-12 6 L-12 8 L-11 9 L-10 8 L-11 7 M5 -12 L8 -12 L10 -11 L12 -8 L13 -7 M10 -10 L11 -8 M8 -12 L9 -11 L10 -8 L11 -7 L13 -7 M11 -7 L9 -7 L8 -6 L8 -4 L9 -2 L12 0 L13 2 M9 -3 L12 -1 M8 -5 L9 -4 L12 -2 L13 0 L13 5 L12 7 L11 8 L9 9 L6 9 L3 8 M7 8 L6 8 L4 7 M12 7 L10 8 L8 8 L6 7 L5 6","-12 12 M-7 -10 L-5 -10 L-3 -9 L-2 -8 L-1 -5 L-1 -3 M-1 -1 L-1 3 L-2 6 L-5 9 L-7 8 L-9 9 M-4 8 L-6 7 L-7 7 M-3 7 L-4 7 L-6 6 L-9 9 M-5 -11 L-2 -10 L-1 -9 L0 -6 L0 3 L1 5 L3 7 L5 8 M-9 -9 L-4 -12 L-2 -11 L0 -9 L1 -6 L1 -3 M1 -1 L1 2 L2 5 L3 6 L5 7 L7 7 M-1 3 L0 6 L2 8 L4 9 L9 6 M1 -6 L2 -9 L5 -12 L7 -11 L9 -12 M4 -11 L6 -10 L7 -10 M3 -10 L4 -10 L6 -9 L9 -12 M-7 1 L-5 -3 L-1 -3 M1 -3 L5 -3 L7 -5 M-5 -2 L5 -2 M-7 1 L-5 -1 L-1 -1 M1 -1 L5 -1 L7 -5","-13 13 M-10 -1 L-10 0 L-9 1 L-7 1 L-5 0 L-5 -3 L-6 -5 L-8 -8 L-8 -10 L-6 -12 M-6 -3 L-8 -7 M-7 1 L-6 0 L-6 -2 L-8 -5 L-9 -7 L-9 -9 L-8 -11 L-6 -12 L-3 -12 L-1 -11 L0 -10 L1 -8 L1 -3 L0 0 L-1 2 L-1 3 L1 5 L2 5 M-1 -10 L0 -8 L0 -2 L-1 1 L-2 3 L1 6 M-3 -12 L-2 -11 L-1 -8 L-1 -2 L-2 2 L-3 4 L0 7 L3 4 M1 -8 L9 -12 M7 -11 L7 8 L6 11 M8 -11 L8 6 L7 9 M9 -12 L9 4 L8 8 L7 10 L5 12 L2 13 L-2 13 L-5 12 L-7 10 L-8 8 L-7 7 L-6 8 L-7 9","-12 12 M-4 -9 L-3 -11 L-1 -12 L2 -12 L4 -11 L5 -10 L6 -8 L6 -5 L5 -3 L4 -2 L2 -1 M-1 -1 L-3 -2 L-4 -4 M4 -10 L5 -9 L5 -4 L4 -3 M2 -12 L3 -11 L4 -9 L4 -4 L3 -2 L2 -1 M-5 3 L-4 1 L-3 0 L-1 -1 L2 -1 L5 0 L7 2 L8 4 L8 8 L7 10 L5 12 L2 13 L-2 13 L-4 12 L-7 8 L-8 7 M6 2 L7 4 L7 8 L6 10 M2 -1 L5 1 L6 3 L6 9 L5 11 L4 12 L2 13 M-3 12 L-4 11 L-6 8 L-7 7 M0 13 L-2 12 L-3 11 L-5 8 L-6 7 L-9 7 L-10 8 L-10 10 L-9 11 L-8 11","-7 7 M-3 -16 L-3 16 M-2 -16 L-2 16 M-3 -16 L4 -16 M-3 16 L4 16","-7 7 M-7 -12 L7 12","-7 7 M2 -16 L2 16 M3 -16 L3 16 M-4 -16 L3 -16 M-4 16 L3 16","-11 11 M-8 2 L0 -3 L8 2 M-8 2 L0 -2 L8 2","-12 12 M-12 16 L12 16","-6 6 M-2 -12 L3 -6 M-2 -12 L-3 -11 L3 -6","-8 9 M2 -5 L-1 -4 L-3 -3 L-4 -2 L-5 1 L-5 4 L-4 7 L-3 9 L3 6 M-4 4 L-3 7 L-2 8 M-1 -4 L-3 -2 L-4 1 L-4 3 L-3 6 L-1 8 M0 -4 L1 -3 L3 -2 L3 7 L5 9 L8 6 M1 -4 L4 -2 L4 6 L6 8 M2 -5 L3 -4 L5 -3 L6 -3 M5 -2 L6 -3 M5 -2 L5 6 L6 7 L7 7","-8 9 M-6 -10 L-5 -9 L-4 -7 M2 -12 L-1 -11 L-3 -9 L-4 -7 L-4 6 L-5 7 M-2 -9 L-3 -7 L-3 6 L0 8 M2 -12 L0 -11 L-1 -10 L-2 -7 L-2 6 L0 7 L1 8 M-5 7 L-4 7 L-2 8 L-1 9 L2 8 M-2 -2 L4 -5 L5 -3 L6 0 L6 3 L5 6 L4 7 L2 8 M3 -4 L4 -3 L5 -1 M2 -4 L4 -2 L5 1 L5 3 L4 6 L2 8","-7 6 M0 -4 L2 -2 L4 -3 L2 -5 L0 -4 L-3 -2 L-4 0 L-4 5 L-3 7 L-1 9 L3 7 M1 -4 L3 -3 M-2 -2 L-3 0 L-3 5 L-2 7 L-1 8 M-1 -3 L-2 -1 L-2 4 L-1 6 L1 8","-8 9 M-1 -12 L-4 -9 L-4 -7 L-3 -6 L1 -4 L4 -2 L5 0 L5 3 L4 6 L2 8 M-3 -8 L-3 -7 L1 -5 L4 -3 L5 -2 M-3 -10 L-3 -9 L-2 -8 L3 -5 L5 -3 L6 0 L6 3 L5 6 L2 8 L-1 9 M0 -4 L-4 -2 L-4 6 L-5 7 M-3 -2 L-3 6 L0 8 M-2 -3 L-2 6 L0 7 L1 8 M-5 7 L-4 7 L-2 8 L-1 9","-7 6 M-2 3 L4 -1 L1 -5 L-3 -2 L-4 0 L-4 5 L-3 7 L-1 9 L3 7 M3 -1 L0 -4 M-2 -2 L-3 0 L-3 5 L-2 7 L-1 8 M2 0 L0 -3 L-1 -3 L-2 -1 L-2 4 L-1 6 L1 8","-6 7 M6 -12 L5 -11 L3 -11 L1 -12 L-1 -12 L-2 -10 L-2 -5 L-3 -3 L-4 -2 M4 -10 L2 -10 L0 -11 L-1 -11 M6 -12 L5 -10 L4 -9 L2 -9 L0 -10 L-1 -10 L-2 -9 M-2 -7 L-1 -5 L0 -4 L2 -3 L4 -3 L4 -2 M-4 -2 L-2 -2 M0 -2 L4 -2 M-2 -2 L-2 2 L-1 14 M1 -3 L-2 -3 L-1 -4 L-1 9 M0 -2 L0 2 L-1 14","-8 9 M2 -5 L-1 -4 L-3 -3 L-4 -2 L-5 1 L-5 4 L-4 7 L-3 9 L3 6 M-4 5 L-3 7 L-2 8 M-1 -4 L-3 -2 L-4 1 L-4 3 L-3 6 L-1 8 M0 -4 L1 -3 L3 -2 L3 6 L4 9 L4 11 L3 13 M1 -4 L4 -2 L4 8 M2 -5 L3 -4 L5 -3 L6 -3 M5 -2 L6 -3 M5 -2 L5 10 L4 12 L3 13 L1 14 L-2 14 L-4 13 L-5 12 L-5 11 L-4 11 L-4 12","-8 9 M-6 -10 L-5 -9 L-4 -7 M2 -12 L-1 -11 L-3 -9 L-4 -7 L-4 6 L-5 7 M-2 -9 L-3 -7 L-3 7 L-2 8 M2 -12 L0 -11 L-1 -10 L-2 -7 L-2 6 L-1 7 L0 7 M-5 7 L-3 8 L-2 9 L1 6 M-2 -2 L4 -5 L5 -3 L6 1 L6 5 L5 8 L4 10 L2 12 L-1 14 M3 -4 L4 -3 L5 0 M2 -4 L4 -1 L5 2 L5 5 L4 9 L2 12","-5 5 M0 -12 L-1 -11 L-1 -10 L0 -9 L1 -10 L1 -11 L0 -12 M-1 -11 L1 -10 M-1 -10 L1 -11 M-3 -3 L-2 -3 L-1 -2 L-1 7 L1 9 L4 6 M-2 -4 L0 -3 L0 6 L2 8 M-4 -2 L-1 -5 L0 -4 L2 -3 M1 -2 L2 -3 M1 -2 L1 6 L2 7 L3 7","-5 5 M0 -12 L-1 -11 L-1 -10 L0 -9 L1 -10 L1 -11 L0 -12 M-1 -11 L1 -10 M-1 -10 L1 -11 M-3 -3 L-2 -3 L-1 -2 L-1 9 L-2 12 L-3 13 L-5 14 M-2 -4 L0 -3 L0 9 L-1 11 M-4 -2 L-1 -5 L0 -4 L2 -3 M1 -2 L2 -3 M1 -2 L1 9 L0 11 L-2 13 L-5 14 M1 9 L2 11 L3 12","-7 7 M-4 -10 L-3 -9 L-2 -7 M3 -12 L1 -11 L-1 -9 L-2 -7 L-2 -5 L-3 -3 L-4 -2 M-2 -2 L-2 6 L-3 7 M0 -9 L-1 -7 L-1 -5 M-1 -3 L-2 -3 L-1 -5 L-1 6 L1 8 M3 -12 L1 -10 L0 -7 L0 -3 M0 -2 L0 6 L1 7 L2 7 M-3 7 L-1 8 L0 9 L3 6 M0 -6 L4 -9 L5 -8 L5 -6 L3 -4 L1 -3 M3 -8 L4 -7 L4 -6 L3 -4 M0 -3 L5 -3 L5 -2 M-4 -2 L-2 -2 M0 -2 L5 -2","-5 5 M-3 -10 L-2 -9 L-1 -7 M5 -12 L2 -11 L0 -9 L-1 -7 L-1 6 L-2 7 M1 -9 L0 -7 L0 7 L2 8 M5 -12 L3 -11 L2 -10 L1 -7 L1 6 L2 7 L3 7 M-2 7 L0 8 L1 9 L4 6","-13 13 M-11 -3 L-10 -3 L-9 -2 L-9 6 L-10 7 L-8 9 M-10 -4 L-8 -2 L-8 6 L-9 7 L-8 8 L-7 7 L-8 6 M-12 -2 L-9 -5 L-7 -3 L-7 6 L-6 7 L-8 9 M-4 -4 L-2 -3 L-1 -1 L-1 6 L-2 7 L0 9 M-2 -4 L-1 -3 L0 -1 L0 6 L-1 7 L0 8 L1 7 L0 6 M-7 -2 L-4 -4 L-2 -5 L0 -4 L1 -2 L1 6 L2 7 L0 9 M4 -4 L5 -3 L7 -2 L7 7 L9 9 L12 6 M5 -4 L8 -2 L8 6 L10 8 M1 -2 L4 -4 L6 -5 L7 -4 L9 -3 L10 -3 M9 -2 L10 -3 M9 -2 L9 6 L10 7 L11 7","-9 9 M-7 -3 L-6 -3 L-5 -2 L-5 6 L-6 7 L-4 9 M-6 -4 L-4 -2 L-4 6 L-5 7 L-4 8 L-3 7 L-4 6 M-8 -2 L-5 -5 L-3 -3 L-3 6 L-2 7 L-4 9 M0 -4 L1 -3 L3 -2 L3 7 L5 9 L8 6 M1 -4 L4 -2 L4 6 L6 8 M-3 -2 L0 -4 L2 -5 L3 -4 L5 -3 L6 -3 M5 -2 L6 -3 M5 -2 L5 6 L6 7 L7 7","-8 9 M-4 -2 L-4 6 L-5 7 M-3 -2 L-3 6 L0 8 M-1 -3 L-2 -2 L-2 6 L0 7 L1 8 M-5 7 L-4 7 L-2 8 L-1 9 L2 8 M-4 -2 L-1 -3 L4 -5 L5 -3 L6 0 L6 3 L5 6 L4 7 L2 8 M3 -4 L4 -3 L5 -1 M2 -4 L4 -2 L5 1 L5 3 L4 6 L2 8","-8 9 M-3 -8 L-5 -6 L-5 -4 L-4 -1 L-4 6 L-6 8 M-4 7 L-3 14 M-4 -5 L-4 -4 L-3 -1 L-3 9 M-4 -7 L-4 -6 L-3 -4 L-2 -1 L-2 6 L-1 6 L1 7 L2 8 M-2 7 L-3 14 M1 8 L-1 7 M2 8 L0 9 L-2 7 M-4 7 L-6 8 M-2 -2 L4 -5 L5 -3 L6 0 L6 3 L5 6 L4 7 L2 8 M3 -4 L4 -3 L5 -1 M2 -4 L4 -2 L5 1 L5 3 L4 6 L2 8","-8 9 M2 -5 L-1 -4 L-3 -3 L-4 -2 L-5 1 L-5 4 L-4 7 L-3 9 L3 6 M-4 5 L-3 7 L-2 8 M-1 -4 L-3 -2 L-4 1 L-4 3 L-3 6 L-1 8 M0 -4 L1 -3 L3 -2 L3 6 L4 14 M1 -4 L4 -2 L4 9 M2 -5 L3 -4 L5 -3 L6 -3 M5 -2 L6 -3 M5 -2 L5 6 L4 14","-7 7 M-4 -3 L-3 -3 L-2 -2 L-2 6 L-3 7 M-3 -4 L-1 -2 L-1 7 L1 8 M-5 -2 L-2 -5 L0 -3 L0 6 L1 7 L2 7 M-3 7 L-1 8 L0 9 L3 6 M2 -4 L3 -2 L5 -3 L4 -5 L0 -3 M3 -4 L4 -3","-6 5 M6 -12 L5 -11 L3 -11 L1 -12 L-1 -12 L-2 -10 L-2 -5 L-3 -3 L-4 -2 M4 -10 L2 -10 L0 -11 L-1 -11 M6 -12 L5 -10 L4 -9 L2 -9 L0 -10 L-1 -10 L-2 -9 M-2 -7 L0 -2 M-2 -2 L-2 2 L-1 14 M-1 -3 L-2 -3 L-1 -4 L-1 9 M0 -2 L0 2 L-1 14 M-4 -2 L-2 -2","-6 6 M1 -9 L0 -6 L-1 -4 L-2 -3 L-4 -2 M1 -9 L1 -3 L4 -3 L4 -2 M-4 -2 L-1 -2 M1 -2 L4 -2 M-1 -2 L-1 6 L-2 7 M0 -3 L-1 -3 L0 -5 L0 6 L2 8 M1 -2 L1 6 L2 7 L3 7 M-2 7 L0 8 L1 9 L4 6","-9 9 M-7 -3 L-6 -3 L-5 -2 L-5 6 L-6 7 M-6 -4 L-4 -2 L-4 6 L-2 8 M-8 -2 L-5 -5 L-3 -3 L-3 6 L-1 7 L0 8 M-6 7 L-5 7 L-3 8 L-2 9 L0 8 L3 6 M4 -5 L2 -3 L3 -2 L3 7 L5 9 L8 6 M4 -2 L5 -3 L4 -4 L3 -3 L4 -2 L4 6 L6 8 M4 -5 L6 -3 L5 -2 L5 6 L6 7 L7 7","-8 9 M-3 -7 L-5 -5 L-5 -3 L-4 0 L-4 6 L-5 7 M-4 -4 L-4 -3 L-3 0 L-3 6 L0 8 M-4 -6 L-4 -5 L-3 -3 L-2 0 L-2 6 L0 7 L1 8 M-5 7 L-4 7 L-2 8 L-1 9 L2 8 M-2 -2 L4 -5 L5 -3 L6 0 L6 3 L5 6 L4 7 L2 8 M3 -4 L4 -3 L5 -1 M2 -4 L4 -2 L5 1 L5 3 L4 6 L2 8","-12 13 M-7 -7 L-9 -5 L-9 -3 L-8 0 L-8 6 L-9 7 L-7 9 M-8 -4 L-8 -3 L-7 0 L-7 6 L-8 7 L-7 8 L-6 7 L-7 6 M-8 -6 L-8 -5 L-7 -3 L-6 0 L-6 6 L-5 7 L-7 9 M-3 -4 L-1 -3 L0 -1 L0 6 L-1 7 M-1 -4 L0 -3 L1 -1 L1 6 L4 8 M-6 -2 L-3 -4 L-1 -5 L1 -4 L2 -2 L2 6 L4 7 L5 8 M-1 7 L0 7 L2 8 L3 9 L6 8 M2 -2 L8 -5 L9 -3 L10 0 L10 2 L9 6 L8 7 L6 8 M7 -4 L8 -3 L9 -1 M6 -4 L8 -2 L9 1 L9 3 L8 6 L6 8","-7 8 M-3 -3 L-2 -3 L-1 -2 L-1 6 L-2 6 L-4 7 L-5 9 L-5 11 L-4 13 L-2 14 L1 14 L4 13 L4 12 L3 12 L3 13 M-2 -4 L0 -2 L0 6 L3 8 M-4 -2 L-1 -5 L1 -3 L1 6 L3 7 L4 8 M6 7 L2 9 L1 8 L-1 7 L-3 7 L-5 9 M3 -4 L4 -2 L6 -3 L5 -5 L1 -3 M4 -4 L5 -3","-8 9 M-3 -7 L-5 -5 L-5 -3 L-4 0 L-4 6 L-5 7 M-4 -4 L-4 -3 L-3 0 L-3 7 L-1 8 M-4 -6 L-4 -5 L-3 -3 L-2 0 L-2 6 L-1 7 L0 7 M-5 7 L-3 8 L-2 9 L1 6 M-2 -2 L4 -5 L5 -3 L6 1 L6 5 L5 8 L4 10 L2 12 L-1 14 M3 -4 L4 -3 L5 0 M2 -4 L4 -1 L5 2 L5 5 L4 9 L2 12","-7 7 M-4 -2 L1 -5 L3 -4 L4 -2 L4 0 L3 2 L-1 4 M1 -4 L3 -3 M0 -4 L2 -3 L3 -1 L3 0 L2 2 L1 3 M1 3 L3 5 L4 7 L4 11 L3 13 L1 14 L-1 14 L-3 13 L-4 11 L-4 9 L-3 7 L-1 6 L5 4 M0 4 L2 5 L3 7 M-1 4 L2 6 L3 8 L3 11 L2 13 L1 14","-7 7 M2 -16 L0 -15 L-1 -14 L-2 -12 L-2 -10 L-1 -8 L0 -7 L1 -5 L1 -3 L-1 -1 M0 -15 L-1 -13 L-1 -11 L0 -9 L1 -8 L2 -6 L2 -4 L1 -2 L-3 0 L1 2 L2 4 L2 6 L1 8 L0 9 L-1 11 L-1 13 L0 15 M-1 1 L1 3 L1 5 L0 7 L-1 8 L-2 10 L-2 12 L-1 14 L0 15 L2 16","-4 4 M0 -16 L0 16","-7 7 M-2 -16 L0 -15 L1 -14 L2 -12 L2 -10 L1 -8 L0 -7 L-1 -5 L-1 -3 L1 -1 M0 -15 L1 -13 L1 -11 L0 -9 L-1 -8 L-2 -6 L-2 -4 L-1 -2 L3 0 L-1 2 L-2 4 L-2 6 L-1 8 L0 9 L1 11 L1 13 L0 15 M1 1 L-1 3 L-1 5 L0 7 L1 8 L2 10 L2 12 L1 14 L0 15 L-2 16","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3","-8 8 M-8 -12 L-8 9 L-7 9 L-7 -12 L-6 -12 L-6 9 L-5 9 L-5 -12 L-4 -12 L-4 9 L-3 9 L-3 -12 L-2 -12 L-2 9 L-1 9 L-1 -12 L0 -12 L0 9 L1 9 L1 -12 L2 -12 L2 9 L3 9 L3 -12 L4 -12 L4 9 L5 9 L5 -12 L6 -12 L6 9 L7 9 L7 -12 L8 -12 L8 9"],
    :gothicita => ["-8 8","-6 6 M0 -12 L-1 -11 L-3 -10 L-1 -9 L0 2 M0 -9 L1 -10 L0 -11 L-1 -10 L0 -9 L0 2 M0 -12 L1 -11 L3 -10 L1 -9 L0 2 M0 6 L-2 8 L0 9 L2 8 L0 6 M0 7 L-1 8 L1 8 L0 7","-9 9 M-4 -12 L-5 -11 L-5 -5 M-4 -11 L-5 -5 M-4 -12 L-3 -11 L-5 -5 M5 -12 L4 -11 L4 -5 M5 -11 L4 -5 M5 -12 L6 -11 L4 -5","-10 11 M1 -16 L-6 16 M7 -16 L0 16 M-6 -3 L8 -3 M-7 3 L7 3","-10 10 M-2 -16 L-2 13 M2 -16 L2 13 M2 -12 L4 -11 L5 -9 L5 -7 L7 -8 L6 -10 L5 -11 L2 -12 L-2 -12 L-5 -11 L-7 -9 L-7 -6 L-6 -4 L-3 -2 L3 0 L5 1 L6 3 L6 6 L5 8 M6 -8 L5 -10 M-6 -6 L-5 -4 L-3 -3 L3 -1 L5 0 L6 2 M-5 7 L-6 5 M-5 -11 L-6 -9 L-6 -7 L-5 -5 L-3 -4 L3 -2 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-2 9 L-5 8 L-6 7 L-7 5 L-5 4 L-5 6 L-4 8 L-2 9","-12 12 M9 -12 L-9 9 M-4 -12 L-2 -10 L-2 -8 L-3 -6 L-5 -5 L-7 -5 L-9 -7 L-9 -9 L-8 -11 L-6 -12 L-4 -12 L-2 -11 L1 -10 L4 -10 L7 -11 L9 -12 M5 2 L3 3 L2 5 L2 7 L4 9 L6 9 L8 8 L9 6 L9 4 L7 2 L5 2","-13 13 M7 -4 L8 -3 L9 -3 L10 -4 M6 -3 L7 -2 L9 -2 M6 -2 L7 -1 L8 -1 L9 -2 L10 -4 M7 -4 L1 2 M0 3 L-6 9 L-10 4 L-4 -2 M-3 -3 L1 -7 L-3 -12 L-8 -6 L-2 0 L2 6 L4 8 L6 9 L8 9 L9 8 L10 6 M-6 8 L-9 4 M0 -7 L-3 -11 M-7 -6 L-2 -1 L2 5 L4 7 L6 8 L9 8 M-5 8 L-9 3 M0 -6 L-4 -11 M-7 -7 L-1 -1 L3 5 L4 6 L6 7 L9 7 L10 6","-4 5 M1 -12 L0 -11 L0 -5 M1 -11 L0 -5 M1 -12 L2 -11 L0 -5","-7 7 M3 -16 L1 -14 L-1 -11 L-3 -7 L-4 -2 L-4 2 L-3 7 L-1 11 L1 14 L3 16 M-1 -10 L-2 -7 L-3 -3 L-3 3 L-2 7 L-1 10 M1 -14 L0 -12 L-1 -9 L-2 -3 L-2 3 L-1 9 L0 12 L1 14","-7 7 M-3 -16 L-1 -14 L1 -11 L3 -7 L4 -2 L4 2 L3 7 L1 11 L-1 14 L-3 16 M1 -10 L2 -7 L3 -3 L3 3 L2 7 L1 10 M-1 -14 L0 -12 L1 -9 L2 -3 L2 3 L1 9 L0 12 L-1 14","-8 8 M0 -12 L-1 -11 L1 -1 L0 0 M0 -12 L0 0 M0 -12 L1 -11 L-1 -1 L0 0 M-5 -9 L-4 -9 L4 -3 L5 -3 M-5 -9 L5 -3 M-5 -9 L-5 -8 L5 -4 L5 -3 M5 -9 L4 -9 L-4 -3 L-5 -3 M5 -9 L-5 -3 M5 -9 L5 -8 L-5 -4 L-5 -3","-12 13 M0 -9 L0 8 L1 8 M0 -9 L1 -9 L1 8 M-8 -1 L9 -1 L9 0 M-8 -1 L-8 0 L9 0","-6 6 M0 12 L0 10 L-2 8 L0 6 L1 8 L1 10 L0 12 L-2 13 M0 7 L-1 8 L0 9 L0 7","-13 13 M-9 0 L9 0","-6 6 M0 6 L-2 8 L0 9 L2 8 L0 6 M0 7 L-1 8 L1 8 L0 7","-11 12 M9 -16 L-9 16 L-8 16 M9 -16 L10 -16 L-8 16","-10 10 M-6 -10 L-6 6 L-8 7 M-5 -9 L-5 6 L-2 8 M-4 -10 L-4 6 L-2 7 L-1 8 M-6 -10 L-4 -10 L1 -11 L3 -12 M1 -11 L2 -10 L4 -9 L4 7 M2 -11 L5 -9 L5 6 M3 -12 L4 -11 L6 -10 L8 -10 L6 -9 L6 7 M-8 7 L-6 7 L-4 8 L-3 9 L-1 8 L4 7 L6 7","-10 10 M-3 -10 L-2 -9 L-1 -7 L-1 6 L-3 7 M-1 -9 L-2 -10 L-1 -11 L0 -9 L0 7 L2 8 M-3 -10 L0 -12 L1 -10 L1 6 L3 7 L4 7 M-3 7 L-2 7 L0 8 L1 9 L2 8 L4 7","-10 10 M-6 -10 L-4 -10 L-2 -11 L-1 -12 L1 -11 L4 -10 L6 -10 M-2 -10 L0 -11 M-6 -10 L-4 -9 L-2 -9 L0 -10 L1 -11 M4 -10 L4 -2 M5 -9 L5 -3 M6 -10 L6 -2 L-1 -2 L-4 -1 L-6 1 L-7 4 L-7 9 M-7 9 L-3 7 L1 6 L4 6 L8 7 M-4 8 L-1 7 L4 7 L7 8 M-7 9 L-2 8 L3 8 L6 9 L8 7","-10 10 M-6 -10 L-5 -10 L-3 -11 L-2 -12 L0 -11 L4 -10 L6 -10 M-3 -10 L-1 -11 M-6 -10 L-4 -9 L-2 -9 L0 -11 M4 -10 L4 -3 M5 -9 L5 -4 M6 -10 L6 -3 L4 -3 L1 -2 L-1 -1 M-1 -2 L1 -1 L4 0 L6 0 L6 7 M5 1 L5 6 M4 0 L4 7 M-7 7 L-5 6 L-3 6 L-1 7 L0 8 M-3 7 L-1 8 M-7 7 L-5 7 L-3 8 L-2 9 L0 8 L4 7 L6 7","-10 10 M3 -12 L-7 -2 L-7 3 L2 3 M4 3 L8 3 L9 4 L9 2 L8 3 M-6 -2 L-6 2 M-5 -4 L-5 3 M2 -11 L2 6 L0 7 M3 -8 L4 -10 L3 -11 L3 7 L5 8 M3 -12 L5 -10 L4 -8 L4 6 L6 7 L7 7 M0 7 L1 7 L3 8 L4 9 L5 8 L7 7","-10 10 M-6 -12 L-6 -3 M-6 -12 L6 -12 M-5 -11 L4 -11 M-6 -10 L3 -10 L5 -11 L6 -12 M4 -6 L3 -5 L1 -4 L-3 -3 L-6 -3 M1 -4 L2 -4 L4 -3 L4 7 M3 -5 L5 -4 L5 6 M4 -6 L5 -5 L7 -4 L8 -4 L6 -3 L6 7 M-7 7 L-5 6 L-3 6 L-1 7 L0 8 M-3 7 L-1 8 M-7 7 L-5 7 L-3 8 L-2 9 L0 8 L4 7 L6 7","-10 10 M-6 -10 L-6 6 L-8 7 M-5 -9 L-5 6 L-2 8 M-4 -10 L-4 6 L-2 7 L-1 8 M-6 -10 L-4 -10 L0 -11 L2 -12 L3 -11 L5 -10 L6 -10 M1 -11 L3 -10 M0 -11 L2 -9 L4 -9 L6 -10 M-4 -2 L-3 -2 L1 -3 L3 -4 L4 -5 M1 -3 L2 -3 L4 -2 L4 7 M3 -4 L5 -2 L5 6 M4 -5 L5 -4 L7 -3 L8 -3 L6 -2 L6 7 M-8 7 L-6 7 L-4 8 L-3 9 L-1 8 L4 7 L6 7","-10 10 M-7 -10 L-5 -12 L-2 -11 L3 -11 L8 -12 M-6 -11 L-3 -10 L2 -10 L5 -11 M-7 -10 L-3 -9 L0 -9 L4 -10 L8 -12 M8 -12 L7 -10 L5 -7 L1 -3 L-1 0 L-2 3 L-2 6 L-1 9 M0 -1 L-1 2 L-1 5 L0 8 M3 -5 L1 -2 L0 1 L0 4 L1 7 L-1 9","-10 10 M-6 -9 L-6 -3 M-5 -8 L-5 -4 M-4 -9 L-4 -3 M-6 -9 L-4 -9 L1 -10 L3 -11 L4 -12 M1 -10 L2 -10 L4 -9 L4 -3 M3 -11 L5 -10 L5 -4 M4 -12 L5 -11 L7 -10 L8 -10 L6 -9 L6 -3 M-6 -3 L-4 -3 L4 0 L6 0 M6 -3 L4 -3 L-4 0 L-6 0 M-6 0 L-6 6 L-8 7 M-5 1 L-5 6 L-2 8 M-4 0 L-4 6 L-2 7 L-1 8 M4 0 L4 7 M5 1 L5 6 M6 0 L6 7 M-8 7 L-6 7 L-4 8 L-3 9 L-1 8 L4 7 L6 7","-10 10 M-6 -10 L-6 -1 L-8 0 M-5 -9 L-5 0 L-3 1 M-4 -10 L-4 -1 L-2 0 L-1 0 M-6 -10 L-4 -10 L1 -11 L3 -12 M1 -11 L2 -10 L4 -9 L4 7 M2 -11 L5 -9 L5 6 M3 -12 L4 -11 L6 -10 L8 -10 L6 -9 L6 7 M-8 0 L-7 0 L-5 1 L-4 2 L-3 1 L-1 0 L3 -1 L4 -1 M-7 7 L-5 6 L-3 6 L-1 7 L0 8 M-3 7 L-1 8 M-7 7 L-5 7 L-3 8 L-2 9 L0 8 L4 7 L6 7","-6 6 M0 -5 L-2 -3 L0 -2 L2 -3 L0 -5 M0 -4 L-1 -3 L1 -3 L0 -4 M0 6 L-2 8 L0 9 L2 8 L0 6 M0 7 L-1 8 L1 8 L0 7","-6 6 M0 -5 L-2 -3 L0 -2 L2 -3 L0 -5 M0 -4 L-1 -3 L1 -3 L0 -4 M0 12 L0 10 L-2 8 L0 6 L1 8 L1 10 L0 12 L-2 13 M0 7 L-1 8 L0 9 L0 7","-12 12 M8 -9 L-8 0 L8 9","-12 13 M-8 -5 L9 -5 L9 -4 M-8 -5 L-8 -4 L9 -4 M-8 3 L9 3 L9 4 M-8 3 L-8 4 L9 4","-12 12 M-8 -9 L8 0 L-8 9","-9 9 M-6 -8 L-5 -10 L-4 -11 L-1 -12 L1 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L3 -2 L1 -1 M-5 -8 L-4 -10 M4 -10 L5 -9 L5 -5 L4 -4 M-6 -8 L-4 -7 L-4 -9 L-3 -11 L-1 -12 M1 -12 L3 -11 L4 -9 L4 -5 L3 -3 L1 -1 M0 -1 L0 2 L1 -1 L-1 -1 L0 2 M0 6 L-2 8 L0 9 L2 8 L0 6 M0 7 L-1 8 L1 8 L0 7","-13 14 M5 -4 L4 -6 L2 -7 L-1 -7 L-3 -6 L-4 -5 L-5 -2 L-5 1 L-4 3 L-2 4 L1 4 L3 3 L4 1 M-1 -7 L-3 -5 L-4 -2 L-4 1 L-3 3 L-2 4 M5 -7 L4 1 L4 3 L6 4 L8 4 L10 2 L11 -1 L11 -3 L10 -6 L9 -8 L7 -10 L5 -11 L2 -12 L-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L2 9 L5 8 L7 7 L8 6 M6 -7 L5 1 L5 3 L6 4","-13 13 M-4 -10 L-6 -9 L-8 -7 L-9 -5 L-10 -2 L-10 1 L-9 3 L-7 4 M-8 -6 L-9 -3 L-9 1 L-8 3 M-4 -10 L-6 -8 L-7 -6 L-8 -3 L-8 0 L-7 4 L-7 6 L-8 8 L-10 9 M4 -10 L6 -10 L6 7 L4 7 M7 -10 L7 7 M8 -11 L8 8 M-10 -12 L-7 -11 L-1 -10 L4 -10 L8 -11 L10 -12 M-8 -2 L6 -2 M-10 9 L-7 8 L-1 7 L4 7 L8 8 L10 9","-13 13 M-6 -11 L-6 8 M-5 -11 L-5 8 M-2 -12 L-4 -11 L-4 8 L-2 9 M-10 -8 L-8 -10 L-6 -11 L-2 -12 L3 -12 L6 -11 L8 -9 L8 -7 L7 -5 M6 -10 L7 -9 L7 -7 L6 -5 M3 -12 L5 -11 L6 -9 L6 -7 L5 -6 M-1 3 L-3 2 L-4 0 L-4 -2 L-3 -4 L-2 -5 L1 -6 L4 -6 L7 -5 L9 -3 L10 -1 L10 2 L9 5 L7 7 L5 8 L2 9 L-2 9 L-6 8 L-8 7 L-10 5 M8 -3 L9 -1 L9 3 L8 5 M4 -6 L7 -4 L8 -1 L8 3 L7 6 L5 8","-13 13 M10 -12 L9 -10 L8 -8 L6 -10 L4 -11 L1 -12 L-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L1 9 L4 8 L6 7 L8 5 L9 7 L10 9 M9 -10 L8 -5 L8 2 L9 7 M8 -7 L7 -8 M8 -4 L7 -7 L6 -9 L4 -11 M-8 -7 L-9 -4 L-9 1 L-8 4 M-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 M7 5 L8 4 M4 8 L6 6 L7 4 L8 1","-13 13 M-7 -11 L-7 8 M-6 -11 L-6 8 M-4 -12 L-5 -11 L-5 8 L-4 9 M-10 -7 L-9 -9 L-7 -11 L-4 -12 L1 -12 L4 -11 L6 -10 L8 -8 L9 -6 L10 -3 L10 0 L9 3 L8 5 L6 7 L4 8 L1 9 L-4 9 L-7 8 L-9 6 L-10 4 M8 -7 L9 -4 L9 1 L8 4 M4 -11 L6 -9 L7 -7 L8 -4 L8 1 L7 4 L6 6 L4 8","-13 13 M10 -12 L9 -10 L8 -8 L6 -10 L4 -11 L1 -12 L-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L1 9 L4 8 L6 7 L8 5 L9 7 L10 9 M9 -10 L8 -5 L8 2 L9 7 M8 -7 L7 -8 M8 -5 L6 -9 L4 -11 M-8 -7 L-9 -4 L-9 1 L-8 4 M-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 M7 5 L8 4 M4 8 L6 6 L7 4 L8 1 M-8 -2 L-7 -3 L-4 -3 L3 -1 L6 -1 L8 -2 M-2 -2 L0 -1 L3 0 L5 0 L7 -1 M-5 -3 L0 0 L3 1 L5 1 L7 0 L8 -2 M8 -5 L7 -6 L6 -6 L5 -5 L6 -4 L7 -5","-13 13 M-8 -10 L-8 8 M-5 -11 L-7 -10 L-7 7 M-3 -12 L-5 -11 L-6 -9 L-6 7 L-4 7 M-10 -8 L-8 -10 L-6 -11 L-3 -12 L1 -12 L4 -11 L6 -10 L7 -9 L10 -12 M10 -12 L9 -10 L8 -6 L8 -3 L9 1 L10 3 M8 -9 L7 -7 M4 -11 L6 -9 L7 -6 L8 -3 M-6 -2 L-5 -3 L-3 -3 L2 -2 L5 -2 L7 -3 M-1 -2 L2 -1 L4 -1 L6 -2 M-4 -3 L2 0 L4 0 L6 -1 L7 -3 L7 -6 L6 -7 L5 -7 L4 -6 L5 -5 L6 -6 M-10 9 L-8 8 L-4 7 L1 7 L7 8 L10 9","-13 13 M10 -12 L9 -10 L8 -8 L6 -10 L4 -11 L1 -12 L-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L2 9 L4 8 L6 7 L7 6 L8 4 L9 7 L10 9 M9 -10 L8 -5 L8 2 L9 7 M8 -7 L7 -8 M8 -4 L7 -7 L6 -9 L4 -11 M-8 -7 L-9 -4 L-9 1 L-8 4 M-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 M6 6 L7 4 L7 0 M4 8 L5 7 L6 4 L6 -1 M-7 1 L-6 0 L-5 1 L-6 2 L-7 2 L-8 1 M-8 -2 L-7 -4 L-5 -5 L-3 -5 L0 -4 L3 -2 L5 -1 M-7 -3 L-5 -4 L-3 -4 L0 -3 L2 -2 M-8 -2 L-6 -3 L-3 -3 L3 -1 L7 -1 L8 -2","-13 13 M-8 -11 L-8 8 L-10 9 M-7 -10 L-7 8 M-4 -10 L-6 -10 L-6 8 M-10 -12 L-8 -11 L-4 -10 L1 -10 L7 -11 L10 -12 M-6 -2 L-5 -4 L-3 -6 L0 -7 L4 -7 L7 -6 L9 -4 L10 -1 L10 2 L9 3 L7 4 M8 -4 L9 -2 L9 1 L8 3 M4 -7 L6 -6 L7 -5 L8 -3 L8 1 L7 4 L7 6 L8 8 L10 9 M-10 9 L-6 8 L-2 8 L3 9","-13 13 M-1 -9 L-1 7 M0 -8 L0 6 M1 -9 L1 7 M-10 -12 L-6 -10 L-2 -9 L2 -9 L6 -10 L10 -12 M-10 9 L-7 8 L-3 7 L3 7 L7 8 L10 9","-13 13 M2 -9 L4 -9 L4 6 L3 8 L1 9 M5 -9 L5 6 L4 7 M6 -10 L6 7 M-10 -12 L-6 -10 L-2 -9 L2 -9 L6 -10 L10 -12 M-9 -3 L-10 -1 L-10 3 L-9 6 L-7 8 L-4 9 L1 9 L4 8 L6 7 L8 5 L10 2 M-9 3 L-8 6 L-7 7 M-10 1 L-8 3 L-7 6 L-6 8 L-4 9","-13 13 M-8 -11 L-8 8 L-10 9 M-7 -10 L-7 8 M-4 -10 L-6 -10 L-6 8 M-10 -12 L-8 -11 L-4 -10 L1 -10 L7 -11 L10 -12 M-6 -2 L-5 -4 L-3 -6 L0 -7 L3 -7 L6 -6 L7 -5 L7 -3 L6 -2 L1 0 L-1 1 L-2 2 L-2 3 L-1 4 L0 3 L-1 2 M5 -6 L6 -5 L6 -3 L5 -2 M3 -7 L5 -5 L5 -3 L4 -2 L1 0 M1 0 L4 0 L7 1 L8 3 L8 5 L7 6 M5 1 L7 3 L7 5 M1 0 L4 1 L6 3 L7 6 L8 8 L9 9 L10 9 M-10 9 L-6 8 L-2 8 L3 9","-13 13 M-8 -11 L-8 8 M-7 -10 L-7 7 M-4 -10 L-6 -10 L-6 7 L-4 7 M10 -7 L8 -4 L7 -2 L6 1 L6 3 L7 5 L9 6 M8 -3 L7 0 L7 3 L8 5 M10 -7 L9 -5 L8 -1 L8 2 L9 6 L10 9 M-10 -12 L-8 -11 L-4 -10 L1 -10 L7 -11 L10 -12 M-10 9 L-8 8 L-4 7 L1 7 L7 8 L10 9","-13 13 M-1 -9 L-1 7 M0 -8 L0 6 M1 -9 L1 7 M-4 7 L-6 5 L-8 4 L-9 3 L-10 0 L-10 -5 L-9 -8 L-7 -10 L-5 -11 L-2 -12 L2 -12 L5 -11 L7 -10 L9 -8 L10 -5 L10 0 L9 3 L8 4 L6 5 L4 7 M-8 3 L-9 0 L-9 -5 L-8 -8 M-6 5 L-7 3 L-8 0 L-8 -6 L-7 -9 L-5 -11 M8 -8 L9 -5 L9 0 L8 3 M5 -11 L7 -9 L8 -6 L8 0 L7 3 L6 5 M-10 -12 L-6 -10 L-2 -9 L2 -9 L6 -10 L10 -12 M-10 9 L-7 8 L-3 7 L3 7 L7 8 L10 9","-13 13 M-8 -10 L-8 8 L-10 9 M-6 -10 L-7 -9 L-7 8 M-3 -12 L-5 -11 L-6 -9 L-6 8 M-10 -8 L-8 -10 L-6 -11 L-3 -12 L1 -12 L4 -11 L6 -10 L8 -8 L9 -6 L10 -3 L10 1 L9 3 L7 4 M8 -7 L9 -4 L9 0 L8 3 M4 -11 L6 -9 L7 -7 L8 -4 L8 0 L7 4 L7 6 L8 8 L9 9 L10 9 M-10 9 L-6 8 L-2 8 L3 9","-13 13 M-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L1 9 L4 8 L6 7 L8 5 L9 3 L10 0 L10 -3 L9 -6 L8 -8 L6 -10 L4 -11 L1 -12 L-1 -12 M-8 -7 L-9 -4 L-9 1 L-8 4 M-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 M8 4 L9 1 L9 -4 L8 -7 M4 8 L6 6 L7 4 L8 1 L8 -4 L7 -7 L6 -9 L4 -11","-13 13 M-8 -9 L-8 8 M-5 -10 L-7 -8 L-7 7 M-1 -12 L-3 -11 L-5 -9 L-6 -7 L-6 7 L-4 7 M-10 -7 L-8 -9 L-4 -11 L-1 -12 L2 -12 L5 -11 L7 -10 L9 -8 L10 -5 L10 -3 L9 0 L7 2 L4 3 L0 3 L-3 2 L-5 0 L-6 -3 M8 -8 L9 -6 L9 -2 L8 0 M5 -11 L7 -9 L8 -6 L8 -2 L7 1 L4 3 M-10 9 L-8 8 L-4 7 L1 7 L7 8 L10 9","-13 13 M-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L1 9 L4 8 L6 7 L8 5 L9 3 L10 0 L10 -3 L9 -6 L8 -8 L6 -10 L4 -11 L1 -12 L-1 -12 M-8 -7 L-9 -4 L-9 1 L-8 4 M-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 M8 4 L9 1 L9 -4 L8 -7 M4 8 L6 6 L7 4 L8 1 L8 -4 L7 -7 L6 -9 L4 -11 M-8 1 L-7 3 L-4 4 L2 5 L9 5 L10 6 L10 8 L9 9 L9 8 L10 7 M-2 5 L0 5 M-7 3 L-4 5 L-1 6 L1 6 L2 5","-13 13 M-8 -9 L-8 8 L-10 9 M-7 -9 L-7 8 M-6 -10 L-6 8 M-10 -7 L-8 -9 L-6 -10 L-4 -11 L-1 -12 L3 -12 L7 -11 L9 -9 L10 -7 L10 -4 L9 -2 L8 -1 M7 -10 L8 -9 L9 -7 L9 -4 L8 -2 M3 -12 L5 -11 L7 -9 L8 -7 L8 -3 L7 -1 M6 0 L3 1 L0 1 L-2 0 L-2 -2 L0 -3 L3 -3 L6 -2 L8 0 L10 3 L10 5 L9 6 L8 6 M6 -1 L7 0 L9 4 L9 5 L8 2 M2 -3 L4 -2 L6 0 L7 2 L8 6 L9 8 L10 9 M-10 9 L-6 8 L-2 8 L3 9","-13 13 M2 -12 L8 -11 L10 -12 L9 -10 L9 -8 L7 -10 L5 -11 L2 -12 L-2 -12 L-5 -11 L-8 -8 L-9 -5 L-9 -3 L-8 0 L-6 2 L-3 3 L0 3 L2 2 L3 1 L4 -1 L4 -2 M9 -11 L8 -10 L9 -8 M-8 -2 L-7 0 L-6 1 L-3 2 L0 2 L2 1 M-7 -9 L-8 -7 L-8 -4 L-7 -2 L-5 0 L-2 1 L0 1 L2 0 L4 -2 L5 -3 L6 -3 M-6 -1 L-5 -1 L-4 -2 L-2 -4 L0 -5 L3 -5 L5 -4 L7 -2 L8 0 L8 3 L7 6 L5 8 M-2 -5 L0 -6 L3 -6 L6 -5 L8 -3 L9 0 L9 3 L8 5 M-9 5 L-8 7 L-9 8 M-4 -2 L-4 -3 L-3 -5 L-2 -6 L0 -7 L3 -7 L6 -6 L9 -3 L10 0 L10 2 L9 5 L7 7 L5 8 L2 9 L-2 9 L-5 8 L-7 7 L-9 5 L-9 7 L-10 9 L-8 8 L-2 9","-13 13 M-1 -10 L-5 -10 L-7 -9 L-8 -8 L-9 -6 L-10 -3 L-10 1 L-9 4 L-8 6 L-7 7 L-5 8 L-2 9 L1 9 L4 8 L6 7 L8 5 L9 3 L10 0 L10 -4 L9 -7 L7 -9 L5 -10 M3 -10 L2 -9 L2 -7 L3 -6 L4 -7 L3 -8 M-9 1 L-8 4 L-6 6 L-4 7 L-1 8 L2 8 L5 7 M-8 -8 L-9 -4 L-9 -1 L-8 2 L-6 5 L-4 6 L-1 7 L2 7 L5 6 L7 5 L9 2 L10 0 M-10 -12 L-7 -9 M-7 -10 L-6 -11 M-9 -11 L-8 -11 L-7 -12 L-5 -11 L-1 -10 L5 -10 L8 -11 L10 -12","-13 13 M-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L3 9 L6 8 L8 7 M-7 -8 L-8 -6 L-9 -3 L-9 1 L-8 4 M-7 -9 L-6 -8 L-6 -7 L-7 -5 L-8 -2 L-8 1 L-7 4 L-6 6 L-4 8 M4 -10 L6 -10 L6 6 L5 8 L3 9 M7 -10 L7 6 L6 7 M8 -11 L8 7 L10 9 M-10 -12 L-7 -11 L-1 -10 L4 -10 L8 -11 L10 -12","-13 13 M-10 -12 L0 9 M-9 -11 L-8 -10 L-1 5 L0 7 M-8 -11 L-7 -10 L0 5 L1 6 M10 -12 L0 9 M5 -4 L3 1 M7 -6 L3 -1 L2 2 L2 4 M-10 -12 L-8 -11 L-3 -10 L3 -10 L8 -11 L10 -12","-13 13 M-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L1 9 L4 8 L6 7 L8 5 L9 3 L10 0 L10 -3 L9 -6 L8 -8 L6 -10 M-8 -6 L-9 -3 L-9 0 L-8 3 L-7 5 M-8 -8 L-7 -7 L-7 -6 L-8 -3 L-8 0 L-7 4 L-6 6 L-4 8 M7 5 L8 3 L9 0 L9 -3 L8 -6 M4 8 L6 6 L7 4 L8 0 L8 -3 L7 -6 L7 -7 L8 -8 M-1 -9 L-1 9 M0 -8 L0 8 M1 -9 L1 9 M-10 -12 L-6 -10 L-2 -9 L2 -9 L6 -10 L10 -12","-13 13 M-10 -12 L6 7 L7 8 M-9 -11 L-7 -10 L8 8 M-6 -10 L10 9 M10 -12 L1 -2 M-1 0 L-8 8 M-2 1 L-5 3 L-6 5 M-1 0 L-5 2 L-6 3 L-7 5 L-7 7 M-10 -12 L-6 -10 L-2 -9 L2 -9 L6 -10 L10 -12 M-10 9 L-8 8 L-4 7 L1 7 L7 8 L10 9","-13 13 M6 -10 L6 8 M7 -10 L7 7 M8 -11 L8 7 M-7 -10 L-9 -8 L-10 -5 L-10 -2 L-9 1 L-7 3 L-5 4 L-2 5 L1 5 L4 4 L6 3 M-6 3 L-3 4 L3 4 M-10 -2 L-9 0 L-7 2 L-4 3 L2 3 L4 4 M-10 -12 L-6 -10 L-2 -9 L2 -9 L6 -10 L10 -12 M-10 5 L-8 7 L-6 8 L-2 9 L2 9 L6 8 L10 6","-13 13 M-10 -12 L-9 -11 L-7 -10 L-4 -10 L1 -12 L4 -12 L7 -11 L8 -9 L8 -7 L7 -5 M6 -11 L7 -9 L7 -7 L6 -5 M4 -12 L5 -11 L6 -9 L6 -6 M6 -4 L2 -3 L0 -3 L-2 -4 L-2 -6 L0 -7 L2 -7 L6 -6 M2 -7 L4 -6 L5 -5 L4 -4 L2 -3 M7 -5 L9 -3 L10 0 L10 2 L9 5 L7 7 L5 8 L2 9 L-2 9 L-5 8 L-7 7 L-9 5 L-10 2 L-10 0 L-9 -3 L-8 -4 L-6 -5 L-4 -5 L-2 -4 L-2 -2 L-3 -1 L-4 -2 L-3 -3 M6 -5 L8 -3 L9 -1 L9 3 L8 5 M6 -4 L7 -3 L8 -1 L8 3 L7 6 L5 8","-7 7 M-3 -16 L-3 16 M-2 -16 L-2 16 M-3 -16 L4 -16 M-3 16 L4 16","-7 7 M-7 -12 L7 12","-7 7 M2 -16 L2 16 M3 -16 L3 16 M-4 -16 L3 -16 M-4 16 L3 16","-11 11 M-8 2 L0 -3 L8 2 M-8 2 L0 -2 L8 2","-13 13 M-13 16 L13 16","-6 6 M-2 -12 L3 -6 M-2 -12 L-3 -11 L3 -6","-8 9 M-2 -1 L-5 2 L-5 6 L-2 9 L2 7 M-4 2 L-4 6 L-2 8 M-3 0 L-3 5 L0 8 M0 1 L-5 -4 L-4 -5 L-3 -4 L-4 -3 M-3 -4 L1 -4 L3 -5 L5 -3 L5 6 L6 7 M3 -4 L4 -3 L4 6 L3 7 L4 8 L5 7 L4 6 M1 -4 L3 -2 L3 6 L2 7 L4 9 L6 7","-9 8 M-4 -10 L-6 -12 L-5 -8 L-5 6 L-2 9 L3 7 L5 6 M-4 -10 L-4 6 L-2 8 M-4 -10 L-2 -12 L-3 -8 L-3 5 L0 8 M-3 -3 L2 -5 L5 -2 L5 6 M2 -4 L4 -2 L4 6 M0 -4 L3 -1 L3 7","-7 5 M-4 -2 L-4 7 L-2 9 L0 7 M-3 -2 L-3 7 L-2 8 M-2 -3 L-2 6 L-1 7 L0 7 M-4 -2 L2 -5 L4 -3 L2 -2 L0 -4 M1 -4 L3 -3","-8 8 M0 -5 L-5 -2 L-5 6 L-2 9 L0 8 L3 7 L5 7 M-4 -2 L-4 6 L-2 8 M-3 -3 L-3 5 L0 8 M-2 -9 L-2 -12 L-1 -9 L5 -2 L5 7 M-2 -9 L4 -2 L4 6 M-2 -9 L-5 -9 L-2 -8 L3 -2 L3 7","-7 6 M-4 -2 L-4 7 L-2 9 L0 7 M-3 -2 L-3 7 L-2 8 M-2 -3 L-2 6 L-1 7 L0 7 M-4 -2 L2 -5 L5 -1 L-2 3 M1 -4 L4 -1 M0 -4 L3 0","-7 5 M-3 -9 L-3 6 L-4 7 L-2 9 M-2 -9 L-2 6 L-3 7 L-2 8 L-1 7 L-2 6 M-1 -10 L-1 6 L0 7 L-2 9 M-3 -9 L3 -12 L5 -10 L3 -9 L1 -11 M2 -11 L4 -10 M-6 -5 L-3 -5 M-1 -5 L3 -5","-8 9 M-5 -2 L-5 6 L-2 9 L3 7 M-4 -2 L-4 6 L-2 8 M-3 -3 L-3 5 L0 8 M-5 -2 L-3 -3 L2 -5 L5 -2 L5 11 L4 13 L3 14 L1 15 L-1 15 L-3 14 L-5 15 L-3 16 L-1 15 M2 -4 L4 -2 L4 11 L3 13 M-2 15 L-4 15 M0 -4 L3 -1 L3 12 L2 14 L1 15","-9 9 M-4 -10 L-6 -12 L-5 -8 L-5 6 L-6 7 L-4 9 M-4 -10 L-4 6 L-5 7 L-4 8 L-3 7 L-4 6 M-4 -10 L-2 -12 L-3 -8 L-3 6 L-2 7 L-4 9 M-3 -3 L0 -4 L2 -5 L5 -2 L5 7 L2 11 L2 14 L3 16 L4 16 L2 14 M2 -4 L4 -2 L4 7 L3 9 M0 -4 L3 -1 L3 8 L2 11","-5 5 M0 -12 L-2 -10 L0 -8 L2 -10 L0 -12 M0 -11 L-1 -10 L0 -9 L1 -10 L0 -11 M0 -5 L-2 -3 L-1 -2 L-1 6 L-2 7 L0 9 M0 -2 L1 -3 L0 -4 L-1 -3 L0 -2 L0 6 L-1 7 L0 8 L1 7 L0 6 M0 -5 L2 -3 L1 -2 L1 6 L2 7 L0 9","-5 5 M0 -12 L-2 -10 L0 -8 L2 -10 L0 -12 M0 -11 L-1 -10 L0 -9 L1 -10 L0 -11 M0 -5 L-2 -3 L-1 -2 L-1 7 L2 11 M0 -2 L1 -3 L0 -4 L-1 -3 L0 -2 L0 7 L1 9 M0 -5 L2 -3 L1 -2 L1 8 L2 11 L2 14 L0 16 L-2 15 L-2 16 L0 16","-9 8 M-4 -10 L-6 -12 L-5 -8 L-5 6 L-6 7 L-4 9 M-4 -10 L-4 6 L-5 7 L-4 8 L-3 7 L-4 6 M-4 -10 L-2 -12 L-3 -8 L-3 6 L-2 7 L-4 9 M-3 -2 L0 -4 L2 -5 L4 -2 L1 0 L-3 3 M1 -4 L3 -2 M0 -4 L2 -1 M0 1 L1 2 L2 7 L4 9 L6 7 M1 1 L2 3 L3 7 L4 8 M1 0 L2 1 L4 6 L5 7 L6 7","-5 5 M0 -10 L-2 -12 L-1 -8 L-1 6 L-2 7 L0 9 M0 -10 L0 6 L-1 7 L0 8 L1 7 L0 6 M0 -10 L2 -12 L1 -8 L1 6 L2 7 L0 9","-13 13 M-11 -3 L-10 -3 L-9 -2 L-9 6 L-10 7 L-8 9 M-9 -4 L-8 -3 L-8 6 L-9 7 L-8 8 L-7 7 L-8 6 M-11 -3 L-9 -5 L-7 -3 L-7 6 L-6 7 L-8 9 M-7 -3 L-4 -4 L-2 -5 L1 -3 L1 6 L2 7 L0 9 M-2 -4 L0 -3 L0 6 L-1 7 L0 8 L1 7 L0 6 M-4 -4 L-1 -2 L-1 6 L-2 7 L0 9 M1 -3 L4 -4 L6 -5 L9 -3 L9 6 L10 7 L8 9 M6 -4 L8 -3 L8 6 L7 7 L8 8 L9 7 L8 6 M4 -4 L7 -2 L7 6 L6 7 L8 9","-9 9 M-7 -3 L-6 -3 L-5 -2 L-5 6 L-6 7 L-4 9 M-5 -4 L-4 -3 L-4 6 L-5 7 L-4 8 L-3 7 L-4 6 M-7 -3 L-5 -5 L-3 -3 L-3 6 L-2 7 L-4 9 M-3 -3 L0 -4 L2 -5 L5 -3 L5 6 L6 7 L4 9 M2 -4 L4 -3 L4 6 L3 7 L4 8 L5 7 L4 6 M0 -4 L3 -2 L3 6 L2 7 L4 9","-8 8 M-5 -2 L-5 6 L-2 9 L3 7 L5 6 M-4 -2 L-4 6 L-2 8 M-3 -3 L-3 5 L0 8 M-5 -2 L-3 -3 L2 -5 L5 -2 L5 6 M2 -4 L4 -2 L4 6 M0 -4 L3 -1 L3 7","-9 8 M-6 -5 L-5 -3 L-5 6 L-7 7 L-5 7 L-5 13 L-6 16 L-4 14 M-4 -3 L-4 14 M-6 -5 L-4 -4 L-3 -3 L-3 6 L-1 7 L0 8 M-4 7 L-3 7 L-1 8 M-3 8 L-2 9 L3 7 L5 6 M-3 8 L-3 13 L-2 16 L-4 14 M-3 -3 L0 -4 L2 -5 L5 -2 L5 6 M2 -4 L4 -2 L4 6 M0 -4 L3 -1 L3 7","-8 9 M-5 -2 L-5 6 L-2 9 L3 7 M-4 -2 L-4 6 L-2 8 M-3 -3 L-3 5 L0 8 M-5 -2 L-3 -3 L2 -5 L5 -2 L5 13 L6 16 L4 14 M2 -4 L4 -2 L4 14 M0 -4 L3 -1 L3 13 L2 16 L4 14","-7 6 M-5 -3 L-4 -3 L-3 -2 L-3 6 L-4 7 L-2 9 M-3 -4 L-2 -3 L-2 6 L-3 7 L-2 8 L-1 7 L-2 6 M-5 -3 L-3 -5 L-1 -3 L-1 6 L0 7 L-2 9 M-1 -3 L3 -5 L5 -3 L3 -2 L1 -4 M2 -4 L4 -3","-8 8 M-5 -2 L-5 1 L-3 3 L3 0 L5 2 L5 6 M-4 -2 L-4 1 L-3 2 M-3 -3 L-3 1 L-2 2 M3 1 L4 2 L4 6 M2 1 L3 2 L3 7 M-5 -2 L1 -5 L4 -4 L2 -3 L-1 -4 M0 -4 L3 -4 M5 6 L-1 9 L-5 7 L-3 6 L1 8 M-3 7 L-1 8","-5 5 M0 -10 L-2 -12 L-1 -8 L-1 6 L-2 7 L0 9 M0 -10 L0 6 L-1 7 L0 8 L1 7 L0 6 M0 -10 L2 -12 L1 -8 L1 6 L2 7 L0 9 M-4 -5 L-1 -5 M1 -5 L4 -5","-9 9 M-7 -3 L-6 -3 L-5 -2 L-5 7 L-2 9 L3 7 M-5 -4 L-4 -3 L-4 7 L-2 8 M-7 -3 L-5 -5 L-3 -3 L-3 6 L0 8 M4 -5 L6 -3 L5 -2 L5 6 L6 7 L7 7 M4 -2 L5 -3 L4 -4 L3 -3 L4 -2 L4 7 L5 8 M4 -5 L2 -3 L3 -2 L3 7 L5 9 L7 7","-9 9 M-6 -5 L-5 -3 L-5 6 L-1 9 L1 7 L5 5 M-5 -4 L-4 -3 L-4 6 L-1 8 M-6 -5 L-4 -4 L-3 -3 L-3 5 L0 7 L1 7 M4 -5 L6 -3 L5 -2 L5 5 M4 -2 L5 -3 L4 -4 L3 -3 L4 -2 L4 5 M4 -5 L2 -3 L3 -2 L3 6","-13 13 M-10 -5 L-9 -3 L-9 6 L-5 9 L-3 7 L-1 6 M-9 -4 L-8 -3 L-8 6 L-5 8 M-10 -5 L-8 -4 L-7 -3 L-7 5 L-4 7 L-3 7 M0 -5 L-2 -3 L-1 -2 L-1 6 L3 9 L5 7 L9 5 M0 -2 L1 -3 L0 -4 L-1 -3 L0 -2 L0 6 L3 8 M0 -5 L2 -3 L1 -2 L1 5 L4 7 L5 7 M8 -5 L10 -3 L9 -2 L9 5 M8 -2 L9 -3 L8 -4 L7 -3 L8 -2 L8 5 M8 -5 L6 -3 L7 -2 L7 6","-9 9 M-6 -3 L-4 -2 L3 8 L4 9 L6 7 M-5 -4 L-3 -3 L3 7 L5 8 M-6 -3 L-4 -5 L-3 -4 L4 6 L6 7 M6 -5 L4 -5 L4 -3 L6 -3 L6 -5 L4 -3 L1 1 M-1 3 L-4 7 L-6 9 L-4 9 L-4 7 L-6 7 L-6 9 M-4 2 L-1 2 M1 2 L4 2","-9 9 M-7 -3 L-6 -3 L-5 -2 L-5 7 L-2 9 L3 7 M-5 -4 L-4 -3 L-4 7 L-2 8 M-7 -3 L-5 -5 L-3 -3 L-3 6 L0 8 M4 -5 L6 -3 L5 -2 L5 11 L4 13 L3 14 L1 15 L-1 15 L-3 14 L-5 15 L-3 16 L-1 15 M4 -2 L5 -3 L4 -4 L3 -3 L4 -2 L4 12 L3 13 M-2 15 L-4 15 M4 -5 L2 -3 L3 -2 L3 12 L2 14 L1 15","-6 9 M0 -4 L-3 -2 L-3 -3 L0 -4 L2 -5 L5 -3 L5 1 L0 3 M2 -4 L4 -3 L4 1 M0 -4 L3 -2 L3 1 L2 2 M0 3 L5 5 L5 11 L4 13 L3 14 L1 15 L-1 15 L-3 14 L-5 15 L-3 16 L-1 15 M4 5 L4 12 L3 13 M-2 15 L-4 15 M2 4 L3 5 L3 12 L2 14 L1 15","-7 7 M2 -16 L0 -15 L-1 -14 L-2 -12 L-2 -10 L-1 -8 L0 -7 L1 -5 L1 -3 L-1 -1 M0 -15 L-1 -13 L-1 -11 L0 -9 L1 -8 L2 -6 L2 -4 L1 -2 L-3 0 L1 2 L2 4 L2 6 L1 8 L0 9 L-1 11 L-1 13 L0 15 M-1 1 L1 3 L1 5 L0 7 L-1 8 L-2 10 L-2 12 L-1 14 L0 15 L2 16","-4 4 M0 -16 L0 16","-7 7 M-2 -16 L0 -15 L1 -14 L2 -12 L2 -10 L1 -8 L0 -7 L-1 -5 L-1 -3 L1 -1 M0 -15 L1 -13 L1 -11 L0 -9 L-1 -8 L-2 -6 L-2 -4 L-1 -2 L3 0 L-1 2 L-2 4 L-2 6 L-1 8 L0 9 L1 11 L1 13 L0 15 M1 1 L-1 3 L-1 5 L0 7 L1 8 L2 10 L2 12 L1 14 L0 15 L-2 16","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3","-8 8 M-8 -12 L-8 9 L-7 9 L-7 -12 L-6 -12 L-6 9 L-5 9 L-5 -12 L-4 -12 L-4 9 L-3 9 L-3 -12 L-2 -12 L-2 9 L-1 9 L-1 -12 L0 -12 L0 9 L1 9 L1 -12 L2 -12 L2 9 L3 9 L3 -12 L4 -12 L4 9 L5 9 L5 -12 L6 -12 L6 9 L7 9 L7 -12 L8 -12 L8 9"],
    :greek => ["-8 8","-5 5 M0 -12 L0 2 M0 7 L-1 8 L0 9 L1 8 L0 7","-8 8 M-4 -12 L-4 -5 M4 -12 L4 -5","-10 11 M1 -16 L-6 16 M7 -16 L0 16 M-6 -3 L8 -3 M-7 3 L7 3","-10 10 M-2 -16 L-2 13 M2 -16 L2 13 M7 -9 L5 -11 L2 -12 L-2 -12 L-5 -11 L-7 -9 L-7 -7 L-6 -5 L-5 -4 L-3 -3 L3 -1 L5 0 L6 1 L7 3 L7 6 L5 8 L2 9 L-2 9 L-5 8 L-7 6","-12 12 M9 -12 L-9 9 M-4 -12 L-2 -10 L-2 -8 L-3 -6 L-5 -5 L-7 -5 L-9 -7 L-9 -9 L-8 -11 L-6 -12 L-4 -12 L-2 -11 L1 -10 L4 -10 L7 -11 L9 -12 M5 2 L3 3 L2 5 L2 7 L4 9 L6 9 L8 8 L9 6 L9 4 L7 2 L5 2","-13 13 M10 -3 L10 -4 L9 -5 L8 -5 L7 -4 L6 -2 L4 3 L2 6 L0 8 L-2 9 L-6 9 L-8 8 L-9 7 L-10 5 L-10 3 L-9 1 L-8 0 L-1 -4 L0 -5 L1 -7 L1 -9 L0 -11 L-2 -12 L-4 -11 L-5 -9 L-5 -7 L-4 -4 L-2 -1 L3 6 L5 8 L7 9 L9 9 L10 8 L10 7","-5 5 M0 -10 L-1 -11 L0 -12 L1 -11 L1 -9 L0 -7 L-1 -6","-7 7 M4 -16 L2 -14 L0 -11 L-2 -7 L-3 -2 L-3 2 L-2 7 L0 11 L2 14 L4 16","-7 7 M-4 -16 L-2 -14 L0 -11 L2 -7 L3 -2 L3 2 L2 7 L0 11 L-2 14 L-4 16","-8 8 M0 -6 L0 6 M-5 -3 L5 3 M5 -3 L-5 3","-13 13 M0 -9 L0 9 M-9 0 L9 0","-4 4 M1 5 L0 6 L-1 5 L0 4 L1 5 L1 7 L-1 9","-13 13 M-9 0 L9 0","-4 4 M0 4 L-1 5 L0 6 L1 5 L0 4","-11 11 M9 -16 L-9 16","-10 10 M-1 -12 L-4 -11 L-6 -8 L-7 -3 L-7 0 L-6 5 L-4 8 L-1 9 L1 9 L4 8 L6 5 L7 0 L7 -3 L6 -8 L4 -11 L1 -12 L-1 -12","-10 10 M-4 -8 L-2 -9 L1 -12 L1 9","-10 10 M-6 -7 L-6 -8 L-5 -10 L-4 -11 L-2 -12 L2 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L3 -1 L-7 9 L7 9","-10 10 M-5 -12 L6 -12 L0 -4 L3 -4 L5 -3 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5","-10 10 M3 -12 L-7 2 L8 2 M3 -12 L3 9","-10 10 M5 -12 L-5 -12 L-6 -3 L-5 -4 L-2 -5 L1 -5 L4 -4 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5","-10 10 M6 -9 L5 -11 L2 -12 L0 -12 L-3 -11 L-5 -8 L-6 -3 L-6 2 L-5 6 L-3 8 L0 9 L1 9 L4 8 L6 6 L7 3 L7 2 L6 -1 L4 -3 L1 -4 L0 -4 L-3 -3 L-5 -1 L-6 2","-10 10 M7 -12 L-3 9 M-7 -12 L7 -12","-10 10 M-2 -12 L-5 -11 L-6 -9 L-6 -7 L-5 -5 L-3 -4 L1 -3 L4 -2 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 2 L-6 0 L-4 -2 L-1 -3 L3 -4 L5 -5 L6 -7 L6 -9 L5 -11 L2 -12 L-2 -12","-10 10 M6 -5 L5 -2 L3 0 L0 1 L-1 1 L-4 0 L-6 -2 L-7 -5 L-7 -6 L-6 -9 L-4 -11 L-1 -12 L0 -12 L3 -11 L5 -9 L6 -5 L6 0 L5 5 L3 8 L0 9 L-2 9 L-5 8 L-6 6","-4 4 M0 -3 L-1 -2 L0 -1 L1 -2 L0 -3 M0 4 L-1 5 L0 6 L1 5 L0 4","-4 4 M0 -3 L-1 -2 L0 -1 L1 -2 L0 -3 M1 5 L0 6 L-1 5 L0 4 L1 5 L1 7 L-1 9","-12 12 M8 -9 L-8 0 L8 9","-13 13 M-9 -3 L9 -3 M-9 3 L9 3","-12 12 M-8 -9 L8 0 L-8 9","-9 9 M-6 -7 L-6 -8 L-5 -10 L-4 -11 L-2 -12 L2 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L4 -3 L0 -1 L0 2 M0 7 L-1 8 L0 9 L1 8 L0 7","-13 14 M5 -4 L4 -6 L2 -7 L-1 -7 L-3 -6 L-4 -5 L-5 -2 L-5 1 L-4 3 L-2 4 L1 4 L3 3 L4 1 M-1 -7 L-3 -5 L-4 -2 L-4 1 L-3 3 L-2 4 M5 -7 L4 1 L4 3 L6 4 L8 4 L10 2 L11 -1 L11 -3 L10 -6 L9 -8 L7 -10 L5 -11 L2 -12 L-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L2 9 L5 8 L7 7 L8 6 M6 -7 L5 1 L5 3 L6 4","-9 9 M0 -12 L-8 9 M0 -12 L8 9 M-5 2 L5 2","-11 10 M-7 -12 L-7 9 M-7 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -6 L6 -4 L5 -3 L2 -2 M-7 -2 L2 -2 L5 -1 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-7 9","-10 10 M-7 -12 L7 9 M-7 9 L7 -12","-9 9 M0 -12 L-8 9 M0 -12 L8 9 M-8 9 L8 9","-10 9 M-6 -12 L-6 9 M-6 -12 L7 -12 M-6 -2 L2 -2 M-6 9 L7 9","-10 10 M0 -12 L0 9 M-2 -7 L-5 -6 L-6 -5 L-7 -3 L-7 0 L-6 2 L-5 3 L-2 4 L2 4 L5 3 L6 2 L7 0 L7 -3 L6 -5 L5 -6 L2 -7 L-2 -7","-10 7 M-6 -12 L-6 9 M-6 -12 L6 -12","-11 11 M-7 -12 L-7 9 M7 -12 L7 9 M-7 -2 L7 -2","-4 4 M0 -12 L0 9","-2 3 M0 -1 L0 0 L1 0 L1 -1 L0 -1","-11 10 M-7 -12 L-7 9 M7 -12 L-7 2 M-2 -3 L7 9","-9 9 M0 -12 L-8 9 M0 -12 L8 9","-12 12 M-8 -12 L-8 9 M-8 -12 L0 9 M8 -12 L0 9 M8 -12 L8 9","-11 11 M-7 -12 L-7 9 M-7 -12 L7 9 M7 -12 L7 9","-11 11 M-2 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 L-2 9 L2 9 L4 8 L6 6 L7 4 L8 1 L8 -4 L7 -7 L6 -9 L4 -11 L2 -12 L-2 -12","-11 11 M-7 -12 L-7 9 M7 -12 L7 9 M-7 -12 L7 -12","-11 11 M-2 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 L-2 9 L2 9 L4 8 L6 6 L7 4 L8 1 L8 -4 L7 -7 L6 -9 L4 -11 L2 -12 L-2 -12 M-3 -2 L3 -2","-11 10 M-7 -12 L-7 9 M-7 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -5 L6 -3 L5 -2 L2 -1 L-7 -1","-9 9 M-7 -12 L0 -2 L-7 9 M-7 -12 L7 -12 M-7 9 L7 9","-8 8 M0 -12 L0 9 M-7 -12 L7 -12","-9 9 M-7 -7 L-7 -9 L-6 -11 L-5 -12 L-3 -12 L-2 -11 L-1 -9 L0 -5 L0 9 M7 -7 L7 -9 L6 -11 L5 -12 L3 -12 L2 -11 L1 -9 L0 -5","-7 7 M-1 -12 L-3 -11 L-4 -9 L-4 -7 L-3 -5 L-1 -4 L1 -4 L3 -5 L4 -7 L4 -9 L3 -11 L1 -12 L-1 -12","-10 10 M-7 9 L-3 9 L-6 2 L-7 -2 L-7 -6 L-6 -9 L-4 -11 L-1 -12 L1 -12 L4 -11 L6 -9 L7 -6 L7 -2 L6 2 L3 9 L7 9","-9 9 M-7 -12 L7 -12 M-3 -2 L3 -2 M-7 9 L7 9","-11 11 M0 -12 L0 9 M-9 -6 L-8 -6 L-7 -5 L-6 -1 L-5 1 L-4 2 L-1 3 L1 3 L4 2 L5 1 L6 -1 L7 -5 L8 -6 L9 -6","-10 10 M7 -12 L-7 9 M-7 -12 L7 -12 M-7 9 L7 9","-7 7 M-3 -16 L-3 16 M-2 -16 L-2 16 M-3 -16 L4 -16 M-3 16 L4 16","-7 7 M-7 -12 L7 12","-7 7 M2 -16 L2 16 M3 -16 L3 16 M-4 -16 L3 -16 M-4 16 L3 16","-8 8 M0 -14 L-8 0 M0 -14 L8 0","-9 9 M-9 16 L9 16","-4 4 M1 -7 L-1 -5 L-1 -3 L0 -2 L1 -3 L0 -4 L-1 -3","-10 11 M-1 -5 L-3 -4 L-5 -2 L-6 0 L-7 3 L-7 6 L-6 8 L-4 9 L-2 9 L0 8 L3 5 L5 2 L7 -2 L8 -5 M-1 -5 L1 -5 L2 -4 L3 -2 L5 6 L6 8 L7 9 L8 9","-9 10 M3 -12 L1 -11 L-1 -9 L-3 -5 L-4 -2 L-5 2 L-6 8 L-7 16 M3 -12 L5 -12 L7 -10 L7 -7 L6 -5 L5 -4 L3 -3 L0 -3 M0 -3 L2 -2 L4 0 L5 2 L5 5 L4 7 L3 8 L1 9 L-1 9 L-3 8 L-4 7 L-5 4","-9 9 M-7 -5 L-5 -5 L-3 -3 L3 14 L5 16 L7 16 M8 -5 L7 -3 L5 0 L-5 11 L-7 14 L-8 16","-9 9 M2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 4 L-5 7 L-4 8 L-2 9 L0 9 L2 8 L4 6 L5 3 L5 0 L4 -3 L2 -5 L0 -7 L-1 -9 L-1 -11 L0 -12 L2 -12 L4 -11 L6 -9","-8 8 M5 -3 L4 -4 L2 -5 L-1 -5 L-3 -4 L-3 -2 L-2 0 L1 1 M1 1 L-3 2 L-5 4 L-5 6 L-4 8 L-2 9 L1 9 L3 8 L5 6","-11 11 M-3 -4 L-5 -3 L-7 -1 L-8 2 L-8 5 L-7 7 L-6 8 L-4 9 L-1 9 L2 8 L5 6 L7 3 L8 0 L8 -3 L6 -5 L4 -5 L2 -3 L0 1 L-2 6 L-5 16","-9 10 M-8 -2 L-6 -4 L-4 -5 L-3 -5 L-1 -4 L0 -3 L1 0 L1 4 L0 9 M8 -5 L7 -2 L6 0 L0 9 L-2 13 L-3 16","-10 10 M-9 -1 L-8 -3 L-6 -5 L-4 -5 L-3 -4 L-3 -2 L-4 2 L-6 9 M-4 2 L-2 -2 L0 -4 L2 -5 L4 -5 L6 -3 L6 0 L5 5 L2 16","-6 5 M0 -5 L-2 2 L-3 6 L-3 8 L-2 9 L0 9 L2 7 L3 5","-11 11 M-7 -7 L7 7 M7 -7 L-7 7","-9 9 M-3 -5 L-7 9 M7 -4 L6 -5 L5 -5 L3 -4 L-1 0 L-3 1 L-4 1 M-4 1 L-2 2 L-1 3 L1 8 L2 9 L3 9 L4 8","-8 8 M-7 -12 L-5 -12 L-3 -11 L-2 -10 L6 9 M0 -5 L-6 9","-10 11 M-3 -5 L-9 16 M-4 -1 L-5 4 L-5 7 L-3 9 L-1 9 L1 8 L3 6 L5 2 M7 -5 L5 2 L4 6 L4 8 L5 9 L7 9 L9 7 L10 5","-9 9 M-6 -5 L-3 -5 L-4 1 L-5 6 L-6 9 M7 -5 L6 -2 L5 0 L3 3 L0 6 L-3 8 L-6 9","-8 9 M0 -5 L-2 -4 L-4 -2 L-5 1 L-5 4 L-4 7 L-3 8 L-1 9 L1 9 L3 8 L5 6 L6 3 L6 0 L5 -3 L4 -4 L2 -5 L0 -5","-11 11 M-2 -5 L-6 9 M3 -5 L4 1 L5 6 L6 9 M-9 -2 L-7 -4 L-4 -5 L9 -5","-11 10 M-10 -1 L-9 -3 L-7 -5 L-5 -5 L-4 -4 L-4 -2 L-5 3 L-5 6 L-4 8 L-3 9 L-1 9 L1 8 L3 5 L4 3 L5 0 L6 -5 L6 -8 L5 -11 L3 -12 L1 -12 L0 -10 L0 -8 L1 -5 L3 -2 L5 0 L8 2","-9 9 M-5 1 L-5 4 L-4 7 L-3 8 L-1 9 L1 9 L3 8 L5 6 L6 3 L6 0 L5 -3 L4 -4 L2 -5 L0 -5 L-2 -4 L-4 -2 L-5 1 L-9 16","-9 11 M9 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 4 L-5 7 L-4 8 L-2 9 L0 9 L2 8 L4 6 L5 3 L5 0 L4 -3 L3 -4 L1 -5","-10 10 M1 -5 L-2 9 M-8 -2 L-6 -4 L-3 -5 L8 -5","-10 10 M-9 -1 L-8 -3 L-6 -5 L-4 -5 L-3 -4 L-3 -2 L-5 4 L-5 7 L-3 9 L-1 9 L2 8 L4 6 L6 2 L7 -2 L7 -5","-13 13 M0 -9 L-1 -8 L0 -7 L1 -8 L0 -9 M-9 0 L9 0 M0 7 L-1 8 L0 9 L1 8 L0 7","-12 11 M-4 -5 L-6 -4 L-8 -1 L-9 2 L-9 5 L-8 8 L-7 9 L-5 9 L-3 8 L-1 5 M0 1 L-1 5 L0 8 L1 9 L3 9 L5 8 L7 5 L8 2 L8 -1 L7 -4 L6 -5","-8 8 M2 -12 L0 -11 L-1 -10 L-1 -9 L0 -8 L3 -7 L6 -7 M3 -7 L0 -6 L-2 -5 L-3 -3 L-3 -1 L-1 1 L2 2 L4 2 M2 2 L-2 3 L-4 4 L-5 6 L-5 8 L-3 10 L1 12 L2 13 L2 15 L0 16 L-2 16","-12 11 M4 -12 L-4 16 M-11 -1 L-10 -3 L-8 -5 L-6 -5 L-5 -4 L-5 -2 L-6 3 L-6 6 L-5 8 L-3 9 L-1 9 L2 8 L4 6 L6 3 L8 -2 L9 -5","-8 7 M2 -12 L0 -11 L-1 -10 L-1 -9 L0 -8 L3 -7 L6 -7 M6 -7 L2 -5 L-1 -3 L-4 0 L-5 3 L-5 5 L-4 7 L-2 9 L1 11 L2 13 L2 15 L1 16 L-1 16 L-2 14","-7 7 M2 -16 L0 -15 L-1 -14 L-2 -12 L-2 -10 L-1 -8 L0 -7 L1 -5 L1 -3 L-1 -1 M0 -15 L-1 -13 L-1 -11 L0 -9 L1 -8 L2 -6 L2 -4 L1 -2 L-3 0 L1 2 L2 4 L2 6 L1 8 L0 9 L-1 11 L-1 13 L0 15 M-1 1 L1 3 L1 5 L0 7 L-1 8 L-2 10 L-2 12 L-1 14 L0 15 L2 16","-4 4 M0 -16 L0 16","-7 7 M-2 -16 L0 -15 L1 -14 L2 -12 L2 -10 L1 -8 L0 -7 L-1 -5 L-1 -3 L1 -1 M0 -15 L1 -13 L1 -11 L0 -9 L-1 -8 L-2 -6 L-2 -4 L-1 -2 L3 0 L-1 2 L-2 4 L-2 6 L-1 8 L0 9 L1 11 L1 13 L0 15 M1 1 L-1 3 L-1 5 L0 7 L1 8 L2 10 L2 12 L1 14 L0 15 L-2 16","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3","-8 8 M-8 -12 L-8 9 L-7 9 L-7 -12 L-6 -12 L-6 9 L-5 9 L-5 -12 L-4 -12 L-4 9 L-3 9 L-3 -12 L-2 -12 L-2 9 L-1 9 L-1 -12 L0 -12 L0 9 L1 9 L1 -12 L2 -12 L2 9 L3 9 L3 -12 L4 -12 L4 9 L5 9 L5 -12 L6 -12 L6 9 L7 9 L7 -12 L8 -12 L8 9"],
    :japanese => ["-14 13 M-10 7 L-11 8 L-10 9 L-9 8 L-10 7","-14 13 M-10 9 L-11 8 L-10 7 L-9 8 L-9 10 L-10 12 L-11 13","-14 13 M-10 -3 L-8 -1 L8 -2 L10 -1 M-9 -2 L10 -1","-14 13 M-5 -10 L-7 -11 L-7 10 M-6 -10 L-6 10 M-6 8 L6 8 M-6 -10 L6 -10 M5 -10 L6 -11 L8 -10 L7 -8 M6 -10 L6 10 M7 -10 L7 10 M-6 -1 L6 -1","-14 13 M-7 -11 L-9 -12 L-9 9 M-8 -11 L-8 9 M-8 -11 L7 -11 M6 -11 L7 -12 L9 -11 L8 -9 M7 -11 L7 5 L6 7 L5 8 M7 6 L7 7 L6 8 M8 -11 L8 7 L7 9 L6 9 L5 8 L3 7 M-1 -11 L-1 -2 M0 -11 L0 -2 M-8 -2 L7 -2","-14 13 M-6 -12 L-8 -7 L-11 -1 M-6 -12 L-5 -11 L-6 -9 L-9 -4 L-11 -1 M-6 -9 L10 -9 L8 -11 L6 -9 M6 -9 L9 -10 M0 -9 L0 10 M1 -9 L1 10 M-4 -3 L-6 -4 L-6 3 M-5 -3 L-5 3 M-5 -3 L9 -3 L7 -5 L5 -3 M5 -3 L8 -4 M-11 3 L11 3 L9 1 L7 3 M7 3 L10 2","-14 13 M-1 -12 L-1 -6 L-2 -1 L-4 3 L-6 6 L-8 8 L-11 10 M0 -11 L0 -7 M-1 -12 L1 -11 L0 -4 L-1 0 L-3 4 L-6 7 L-9 9 L-11 10 M-11 -5 L11 -5 L9 -7 L7 -5 M7 -5 L10 -6 M1 -5 L2 -1 L3 2 L4 4 L6 7 L9 10 L11 9 M7 7 L9 9 M1 -5 L2 -2 L4 2 L6 5 L8 7 L11 9","-14 13 M-8 -11 L-10 -12 L-10 10 M-9 -11 L-9 10 M-9 -11 L9 -11 M8 -11 L9 -12 L11 -11 L10 -9 M9 -11 L9 10 M10 -11 L10 10 M-7 -7 L7 -7 L6 -8 L5 -7 M-1 -7 L-1 5 M0 -7 L0 5 M-6 -1 L6 -1 L5 -2 L4 -1 M-7 5 L7 5 L6 4 L5 5 M2 1 L3 3 L4 3 L4 2 L2 1 M-9 9 L9 9","-14 13 M-1 -12 L-1 -6 L-2 -1 L-4 3 L-6 6 L-8 8 L-11 10 M0 -11 L0 -7 M-1 -12 L1 -11 L0 -4 L-1 0 L-3 4 L-6 7 L-9 9 L-11 10 M1 -11 L1 -7 L2 -1 L3 2 L4 4 L6 7 L9 10 L11 9 M7 7 L9 9 M1 -7 L2 -2 L4 2 L6 5 L8 7 L11 9","-14 13 M0 -11 L1 -12 L-1 -12 L-1 10 M0 -11 L0 10 M-11 -10 L11 -10 L9 -11 L8 -10 M-6 -6 L-8 -7 L-8 3 M-7 -6 L-7 3 M-7 -6 L6 -6 M5 -6 L6 -7 L8 -6 L7 -4 M6 -6 L6 3 M7 -6 L7 3 M-7 -2 L6 -2 M-7 2 L6 2 M-1 2 L-4 5 L-7 7 L-11 9 M-1 4 L-4 6 L-6 7 L-11 9 M0 2 L3 6 L6 8 L9 9 L11 8 M0 2 L3 5 L7 7 L11 8","-14 13 M0 -10 L1 -11 L-1 -12 L-1 11 M0 -11 L0 11 M-8 -6 L-10 -7 L-10 4 M-9 -6 L-9 4 M-9 -6 L8 -6 M7 -6 L8 -7 L10 -6 L9 -4 M8 -6 L8 4 M9 -6 L9 4 M-9 3 L8 3","-14 13 M0 -10 L1 -11 L-1 -12 L-1 10 M0 -11 L0 10 M-11 -6 L11 -6 L9 -8 L7 -6 M7 -6 L10 -7 M-2 -6 L-5 0 L-8 4 L-11 7 M-1 -5 L-3 -1 L-5 2 L-7 4 L-11 7 M1 -5 L2 -2 L3 0 L6 4 L9 7 L11 6 M7 4 L9 6 M1 -5 L2 -3 L5 1 L8 4 L11 6 M-5 5 L4 5 L3 4 L2 5","-14 13 M0 -11 L0 -12 L1 -13 L-1 -13 L-1 -11 M-11 -11 L11 -11 L9 -13 L7 -11 M7 -11 L10 -12 M-6 -7 L-8 -8 L-8 0 M-7 -7 L-7 0 M-7 -7 L6 -7 M5 -7 L6 -8 L8 -7 L7 -5 M6 -7 L6 0 M7 -7 L7 0 M-7 -1 L6 -1 M-1 -1 L-1 6 L-2 8 L-3 9 M-1 7 L-1 8 L-2 9 M0 -1 L0 8 L-1 10 L-2 10 L-3 9 L-5 8 M-6 2 L-11 7 M-6 2 L-5 3 L-11 7 M4 2 L6 4 L8 7 L9 7 L9 6 L8 5 L4 2","-14 13 M-1 -12 L-1 9 M-1 -12 L0 -12 L0 9 M-8 -10 L-8 -2 M-8 -10 L-7 -10 L-7 -2 M-7 -3 L6 -3 M6 -10 L6 -2 M6 -10 L7 -10 L7 -2 M-10 1 L-10 10 M-10 1 L-9 1 L-9 10 M-9 9 L8 9 M8 1 L8 10 M8 1 L9 1 L9 10","-14 13 M-10 -12 L-10 5 M-10 -12 L-9 -11 L-9 5 M-9 -11 L-5 -11 M-5 -11 L-5 4 M-6 -11 L-5 -12 L-4 -11 L-4 4 M-9 -4 L-5 -4 M-9 3 L-5 3 M3 -11 L4 -12 L2 -12 L2 -4 M3 -11 L3 -4 M-2 -8 L9 -8 L7 -9 L6 -8 M-4 -4 L11 -4 L9 -5 L8 -4 M5 -4 L5 8 L4 9 M6 -4 L6 8 L5 10 L4 9 L2 8 M-4 0 L11 0 L9 -1 L8 0 M-1 2 L0 3 L1 5 L2 5 L2 4 L1 3 L-1 2","-14 13 M0 -10 L1 -11 L-1 -12 L-1 9 M0 -11 L0 9 M0 -2 L9 -2 L7 -4 L5 -2 M5 -2 L8 -3 M-11 9 L11 9 L9 7 L7 9 M7 9 L10 8","-14 13 M-1 -11 L0 -12 L-2 -12 L-2 -5 M-1 -11 L-1 -5 M-9 -9 L3 -9 L2 -10 L1 -9 M-11 -5 L11 -5 L9 -6 L8 -5 M6 -11 L3 -7 L0 -4 L-4 -1 L-9 2 M6 -11 L7 -10 L2 -5 L-2 -2 L-5 0 L-9 2 L-11 3 M-3 -1 L-5 -2 L-5 10 M-4 -1 L-4 10 M-4 -1 L6 -1 M5 -1 L6 -2 L8 -1 L7 1 M6 -1 L6 10 M7 -1 L7 10 M-4 4 L6 4 M-4 9 L6 9","-14 13 M0 -10 L1 -11 L-1 -12 L-1 10 M0 -11 L0 10 M-11 -3 L11 -3 L9 -5 L7 -3 M7 -3 L10 -4","-14 13 M-11 -1 L11 -1 L8 -3 L6 -1 M6 -1 L9 -2","-14 13 M-8 -8 L8 -8 L6 -10 L4 -8 M4 -8 L7 -9 M-11 6 L11 6 L9 4 L7 6 M7 6 L10 5","-14 13 M-9 -9 L9 -9 L7 -11 L5 -9 M5 -9 L8 -10 M-7 -1 L7 -1 L5 -3 L3 -1 M3 -1 L6 -2 M-11 8 L11 8 L9 6 L7 8 M7 8 L10 7","-14 13 M-8 -9 L-10 -10 L-10 8 M-9 -9 L-9 8 M-9 -9 L9 -9 M8 -9 L9 -10 L11 -9 L10 -7 M9 -9 L9 8 M10 -9 L10 8 M-3 -9 L-3 -4 L-4 0 L-5 2 M-2 -9 L-2 -4 L-3 -1 L-5 2 L-7 4 M1 -9 L1 1 L2 2 L6 2 L7 1 L6 0 M2 -9 L2 0 L3 1 L5 1 L6 0 L6 -2 M-9 7 L9 7","-14 13 M-9 -10 L8 -10 L6 -12 L4 -10 M4 -10 L7 -11 M-1 -10 L-4 8 M0 -10 L-3 8 M-9 -2 L4 -2 M3 -2 L4 -3 L6 -2 L5 0 M4 -2 L3 8 M5 -2 L5 0 L4 8 M-11 8 L11 8 L9 6 L7 8 M7 8 L10 7","-14 13 M0 -9 L1 -10 L-1 -11 L-1 -5 M0 -10 L0 -5 M-11 -5 L11 -5 L9 -7 L7 -5 M7 -5 L10 -6 M-5 -1 L-6 2 L-8 6 L-10 9 M-4 0 L-5 2 M-5 -1 L-3 0 L-5 3 L-8 7 L-10 9 M2 -1 L4 1 L7 5 L8 7 L9 8 L10 7 L9 5 L6 2 L2 -1 M7 4 L9 7","-14 13 M-5 -9 L-4 -10 L-6 -11 L-6 8 L-5 9 L7 9 L8 8 L7 6 M6 8 L7 8 L7 7 M-5 -10 L-5 7 L-4 8 L5 8 L7 6 L8 3 M-10 -1 L-4 -2 L1 -3 L9 -5 L6 -6 L5 -4 M5 -4 L7 -5","-14 13 M0 -6 L-1 -3 L-3 2 L-5 5 L-8 8 L-11 10 M0 -6 L1 -5 L0 -2 L-2 2 L-4 5 L-6 7 L-9 9 L-11 10 M-6 -11 L3 -11 M0 -11 L1 -12 L3 -11 L1 -9 M1 -11 L1 -6 L2 -1 L3 2 L4 4 L6 7 L9 10 L11 9 M7 7 L9 9 M1 -6 L2 -2 L4 2 L6 5 L8 7 L11 9","-14 13 M-4 -9 L-3 -10 L-5 -11 L-5 0 L-6 4 L-8 7 L-11 10 M-4 -10 L-4 0 L-5 4 L-7 7 L-11 10 M-11 -4 L2 -5 M1 -5 L2 -6 L4 -5 L3 -3 M2 -5 L2 8 L3 9 L10 9 L11 8 L10 6 M9 8 L10 8 L10 7 M3 -5 L3 7 L4 8 L8 8 L10 6 L11 3","-14 13 M-10 7 L-11 8 L-10 9 L-9 8 L-10 7","-14 13 M-10 7 L-11 8 L-10 9 L-9 8 L-10 7","-14 13 M-10 7 L-11 8 L-10 9 L-9 8 L-10 7","-14 13 M-10 7 L-11 8 L-10 9 L-9 8 L-10 7","-14 13 M-10 7 L-11 8 L-10 9 L-9 8 L-10 7","-14 13 M-10 7 L-11 8 L-10 9 L-9 8 L-10 7","-14 13 M-3 -12 L-1 -11 L-1 -9 L-2 -6 M-2 -11 L-2 0 L-1 4 M-7 -7 L-5 -6 L0 -6 L3 -7 L6 -8 M3 -7 L4 -8 L6 -8 M1 1 L2 -3 L3 -2 L1 1 L-2 5 L-4 7 L-6 8 L-8 8 L-9 7 L-9 4 L-8 2 L-6 0 L-4 -1 L-1 -2 L4 -2 L7 -1 L9 1 L10 3 L10 5 L9 7 L7 9 L4 10 L2 10 M-7 8 L-8 7 L-8 4 L-7 2 L-5 0 L-1 -2 M4 -2 L6 -1 L8 1 L9 3 L9 5 L8 7 L6 9 L4 10","-14 13 M-10 -10 L-8 -9 L-8 -7 L-9 -5 L-10 -2 M-9 -9 L-9 -7 L-10 -2 L-10 1 L-9 4 L-8 5 L-6 6 L-5 6 L-5 4 L-4 1 L-3 -1 M-8 5 L-6 5 L-5 4 M5 -6 L7 -5 L9 -2 L10 1 L10 3 L8 2 L5 3 M9 -2 L9 1 L8 2","-14 13 M-4 -13 L-3 -12 L-1 -11 L3 -11 M-3 -12 L2 -12 L3 -11 L-1 -9 M-7 -5 L-7 -4 L-6 -3 L-5 -3 L-2 -5 L0 -6 M-7 -4 L-6 -4 L-3 -5 L0 -6 L2 -6 L5 -5 L6 -3 L6 0 L5 3 L3 6 L0 8 L-4 10 M2 -6 L4 -5 L5 -3 L5 0 L4 3 L3 5 L1 7 L-2 9","-14 13 M-4 -13 L-3 -12 L-1 -11 L3 -11 M-3 -12 L2 -12 L3 -11 L-1 -9 M-8 -5 L-8 -4 L-7 -3 L-5 -3 L0 -5 L3 -6 L4 -5 M-8 -4 L-5 -4 L0 -5 M4 -5 L0 -2 L-6 4 L-10 8 M3 -6 L0 -2 M-10 8 L-10 7 L-6 4 L-4 3 L0 3 L1 4 L2 8 L3 9 L10 9 M5 9 L8 8 L9 8 L10 9","-14 13 M-5 -12 L-3 -11 L-3 -9 L-4 -5 M-4 -11 L-4 9 M-4 2 L-3 8 L-4 9 L-5 7 L-7 6 L-10 5 M-10 -5 L-8 -4 L-4 -4 L-1 -5 L1 -6 M-4 -4 L-2 -5 L-1 -6 L1 -6 M-10 6 L-6 3 L-1 0 L2 -1 L4 -1 L7 0 L8 2 L8 4 L7 6 L5 7 L3 7 L1 6 L0 4 M-10 6 L-10 5 L-6 3 M4 -1 L6 0 L7 2 L7 4 L6 6 L5 7 M5 -7 L7 -7 L9 -6 L10 -5 L8 -5 L7 -4 M7 -7 L8 -6 L8 -5","-14 13 M-4 -12 L-2 -11 L-2 -9 L-3 -6 L-5 -1 L-10 9 M-3 -11 L-3 -9 L-5 -3 L-7 2 L-10 9 M-10 -5 L-10 -4 L-9 -3 L-8 -3 L-5 -5 L-3 -6 L0 -6 L2 -5 L3 -3 L3 0 L2 4 L0 8 L-1 9 L-2 9 L-2 8 L-3 7 L-5 6 M-10 -4 L-8 -4 L-5 -5 M0 -6 L2 -4 L2 0 L1 4 L0 6 L-2 8 M5 -5 L7 -4 L9 -2 L10 0 L10 2 L9 1 L7 2 M8 -3 L9 -1 L9 1","-14 13 M-4 -12 L-1 -11 L0 -7 L1 -4 L3 0 L6 4 L5 5 M-2 -11 L0 -7 M3 0 L5 5 M-6 -7 L-4 -6 L-1 -6 L2 -7 M-9 -3 L-8 -2 L-5 -1 L0 -1 L5 -2 L8 -3 M5 -2 L7 -4 L8 -3 M5 5 L3 4 L0 3 L-4 3 L-6 4 L-7 5 L-7 7 L-6 8 L-4 9 L-1 10 L5 10 M-4 9 L4 9 L5 10","-14 13 M2 -12 L4 -11 L4 -10 L-4 -2 M3 -11 L2 -9 L-4 -2 L-4 -1 L1 4 L3 7 L4 9 M-4 -1 L4 6 L5 8 L4 9","-14 13 M-9 -11 L-7 -10 L-7 -8 L-8 -5 L-9 -1 M-8 -10 L-8 -7 L-9 -1 L-9 3 L-8 7 L-7 8 L-7 6 L-6 2 L-5 -1 L-4 -3 L-3 -4 L-1 -5 L8 -5 L10 -6 M-9 3 L-8 5 L-7 6 M4 -5 L8 -6 L9 -7 L10 -6 M4 -12 L6 -11 L6 3 L5 6 L3 8 L0 10 M5 -11 L6 -8 M6 0 L5 4 L3 7 L0 10","-14 13 M-5 -10 L-3 -9 L0 -8 L2 -8 L5 -9 M-3 -9 L2 -9 L4 -10 L5 -9 L-1 -6 M-7 1 L-7 3 L-6 5 L-4 6 L0 7 L7 7 M-4 6 L6 6 L7 7","-14 13 M-8 -7 L-7 -6 L-4 -5 L0 -5 L4 -6 L6 -7 L7 -8 M4 -6 L6 -8 L7 -8 M-2 -12 L-1 -9 L0 -7 L3 -3 L5 0 L6 2 M-2 -12 L-1 -12 L-1 -10 L0 -7 M3 -3 L6 0 L7 2 L7 3 M7 3 L6 2 L4 1 L0 0 L-4 0 L-7 1 L-8 3 L-8 5 L-7 7 L-5 8 L-1 9 L3 9 M-8 5 L-7 6 L-5 7 L-1 8 L4 8 L3 9","-14 13 M-6 -12 L-4 -11 L-5 1 L-5 6 L-4 8 M-5 -11 L-6 1 L-6 5 L-5 7 L-4 8 L-2 9 L1 9 L4 8 L7 6 L9 4","-14 13 M0 -12 L2 -11 L2 1 L1 3 L-1 4 L-3 3 L-4 1 L-4 0 L-3 -2 L-1 -3 L1 -2 L2 0 L2 4 L1 8 L-1 10 M1 -11 L2 -6 M2 4 L1 7 L-1 10 M-10 -8 L-8 -6 L-5 -6 L4 -7 L8 -8 L10 -7 M-9 -7 L-5 -6 M4 -7 L10 -7","-14 13 M-6 -8 L-4 -7 L-4 4 L-3 6 L-2 7 L0 8 L8 8 M-5 -7 L-4 -4 M3 8 L6 7 L7 7 L8 8 M3 -11 L5 -10 L5 2 L4 4 L3 3 L0 1 M4 -10 L5 -7 M5 -1 L4 2 L3 3 M-10 -4 L-8 -2 L-6 -2 L-2 -3 L3 -4 L7 -5 L9 -5 L10 -4 M-9 -3 L-2 -3 M3 -4 L10 -4","-14 13 M-4 -11 L-2 -9 L4 -11 M-3 -10 L-1 -10 L4 -11 L5 -10 M5 -10 L2 -7 L-4 -3 L-8 -1 M4 -11 L3 -9 L1 -7 L-4 -3 M-9 -2 L-7 0 L-3 -2 M-8 -1 L-3 -2 L3 -3 L8 -4 L9 -3 M3 -3 L9 -3 M3 -3 L1 -2 L-1 0 L-2 2 L-2 4 L-1 6 L0 7 L3 8 L7 8 M-1 6 L2 7 L6 7 L7 8","-14 13 M-4 -12 L-2 -11 L-2 -9 L-4 -3 L-5 0 L-7 5 L-9 9 M-3 -11 L-3 -8 L-4 -3 M-5 0 L-7 4 L-9 7 L-9 9 M-10 -5 L-8 -4 L-5 -4 L-2 -5 L0 -6 L2 -7 M0 -6 L1 -8 L2 -7 M3 -4 L6 -4 L9 -3 L7 -3 L5 -2 M6 -4 L7 -3 M0 4 L1 6 L2 7 L4 8 L9 8 M1 6 L3 7 L10 7 L9 8","-14 13 M-5 -12 L-3 -11 L-3 -9 L-5 -4 L-6 0 L-6 2 L-5 3 M-4 -11 L-4 -7 M-5 -4 L-5 3 M-10 -8 L-7 -7 L-3 -7 L1 -8 L3 -9 M1 -8 L2 -10 L3 -9 M-5 3 L-3 1 L0 -1 L3 -2 L6 -2 L8 -1 L9 1 L9 4 L8 6 L5 8 L1 9 L-3 9 M6 -2 L7 -1 L8 1 L8 4 L7 6 L5 8","-14 13 M-10 -6 L-8 -4 L-3 -6 L1 -7 L5 -7 L8 -6 L9 -5 L10 -3 L10 0 L9 2 L8 3 L6 4 L3 5 L-2 6 M-9 -5 L-3 -6 M5 -7 L7 -6 L8 -5 L9 -3 L9 0 L8 2 L6 4","-14 13 M-10 -9 L-8 -7 L-6 -7 L-2 -8 L3 -9 L7 -10 L9 -10 L10 -9 M-9 -8 L-2 -8 M3 -9 L10 -9 M7 -9 L4 -8 L1 -6 L-1 -3 L-2 0 L-2 3 L-1 6 L0 7 L2 8 L6 9 L9 9 M-2 3 L-1 5 L0 6 L2 7 L6 8 L8 8 L9 9","-14 13 M-3 -12 L-1 -11 L-1 -1 M-2 -11 L-2 -5 L-1 -1 M5 -4 L7 -2 L-1 -1 M6 -3 L2 -2 L-1 -1 L-4 0 L-6 1 L-7 3 L-7 5 L-6 7 L-5 8 L-3 9 L8 9 M-6 7 L-4 8 L7 8 L8 9","-14 13 M-5 -12 L-3 -11 L-3 -9 L-5 -3 L-6 0 L-8 5 L-10 9 M-4 -11 L-4 -8 L-5 -3 M-6 0 L-8 4 L-10 7 L-10 9 M-10 -5 L-8 -4 L-6 -4 L-3 -5 L-1 -6 L1 -7 M-1 -6 L0 -8 L1 -7 M4 -8 L6 -8 L8 -7 L10 -5 L8 -6 L6 -5 M6 -8 L8 -6 M4 -3 L4 -1 L5 2 L6 4 L6 6 L5 8 L3 9 L0 9 L-2 8 L-3 6 L-2 4 L0 3 L3 3 L5 4 L9 8 M4 -1 L5 4 L5 7 L3 9 M7 6 L8 8 L9 8","-14 13 M-9 -11 L-7 -10 L-7 -8 L-8 -5 L-9 -1 M-8 -10 L-8 -7 L-9 -1 L-9 3 L-8 7 L-7 8 L-7 6 L-6 2 L-5 -1 M-9 3 L-8 5 L-7 6 M1 -8 L4 -9 L7 -9 L9 -8 L7 -8 L5 -7 M5 -9 L7 -8 M-1 1 L-1 3 L0 5 L3 6 L10 6 M-1 3 L0 4 L3 5 L8 5 L10 6","-14 13 M-8 -9 L-6 -8 L-6 -3 M-7 -8 L-6 -3 L-5 0 L-4 2 L-3 4 L-2 5 M-4 2 L-2 4 L-2 5 M0 -11 L2 -10 L2 -8 L0 -3 L-3 4 L-5 7 L-7 8 L-9 8 L-10 6 L-10 4 L-9 1 L-8 -1 L-6 -3 L-3 -5 L1 -6 L4 -6 L7 -5 L9 -3 L10 0 L10 3 L9 6 L8 7 L6 8 L4 8 L2 7 L1 6 L1 5 L2 4 L4 3 L6 3 L8 4 L10 7 M1 -10 L1 -8 L0 -3 M-8 8 L-9 6 L-9 3 L-8 0 L-6 -3 M4 -6 L6 -5 L8 -3 L9 0 L9 4 L8 7 M8 4 L10 6 L10 7","-14 13 M-5 -12 L-3 -11 L-3 -9 L-5 9 M-4 -11 L-4 9 L-5 9 L-6 6 L-7 5 L-9 4 M-10 -6 L-9 -4 L-7 -4 L-3 -6 L-3 -5 M-9 -5 L-6 -5 L-4 -6 L-5 -2 M-3 -5 L-5 -2 L-7 1 L-10 5 L-10 4 L-7 1 L-3 -3 L1 -6 L4 -7 L6 -7 L8 -6 L9 -4 L9 3 L8 6 L7 7 L5 8 L3 8 L1 7 L0 6 L0 5 L1 4 L3 3 L5 3 L7 4 L8 5 L10 8 M6 -7 L7 -6 L8 -4 L8 4 L7 7 M8 5 L10 7 L10 8","-14 13 M-1 -10 L0 -8 L0 -5 L-1 -2 L-2 0 L-4 3 L-6 5 L-8 5 L-9 4 L-10 2 L-10 -1 L-9 -4 L-7 -7 L-4 -9 L-1 -10 L2 -10 L5 -9 L7 -8 L9 -6 L10 -3 L10 0 L9 3 L7 5 L5 6 L2 7 L-1 7 M-4 3 L-6 4 L-8 4 L-9 2 L-9 -1 L-8 -5 L-7 -7 M5 -9 L8 -6 L9 -3 L9 0 L8 3 L5 6","-14 13 M-9 -11 L-7 -10 L-7 -8 L-8 -5 L-9 -1 M-8 -10 L-8 -7 L-9 -1 L-9 3 L-8 7 L-7 8 L-7 6 L-6 2 L-5 -1 M-9 3 L-8 5 L-7 6 M3 -11 L5 -10 L5 5 L4 7 L2 8 L0 8 L-2 7 L-3 5 L-2 3 L0 2 L2 2 L4 3 L9 7 M4 -10 L5 -6 M4 3 L9 6 L9 7 M-2 -5 L0 -4 L3 -4 L7 -5 L9 -6 M7 -5 L8 -7 L9 -6","-14 13 M-9 -11 L-8 -10 L-6 -9 L-2 -9 M-8 -10 L-3 -10 L-2 -9 M-2 -9 L-5 -7 L-7 -5 L-9 -2 L-10 1 L-10 4 L-9 6 L-8 7 L-6 8 L-3 8 L0 7 L2 5 L3 3 L4 -1 L4 -5 L3 -9 L4 -9 M-10 3 L-9 5 L-8 6 L-6 7 L-3 7 L0 6 L2 4 L3 2 L4 -1 M4 -9 L6 -6 L7 -4 L9 -1 L10 1 L8 1 L7 2 M3 -9 L6 -6 M7 -4 L8 -1 L8 1","-14 13 M-2 -12 L-1 -9 L1 -8 M-1 -10 L1 -9 L2 -9 L2 -8 M2 -8 L-1 -7 L-3 -6 L-4 -5 L-4 -3 L-3 -2 L-1 -1 L1 0 L2 1 L3 3 L3 5 L2 7 L0 8 L-2 8 L-5 7 L-7 5 M-1 -1 L1 1 L2 3 L2 5 L1 7 L0 8 M-9 7 L-6 4 L-3 2 L0 1 M4 1 L7 2 L9 4 L10 6 L7 6 M-9 7 L-9 6 L-6 4 M4 1 L6 2 L8 4 L9 6","-14 13 M-10 -2 L-8 0 L-5 -5 M-9 -1 L-4 -6 L-2 -6 L3 -1 L7 2 L9 3 L10 4 L8 4 L6 5 M3 -1 L8 4","-14 13 M-9 -11 L-7 -10 L-7 -8 L-8 -5 L-9 -1 M-8 -10 L-8 -7 L-9 -1 L-9 3 L-8 7 L-7 8 L-7 6 L-6 2 L-5 -1 M-9 3 L-8 5 L-7 6 M-1 -11 L1 -10 L3 -10 L7 -11 M3 -10 L5 -11 L6 -12 L7 -11 M-2 -3 L1 -2 L4 -2 L7 -3 L9 -4 M7 -3 L8 -5 L9 -4 M3 -10 L5 -9 L5 5 L4 7 L2 8 L0 8 L-2 7 L-3 5 L-2 3 L0 2 L2 2 L4 3 L9 7 M4 -9 L5 -5 M4 3 L9 6 L9 7","-14 13 M0 -12 L2 -11 L2 6 L1 8 L-1 9 L-3 9 L-5 8 L-6 6 L-5 4 L-3 3 L-1 3 L2 4 L5 6 L8 9 M1 -11 L2 -7 M5 6 L8 8 L8 9 M-10 -9 L-8 -7 L1 -7 L8 -8 M-9 -8 L-4 -7 M1 -7 L5 -8 L7 -9 L8 -8 M-5 -2 L-3 -1 L1 -1 L5 -2 L7 -3 M5 -2 L6 -4 L7 -3","-14 13 M-8 -11 L-7 -9 L-5 -9 L-2 -10 L1 -12 L2 -11 M-7 -10 L-2 -10 M2 -11 L-2 -5 L-5 1 L-7 4 L-8 5 L-9 5 L-10 4 L-10 2 L-9 0 L-7 -1 L-2 -1 L2 0 L5 1 L10 3 M1 -12 L-2 -5 M2 0 L10 2 L10 3 M4 -5 L6 -4 L6 2 L5 5 L3 7 L1 8 L-2 9 M5 -4 L5 3 L4 6","-14 13 M-5 -12 L-3 -11 L-3 -9 L-4 -5 L-5 -1 L-6 2 L-7 4 L-8 5 L-9 5 L-10 4 L-10 2 L-9 0 L-8 -1 L-7 -1 L-6 0 L-6 5 L-5 8 L-3 9 L3 9 L6 8 L7 7 L6 6 L5 4 L4 0 L4 -4 L5 -5 L7 -5 L9 -4 L10 -2 L10 -1 L9 -1 L7 0 M-4 -11 L-4 -5 M-6 5 L-5 7 L-3 8 L3 8 L5 7 L6 6 M7 -5 L9 -3 L9 -1 M-10 -7 L-7 -6 L-4 -6 L-1 -7 L1 -8 M-1 -7 L0 -9 L1 -8","-14 13 M-8 -9 L-6 -8 L-6 -3 M-7 -8 L-6 -3 L-5 0 L-4 2 L-3 4 L-2 5 M-4 2 L-2 4 L-2 5 M1 -11 L3 -10 L3 -8 L2 -5 L0 0 L-1 2 L-3 5 L-5 7 L-7 8 L-9 8 L-10 7 L-10 5 L-9 2 L-8 0 L-6 -2 L-3 -4 L0 -5 L4 -5 L7 -4 L9 -2 L10 1 L10 4 L9 6 L8 7 L6 8 L3 9 L0 9 M2 -10 L2 -8 L0 0 M-8 8 L-9 7 L-9 4 L-8 1 L-6 -2 M4 -5 L6 -4 L8 -2 L9 1 L9 4 L8 6 L6 8","-14 13 M-3 -12 L-1 -11 L-1 -9 L-2 -5 M-2 -11 L-2 2 L-1 6 L0 8 L2 9 L6 9 L8 8 L9 6 L9 4 L8 2 L6 0 L3 -2 M5 9 L7 8 L8 6 L8 3 L7 1 M-6 -8 L-5 -7 L-2 -6 L1 -6 M-5 -7 L0 -7 L1 -6 M1 -6 L-2 -5 L-4 -4 L-6 -2 L-7 0 L-6 2 L-4 3 L1 3","-14 13 M-2 -12 L0 -11 L1 -10 L2 -8 L1 -7 L-2 -8 L-5 -8 L-6 -7 L-6 -5 L-3 2 L-1 9 M0 -11 L1 -9 L1 -7 M-3 2 L0 8 L-1 9 M-10 -4 L-9 -2 L-7 -2 L-4 -4 L0 -6 L4 -7 L7 -7 L9 -6 L10 -4 L10 -2 L9 0 L8 1 L5 2 L2 2 L-1 1 M-9 -3 L-7 -3 L-4 -4 M7 -7 L8 -6 L9 -4 L9 -2 L8 0 L7 1 L5 2","-14 13 M-10 -10 L-8 -9 L-8 -7 L-9 -5 L-10 -2 M-9 -9 L-9 -7 L-10 -2 L-10 1 L-9 4 L-8 5 L-6 6 L-5 6 L-5 4 L-4 1 L-3 -1 M-8 5 L-6 5 L-5 4 M5 -6 L7 -5 L9 -2 L10 1 L10 3 L8 2 L5 3 M9 -2 L9 1 L8 2","-14 13 M-10 -8 L-8 -7 L-8 -5 L-9 -2 M-9 -7 L-9 2 L-8 5 L-7 6 L-7 4 L-6 1 L-5 -1 L-3 -4 L0 -7 L3 -8 L6 -8 L8 -7 L9 -6 L10 -4 L10 -1 L9 1 L7 3 L5 4 L2 4 L0 3 L-2 1 L-3 -2 L-3 -5 L-2 -9 L-1 -11 L1 -12 L3 -12 L4 -10 L4 1 L3 5 L2 7 L-1 9 M-9 2 L-8 4 L-7 4 M8 -7 L9 -4 L9 -1 L8 2 M4 1 L3 4 L2 6 L-1 9","-14 13 M-4 -13 L-3 -12 L-1 -11 L3 -11 M-3 -12 L2 -12 L3 -11 L-1 -9 M-8 -5 L-8 -4 L-7 -3 L-5 -3 L0 -5 L3 -6 L4 -5 M-8 -4 L-5 -4 L0 -5 M4 -5 L0 -2 L-6 4 L-10 8 M3 -6 L0 -2 M-10 8 L-10 7 L-6 4 L-4 3 L0 3 L1 4 L2 8 L3 9 L10 9 M5 9 L8 8 L9 8 L10 9","-14 13 M-2 -12 L1 -11 L1 -9 L0 -4 M0 -11 L0 6 L-1 8 L-3 9 L-6 9 L-8 8 L-9 7 L-9 5 L-8 4 L-6 3 L-3 3 L0 4 L4 6 L9 9 M0 4 L5 6 L9 8 L9 9 M0 -4 L3 -4 L7 -5 M3 -4 L5 -5 L6 -6 L7 -5","-14 13 M-3 -12 L-1 -12 L1 -11 L2 -10 L0 -10 L-2 -9 M-1 -12 L0 -11 L0 -10 M-6 -6 L-7 -4 L-8 0 L-8 2 L-7 3 L-3 0 L-1 -1 L2 -2 L5 -2 L7 -1 L8 1 L8 3 L7 5 L5 7 L3 8 L-1 9 L-3 9 M-8 0 L-7 2 L-6 2 M5 -2 L6 -1 L7 1 L7 3 L6 5 L4 7 L2 8 L-1 9","-14 13 M-6 -12 L-4 -11 L-4 -9 L-6 -5 M-5 -11 L-5 -9 L-6 -5 L-6 -2 L-5 1 L-4 2 L-4 0 L-3 -3 L-1 -6 L1 -8 L3 -9 L5 -9 L6 -8 L7 -5 L7 0 L6 4 L4 7 L1 9 L-3 10 M-6 -2 L-5 0 L-4 0 M4 -9 L5 -8 L6 -5 L6 0 L5 4 L3 7 L1 9","-14 13 M-5 -11 L-4 -9 L-2 -9 L3 -11 M-4 -10 L-2 -10 L3 -11 L4 -10 M4 -10 L0 -7 L-4 -2 L-7 3 M3 -11 L0 -7 M-4 -2 L-7 1 L-7 3 M-7 3 L-5 1 L-2 -1 L1 -2 L4 -2 L6 -1 L7 0 L8 2 L8 5 L7 7 L6 8 L4 9 L1 9 L-1 8 L-2 7 L-2 6 L-1 5 L1 5 L3 6 L5 8 M4 -2 L6 0 L7 2 L7 5 L6 7 L4 9","-14 13 M-5 -12 L-3 -11 L-3 -9 L-5 9 M-4 -11 L-4 9 L-5 9 L-6 6 L-7 5 L-9 4 M-10 -6 L-9 -4 L-7 -4 L-3 -6 L-3 -5 M-9 -5 L-6 -5 L-3 -6 L-5 -2 M-3 -5 L-5 -2 L-7 1 L-10 5 L-10 4 L-7 1 L-3 -3 L1 -6 L4 -7 L5 -7 L7 -6 L8 -4 L7 6 L7 8 L8 9 M5 -7 L6 -6 L7 -4 L6 6 L6 8 L7 9 L8 9 L9 8 L10 6","-14 13 M-5 -11 L-4 -9 L-2 -9 L3 -11 M-4 -10 L-2 -10 L3 -11 L4 -10 M4 -10 L0 -7 L-4 -2 L-7 3 M3 -11 L0 -7 M-4 -2 L-7 1 L-7 3 M-7 3 L-5 1 L-2 -1 L1 -2 L4 -2 L6 -1 L7 0 L8 2 L8 5 L7 7 L5 9 L2 10 L0 10 M4 -2 L6 0 L7 2 L7 5 L6 8","-14 13 M-5 -12 L-3 -11 L-3 -9 L-5 9 M-4 -11 L-4 9 L-5 9 L-6 6 L-7 5 L-9 4 M-10 -6 L-9 -4 L-7 -4 L-3 -6 L-3 -5 M-9 -5 L-6 -5 L-3 -6 L-5 -2 M-3 -5 L-5 -2 L-7 1 L-10 5 L-10 4 L-7 1 L-4 -2 L-1 -4 L2 -5 L5 -5 L7 -4 L8 -3 L9 -1 L9 2 L8 5 L6 7 L4 8 L1 9 M5 -5 L7 -3 L8 -1 L8 2 L7 5 L4 8","-14 13 M-5 -11 L-4 -9 L-2 -9 L2 -11 M-4 -10 L-2 -10 L2 -11 L3 -10 M3 -10 L-1 -4 L-5 4 L-6 6 L-7 7 L-9 7 L-10 5 L-10 3 L-9 1 L-7 -1 L-4 -3 L0 -4 L4 -4 L7 -3 L9 -1 L10 1 L10 4 L9 6 L7 8 L5 9 L2 9 L0 8 L-1 7 L-1 6 L0 5 L2 5 L4 6 L6 8 M2 -11 L-1 -4 M-8 7 L-9 5 L-9 3 L-8 0 M8 -2 L9 1 L9 4 L8 7","-14 13 M-4 -13 L-3 -12 L-1 -11 L3 -11 M-3 -12 L2 -12 L3 -11 L-1 -9 M-7 -5 L-7 -4 L-6 -3 L-5 -3 L-2 -5 L0 -6 M-7 -4 L-6 -4 L-3 -5 L0 -6 L2 -6 L5 -5 L6 -3 L6 0 L5 3 L3 6 L0 8 L-4 10 M2 -6 L4 -5 L5 -3 L5 0 L4 3 L3 5 L1 7 L-2 9","-14 13 M-6 -11 L-5 -9 L-3 -9 L-1 -10 L2 -12 M-5 -10 L-3 -10 L0 -11 L2 -12 L3 -11 M3 -11 L-1 -8 L-5 -4 L-8 0 M2 -12 L-1 -8 M-8 0 L-8 -2 L-5 -4 L-3 -5 L0 -6 L3 -6 L5 -5 L6 -3 L6 -1 L5 1 L3 2 L-2 2 L-3 1 L-3 -1 L-2 -2 L0 -2 L1 -1 L1 1 L0 2 L-4 3 L-7 5 L-10 8 L-10 9 L-9 9 L-7 5 M-8 7 L-6 6 L-4 6 L-2 8 L-1 8 L1 6 L4 5 L7 5 L9 6 L10 7 L10 9 L9 8 L7 8 M-4 6 L-2 7 L-1 7 L1 6 M7 5 L9 7 L9 8","-14 13 M-2 -12 L0 -11 L0 -10 L-2 -6 L-4 -3 L-7 0 L-10 3 M-1 -11 L-1 -10 L-2 -6 M-7 0 L-10 2 L-10 3 M-5 -2 L-3 -3 L-1 -3 L1 -2 L2 0 L2 4 M-1 -3 L0 -2 L1 0 L1 5 L2 4 M-9 -8 L-6 -7 L-3 -7 L1 -8 L5 -9 M1 -8 L4 -10 L5 -9 M9 -3 L10 -1 L2 0 L-1 1 L-3 2 L-4 4 L-4 6 L-3 8 L-1 9 L7 9 M9 -2 L2 0 M2 9 L6 8 L7 9","-14 13 M-1 -12 L1 -10 L-2 -5 L-6 2 L-10 9 M0 -11 L-2 -5 M-10 9 L-10 7 L-6 2 L-4 0 L-2 -1 L0 -1 L2 0 L2 5 L3 7 L4 8 M0 -1 L1 0 L1 5 L2 7 L4 8 L6 8 L8 7 L9 5 L10 2","-14 13 M-10 7 L-11 8 L-10 9 L-9 8 L-10 7","-14 13 M-10 7 L-11 8 L-10 9 L-9 8 L-10 7","-14 13 M-10 7 L-11 8 L-10 9 L-9 8 L-10 7","-14 13 M-10 7 L-11 8 L-10 9 L-9 8 L-10 7","-14 13 M-4 -12 L-2 -11 L-2 -9 L-3 -6 L-5 -1 L-10 9 M-3 -11 L-3 -9 L-5 -3 L-7 2 L-10 9 M-10 -5 L-10 -4 L-9 -3 L-8 -3 L-5 -5 L-3 -6 L0 -6 L2 -5 L3 -3 L3 0 L2 4 L0 8 L-1 9 L-2 9 L-2 8 L-3 7 L-5 6 M-10 -4 L-8 -4 L-5 -5 M0 -6 L2 -4 L2 0 L1 4 L0 6 L-2 8 M5 -5 L7 -4 L9 -2 L10 0 L10 2 L9 1 L7 2 M8 -3 L9 -1 L9 1 M5 -10 L7 -8 M7 -12 L9 -10","-14 13 M-4 -12 L-1 -11 L0 -7 L1 -4 L3 0 L6 4 L5 5 M-2 -11 L0 -7 M3 0 L5 5 M-6 -7 L-4 -6 L-1 -6 L2 -7 M-9 -3 L-8 -2 L-5 -1 L0 -1 L5 -2 L8 -3 M5 -2 L7 -4 L8 -3 M5 5 L3 4 L0 3 L-4 3 L-6 4 L-7 5 L-7 7 L-6 8 L-4 9 L-1 10 L5 10 M-4 9 L4 9 L5 10 M5 -10 L7 -8 M7 -12 L9 -10","-14 13 M2 -12 L4 -11 L4 -10 L-4 -2 M3 -11 L2 -9 L-4 -2 L-4 -1 L1 4 L3 7 L4 9 M-4 -1 L4 6 L5 8 L4 9 M7 -10 L9 -8 M9 -12 L11 -10","-14 13 M-9 -11 L-7 -10 L-7 -8 L-8 -5 L-9 -1 M-8 -10 L-8 -7 L-9 -1 L-9 3 L-8 7 L-7 8 L-7 6 L-6 2 L-5 -1 L-4 -3 L-3 -4 L-1 -5 L8 -5 L10 -6 M-9 3 L-8 5 L-7 6 M4 -5 L8 -6 L9 -7 L10 -6 M4 -12 L6 -11 L6 3 L5 6 L3 8 L0 10 M5 -11 L6 -8 M6 0 L5 4 L3 7 L0 10 M9 -11 L11 -9 M11 -13 L13 -11","-14 13 M-5 -10 L-3 -9 L0 -8 L2 -8 L5 -9 M-3 -9 L2 -9 L4 -10 L5 -9 L-1 -6 M-7 1 L-7 3 L-6 5 L-4 6 L0 7 L7 7 M-4 6 L6 6 L7 7 M7 -11 L9 -9 M9 -13 L11 -11","-14 13 M-8 -7 L-7 -6 L-4 -5 L0 -5 L4 -6 L6 -7 L7 -8 M4 -6 L6 -8 L7 -8 M-2 -12 L-1 -9 L0 -7 L3 -3 L5 0 L6 2 M-2 -12 L-1 -12 L-1 -10 L0 -7 M3 -3 L6 0 L7 2 L7 3 M7 3 L6 2 L4 1 L0 0 L-4 0 L-7 1 L-8 3 L-8 5 L-7 7 L-5 8 L-1 9 L3 9 M-8 5 L-7 6 L-5 7 L-1 8 L4 8 L3 9 M8 -11 L10 -9 M10 -13 L12 -11","-14 13 M-6 -12 L-4 -11 L-5 1 L-5 6 L-4 8 M-5 -11 L-6 1 L-6 5 L-5 7 L-4 8 L-2 9 L1 9 L4 8 L7 6 L9 4 M1 -10 L3 -8 M3 -12 L5 -10","-14 13 M0 -12 L2 -11 L2 1 L1 3 L-1 4 L-3 3 L-4 1 L-4 0 L-3 -2 L-1 -3 L1 -2 L2 0 L2 4 L1 8 L-1 10 M1 -11 L2 -6 M2 4 L1 7 L-1 10 M-10 -8 L-8 -6 L-5 -6 L4 -7 L8 -8 L10 -7 M-9 -7 L-5 -6 M4 -7 L10 -7 M6 -12 L8 -10 M9 -13 L11 -11","-14 13 M-6 -8 L-4 -7 L-4 4 L-3 6 L-2 7 L0 8 L8 8 M-5 -7 L-4 -4 M3 8 L6 7 L7 7 L8 8 M3 -11 L5 -10 L5 2 L4 4 L3 3 L0 1 M4 -10 L5 -7 M5 -1 L4 2 L3 3 M-10 -4 L-8 -2 L-6 -2 L-2 -3 L3 -4 L7 -5 L9 -5 L10 -4 M-9 -3 L-2 -3 M3 -4 L10 -4 M8 -10 L10 -8 M10 -12 L12 -10","-14 13 M-4 -11 L-2 -9 L4 -11 M-3 -10 L-1 -10 L4 -11 L5 -10 M5 -10 L2 -7 L-4 -3 L-8 -1 M4 -11 L3 -9 L1 -7 L-4 -3 M-9 -2 L-7 0 L-3 -2 M-8 -1 L-3 -2 L3 -3 L8 -4 L9 -3 M3 -3 L9 -3 M3 -3 L1 -2 L-1 0 L-2 2 L-2 4 L-1 6 L0 7 L3 8 L7 8 M-1 6 L2 7 L6 7 L7 8 M8 -10 L10 -8 M10 -12 L12 -10","-14 13 M-4 -12 L-2 -11 L-2 -9 L-4 -3 L-5 0 L-7 5 L-9 9 M-3 -11 L-3 -8 L-4 -3 M-5 0 L-7 4 L-9 7 L-9 9 M-10 -5 L-8 -4 L-5 -4 L-2 -5 L0 -6 L2 -7 M0 -6 L1 -8 L2 -7 M3 -4 L6 -4 L9 -3 L7 -3 L5 -2 M6 -4 L7 -3 M0 4 L1 6 L2 7 L4 8 L9 8 M1 6 L3 7 L10 7 L9 8 M6 -10 L8 -8 M8 -12 L10 -10","-14 13 M-5 -12 L-3 -11 L-3 -9 L-5 -4 L-6 0 L-6 2 L-5 3 M-4 -11 L-4 -7 M-5 -4 L-5 3 M-10 -8 L-7 -7 L-3 -7 L1 -8 L3 -9 M1 -8 L2 -10 L3 -9 M-5 3 L-3 1 L0 -1 L3 -2 L6 -2 L8 -1 L9 1 L9 4 L8 6 L5 8 L1 9 L-3 9 M6 -2 L7 -1 L8 1 L8 4 L7 6 L5 8 M6 -9 L8 -7 M8 -11 L10 -9","-14 13 M-10 -6 L-8 -4 L-3 -6 L1 -7 L5 -7 L8 -6 L9 -5 L10 -3 L10 0 L9 2 L8 3 L6 4 L3 5 L-2 6 M-9 -5 L-3 -6 M5 -7 L7 -6 L8 -5 L9 -3 L9 0 L8 2 L6 4 M8 -10 L10 -8 M10 -12 L12 -10","-14 13 M-10 -9 L-8 -7 L-6 -7 L-2 -8 L3 -9 L7 -10 L9 -10 L10 -9 M-9 -8 L-2 -8 M3 -9 L10 -9 M7 -9 L4 -8 L1 -6 L-1 -3 L-2 0 L-2 3 L-1 6 L0 7 L2 8 L6 9 L9 9 M-2 3 L-1 5 L0 6 L2 7 L6 8 L8 8 L9 9 M8 -5 L10 -3 M10 -7 L12 -5","-14 13 M-3 -12 L-1 -11 L-1 -1 M-2 -11 L-2 -5 L-1 -1 M5 -4 L7 -2 L-1 -1 M6 -3 L2 -2 L-1 -1 L-4 0 L-6 1 L-7 3 L-7 5 L-6 7 L-5 8 L-3 9 L8 9 M-6 7 L-4 8 L7 8 L8 9 M6 -9 L8 -7 M8 -11 L10 -9","-14 13 M-9 -11 L-7 -10 L-7 -8 L-8 -5 L-9 -1 M-8 -10 L-8 -7 L-9 -1 L-9 3 L-8 7 L-7 8 L-7 6 L-6 2 L-5 -1 M-9 3 L-8 5 L-7 6 M3 -11 L5 -10 L5 5 L4 7 L2 8 L0 8 L-2 7 L-3 5 L-2 3 L0 2 L2 2 L4 3 L9 7 M4 -10 L5 -6 M4 3 L9 6 L9 7 M-2 -5 L0 -4 L3 -4 L7 -5 L9 -6 M7 -5 L8 -7 L9 -6 M8 -11 L10 -9 M10 -13 L12 -11","-14 13 M-9 -11 L-8 -10 L-6 -9 L-2 -9 M-8 -10 L-3 -10 L-2 -9 M-2 -9 L-5 -7 L-7 -5 L-9 -2 L-10 1 L-10 4 L-9 6 L-8 7 L-6 8 L-3 8 L0 7 L2 5 L3 3 L4 -1 L4 -5 L3 -9 L4 -9 M-10 3 L-9 5 L-8 6 L-6 7 L-3 7 L0 6 L2 4 L3 2 L4 -1 M4 -9 L6 -6 L7 -4 L9 -1 L10 1 L8 1 L7 2 M3 -9 L6 -6 M7 -4 L8 -1 L8 1 M7 -10 L9 -8 M9 -12 L11 -10","-14 13 M-2 -12 L-1 -9 L1 -8 M-1 -10 L1 -9 L2 -9 L2 -8 M2 -8 L-1 -7 L-3 -6 L-4 -5 L-4 -3 L-3 -2 L-1 -1 L1 0 L2 1 L3 3 L3 5 L2 7 L0 8 L-2 8 L-5 7 L-7 5 M-1 -1 L1 1 L2 3 L2 5 L1 7 L0 8 M-9 7 L-6 4 L-3 2 L0 1 M4 1 L7 2 L9 4 L10 6 L7 6 M-9 7 L-9 6 L-6 4 M4 1 L6 2 L8 4 L9 6 M5 -9 L7 -7 M7 -11 L9 -9","-14 13 M-10 -2 L-8 0 L-5 -5 M-9 -1 L-4 -6 L-2 -6 L3 -1 L7 2 L9 3 L10 4 L8 4 L6 5 M3 -1 L8 4 M3 -8 L5 -6 M5 -10 L7 -8","-14 13 M-9 -11 L-7 -10 L-7 -8 L-8 -5 L-9 -1 M-8 -10 L-8 -7 L-9 -1 L-9 3 L-8 7 L-7 8 L-7 6 L-6 2 L-5 -1 M-9 3 L-8 5 L-7 6 M-1 -11 L1 -10 L3 -10 L7 -11 M3 -10 L5 -11 L6 -12 L7 -11 M-2 -3 L1 -2 L4 -2 L7 -3 L9 -4 M7 -3 L8 -5 L9 -4 M3 -10 L5 -9 L5 5 L4 7 L2 8 L0 8 L-2 7 L-3 5 L-2 3 L0 2 L2 2 L4 3 L9 7 M4 -9 L5 -5 M4 3 L9 6 L9 7 M9 -9 L11 -7 M11 -11 L13 -9","-14 13 M-9 -11 L-7 -10 L-7 -8 L-8 -5 L-9 -1 M-8 -10 L-8 -7 L-9 -1 L-9 3 L-8 7 L-7 8 L-7 6 L-6 2 L-5 -1 M-9 3 L-8 5 L-7 6 M3 -11 L5 -10 L5 5 L4 7 L2 8 L0 8 L-2 7 L-3 5 L-2 3 L0 2 L2 2 L4 3 L9 7 M4 -10 L5 -6 M4 3 L9 6 L9 7 M-2 -5 L0 -4 L3 -4 L7 -5 L9 -6 M7 -5 L8 -7 L9 -6 M9 -13 L8 -12 L8 -10 L9 -9 L11 -9 L12 -10 L12 -12 L11 -13 L9 -13","-14 13 M-9 -11 L-8 -10 L-6 -9 L-2 -9 M-8 -10 L-3 -10 L-2 -9 M-2 -9 L-5 -7 L-7 -5 L-9 -2 L-10 1 L-10 4 L-9 6 L-8 7 L-6 8 L-3 8 L0 7 L2 5 L3 3 L4 -1 L4 -5 L3 -9 L4 -9 M-10 3 L-9 5 L-8 6 L-6 7 L-3 7 L0 6 L2 4 L3 2 L4 -1 M4 -9 L6 -6 L7 -4 L9 -1 L10 1 L8 1 L7 2 M3 -9 L6 -6 M7 -4 L8 -1 L8 1 M8 -12 L7 -11 L7 -9 L8 -8 L10 -8 L11 -9 L11 -11 L10 -12 L8 -12","-14 13 M-2 -12 L-1 -9 L1 -8 M-1 -10 L1 -9 L2 -9 L2 -8 M2 -8 L-1 -7 L-3 -6 L-4 -5 L-4 -3 L-3 -2 L-1 -1 L1 0 L2 1 L3 3 L3 5 L2 7 L0 8 L-2 8 L-5 7 L-7 5 M-1 -1 L1 1 L2 3 L2 5 L1 7 L0 8 M-9 7 L-6 4 L-3 2 L0 1 M4 1 L7 2 L9 4 L10 6 L7 6 M-9 7 L-9 6 L-6 4 M4 1 L6 2 L8 4 L9 6 M6 -11 L5 -10 L5 -8 L6 -7 L8 -7 L9 -8 L9 -10 L8 -11 L6 -11","-14 13 M-10 -2 L-8 0 L-5 -5 M-9 -1 L-4 -6 L-2 -6 L3 -1 L7 2 L9 3 L10 4 L8 4 L6 5 M3 -1 L8 4 M4 -10 L3 -9 L3 -7 L4 -6 L6 -6 L7 -7 L7 -9 L6 -10 L4 -10","-14 13 M-9 -11 L-7 -10 L-7 -8 L-8 -5 L-9 -1 M-8 -10 L-8 -7 L-9 -1 L-9 3 L-8 7 L-7 8 L-7 6 L-6 2 L-5 -1 M-9 3 L-8 5 L-7 6 M-1 -11 L1 -10 L3 -10 L7 -11 M3 -10 L5 -11 L6 -12 L7 -11 M-2 -3 L1 -2 L4 -2 L7 -3 L9 -4 M7 -3 L8 -5 L9 -4 M3 -10 L5 -9 L5 5 L4 7 L2 8 L0 8 L-2 7 L-3 5 L-2 3 L0 2 L2 2 L4 3 L9 7 M4 -9 L5 -5 M4 3 L9 6 L9 7 M10 -11 L9 -10 L9 -8 L10 -7 L12 -7 L13 -8 L13 -10 L12 -11 L10 -11","-14 13 M-10 -11 L-8 -9 L-3 -10 L3 -11 L8 -12 L10 -10 M-9 -10 L-3 -10 M3 -11 L9 -11 M10 -10 L8 -8 L4 -5 L2 -4 M9 -11 L7 -8 L5 -6 L2 -4 M0 -5 L2 -4 L2 -1 L1 3 L-1 6 L-4 9 M0 -5 L1 -4 L1 -1 L0 3 L-2 7","-14 13 M4 -12 L6 -10 L3 -6 L0 -3 L-4 0 L-7 2 M5 -11 L4 -9 L1 -5 L-3 -1 L-7 2 M1 -4 L3 -3 L3 10 M1 -4 L2 -3 L2 9 L3 10","-14 13 M-2 -12 L1 -11 L1 -9 L0 -7 M-2 -12 L0 -11 L0 -7 M-8 -9 L-7 -7 L-7 -2 L-6 -1 M-6 -7 L-6 -1 M-6 -7 L7 -7 M-8 -9 L-7 -8 L-3 -7 M3 -7 L6 -8 L8 -6 M8 -6 L5 0 L3 3 L0 6 L-3 8 L-5 9 M7 -7 L6 -4 L4 0 L1 4 L-2 7 L-5 9","-14 13 M-1 -7 L1 -6 L1 5 M0 -6 L0 5 M-8 -8 L-6 -6 L6 -8 L8 -7 M-7 -7 L8 -7 M-10 4 L-8 6 L8 4 L10 5 M-9 5 L10 5","-14 13 M0 -12 L3 -11 L3 7 L2 9 L1 7 L-2 5 M2 -11 L2 6 L1 7 M-10 -6 L-8 -4 L-3 -5 L3 -6 L8 -7 L10 -6 M-9 -5 L-3 -5 M3 -6 L10 -6 M1 -5 L-2 -1 L-6 3 L-10 6 M2 -5 L0 -2 L-3 1 L-7 4 L-10 6","-14 13 M-1 -12 L1 -10 L0 -7 L-2 -2 L-4 2 L-6 5 L-9 9 M0 -11 L-1 -8 L-3 -2 L-5 3 L-9 9 M-9 -6 L-7 -4 L-3 -5 L2 -6 L6 -7 L8 -5 M-8 -5 L-3 -5 M2 -6 L7 -6 M8 -5 L7 1 L6 5 L5 7 L3 9 L2 8 L0 7 M7 -6 L6 1 L5 5 L4 7 L2 8","-14 13 M-3 -12 L0 -11 L2 9 M-1 -11 L1 10 L2 9 M-8 -6 L-6 -4 L-2 -5 L2 -6 L6 -7 L8 -6 M-7 -5 L-2 -5 M2 -6 L8 -6 M-10 0 L-8 2 L-3 1 L3 0 L8 -1 L10 0 M-9 1 L-3 1 M3 0 L10 0","-14 13 M-2 -12 L0 -10 L-2 -6 L-4 -3 L-6 -1 L-8 1 M-1 -11 L-2 -8 L-4 -4 L-6 -1 M-1 -8 L1 -7 L6 -7 M3 -7 L5 -8 L7 -6 M7 -6 L4 0 L1 4 L-2 7 L-5 9 L-7 10 M6 -7 L5 -4 L3 0 L0 4 L-3 7 L-7 10","-14 13 M-4 -12 L-2 -10 L-4 -6 L-6 -3 L-8 -1 L-10 1 M-3 -11 L-4 -8 L-6 -4 L-8 -1 M-6 -3 L2 -4 L7 -5 L10 -4 M2 -4 L10 -4 M0 -3 L2 -1 L0 3 L-2 6 L-4 8 L-6 10 M1 -2 L0 1 L-2 5 L-4 8","-14 13 M-8 -8 L-6 -6 L6 -8 L8 -6 M-7 -7 L7 -7 M8 -6 L7 -3 L6 4 M7 -7 L6 -2 L6 4 M-8 4 L-6 6 L6 4 L7 5 M-7 5 L7 5","-14 13 M-6 -9 L-4 -8 L-4 -3 L-5 1 M-5 -8 L-5 1 M2 -12 L5 -11 L5 -6 L4 -1 L3 2 L2 4 L0 7 L-2 9 M4 -11 L4 -6 L3 -1 L2 3 L0 7 M-10 -5 L-8 -3 L-3 -4 L3 -5 L8 -6 L10 -5 M-9 -4 L-3 -4 M3 -5 L10 -5","-14 13 M-5 -11 L-3 -10 L-2 -9 L-2 -8 L-3 -8 L-4 -10 L-5 -11 M-10 -4 L-8 -3 L-7 -2 L-7 -1 L-8 -1 L-9 -3 L-10 -4 M-9 6 L-7 8 L-3 6 L1 3 L5 -1 L9 -6 M-8 7 L-3 5 L1 2 L9 -6","-14 13 M-8 -9 L-6 -7 L5 -9 L7 -7 M-7 -8 L6 -8 M7 -7 L5 -4 L2 -1 L-1 1 L-3 2 L-8 4 M6 -8 L5 -6 L3 -3 L1 -1 L-2 1 L-8 4 M3 1 L6 3 L8 5 L8 6 L7 6 L6 4 L3 1","-14 13 M-3 -11 L0 -10 L0 -8 L-1 1 M-1 -10 L-1 4 L0 6 L2 7 L9 7 M4 7 L8 6 L9 7 M-10 -4 L-8 -2 L-3 -3 L3 -4 L8 -5 L10 -3 M-9 -3 L-3 -3 M3 -4 L9 -4 M10 -3 L7 -1 L4 2 M9 -4 L4 2","-14 13 M-9 -9 L-7 -8 L-6 -7 L-6 -6 L-7 -6 L-8 -8 L-9 -9 M6 -10 L8 -8 L5 -2 L2 2 L-1 5 L-4 7 L-6 8 M7 -9 L6 -6 L4 -2 L1 2 L-2 5 L-6 8","-14 13 M-2 -12 L0 -10 L-2 -6 L-4 -3 L-6 -1 L-8 1 M-1 -11 L-2 -8 L-4 -4 L-6 -1 M-1 -8 L1 -7 L6 -7 M3 -7 L5 -8 L7 -6 M7 -6 L4 0 L1 4 L-2 7 L-5 9 L-7 10 M6 -7 L5 -4 L3 0 L0 4 L-3 7 L-7 10 M-4 -2 L-1 -1 L1 0 L4 2 L5 3 L5 4 L4 4 L3 2 L1 0","-14 13 M-6 -8 L-3 -8 L2 -9 L6 -11 M-3 -8 L0 -9 L2 -10 L5 -12 L6 -11 M-2 -8 L1 -7 L1 -1 L0 3 L-2 6 L-5 9 M0 -7 L0 -1 L-1 3 L-3 7 M-10 -4 L-8 -2 L-3 -3 L3 -4 L8 -5 L10 -4 M-9 -3 L-3 -3 M3 -4 L10 -4","-14 13 M-9 -9 L-7 -8 L-6 -7 L-6 -6 L-7 -6 L-8 -8 L-9 -9 M-3 -10 L-1 -9 L0 -8 L0 -7 L-1 -7 L-2 -9 L-3 -10 M6 -10 L8 -8 L5 -2 L2 2 L-1 5 L-4 7 L-6 8 M7 -9 L6 -6 L4 -2 L1 2 L-2 5 L-6 8","-14 13 M-6 -12 L-4 -10 L5 -12 L6 -11 M-5 -11 L6 -11 M-10 -4 L-8 -2 L-3 -3 L3 -4 L8 -5 L10 -4 M-9 -3 L-3 -3 M3 -4 L10 -4 M1 -3 L1 -1 L0 3 L-2 6 L-5 9 M0 -3 L0 -1 L-1 3 L-3 7","-14 13 M-5 -12 L-2 -11 L-2 10 M-3 -11 L-3 9 L-2 10 M-2 -3 L0 -3 L3 -2 L4 -1 L4 0 L3 0 L2 -2 L0 -3","-14 13 M-1 -12 L2 -11 L2 -6 L1 -1 L0 2 L-1 4 L-3 7 L-5 9 M1 -11 L1 -6 L0 -1 L-1 3 L-3 7 M-10 -4 L-8 -2 L-3 -3 L3 -4 L8 -5 L10 -4 M-9 -3 L-3 -3 M3 -4 L10 -4","-14 13 M-6 -8 L-4 -6 L5 -8 L6 -7 M-5 -7 L6 -7 M-10 4 L-8 6 L8 4 L10 5 M-9 5 L10 5","-14 13 M-8 -9 L-6 -7 L5 -9 L7 -7 M-7 -8 L6 -8 M7 -7 L5 -4 L2 -1 L-1 1 L-3 2 L-8 4 M6 -8 L5 -6 L3 -3 L1 -1 L-2 1 L-8 4 M-5 -3 L-2 -2 L2 0 L5 2 L7 4 L7 5 L6 5 L4 2 L2 0","-14 13 M-2 -12 L0 -11 L1 -10 L1 -9 L0 -9 L-1 -11 L-2 -12 M-8 -6 L-6 -4 L4 -6 L6 -4 M-7 -5 L5 -5 M6 -4 L2 0 L-1 2 L-3 3 L-8 5 M5 -5 L3 -2 L1 0 L-2 2 L-8 5 M0 1 L1 2 L1 10 M0 1 L0 9 L1 10 M6 3 L8 4 L9 5 L9 6 L8 6 L7 4 L6 3","-14 13 M5 -10 L7 -8 L4 -2 L1 2 L-2 5 L-5 7 L-7 8 M6 -9 L5 -6 L2 -1 L-1 3 L-4 6 L-7 8","-14 13 M-6 -6 L-4 -4 L-5 -1 L-6 1 L-8 3 L-10 4 M-5 -5 L-6 -1 L-8 3 M4 -6 L6 -4 L8 -1 L10 3 L10 4 L9 4 L8 0 L6 -4","-14 13 M-9 -11 L-6 -10 L-6 -8 L-7 1 M-7 -10 L-7 4 L-6 6 L-4 7 L7 7 M-1 7 L3 6 L5 6 L7 7 M-7 0 L-3 -1 L0 -2 L6 -4 M0 -2 L4 -4 L6 -4","-14 13 M-8 -11 L-6 -9 L7 -9 M-7 -10 L-3 -9 M3 -9 L6 -10 L8 -8 M8 -8 L5 -2 L3 1 L0 4 L-3 6 L-5 7 M7 -9 L6 -6 L4 -2 L1 2 L-2 5 L-5 7","-14 13 M-11 -1 L-9 1 L-2 -6 L-1 -6 L9 4 M-10 0 L-8 -1 L-4 -4 M3 -2 L8 2 L10 3 L9 4","-14 13 M-2 -12 L1 -11 L1 7 L0 9 L-1 7 L-3 6 M0 -11 L0 6 L-1 7 M-10 -6 L-8 -4 L-3 -5 L3 -6 L8 -7 L10 -6 M-9 -5 L-3 -5 M3 -6 L10 -6 M-6 1 L-8 4 L-9 5 L-10 5 L-10 4 L-8 3 L-6 1 M6 1 L9 3 L10 4 L10 5 L9 5 L8 3 L6 1","-14 13 M-10 -6 L-8 -4 L-3 -5 L3 -6 L8 -7 L10 -5 M-9 -5 L-3 -5 M3 -6 L9 -6 M10 -5 L8 -3 L4 0 L2 1 M9 -6 L7 -3 L5 -1 L2 1 M-1 0 L2 2 L4 4 L4 5 L3 5 L2 3 L-1 0","-14 13 M-2 -12 L1 -11 L3 -10 L4 -9 L4 -8 L3 -8 L1 -10 L-2 -12 M-5 -5 L-2 -4 L0 -3 L1 -2 L1 -1 L0 -1 L-2 -3 L-5 -5 M-4 4 L1 6 L3 7 L4 8 L4 9 L3 9 L1 7 L-2 5 L-4 4","-14 13 M0 -9 L2 -7 L-5 5 M1 -8 L-5 5 M-10 5 L-8 7 L7 4 M-9 6 L7 4 M4 1 L6 3 L8 6 L9 6 L9 5 L7 3 L4 1","-14 13 M5 -10 L7 -8 L4 -2 L1 2 L-2 5 L-5 7 L-7 8 M6 -9 L5 -6 L3 -2 L0 2 L-3 5 L-7 8 M-3 -4 L1 -2 L4 0 L6 2 L6 3 L5 3 L4 1 L2 -1 L-1 -3","-14 13 M-6 -9 L-4 -7 L5 -9 L6 -8 M-5 -8 L6 -8 M-1 -7 L-1 4 L0 6 L2 7 L9 7 M0 -7 L0 -5 L-1 1 M4 7 L8 6 L9 7 M-10 -1 L-8 1 L-3 0 L3 -1 L8 -2 L10 -1 M-9 0 L-3 0 M3 -1 L10 -1","-14 13 M-3 -12 L0 -11 L2 9 M-1 -11 L1 10 L2 9 M-10 -6 L-8 -4 L-3 -5 L3 -6 L8 -7 L10 -5 M-9 -5 L-3 -5 M3 -6 L9 -6 M10 -5 L7 -2 L4 0 L2 1 M9 -6 L8 -4 L5 -1 L2 1","-14 13 M4 -12 L6 -10 L3 -6 L0 -3 L-4 0 L-7 2 M5 -11 L4 -9 L1 -5 L-3 -1 L-7 2 M1 -4 L3 -3 L3 10 M1 -4 L2 -3 L2 9 L3 10","-14 13 M-9 -8 L-7 -6 L3 -8 L5 -6 M-8 -7 L4 -7 M5 -6 L4 -3 L3 4 M4 -7 L3 -2 L3 4 M-10 4 L-8 6 L8 4 L10 5 M-9 5 L10 5","-14 13 M-1 -7 L1 -6 L1 5 M0 -6 L0 5 M-8 -8 L-6 -6 L6 -8 L8 -7 M-7 -7 L8 -7 M-10 4 L-8 6 L8 4 L10 5 M-9 5 L10 5","-14 13 M-8 -8 L-6 -6 L6 -8 L8 -6 M-7 -7 L7 -7 M-8 -2 L-6 0 L6 -2 M-7 -1 L6 -1 M-8 4 L-6 6 L6 4 M-7 5 L6 5 M8 -6 L7 -3 L7 7 M7 -7 L6 -2 L6 7","-14 13 M-6 -12 L-4 -10 L5 -12 L6 -11 M-5 -11 L6 -11 M-8 -5 L-6 -3 L5 -5 L7 -3 M-7 -4 L6 -4 M7 -3 L5 0 L2 3 L-1 5 L-3 6 L-6 7 M6 -4 L5 -2 L3 1 L1 3 L-2 5 L-6 7","-14 13 M-6 -9 L-4 -8 L-4 -3 L-5 1 M-5 -8 L-5 1 M2 -12 L5 -11 L5 -1 L4 3 L2 6 L-1 9 M4 -11 L4 -1 L3 3 L2 5 L-1 9","-14 13 M-6 -8 L-4 -7 L-4 -4 L-5 0 L-7 3 L-10 6 M-5 -7 L-5 -4 L-6 0 L-7 2 L-10 6 M-1 -9 L1 -8 L1 -5 L0 1 M0 -8 L0 4 L1 6 L3 6 L5 5 L7 3 L10 -1 M0 4 L1 5 L4 5 L6 4","-14 13 M-10 -9 L-7 -8 L-7 -5 L-8 1 M-8 -8 L-8 4 L-7 6 L-4 6 L-1 5 L2 3 L6 0 L9 -3 M-8 4 L-7 5 L-4 5 L-1 4 L3 2 L6 0","-14 13 M-8 -8 L-6 -6 L6 -8 L8 -6 M-7 -7 L7 -7 M-7 -7 L-7 8 M-6 -6 L-6 6 L-7 8 M8 -6 L7 -3 L6 4 M7 -7 L6 -2 L6 4 M-6 6 L6 4 L7 5 M-6 5 L7 5","-14 13 M-8 -11 L-7 -9 L-7 -4 L-6 -3 M-6 -9 L-6 -3 M-6 -9 L7 -9 M-8 -11 L-7 -10 L-3 -9 M3 -9 L6 -10 L8 -8 M8 -8 L5 -2 L3 1 L0 4 L-3 6 L-5 7 M7 -9 L6 -6 L4 -2 L1 2 L-2 5 L-5 7","-14 13 M-1 -12 L2 -11 L2 9 M1 -11 L1 10 L2 9 M-8 -8 L-6 -6 L6 -8 L8 -7 M-7 -7 L8 -7 M-6 -6 L-4 -5 L-4 0 M-5 -5 L-5 0 M-10 -1 L-8 1 L8 -1 L10 0 M-9 0 L10 0","-14 13 M-2 -12 L1 -11 L1 -9 L0 -7 M-2 -12 L0 -11 L0 -7 M-8 -9 L-7 -7 L-7 -2 L-6 -1 M-6 -7 L-6 -1 M-6 -7 L7 -7 M-8 -9 L-7 -8 L-3 -7 M3 -7 L6 -8 L8 -6 M8 -6 L5 0 L3 3 L0 6 L-3 8 L-5 9 M7 -7 L6 -4 L4 0 L1 4 L-2 7 L-5 9","-14 13 M-8 -8 L-6 -6 L6 -8 L8 -6 M-7 -7 L7 -7 M8 -6 L5 -4 L1 -1 M7 -7 L1 -1 M-1 -2 L1 -1 L1 5 M0 -1 L0 5 M-10 4 L-8 6 L8 4 L10 5 M-9 5 L10 5","-14 13 M-8 -11 L-6 -9 L7 -9 M-7 -10 L-3 -9 M3 -9 L6 -10 L8 -8 M-6 -4 L-4 -2 L4 -3 M-5 -3 L4 -3 M8 -8 L5 -2 L3 1 L0 4 L-3 6 L-5 7 M7 -9 L6 -6 L4 -2 L1 2 L-2 5 L-5 7","-14 13 M-8 -10 L-6 -9 L-5 -8 L-5 -7 L-6 -7 L-7 -9 L-8 -10 M-9 5 L-7 7 L-3 5 L1 2 L5 -2 L9 -7 M-8 6 L-3 4 L1 1 L9 -7","-14 13 M-10 7 L-11 8 L-10 9 L-9 8 L-10 7","-14 13 M-10 7 L-11 8 L-10 9 L-9 8 L-10 7","-14 13 M-10 7 L-11 8 L-10 9 L-9 8 L-10 7","-14 13 M-10 7 L-11 8 L-10 9 L-9 8 L-10 7","-14 13 M-1 -12 L1 -10 L0 -7 L-2 -2 L-4 2 L-6 5 L-9 9 M0 -11 L-1 -8 L-3 -2 L-5 3 L-9 9 M-9 -6 L-7 -4 L-3 -5 L2 -6 L6 -7 L8 -5 M-8 -5 L-3 -5 M2 -6 L7 -6 M8 -5 L7 1 L6 5 L5 7 L3 9 L2 8 L0 7 M7 -6 L6 1 L5 5 L4 7 L2 8 M8 -10 L10 -8 M10 -12 L12 -10","-14 13 M-3 -12 L0 -11 L2 9 M-1 -11 L1 10 L2 9 M-8 -6 L-6 -4 L-2 -5 L2 -6 L6 -7 L8 -6 M-7 -5 L-2 -5 M2 -6 L8 -6 M-10 0 L-8 2 L-3 1 L3 0 L8 -1 L10 0 M-9 1 L-3 1 M3 0 L10 0 M8 -10 L10 -8 M10 -12 L12 -10","-14 13 M-2 -12 L0 -10 L-2 -6 L-4 -3 L-6 -1 L-8 1 M-1 -11 L-2 -8 L-4 -4 L-6 -1 M-1 -8 L1 -7 L6 -7 M3 -7 L5 -8 L7 -6 M7 -6 L4 0 L1 4 L-2 7 L-5 9 L-7 10 M6 -7 L5 -4 L3 0 L0 4 L-3 7 L-7 10 M7 -10 L9 -8 M9 -12 L11 -10","-14 13 M-4 -12 L-2 -10 L-4 -6 L-6 -3 L-8 -1 L-10 1 M-3 -11 L-4 -8 L-6 -4 L-8 -1 M-6 -3 L2 -4 L7 -5 L10 -4 M2 -4 L10 -4 M0 -3 L2 -1 L0 3 L-2 6 L-4 8 L-6 10 M1 -2 L0 1 L-2 5 L-4 8 M7 -10 L9 -8 M9 -12 L11 -10","-14 13 M-8 -8 L-6 -6 L6 -8 L8 -6 M-7 -7 L7 -7 M8 -6 L7 -3 L6 4 M7 -7 L6 -2 L6 4 M-8 4 L-6 6 L6 4 L7 5 M-7 5 L7 5 M8 -10 L10 -8 M10 -12 L12 -10","-14 13 M-6 -9 L-4 -8 L-4 -3 L-5 1 M-5 -8 L-5 1 M2 -12 L5 -11 L5 -6 L4 -1 L3 2 L2 4 L0 7 L-2 9 M4 -11 L4 -6 L3 -1 L2 3 L0 7 M-10 -5 L-8 -3 L-3 -4 L3 -5 L8 -6 L10 -5 M-9 -4 L-3 -4 M3 -5 L10 -5 M8 -10 L10 -8 M10 -12 L12 -10","-14 13 M-5 -11 L-3 -10 L-2 -9 L-2 -8 L-3 -8 L-4 -10 L-5 -11 M-10 -4 L-8 -3 L-7 -2 L-7 -1 L-8 -1 L-9 -3 L-10 -4 M-9 6 L-7 8 L-3 6 L1 3 L5 -1 L9 -6 M-8 7 L-3 5 L1 2 L9 -6 M4 -10 L6 -8 M6 -12 L8 -10","-14 13 M-8 -9 L-6 -7 L5 -9 L7 -7 M-7 -8 L6 -8 M7 -7 L5 -4 L2 -1 L-1 1 L-3 2 L-8 4 M6 -8 L5 -6 L3 -3 L1 -1 L-2 1 L-8 4 M3 1 L6 3 L8 5 L8 6 L7 6 L6 4 L3 1 M8 -10 L10 -8 M10 -12 L12 -10","-14 13 M-3 -11 L0 -10 L0 -8 L-1 1 M-1 -10 L-1 4 L0 6 L2 7 L9 7 M4 7 L8 6 L9 7 M-10 -4 L-8 -2 L-3 -3 L3 -4 L8 -5 L10 -3 M-9 -3 L-3 -3 M3 -4 L9 -4 M10 -3 L7 -1 L4 2 M9 -4 L4 2 M7 -10 L9 -8 M9 -12 L11 -10","-14 13 M-9 -9 L-7 -8 L-6 -7 L-6 -6 L-7 -6 L-8 -8 L-9 -9 M6 -10 L8 -8 L5 -2 L2 2 L-1 5 L-4 7 L-6 8 M7 -9 L6 -6 L4 -2 L1 2 L-2 5 L-6 8 M9 -11 L11 -9 M11 -13 L13 -11","-14 13 M-2 -12 L0 -10 L-2 -6 L-4 -3 L-6 -1 L-8 1 M-1 -11 L-2 -8 L-4 -4 L-6 -1 M-1 -8 L1 -7 L6 -7 M3 -7 L5 -8 L7 -6 M7 -6 L4 0 L1 4 L-2 7 L-5 9 L-7 10 M6 -7 L5 -4 L3 0 L0 4 L-3 7 L-7 10 M-4 -2 L-1 -1 L1 0 L4 2 L5 3 L5 4 L4 4 L3 2 L1 0 M7 -10 L9 -8 M9 -12 L11 -10","-14 13 M-6 -8 L-3 -8 L2 -9 L6 -11 M-3 -8 L0 -9 L2 -10 L5 -12 L6 -11 M-2 -8 L1 -7 L1 -1 L0 3 L-2 6 L-5 9 M0 -7 L0 -1 L-1 3 L-3 7 M-10 -4 L-8 -2 L-3 -3 L3 -4 L8 -5 L10 -4 M-9 -3 L-3 -3 M3 -4 L10 -4 M8 -10 L10 -8 M10 -12 L12 -10","-14 13 M-9 -9 L-7 -8 L-6 -7 L-6 -6 L-7 -6 L-8 -8 L-9 -9 M-3 -10 L-1 -9 L0 -8 L0 -7 L-1 -7 L-2 -9 L-3 -10 M6 -10 L8 -8 L5 -2 L2 2 L-1 5 L-4 7 L-6 8 M7 -9 L6 -6 L4 -2 L1 2 L-2 5 L-6 8 M9 -11 L11 -9 M11 -13 L13 -11","-14 13 M-6 -12 L-4 -10 L5 -12 L6 -11 M-5 -11 L6 -11 M-10 -4 L-8 -2 L-3 -3 L3 -4 L8 -5 L10 -4 M-9 -3 L-3 -3 M3 -4 L10 -4 M1 -3 L1 -1 L0 3 L-2 6 L-5 9 M0 -3 L0 -1 L-1 3 L-3 7 M8 -10 L10 -8 M10 -12 L12 -10","-14 13 M-5 -12 L-2 -11 L-2 10 M-3 -11 L-3 9 L-2 10 M-2 -3 L0 -3 L3 -2 L4 -1 L4 0 L3 0 L2 -2 L0 -3 M2 -10 L4 -8 M4 -12 L6 -10","-14 13 M-6 -6 L-4 -4 L-5 -1 L-6 1 L-8 3 L-10 4 M-5 -5 L-6 -1 L-8 3 M4 -6 L6 -4 L8 -1 L10 3 L10 4 L9 4 L8 0 L6 -4 M7 -9 L9 -7 M9 -11 L11 -9","-14 13 M-9 -11 L-6 -10 L-6 -8 L-7 1 M-7 -10 L-7 4 L-6 6 L-4 7 L7 7 M-1 7 L3 6 L5 6 L7 7 M-7 0 L-3 -1 L0 -2 L6 -4 M0 -2 L4 -4 L6 -4 M7 -9 L9 -7 M9 -11 L11 -9","-14 13 M-8 -11 L-6 -9 L7 -9 M-7 -10 L-3 -9 M3 -9 L6 -10 L8 -8 M8 -8 L5 -2 L3 1 L0 4 L-3 6 L-5 7 M7 -9 L6 -6 L4 -2 L1 2 L-2 5 L-5 7 M9 -11 L11 -9 M11 -13 L13 -11","-14 13 M-11 -1 L-9 1 L-2 -6 L-1 -6 L9 4 M-10 0 L-8 -1 L-4 -4 M3 -2 L8 2 L10 3 L9 4 M4 -8 L6 -6 M6 -10 L8 -8","-14 13 M-2 -12 L1 -11 L1 7 L0 9 L-1 7 L-3 6 M0 -11 L0 6 L-1 7 M-10 -6 L-8 -4 L-3 -5 L3 -6 L8 -7 L10 -6 M-9 -5 L-3 -5 M3 -6 L10 -6 M-6 1 L-8 4 L-9 5 L-10 5 L-10 4 L-8 3 L-6 1 M6 1 L9 3 L10 4 L10 5 L9 5 L8 3 L6 1 M8 -11 L10 -9 M10 -13 L12 -11","-14 13 M-6 -6 L-4 -4 L-5 -1 L-6 1 L-8 3 L-10 4 M-5 -5 L-6 -1 L-8 3 M4 -6 L6 -4 L8 -1 L10 3 L10 4 L9 4 L8 0 L6 -4 M8 -11 L7 -10 L7 -8 L8 -7 L10 -7 L11 -8 L11 -10 L10 -11 L8 -11","-14 13 M-9 -11 L-6 -10 L-6 -8 L-7 1 M-7 -10 L-7 4 L-6 6 L-4 7 L7 7 M-1 7 L3 6 L5 6 L7 7 M-7 0 L-3 -1 L0 -2 L6 -4 M0 -2 L4 -4 L6 -4 M8 -11 L7 -10 L7 -8 L8 -7 L10 -7 L11 -8 L11 -10 L10 -11 L8 -11","-14 13 M-8 -11 L-6 -9 L7 -9 M-7 -10 L-3 -9 M3 -9 L6 -10 L8 -8 M8 -8 L5 -2 L3 1 L0 4 L-3 6 L-5 7 M7 -9 L6 -6 L4 -2 L1 2 L-2 5 L-5 7 M10 -13 L9 -12 L9 -10 L10 -9 L12 -9 L13 -10 L13 -12 L12 -13 L10 -13","-14 13 M-11 -1 L-9 1 L-2 -6 L-1 -6 L9 4 M-10 0 L-8 -1 L-4 -4 M3 -2 L8 2 L10 3 L9 4 M5 -10 L4 -9 L4 -7 L5 -6 L7 -6 L8 -7 L8 -9 L7 -10 L5 -10","-14 13 M-2 -12 L1 -11 L1 7 L0 9 L-1 7 L-3 6 M0 -11 L0 6 L-1 7 M-10 -6 L-8 -4 L-3 -5 L3 -6 L8 -7 L10 -6 M-9 -5 L-3 -5 M3 -6 L10 -6 M-6 1 L-8 4 L-9 5 L-10 5 L-10 4 L-8 3 L-6 1 M6 1 L9 3 L10 4 L10 5 L9 5 L8 3 L6 1 M9 -13 L8 -12 L8 -10 L9 -9 L11 -9 L12 -10 L12 -12 L11 -13 L9 -13"],
    :markers => ["-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-7 7 M-1 -7 L-4 -6 L-6 -4 L-7 -1 L-7 1 L-6 4 L-4 6 L-1 7 L1 7 L4 6 L6 4 L7 1 L7 -1 L6 -4 L4 -6 L1 -7 L-1 -7","-6 6 M-6 -6 L-6 6 L6 6 L6 -6 L-6 -6","-7 7 M0 -8 L-7 4 L7 4 L0 -8","-6 6 M0 -10 L-6 0 L0 10 L6 0 L0 -10","-8 8 M0 -9 L-2 -3 L-8 -3 L-3 1 L-5 7 L0 3 L5 7 L3 1 L8 -3 L2 -3 L0 -9","-6 6 M-2 -6 L-2 -2 L-6 -2 L-6 2 L-2 2 L-2 6 L2 6 L2 2 L6 2 L6 -2 L2 -2 L2 -6 L-2 -6","-7 7 M0 -7 L0 7 M-7 0 L7 0","-5 5 M-5 -5 L5 5 M5 -5 L-5 5","-5 5 M0 -6 L0 6 M-5 -3 L5 3 M5 -3 L-5 3","-4 4 M-1 -4 L-3 -3 L-4 -1 L-4 1 L-3 3 L-1 4 L1 4 L3 3 L4 1 L4 -1 L3 -3 L1 -4 L-1 -4 M-3 -1 L-3 1 M-2 -2 L-2 2 M-1 -3 L-1 3 M0 -3 L0 3 M1 -3 L1 3 M2 -2 L2 2 M3 -1 L3 1","-4 4 M-4 -4 L-4 4 L4 4 L4 -4 L-4 -4 M-3 -3 L-3 3 M-2 -3 L-2 3 M-1 -3 L-1 3 M0 -3 L0 3 M1 -3 L1 3 M2 -3 L2 3 M3 -3 L3 3","-5 5 M0 -6 L-5 3 L5 3 L0 -6 M0 -3 L-3 2 M0 -3 L3 2 M0 0 L-1 2 M0 0 L1 2","-6 3 M-6 0 L3 5 L3 -5 L-6 0 M-3 0 L2 3 M-3 0 L2 -3 M0 0 L2 1 M0 0 L2 -1","-5 5 M0 6 L5 -3 L-5 -3 L0 6 M0 3 L3 -2 M0 3 L-3 -2 M0 0 L1 -2 M0 0 L-1 -2","-3 6 M6 0 L-3 -5 L-3 5 L6 0 M3 0 L-2 -3 M3 0 L-2 3 M0 0 L-2 -1 M0 0 L-2 1","-14 14 M-14 0 L14 0 M-14 0 L0 16 M14 0 L0 16","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-7 7 M-1 -7 L-4 -6 L-6 -4 L-7 -1 L-7 1 L-6 4 L-4 6 L-1 7 L1 7 L4 6 L6 4 L7 1 L7 -1 L6 -4 L4 -6 L1 -7 L-1 -7","-6 6 M-6 -6 L-6 6 L6 6 L6 -6 L-6 -6","-7 7 M0 -8 L-7 4 L7 4 L0 -8","-6 6 M0 -10 L-6 0 L0 10 L6 0 L0 -10","-8 8 M0 -9 L-2 -3 L-8 -3 L-3 1 L-5 7 L0 3 L5 7 L3 1 L8 -3 L2 -3 L0 -9","-6 6 M-2 -6 L-2 -2 L-6 -2 L-6 2 L-2 2 L-2 6 L2 6 L2 2 L6 2 L6 -2 L2 -2 L2 -6 L-2 -6","-7 7 M0 -7 L0 7 M-7 0 L7 0","-5 5 M-5 -5 L5 5 M5 -5 L-5 5","-5 5 M0 -6 L0 6 M-5 -3 L5 3 M5 -3 L-5 3","-4 4 M-1 -4 L-3 -3 L-4 -1 L-4 1 L-3 3 L-1 4 L1 4 L3 3 L4 1 L4 -1 L3 -3 L1 -4 L-1 -4 M-3 -1 L-3 1 M-2 -2 L-2 2 M-1 -3 L-1 3 M0 -3 L0 3 M1 -3 L1 3 M2 -2 L2 2 M3 -1 L3 1","-4 4 M-4 -4 L-4 4 L4 4 L4 -4 L-4 -4 M-3 -3 L-3 3 M-2 -3 L-2 3 M-1 -3 L-1 3 M0 -3 L0 3 M1 -3 L1 3 M2 -3 L2 3 M3 -3 L3 3","-5 5 M0 -6 L-5 3 L5 3 L0 -6 M0 -3 L-3 2 M0 -3 L3 2 M0 0 L-1 2 M0 0 L1 2","-6 3 M-6 0 L3 5 L3 -5 L-6 0 M-3 0 L2 3 M-3 0 L2 -3 M0 0 L2 1 M0 0 L2 -1","-5 5 M0 6 L5 -3 L-5 -3 L0 6 M0 3 L3 -2 M0 3 L-3 -2 M0 0 L1 -2 M0 0 L-1 -2","-3 6 M6 0 L-3 -5 L-3 5 L6 0 M3 0 L-2 -3 M3 0 L-2 3 M0 0 L-2 -1 M0 0 L-2 1","-14 14 M-14 0 L14 0 M-14 0 L0 16 M14 0 L0 16","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8"],
    :mathlow => ["-8 8","-12 12 M0 -8 L0 9 M-8 0 L8 0 M-8 9 L8 9","-12 12 M0 -8 L0 9 M-8 -8 L8 -8 M-8 0 L8 0","-11 11 M-7 -7 L7 7 M7 -7 L-7 7","-2 3 M0 -1 L0 0 L1 0 L1 -1 L0 -1","-12 12 M9 -12 L-9 9 M-4 -12 L-2 -10 L-2 -8 L-3 -6 L-5 -5 L-7 -5 L-9 -7 L-9 -9 L-8 -11 L-6 -12 L-4 -12 L-2 -11 L1 -10 L4 -10 L7 -11 L9 -12 M5 2 L3 3 L2 5 L2 7 L4 9 L6 9 L8 8 L9 6 L9 4 L7 2 L5 2","-12 12 M8 -12 L-8 -5 L8 2 M-8 4 L8 4 M-8 9 L8 9","-12 12 M-8 -12 L8 -5 L-8 2 M-8 4 L8 4 M-8 9 L8 9","-7 7 M4 -16 L2 -14 L0 -11 L-2 -7 L-3 -2 L-3 2 L-2 7 L0 11 L2 14 L4 16 M2 -14 L0 -10 L-1 -7 L-2 -2 L-2 2 L-1 7 L0 10 L2 14","-7 7 M-4 -16 L-2 -14 L0 -11 L2 -7 L3 -2 L3 2 L2 7 L0 11 L-2 14 L-4 16 M-2 -14 L0 -10 L1 -7 L2 -2 L2 2 L1 7 L0 10 L-2 14","-8 8 M0 -6 L0 6 M-5 -3 L5 3 M5 -3 L-5 3","-13 13 M0 -9 L0 9 M-9 0 L9 0","-4 4 M1 5 L0 6 L-1 5 L0 4 L1 5 L1 7 L-1 9","-13 13 M-9 0 L9 0","-4 4 M0 4 L-1 5 L0 6 L1 5 L0 4","-11 11 M9 -16 L-9 16","-10 10 M-1 -12 L-4 -11 L-6 -8 L-7 -3 L-7 0 L-6 5 L-4 8 L-1 9 L1 9 L4 8 L6 5 L7 0 L7 -3 L6 -8 L4 -11 L1 -12 L-1 -12","-10 10 M-4 -8 L-2 -9 L1 -12 L1 9","-10 10 M-6 -7 L-6 -8 L-5 -10 L-4 -11 L-2 -12 L2 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L3 -1 L-7 9 L7 9","-10 10 M-5 -12 L6 -12 L0 -4 L3 -4 L5 -3 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5","-10 10 M3 -12 L-7 2 L8 2 M3 -12 L3 9","-10 10 M5 -12 L-5 -12 L-6 -3 L-5 -4 L-2 -5 L1 -5 L4 -4 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5","-10 10 M6 -9 L5 -11 L2 -12 L0 -12 L-3 -11 L-5 -8 L-6 -3 L-6 2 L-5 6 L-3 8 L0 9 L1 9 L4 8 L6 6 L7 3 L7 2 L6 -1 L4 -3 L1 -4 L0 -4 L-3 -3 L-5 -1 L-6 2","-10 10 M7 -12 L-3 9 M-7 -12 L7 -12","-10 10 M-2 -12 L-5 -11 L-6 -9 L-6 -7 L-5 -5 L-3 -4 L1 -3 L4 -2 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 2 L-6 0 L-4 -2 L-1 -3 L3 -4 L5 -5 L6 -7 L6 -9 L5 -11 L2 -12 L-2 -12","-10 10 M6 -5 L5 -2 L3 0 L0 1 L-1 1 L-4 0 L-6 -2 L-7 -5 L-7 -6 L-6 -9 L-4 -11 L-1 -12 L0 -12 L3 -11 L5 -9 L6 -5 L6 0 L5 5 L3 8 L0 9 L-2 9 L-5 8 L-6 6","-17 17 M-10 -16 L-10 16 M-9 -16 L-9 16 M9 -16 L9 16 M10 -16 L10 16 M-14 -16 L14 -16 M-14 16 L-5 16 M5 16 L14 16","-16 15 M-11 -16 L-1 -2 L-12 16 M-12 -16 L-2 -2 M-13 -16 L-2 -1 M-13 -16 L10 -16 L12 -9 L9 -16 M-11 15 L10 15 M-12 16 L10 16 L12 9 L9 16","-12 12 M8 -9 L-8 0 L8 9","-13 13 M-9 -3 L9 -3 M-9 3 L9 3","-12 12 M-8 -9 L8 0 L-8 9","-13 13 M7 -9 L-7 9 M-9 -3 L9 -3 M-9 3 L9 3","-13 13 M-9 -5 L9 -5 M-9 0 L9 0 M-9 5 L9 5","-9 10 M6 -5 L6 9 M6 -2 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6","-10 9 M-6 -12 L-6 9 M-6 -2 L-4 -4 L-2 -5 L1 -5 L3 -4 L5 -2 L6 1 L6 3 L5 6 L3 8 L1 9 L-2 9 L-4 8 L-6 6","-9 9 M6 -2 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6","-9 10 M6 -12 L6 9 M6 -2 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6","-9 9 M-6 1 L6 1 L6 -1 L5 -3 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6","-5 7 M5 -12 L3 -12 L1 -11 L0 -8 L0 9 M-3 -5 L4 -5","-9 10 M6 -5 L6 11 L5 14 L4 15 L2 16 L-1 16 L-3 15 M6 -2 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6","-9 10 M-5 -12 L-5 9 M-5 -1 L-2 -4 L0 -5 L3 -5 L5 -4 L6 -1 L6 9","-4 4 M-1 -12 L0 -11 L1 -12 L0 -13 L-1 -12 M0 -5 L0 9","-5 5 M0 -12 L1 -11 L2 -12 L1 -13 L0 -12 M1 -5 L1 12 L0 15 L-2 16 L-4 16","-9 8 M-5 -12 L-5 9 M5 -5 L-5 5 M-1 1 L6 9","-4 4 M0 -12 L0 9","-15 15 M-11 -5 L-11 9 M-11 -1 L-8 -4 L-6 -5 L-3 -5 L-1 -4 L0 -1 L0 9 M0 -1 L3 -4 L5 -5 L8 -5 L10 -4 L11 -1 L11 9","-9 10 M-5 -5 L-5 9 M-5 -1 L-2 -4 L0 -5 L3 -5 L5 -4 L6 -1 L6 9","-9 10 M-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6 L7 3 L7 1 L6 -2 L4 -4 L2 -5 L-1 -5","-10 9 M-6 -5 L-6 16 M-6 -2 L-4 -4 L-2 -5 L1 -5 L3 -4 L5 -2 L6 1 L6 3 L5 6 L3 8 L1 9 L-2 9 L-4 8 L-6 6","-9 10 M6 -5 L6 16 M6 -2 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6","-7 6 M-3 -5 L-3 9 M-3 1 L-2 -2 L0 -4 L2 -5 L5 -5","-8 9 M6 -2 L5 -4 L2 -5 L-1 -5 L-4 -4 L-5 -2 L-4 0 L-2 1 L3 2 L5 3 L6 5 L6 6 L5 8 L2 9 L-1 9 L-4 8 L-5 6","-5 7 M0 -12 L0 5 L1 8 L3 9 L5 9 M-3 -5 L4 -5","-9 10 M-5 -5 L-5 5 L-4 8 L-2 9 L1 9 L3 8 L6 5 M6 -5 L6 9","-8 8 M-6 -5 L0 9 M6 -5 L0 9","-11 11 M-8 -5 L-4 9 M0 -5 L-4 9 M0 -5 L4 9 M8 -5 L4 9","-8 9 M-5 -5 L6 9 M6 -5 L-5 9","-8 8 M-6 -5 L0 9 M6 -5 L0 9 L-2 13 L-4 15 L-6 16 L-7 16","-8 9 M6 -5 L-5 9 M-5 -5 L6 -5 M-5 9 L6 9","-7 7 M-3 -16 L-3 16 M-2 -16 L-2 16 M-3 -16 L4 -16 M-3 16 L4 16","-7 7 M-7 -12 L7 12","-7 7 M2 -16 L2 16 M3 -16 L3 16 M-4 -16 L3 -16 M-4 16 L3 16","-12 13 M9 5 L7 5 L5 4 L3 2 L0 -2 L-1 -3 L-3 -4 L-5 -4 L-7 -3 L-8 -1 L-8 1 L-7 3 L-5 4 L-3 4 L-1 3 L0 2 L3 -2 L5 -4 L7 -5 L9 -5","-12 13 M10 1 L9 3 L7 4 L5 4 L3 3 L2 2 L-1 -2 L-2 -3 L-4 -4 L-6 -4 L-8 -3 L-9 -1 L-9 1 L-8 3 L-6 4 L-4 4 L-2 3 L-1 2 L2 -2 L3 -3 L5 -4 L7 -4 L9 -3 L10 -1 L10 1","-7 7 M-1 -12 L-3 -11 L-4 -9 L-4 -7 L-3 -5 L-1 -4 L1 -4 L3 -5 L4 -7 L4 -9 L3 -11 L1 -12 L-1 -12","-10 10 M-2 -16 L-2 13 M2 -16 L2 13 M7 -9 L5 -11 L2 -12 L-2 -12 L-5 -11 L-7 -9 L-7 -7 L-6 -5 L-5 -4 L-3 -3 L3 -1 L5 0 L6 1 L7 3 L7 6 L5 8 L2 9 L-2 9 L-5 8 L-7 6","-13 9 M-10 -5 L-6 -5 L0 7 M-7 -5 L0 9 M9 -16 L0 9","-17 16 M-14 -5 L-9 -5 L0 7 M-10 -4 L0 9 M16 -24 L0 9","-12 12 M8 -8 L1 -8 L-3 -7 L-5 -6 L-7 -4 L-8 -1 L-8 1 L-7 4 L-5 6 L-3 7 L1 8 L8 8","-12 12 M-8 -8 L-8 -1 L-7 3 L-6 5 L-4 7 L-1 8 L1 8 L4 7 L6 5 L7 3 L8 -1 L8 -8","-12 12 M-8 -8 L-1 -8 L3 -7 L5 -6 L7 -4 L8 -1 L8 1 L7 4 L5 6 L3 7 L-1 8 L-8 8","-12 12 M-8 8 L-8 1 L-7 -3 L-6 -5 L-4 -7 L-1 -8 L1 -8 L4 -7 L6 -5 L7 -3 L8 1 L8 8","-12 12 M8 -8 L1 -8 L-3 -7 L-5 -6 L-7 -4 L-8 -1 L-8 1 L-7 4 L-5 6 L-3 7 L1 8 L8 8 M-8 0 L4 0","-13 13 M6 -2 L9 0 L6 2 M3 -5 L8 0 L3 5 M-9 0 L8 0","-8 8 M-2 -6 L0 -9 L2 -6 M-5 -3 L0 -8 L5 -3 M0 -8 L0 9","-13 13 M-6 -2 L-9 0 L-6 2 M-3 -5 L-8 0 L-3 5 M-8 0 L9 0","-8 8 M-2 6 L0 9 L2 6 M-5 3 L0 8 L5 3 M0 -9 L0 8","-9 10 M6 0 L5 -3 L4 -4 L2 -5 L0 -5 L-3 -4 L-5 -1 L-6 2 L-6 5 L-5 7 L-4 8 L-2 9 L0 9 L3 8 L5 6 L6 3 L7 -2 L7 -7 L6 -10 L5 -11 L3 -12 L0 -12 L-2 -11 L-3 -10 L-3 -9 L-2 -9 L-2 -10 M0 -5 L-2 -4 L-4 -1 L-5 2 L-5 6 L-4 8 M0 9 L2 8 L4 6 L5 3 L6 -2 L6 -7 L5 -10 L3 -12","-10 10 M-8 -12 L0 9 M-7 -12 L0 7 M8 -12 L0 9 M-8 -12 L8 -12 M-7 -11 L7 -11","-17 16 M-14 -5 L-9 -5 L0 7 M-10 -4 L0 9 M16 -24 L0 9","-12 12 M9 -15 L8 -14 L9 -13 L10 -14 L10 -15 L9 -16 L7 -16 L5 -15 L3 -13 L2 -11 L1 -8 L0 -4 L-2 8 L-3 12 L-4 14 M4 -14 L3 -12 L2 -8 L0 4 L-1 8 L-2 11 L-3 13 L-5 15 L-7 16 L-9 16 L-10 15 L-10 14 L-9 13 L-8 14 L-9 15","-15 15 M11 -36 L10 -36 L9 -35 L9 -34 L10 -33 L11 -33 L12 -34 L12 -36 L11 -38 L9 -39 L7 -39 L5 -38 L3 -36 L2 -34 L1 -31 L0 -24 L-1 -8 L-1 24 L-2 33 L-3 36 M10 -35 L10 -34 L11 -34 L11 -35 L10 -35 M0 -24 L0 24 M3 -36 L2 -33 L1 -24 L1 8 L0 24 L-1 31 L-2 34 L-3 36 L-5 38 L-7 39 L-9 39 L-11 38 L-12 36 L-12 34 L-11 33 L-10 33 L-9 34 L-9 35 L-10 36 L-11 36 M-11 34 L-11 35 L-10 35 L-10 34 L-11 34","-9 9 M6 -39 L3 -33 L0 -26 L-2 -21 L-3 -17 L-4 -12 L-5 -4 L-5 4 L-4 12 L-3 17 L-2 21 L0 26 L3 33 L6 39 M3 -33 L1 -28 L-1 -22 L-2 -18 L-3 -12 L-4 -4 L-4 4 L-3 12 L-2 18 L-1 22 L1 28 L3 33","-9 9 M-6 -39 L-3 -33 L0 -26 L2 -21 L3 -17 L4 -12 L5 -4 L5 4 L4 12 L3 17 L2 21 L0 26 L-3 33 L-6 39 M-3 -33 L-1 -28 L1 -22 L2 -18 L3 -12 L4 -4 L4 4 L3 12 L2 18 L1 22 L-1 28 L-3 33","-9 9 M-5 -39 L-5 0 L-5 39 M-4 -39 L-4 0 L-4 39 M-5 -39 L6 -39 M-5 39 L6 39","-9 9 M4 -39 L4 0 L4 39 M5 -39 L5 0 L5 39 M-6 -39 L5 -39 M-6 39 L5 39","-9 10 M6 -12 L6 9 M-7 -12 L6 -12 M-2 -2 L6 -2 M-7 9 L6 9","-10 10 M-7 -9 L-6 -7 L6 5 L7 7 L7 9 M-6 -6 L6 6 M-7 -9 L-7 -7 L-6 -5 L6 7 L7 9 M-2 -2 L-6 2 L-7 4 L-7 6 L-6 8 L-7 9 M-7 4 L-5 8 M-6 2 L-6 4 L-5 6 L-5 8 L-7 9 M1 1 L6 -4 M4 -9 L4 -6 L5 -4 L7 -4 L7 -6 L5 -7 L4 -9 M4 -9 L5 -6 L7 -4","-13 13 M0 -9 L-1 -8 L0 -7 L1 -8 L0 -9 M-9 0 L9 0 M0 7 L-1 8 L0 9 L1 8 L0 7","-7 7 M-3 -16 L-3 16 M3 -16 L3 16","-12 12 M0 -16 L0 9 M-9 9 L9 9","-7 7 M2 -16 L0 -15 L-1 -14 L-2 -12 L-2 -10 L-1 -8 L0 -7 L1 -5 L1 -3 L-1 -1 M0 -15 L-1 -13 L-1 -11 L0 -9 L1 -8 L2 -6 L2 -4 L1 -2 L-3 0 L1 2 L2 4 L2 6 L1 8 L0 9 L-1 11 L-1 13 L0 15 M-1 1 L1 3 L1 5 L0 7 L-1 8 L-2 10 L-2 12 L-1 14 L0 15 L2 16","-12 12 M9 -16 L-9 9 L9 9","-7 7 M-2 -16 L0 -15 L1 -14 L2 -12 L2 -10 L1 -8 L0 -7 L-1 -5 L-1 -3 L1 -1 M0 -15 L1 -13 L1 -11 L0 -9 L-1 -8 L-2 -6 L-2 -4 L-1 -2 L3 0 L-1 2 L-2 4 L-2 6 L-1 8 L0 9 L1 11 L1 13 L0 15 M1 1 L-1 3 L-1 5 L0 7 L1 8 L2 10 L2 12 L1 14 L0 15 L-2 16","-13 13 M0 -9 L-1 -8 L0 -7 L1 -8 L0 -9 M-9 7 L-10 8 L-9 9 L-8 8 L-9 7 M9 7 L8 8 L9 9 L10 8 L9 7","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3"],
    :mathupp => ["-8 8","-12 12 M0 -8 L0 9 M-8 0 L8 0 M-8 9 L8 9","-12 12 M0 -8 L0 9 M-8 -8 L8 -8 M-8 0 L8 0","-11 11 M-7 -7 L7 7 M7 -7 L-7 7","-2 3 M0 -1 L0 0 L1 0 L1 -1 L0 -1","-12 12 M9 -12 L-9 9 M-4 -12 L-2 -10 L-2 -8 L-3 -6 L-5 -5 L-7 -5 L-9 -7 L-9 -9 L-8 -11 L-6 -12 L-4 -12 L-2 -11 L1 -10 L4 -10 L7 -11 L9 -12 M5 2 L3 3 L2 5 L2 7 L4 9 L6 9 L8 8 L9 6 L9 4 L7 2 L5 2","-12 12 M8 -12 L-8 -5 L8 2 M-8 4 L8 4 M-8 9 L8 9","-12 12 M-8 -12 L8 -5 L-8 2 M-8 4 L8 4 M-8 9 L8 9","-7 7 M4 -16 L2 -14 L0 -11 L-2 -7 L-3 -2 L-3 2 L-2 7 L0 11 L2 14 L4 16 M2 -14 L0 -10 L-1 -7 L-2 -2 L-2 2 L-1 7 L0 10 L2 14","-7 7 M-4 -16 L-2 -14 L0 -11 L2 -7 L3 -2 L3 2 L2 7 L0 11 L-2 14 L-4 16 M-2 -14 L0 -10 L1 -7 L2 -2 L2 2 L1 7 L0 10 L-2 14","-8 8 M0 -6 L0 6 M-5 -3 L5 3 M5 -3 L-5 3","-13 13 M0 -9 L0 9 M-9 0 L9 0","-5 5 M1 8 L0 9 L-1 8 L0 7 L1 8 L1 10 L0 12 L-1 13","-13 13 M-9 0 L9 0","-5 5 M0 7 L-1 8 L0 9 L1 8 L0 7","-11 11 M9 -16 L-9 16","-10 10 M-1 -12 L-4 -11 L-6 -8 L-7 -3 L-7 0 L-6 5 L-4 8 L-1 9 L1 9 L4 8 L6 5 L7 0 L7 -3 L6 -8 L4 -11 L1 -12 L-1 -12","-10 10 M-4 -8 L-2 -9 L1 -12 L1 9","-10 10 M-6 -7 L-6 -8 L-5 -10 L-4 -11 L-2 -12 L2 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L3 -1 L-7 9 L7 9","-10 10 M-5 -12 L6 -12 L0 -4 L3 -4 L5 -3 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5","-10 10 M3 -12 L-7 2 L8 2 M3 -12 L3 9","-10 10 M5 -12 L-5 -12 L-6 -3 L-5 -4 L-2 -5 L1 -5 L4 -4 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5","-10 10 M6 -9 L5 -11 L2 -12 L0 -12 L-3 -11 L-5 -8 L-6 -3 L-6 2 L-5 6 L-3 8 L0 9 L1 9 L4 8 L6 6 L7 3 L7 2 L6 -1 L4 -3 L1 -4 L0 -4 L-3 -3 L-5 -1 L-6 2","-10 10 M7 -12 L-3 9 M-7 -12 L7 -12","-10 10 M-2 -12 L-5 -11 L-6 -9 L-6 -7 L-5 -5 L-3 -4 L1 -3 L4 -2 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 2 L-6 0 L-4 -2 L-1 -3 L3 -4 L5 -5 L6 -7 L6 -9 L5 -11 L2 -12 L-2 -12","-10 10 M6 -5 L5 -2 L3 0 L0 1 L-1 1 L-4 0 L-6 -2 L-7 -5 L-7 -6 L-6 -9 L-4 -11 L-1 -12 L0 -12 L3 -11 L5 -9 L6 -5 L6 0 L5 5 L3 8 L0 9 L-2 9 L-5 8 L-6 6","-17 17 M-10 -16 L-10 16 M-9 -16 L-9 16 M9 -16 L9 16 M10 -16 L10 16 M-14 -16 L14 -16 M-14 16 L-5 16 M5 16 L14 16","-16 15 M-11 -16 L-1 -2 L-12 16 M-12 -16 L-2 -2 M-13 -16 L-2 -1 M-13 -16 L10 -16 L12 -9 L9 -16 M-11 15 L10 15 M-12 16 L10 16 L12 9 L9 16","-12 12 M8 -9 L-8 0 L8 9","-13 13 M-9 -3 L9 -3 M-9 3 L9 3","-12 12 M-8 -9 L8 0 L-8 9","-13 13 M7 -9 L-7 9 M-9 -3 L9 -3 M-9 3 L9 3","-13 13 M-9 -5 L9 -5 M-9 0 L9 0 M-9 5 L9 5","-9 9 M0 -12 L-8 9 M0 -12 L8 9 M-5 2 L5 2","-11 10 M-7 -12 L-7 9 M-7 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -6 L6 -4 L5 -3 L2 -2 M-7 -2 L2 -2 L5 -1 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-7 9","-10 11 M8 -7 L7 -9 L5 -11 L3 -12 L-1 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -4 L-7 1 L-6 4 L-5 6 L-3 8 L-1 9 L3 9 L5 8 L7 6 L8 4","-11 10 M-7 -12 L-7 9 M-7 -12 L0 -12 L3 -11 L5 -9 L6 -7 L7 -4 L7 1 L6 4 L5 6 L3 8 L0 9 L-7 9","-10 9 M-6 -12 L-6 9 M-6 -12 L7 -12 M-6 -2 L2 -2 M-6 9 L7 9","-10 8 M-6 -12 L-6 9 M-6 -12 L7 -12 M-6 -2 L2 -2","-10 11 M8 -7 L7 -9 L5 -11 L3 -12 L-1 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -4 L-7 1 L-6 4 L-5 6 L-3 8 L-1 9 L3 9 L5 8 L7 6 L8 4 L8 1 M3 1 L8 1","-11 11 M-7 -12 L-7 9 M7 -12 L7 9 M-7 -2 L7 -2","-4 4 M0 -12 L0 9","-8 8 M4 -12 L4 4 L3 7 L2 8 L0 9 L-2 9 L-4 8 L-5 7 L-6 4 L-6 2","-11 10 M-7 -12 L-7 9 M7 -12 L-7 2 M-2 -3 L7 9","-10 7 M-6 -12 L-6 9 M-6 9 L6 9","-12 12 M-8 -12 L-8 9 M-8 -12 L0 9 M8 -12 L0 9 M8 -12 L8 9","-11 11 M-7 -12 L-7 9 M-7 -12 L7 9 M7 -12 L7 9","-11 11 M-2 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 L-2 9 L2 9 L4 8 L6 6 L7 4 L8 1 L8 -4 L7 -7 L6 -9 L4 -11 L2 -12 L-2 -12","-11 10 M-7 -12 L-7 9 M-7 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -5 L6 -3 L5 -2 L2 -1 L-7 -1","-11 11 M-2 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 L-2 9 L2 9 L4 8 L6 6 L7 4 L8 1 L8 -4 L7 -7 L6 -9 L4 -11 L2 -12 L-2 -12 M1 5 L7 11","-11 10 M-7 -12 L-7 9 M-7 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -6 L6 -4 L5 -3 L2 -2 L-7 -2 M0 -2 L7 9","-10 10 M7 -9 L5 -11 L2 -12 L-2 -12 L-5 -11 L-7 -9 L-7 -7 L-6 -5 L-5 -4 L-3 -3 L3 -1 L5 0 L6 1 L7 3 L7 6 L5 8 L2 9 L-2 9 L-5 8 L-7 6","-8 8 M0 -12 L0 9 M-7 -12 L7 -12","-11 11 M-7 -12 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 3 L7 -12","-9 9 M-8 -12 L0 9 M8 -12 L0 9","-12 12 M-10 -12 L-5 9 M0 -12 L-5 9 M0 -12 L5 9 M10 -12 L5 9","-10 10 M-7 -12 L7 9 M7 -12 L-7 9","-9 9 M-8 -12 L0 -2 L0 9 M8 -12 L0 -2","-10 10 M7 -12 L-7 9 M-7 -12 L7 -12 M-7 9 L7 9","-7 7 M-3 -16 L-3 16 M-2 -16 L-2 16 M-3 -16 L4 -16 M-3 16 L4 16","-7 7 M-7 -12 L7 12","-7 7 M2 -16 L2 16 M3 -16 L3 16 M-4 -16 L3 -16 M-4 16 L3 16","-12 13 M9 5 L7 5 L5 4 L3 2 L0 -2 L-1 -3 L-3 -4 L-5 -4 L-7 -3 L-8 -1 L-8 1 L-7 3 L-5 4 L-3 4 L-1 3 L0 2 L3 -2 L5 -4 L7 -5 L9 -5","-12 13 M10 1 L9 3 L7 4 L5 4 L3 3 L2 2 L-1 -2 L-2 -3 L-4 -4 L-6 -4 L-8 -3 L-9 -1 L-9 1 L-8 3 L-6 4 L-4 4 L-2 3 L-1 2 L2 -2 L3 -3 L5 -4 L7 -4 L9 -3 L10 -1 L10 1","-7 7 M-1 -12 L-3 -11 L-4 -9 L-4 -7 L-3 -5 L-1 -4 L1 -4 L3 -5 L4 -7 L4 -9 L3 -11 L1 -12 L-1 -12","-8 8 M0 -6 L0 6 M-5 -3 L5 3 M5 -3 L-5 3","-13 9 M-10 -5 L-6 -5 L0 7 M-7 -5 L0 9 M9 -16 L0 9","-17 16 M-14 -5 L-9 -5 L0 7 M-10 -4 L0 9 M16 -24 L0 9","-12 12 M8 -8 L1 -8 L-3 -7 L-5 -6 L-7 -4 L-8 -1 L-8 1 L-7 4 L-5 6 L-3 7 L1 8 L8 8","-12 12 M-8 -8 L-8 -1 L-7 3 L-6 5 L-4 7 L-1 8 L1 8 L4 7 L6 5 L7 3 L8 -1 L8 -8","-12 12 M-8 -8 L-1 -8 L3 -7 L5 -6 L7 -4 L8 -1 L8 1 L7 4 L5 6 L3 7 L-1 8 L-8 8","-12 12 M-8 8 L-8 1 L-7 -3 L-6 -5 L-4 -7 L-1 -8 L1 -8 L4 -7 L6 -5 L7 -3 L8 1 L8 8","-12 12 M8 -8 L1 -8 L-3 -7 L-5 -6 L-7 -4 L-8 -1 L-8 1 L-7 4 L-5 6 L-3 7 L1 8 L8 8 M-8 0 L4 0","-13 13 M6 -2 L9 0 L6 2 M3 -5 L8 0 L3 5 M-9 0 L8 0","-8 8 M-2 -6 L0 -9 L2 -6 M-5 -3 L0 -8 L5 -3 M0 -8 L0 9","-13 13 M-6 -2 L-9 0 L-6 2 M-3 -5 L-8 0 L-3 5 M-8 0 L9 0","-8 8 M-2 6 L0 9 L2 6 M-5 3 L0 8 L5 3 M0 -9 L0 8","-9 10 M6 0 L5 -3 L4 -4 L2 -5 L0 -5 L-3 -4 L-5 -1 L-6 2 L-6 5 L-5 7 L-4 8 L-2 9 L0 9 L3 8 L5 6 L6 3 L7 -2 L7 -7 L6 -10 L5 -11 L3 -12 L0 -12 L-2 -11 L-3 -10 L-3 -9 L-2 -9 L-2 -10 M0 -5 L-2 -4 L-4 -1 L-5 2 L-5 6 L-4 8 M0 9 L2 8 L4 6 L5 3 L6 -2 L6 -7 L5 -10 L3 -12","-10 10 M-8 -12 L0 9 M-7 -12 L0 7 M8 -12 L0 9 M-8 -12 L8 -12 M-7 -11 L7 -11","-17 16 M-14 -5 L-9 -5 L0 7 M-10 -4 L0 9 M16 -24 L0 9","-12 12 M9 -15 L8 -14 L9 -13 L10 -14 L10 -15 L9 -16 L7 -16 L5 -15 L3 -13 L2 -11 L1 -8 L0 -4 L-2 8 L-3 12 L-4 14 M4 -14 L3 -12 L2 -8 L0 4 L-1 8 L-2 11 L-3 13 L-5 15 L-7 16 L-9 16 L-10 15 L-10 14 L-9 13 L-8 14 L-9 15","-15 15 M11 -36 L10 -36 L9 -35 L9 -34 L10 -33 L11 -33 L12 -34 L12 -36 L11 -38 L9 -39 L7 -39 L5 -38 L3 -36 L2 -34 L1 -31 L0 -24 L-1 -8 L-1 24 L-2 33 L-3 36 M10 -35 L10 -34 L11 -34 L11 -35 L10 -35 M0 -24 L0 24 M3 -36 L2 -33 L1 -24 L1 8 L0 24 L-1 31 L-2 34 L-3 36 L-5 38 L-7 39 L-9 39 L-11 38 L-12 36 L-12 34 L-11 33 L-10 33 L-9 34 L-9 35 L-10 36 L-11 36 M-11 34 L-11 35 L-10 35 L-10 34 L-11 34","-9 9 M6 -39 L3 -33 L0 -26 L-2 -21 L-3 -17 L-4 -12 L-5 -4 L-5 4 L-4 12 L-3 17 L-2 21 L0 26 L3 33 L6 39 M3 -33 L1 -28 L-1 -22 L-2 -18 L-3 -12 L-4 -4 L-4 4 L-3 12 L-2 18 L-1 22 L1 28 L3 33","-9 9 M-6 -39 L-3 -33 L0 -26 L2 -21 L3 -17 L4 -12 L5 -4 L5 4 L4 12 L3 17 L2 21 L0 26 L-3 33 L-6 39 M-3 -33 L-1 -28 L1 -22 L2 -18 L3 -12 L4 -4 L4 4 L3 12 L2 18 L1 22 L-1 28 L-3 33","-9 9 M-5 -39 L-5 0 L-5 39 M-4 -39 L-4 0 L-4 39 M-5 -39 L6 -39 M-5 39 L6 39","-9 9 M4 -39 L4 0 L4 39 M5 -39 L5 0 L5 39 M-6 -39 L5 -39 M-6 39 L5 39","-9 10 M6 -12 L6 9 M-7 -12 L6 -12 M-2 -2 L6 -2 M-7 9 L6 9","-10 10 M-7 -9 L-6 -7 L6 5 L7 7 L7 9 M-6 -6 L6 6 M-7 -9 L-7 -7 L-6 -5 L6 7 L7 9 M-2 -2 L-6 2 L-7 4 L-7 6 L-6 8 L-7 9 M-7 4 L-5 8 M-6 2 L-6 4 L-5 6 L-5 8 L-7 9 M1 1 L6 -4 M4 -9 L4 -6 L5 -4 L7 -4 L7 -6 L5 -7 L4 -9 M4 -9 L5 -6 L7 -4","-13 13 M0 -9 L-1 -8 L0 -7 L1 -8 L0 -9 M-9 0 L9 0 M0 7 L-1 8 L0 9 L1 8 L0 7","-7 7 M-3 -16 L-3 16 M3 -16 L3 16","-12 12 M0 -16 L0 9 M-9 9 L9 9","-7 7 M2 -16 L2 16 M3 -16 L3 16 M-4 -16 L3 -16 M-4 16 L3 16","-12 12 M9 -16 L-9 9 L9 9","-7 7 M2 -16 L0 -15 L-1 -14 L-2 -12 L-2 -10 L-1 -8 L0 -7 L1 -5 L1 -3 L-1 -1 M0 -15 L-1 -13 L-1 -11 L0 -9 L1 -8 L2 -6 L2 -4 L1 -2 L-3 0 L1 2 L2 4 L2 6 L1 8 L0 9 L-1 11 L-1 13 L0 15 M-1 1 L1 3 L1 5 L0 7 L-1 8 L-2 10 L-2 12 L-1 14 L0 15 L2 16","-13 13 M0 -9 L-1 -8 L0 -7 L1 -8 L0 -9 M-9 7 L-10 8 L-9 9 L-8 8 L-9 7 M9 7 L8 8 L9 9 L10 8 L9 7","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3"],
    :meteorology => ["-8 8","-2 1 M1 0 L0 1 L-1 1 L-2 0 L-2 -1 L-1 -2 L0 -2 L1 -1 L1 1 L0 3 L-1 4 M-1 -1 L-1 0 L0 0 L0 -1 L-1 -1","-2 2 M-1 -2 L-2 -1 L-2 1 L-1 2 L1 2 L2 1 L2 -1 L1 -2 L-1 -2 M0 -1 L-1 0 L0 1 L1 0 L0 -1","-4 4 M-2 -3 L2 3 M2 -3 L-2 3 M-4 0 L4 0","-5 5 M0 -7 L-1 -5 L-3 -2 L-5 0 M0 -7 L1 -5 L3 -2 L5 0 M0 -5 L-3 -1 M0 -5 L3 -1 M0 -3 L-2 -1 M0 -3 L2 -1 M-1 -1 L1 -1 M-5 0 L5 0","-12 12 M9 -12 L-9 9 M-4 -12 L-2 -10 L-2 -8 L-3 -6 L-5 -5 L-7 -5 L-9 -7 L-9 -9 L-8 -11 L-6 -12 L-4 -12 L-2 -11 L1 -10 L4 -10 L7 -11 L9 -12 M5 2 L3 3 L2 5 L2 7 L4 9 L6 9 L8 8 L9 6 L9 4 L7 2 L5 2","-5 5 M-5 0 L-5 -1 L-4 -3 L-3 -4 L-1 -5 L1 -5 L3 -4 L4 -3 L5 -1 L5 0 M-2 -4 L2 -4 M-3 -3 L3 -3 M-4 -2 L4 -2 M-4 -1 L4 -1 M-5 0 L5 0","-6 0 M-6 -12 L-6 0 L0 0 L-6 -12 M-6 -9 L-2 -1 M-6 -6 L-3 0 M-6 -3 L-5 -1","-5 5 M0 -7 L-1 -5 L-3 -2 L-5 0 M0 -7 L1 -5 L3 -2 L5 0","-5 5 M5 0 L5 -1 L4 -3 L3 -4 L1 -5 L-1 -5 L-3 -4 L-4 -3 L-5 -1 L-5 0","-8 8 M0 -6 L0 6 M-5 -3 L5 3 M5 -3 L-5 3","-11 11 M11 0 L11 -2 L10 -5 L8 -8 L5 -10 L2 -11 L-2 -11 L-5 -10 L-8 -8 L-10 -5 L-11 -2 L-11 0","-4 4 M1 5 L0 6 L-1 5 L0 4 L1 5 L1 7 L-1 9","-13 13 M-9 0 L9 0","-4 4 M0 4 L-1 5 L0 6 L1 5 L0 4","-11 11 M9 -16 L-9 16","-10 10 M-1 -12 L-4 -11 L-6 -8 L-7 -3 L-7 0 L-6 5 L-4 8 L-1 9 L1 9 L4 8 L6 5 L7 0 L7 -3 L6 -8 L4 -11 L1 -12 L-1 -12","-10 10 M-4 -8 L-2 -9 L1 -12 L1 9","-10 10 M-6 -7 L-6 -8 L-5 -10 L-4 -11 L-2 -12 L2 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L3 -1 L-7 9 L7 9","-10 10 M-5 -12 L6 -12 L0 -4 L3 -4 L5 -3 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5","-10 10 M3 -12 L-7 2 L8 2 M3 -12 L3 9","-10 10 M5 -12 L-5 -12 L-6 -3 L-5 -4 L-2 -5 L1 -5 L4 -4 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5","-10 10 M6 -9 L5 -11 L2 -12 L0 -12 L-3 -11 L-5 -8 L-6 -3 L-6 2 L-5 6 L-3 8 L0 9 L1 9 L4 8 L6 6 L7 3 L7 2 L6 -1 L4 -3 L1 -4 L0 -4 L-3 -3 L-5 -1 L-6 2","-10 10 M7 -12 L-3 9 M-7 -12 L7 -12","-10 10 M-2 -12 L-5 -11 L-6 -9 L-6 -7 L-5 -5 L-3 -4 L1 -3 L4 -2 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 2 L-6 0 L-4 -2 L-1 -3 L3 -4 L5 -5 L6 -7 L6 -9 L5 -11 L2 -12 L-2 -12","-10 10 M6 -5 L5 -2 L3 0 L0 1 L-1 1 L-4 0 L-6 -2 L-7 -5 L-7 -6 L-6 -9 L-4 -11 L-1 -12 L0 -12 L3 -11 L5 -9 L6 -5 L6 0 L5 5 L3 8 L0 9 L-2 9 L-5 8 L-6 6","-5 5 M-5 0 L-5 1 L-4 3 L-3 4 L-1 5 L1 5 L3 4 L4 3 L5 1 L5 0","-6 6 M-6 -2 L-4 0 L-1 1 L1 1 L4 0 L6 -2","0 3 M0 3 L2 2 L3 0 L2 -2 L0 -3","0 4 M0 0 L3 -2 L4 -4 L4 -6 L3 -7 L2 -7","-4 0 M0 0 L-3 -2 L-4 -4 L-4 -6 L-3 -7 L-2 -7","-9 9 M-5 -8 L-4 -7 L-5 -6 L-6 -7 L-6 -8 L-5 -10 L-4 -11 L-2 -12 L1 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L4 -3 L0 -1 L0 2 M1 -12 L3 -11 L4 -10 L5 -8 L5 -6 L4 -4 L2 -2 M0 7 L-1 8 L0 9 L1 8 L0 7","-13 14 M5 -4 L4 -6 L2 -7 L-1 -7 L-3 -6 L-4 -5 L-5 -2 L-5 1 L-4 3 L-2 4 L1 4 L3 3 L4 1 M-1 -7 L-3 -5 L-4 -2 L-4 1 L-3 3 L-2 4 M5 -7 L4 1 L4 3 L6 4 L8 4 L10 2 L11 -1 L11 -3 L10 -6 L9 -8 L7 -10 L5 -11 L2 -12 L-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L2 9 L5 8 L7 7 L8 6 M6 -7 L5 1 L5 3 L6 4","-9 9 M0 -12 L-8 9 M0 -12 L8 9 M-5 2 L5 2","-11 10 M-7 -12 L-7 9 M-7 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -6 L6 -4 L5 -3 L2 -2 M-7 -2 L2 -2 L5 -1 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-7 9","-10 11 M8 -7 L7 -9 L5 -11 L3 -12 L-1 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -4 L-7 1 L-6 4 L-5 6 L-3 8 L-1 9 L3 9 L5 8 L7 6 L8 4","-11 10 M-7 -12 L-7 9 M-7 -12 L0 -12 L3 -11 L5 -9 L6 -7 L7 -4 L7 1 L6 4 L5 6 L3 8 L0 9 L-7 9","-10 9 M-6 -12 L-6 9 M-6 -12 L7 -12 M-6 -2 L2 -2 M-6 9 L7 9","-10 8 M-6 -12 L-6 9 M-6 -12 L7 -12 M-6 -2 L2 -2","-10 11 M8 -7 L7 -9 L5 -11 L3 -12 L-1 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -4 L-7 1 L-6 4 L-5 6 L-3 8 L-1 9 L3 9 L5 8 L7 6 L8 4 L8 1 M3 1 L8 1","-11 11 M-7 -12 L-7 9 M7 -12 L7 9 M-7 -2 L7 -2","-4 4 M0 -12 L0 9","-8 8 M4 -12 L4 4 L3 7 L2 8 L0 9 L-2 9 L-4 8 L-5 7 L-6 4 L-6 2","-11 10 M-7 -12 L-7 9 M7 -12 L-7 2 M-2 -3 L7 9","-10 7 M-6 -12 L-6 9 M-6 9 L6 9","-12 12 M-8 -12 L-8 9 M-8 -12 L0 9 M8 -12 L0 9 M8 -12 L8 9","-11 11 M-7 -12 L-7 9 M-7 -12 L7 9 M7 -12 L7 9","-11 11 M-2 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 L-2 9 L2 9 L4 8 L6 6 L7 4 L8 1 L8 -4 L7 -7 L6 -9 L4 -11 L2 -12 L-2 -12","-11 10 M-7 -12 L-7 9 M-7 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -5 L6 -3 L5 -2 L2 -1 L-7 -1","-11 11 M-2 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 L-2 9 L2 9 L4 8 L6 6 L7 4 L8 1 L8 -4 L7 -7 L6 -9 L4 -11 L2 -12 L-2 -12 M1 5 L7 11","-11 10 M-7 -12 L-7 9 M-7 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -6 L6 -4 L5 -3 L2 -2 L-7 -2 M0 -2 L7 9","-10 10 M7 -9 L5 -11 L2 -12 L-2 -12 L-5 -11 L-7 -9 L-7 -7 L-6 -5 L-5 -4 L-3 -3 L3 -1 L5 0 L6 1 L7 3 L7 6 L5 8 L2 9 L-2 9 L-5 8 L-7 6","-8 8 M0 -12 L0 9 M-7 -12 L7 -12","-11 11 M-7 -12 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 3 L7 -12","-9 9 M-8 -12 L0 9 M8 -12 L0 9","-12 12 M-10 -12 L-5 9 M0 -12 L-5 9 M0 -12 L5 9 M10 -12 L5 9","-10 10 M-7 -12 L7 9 M7 -12 L-7 9","-9 9 M-8 -12 L0 -2 L0 9 M8 -12 L0 -2","-10 10 M7 -12 L-7 9 M-7 -12 L7 -12 M-7 9 L7 9","-7 7 M-3 -16 L-3 16 M-2 -16 L-2 16 M-3 -16 L4 -16 M-3 16 L4 16","-7 7 M-7 -12 L7 12","-7 7 M2 -16 L2 16 M3 -16 L3 16 M-4 -16 L3 -16 M-4 16 L3 16","-10 10 M7 -9 L5 -11 L2 -12 L-2 -12 L-5 -11 L-7 -9 L-7 -7 L-6 -5 L-5 -4 L-3 -3 L3 -1 L5 0 L6 1 L7 3 L7 6 L5 8 L2 9 L-2 9 L-5 8 L-7 6","-11 11 M0 0 L2 3 L3 4 L5 5 L7 5 L9 4 L10 3 L11 1 L11 -1 L10 -3 L9 -4 L7 -5 L5 -5 L3 -4 L2 -3 L-2 3 L-3 4 L-5 5 L-7 5 L-9 4 L-10 3 L-11 1 L-11 -1 L-10 -3 L-9 -4 L-7 -5 L-5 -5 L-3 -4 L-2 -3 L0 0","-11 11 M-9 5 L-10 4 L-11 2 L-11 -1 L-10 -3 L-9 -4 L-7 -5 L-5 -5 L-3 -4 L-2 -3 L2 3 L3 4 L5 5 L7 5 L9 4 L10 3 L11 1 L11 -2 L10 -4 L9 -5","-9 10 M6 -5 L6 9 M6 -2 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6","-10 9 M-6 -12 L-6 9 M-6 -2 L-4 -4 L-2 -5 L1 -5 L3 -4 L5 -2 L6 1 L6 3 L5 6 L3 8 L1 9 L-2 9 L-4 8 L-6 6","-9 9 M6 -2 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6","-9 10 M6 -12 L6 9 M6 -2 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6","-9 9 M-6 1 L6 1 L6 -1 L5 -3 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6","-5 7 M5 -12 L3 -12 L1 -11 L0 -8 L0 9 M-3 -5 L4 -5","-9 10 M6 -5 L6 11 L5 14 L4 15 L2 16 L-1 16 L-3 15 M6 -2 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6","-9 10 M-5 -12 L-5 9 M-5 -1 L-2 -4 L0 -5 L3 -5 L5 -4 L6 -1 L6 9","-4 4 M-1 -12 L0 -11 L1 -12 L0 -13 L-1 -12 M0 -5 L0 9","-5 5 M0 -12 L1 -11 L2 -12 L1 -13 L0 -12 M1 -5 L1 12 L0 15 L-2 16 L-4 16","-9 8 M-5 -12 L-5 9 M5 -5 L-5 5 M-1 1 L6 9","-4 4 M0 -12 L0 9","-15 15 M-11 -5 L-11 9 M-11 -1 L-8 -4 L-6 -5 L-3 -5 L-1 -4 L0 -1 L0 9 M0 -1 L3 -4 L5 -5 L8 -5 L10 -4 L11 -1 L11 9","-9 10 M-5 -5 L-5 9 M-5 -1 L-2 -4 L0 -5 L3 -5 L5 -4 L6 -1 L6 9","-9 10 M-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6 L7 3 L7 1 L6 -2 L4 -4 L2 -5 L-1 -5","-10 9 M-6 -5 L-6 16 M-6 -2 L-4 -4 L-2 -5 L1 -5 L3 -4 L5 -2 L6 1 L6 3 L5 6 L3 8 L1 9 L-2 9 L-4 8 L-6 6","-9 10 M6 -5 L6 16 M6 -2 L4 -4 L2 -5 L-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 L2 9 L4 8 L6 6","-7 6 M-3 -5 L-3 9 M-3 1 L-2 -2 L0 -4 L2 -5 L5 -5","-8 9 M6 -2 L5 -4 L2 -5 L-1 -5 L-4 -4 L-5 -2 L-4 0 L-2 1 L3 2 L5 3 L6 5 L6 6 L5 8 L2 9 L-1 9 L-4 8 L-5 6","-5 7 M0 -12 L0 5 L1 8 L3 9 L5 9 M-3 -5 L4 -5","-9 10 M-5 -5 L-5 5 L-4 8 L-2 9 L1 9 L3 8 L6 5 M6 -5 L6 9","-8 8 M-6 -5 L0 9 M6 -5 L0 9","-11 11 M-8 -5 L-4 9 M0 -5 L-4 9 M0 -5 L4 9 M8 -5 L4 9","-8 9 M-5 -5 L6 9 M6 -5 L-5 9","-8 8 M-6 -5 L0 9 M6 -5 L0 9 L-2 13 L-4 15 L-6 16 L-7 16","-8 9 M6 -5 L-5 9 M-5 -5 L6 -5 M-5 9 L6 9","-7 7 M2 -16 L0 -15 L-1 -14 L-2 -12 L-2 -10 L-1 -8 L0 -7 L1 -5 L1 -3 L-1 -1 M0 -15 L-1 -13 L-1 -11 L0 -9 L1 -8 L2 -6 L2 -4 L1 -2 L-3 0 L1 2 L2 4 L2 6 L1 8 L0 9 L-1 11 L-1 13 L0 15 M-1 1 L1 3 L1 5 L0 7 L-1 8 L-2 10 L-2 12 L-1 14 L0 15 L2 16","-10 10 M-7 -12 L-7 9 M-10 -12 L9 -12 L-1 -2 L9 8 M8 4 L9 7 L10 9 M8 4 L8 7 M5 7 L8 7 M5 7 L8 8 L10 9","-7 7 M-2 -16 L0 -15 L1 -14 L2 -12 L2 -10 L1 -8 L0 -7 L-1 -5 L-1 -3 L1 -1 M0 -15 L1 -13 L1 -11 L0 -9 L-1 -8 L-2 -6 L-2 -4 L-1 -2 L3 0 L-1 2 L-2 4 L-2 6 L-1 8 L0 9 L1 11 L1 13 L0 15 M1 1 L-1 3 L-1 5 L0 7 L1 8 L2 10 L2 12 L1 14 L0 15 L-2 16","-7 7 M3 -17 L0 -16 L-2 -15 L-4 -13 L-6 -10 L-7 -6 L-7 0 L-6 3 L-4 5 L-1 6 L1 6 L4 5 L6 3 L7 0 M-7 -2 L-6 -5 L-4 -7 L-1 -8 L1 -8 L4 -7 L6 -5 L7 -2 L7 4 L6 8 L4 11 L2 13 L0 14 L-3 15","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3"],
    :music => ["-8 8","-5 5 M0 -12 L-1 -10 L0 2 L1 -10 L0 -12 M0 -10 L0 -4 M0 7 L-1 8 L0 9 L1 8 L0 7","-8 8 M-5 -2 L-1 0 L2 2 L4 4 L5 7 L5 9 L4 11 L3 12 M-5 -1 L1 2 M-5 0 L-2 1 L2 3 L4 5 L5 7","-8 8 M5 -7 L4 -5 L2 -3 L-2 -1 L-5 0 M1 -2 L-5 1 M3 -12 L4 -11 L5 -9 L5 -7 L4 -4 L2 -2 L-1 0 L-5 2","-10 10 M1 -5 L-3 -4 L-6 -2 L-7 0 L-7 2 L-6 4 L-4 5 L-1 5 L3 4 L6 2 L7 0 L7 -2 L6 -4 L4 -5 L1 -5 M6 -4 L1 -5 M4 -5 L-1 -4 L-6 -2 M-3 -4 L-7 0 M-6 4 L-1 5 M-4 5 L1 4 L6 2 M3 4 L7 0","-10 10 M1 -5 L-3 -4 L-6 -2 L-7 0 L-7 2 L-6 4 L-4 5 L-1 5 L3 4 L6 2 L7 0 L7 -2 L6 -4 L4 -5 L1 -5 M6 -4 L1 -5 M4 -5 L-1 -4 L-6 -2 M-3 -4 L-7 0 M-6 4 L-1 5 M-4 5 L1 4 L6 2 M3 4 L7 0","-8 9 M1 -5 L-2 -4 L-4 -2 L-5 0 L-5 2 L-4 4 L-2 5 L0 5 L3 4 L5 2 L6 0 L6 -2 L5 -4 L3 -5 L1 -5 M-3 -2 L3 -5 M-4 0 L4 -4 M-5 2 L5 -3 M-4 3 L6 -2 M-3 4 L5 0 M-2 5 L4 2","-8 8 M-3 -11 L-3 12 M3 -12 L3 11 M-5 -4 L5 -6 M-5 -3 L5 -5 M-5 5 L5 3 M-5 6 L5 4","-8 8 M-4 -12 L-4 6 M4 -6 L4 12 M-4 -4 L4 -6 M-4 -3 L4 -5 M-4 5 L4 3 M-4 6 L4 4","-8 8 M-4 -16 L-4 5 M-4 -4 L-1 -6 L2 -6 L4 -5 L5 -3 L5 -1 L4 1 L1 3 L-1 4 L-4 5 M-4 -4 L-1 -5 L2 -5 L4 -4 M3 -5 L4 -3 L4 -1 L3 1 L1 3","-13 13 M-10 -9 L-10 -6 M10 -9 L10 -6 M-10 -9 L10 -9 M-10 -8 L10 -8 M-10 -7 L10 -7 M-10 -6 L10 -6","-8 8 M-5 -4 L-5 -1 M5 -4 L5 -1 M-5 -4 L5 -4 M-5 -3 L5 -3 M-5 -2 L5 -2 M-5 -1 L5 -1","-8 8 M-5 -6 L5 6 M-5 -6 L-3 -4 L-1 -3 L2 -3 L4 -4 L5 -5 L5 -7 L3 -7 L3 -5 L2 -3 M-3 -4 L2 -3 M-1 -3 L5 -5 M4 -7 L4 -4 M3 -6 L5 -6 M5 6 L3 4 L1 3 L-2 3 L-4 4 L-5 5 L-5 7 L-3 7 L-3 5 L-2 3 M3 4 L-2 3 M1 3 L-5 5 M-4 4 L-4 7 M-5 6 L-3 6","-8 8 M-2 -3 L-3 -5 L-3 -7 L-5 -7 L-5 -5 L-4 -4 L-2 -3 L1 -3 L3 -4 L5 -6 M-4 -7 L-4 -4 M-5 -6 L-3 -6 M-5 -5 L1 -3 M-2 -3 L3 -4 M5 -6 L5 7","-8 8 M-1 -15 L4 -5 L0 2 L0 3 M3 -6 L-1 1 M2 -9 L2 -7 L-2 0 L0 3 L3 7 M5 10 L3 7 L1 6 L-1 6 L-3 7 L-4 9 L-4 11 L-3 13 L0 15 M5 10 L3 8 L1 7 L-3 7 L-3 11 L-2 13 L0 15 M1 6 L-2 8 L-4 11","-13 20 M-4 1 L-3 3 L-1 4 L1 4 L3 3 L4 1 L4 -1 L3 -3 L1 -4 L-1 -4 L-3 -3 L-4 -2 L-5 1 L-5 4 L-4 7 L-2 9 L1 10 L4 10 L7 9 L9 7 L10 5 L11 2 L11 -2 L10 -5 L8 -8 L6 -9 L3 -10 L0 -10 L-3 -9 L-5 -8 L-7 -6 L-9 -3 L-10 1 L-10 6 L-9 11 L-7 15 L-5 17 L-2 19 L2 20 L7 20 L11 19 L14 17 L16 15 M-7 -6 L-8 -4 L-9 0 L-9 6 L-8 10 L-6 14 L-4 16 L-1 18 L3 19 L7 19 L11 18 L13 17 L16 15 M-2 -3 L2 -3 M-3 -2 L3 -2 M-4 -1 L4 -1 M-4 0 L4 0 M-4 1 L4 1 M-3 2 L3 2 M-2 3 L2 3 M15 -6 L15 -4 L17 -4 L17 -6 L15 -6 M16 -6 L16 -4 M15 -5 L17 -5 M15 4 L15 6 L17 6 L17 4 L15 4 M16 4 L16 6 M15 5 L17 5","-10 10 M-1 -12 L-4 -11 L-6 -8 L-7 -3 L-7 0 L-6 5 L-4 8 L-1 9 L1 9 L4 8 L6 5 L7 0 L7 -3 L6 -8 L4 -11 L1 -12 L-1 -12 M-1 -12 L-3 -11 L-4 -10 L-5 -8 L-6 -3 L-6 0 L-5 5 L-4 7 L-3 8 L-1 9 M1 9 L3 8 L4 7 L5 5 L6 0 L6 -3 L5 -8 L4 -10 L3 -11 L1 -12","-10 10 M-4 -8 L-2 -9 L1 -12 L1 9 M0 -11 L0 9 M-4 9 L5 9","-10 10 M-6 -8 L-5 -7 L-6 -6 L-7 -7 L-7 -8 L-6 -10 L-5 -11 L-2 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -6 L6 -4 L3 -2 L-2 0 L-4 1 L-6 3 L-7 6 L-7 9 M2 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L2 -2 L-2 0 M-7 7 L-6 6 L-4 6 L1 8 L4 8 L6 7 L7 6 M-4 6 L1 9 L5 9 L6 8 L7 6 L7 4","-10 10 M-6 -8 L-5 -7 L-6 -6 L-7 -7 L-7 -8 L-6 -10 L-5 -11 L-2 -12 L2 -12 L5 -11 L6 -9 L6 -6 L5 -4 L2 -3 L-1 -3 M2 -12 L4 -11 L5 -9 L5 -6 L4 -4 L2 -3 M2 -3 L4 -2 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 4 L-6 3 L-5 4 L-6 5 M5 -1 L6 2 L6 5 L5 7 L4 8 L2 9","-10 10 M2 -10 L2 9 M3 -12 L3 9 M3 -12 L-8 3 L8 3 M-1 9 L6 9","-10 10 M-5 -12 L-7 -2 M-7 -2 L-5 -4 L-2 -5 L1 -5 L4 -4 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 4 L-6 3 L-5 4 L-6 5 M1 -5 L3 -4 L5 -2 L6 1 L6 3 L5 6 L3 8 L1 9 M-5 -12 L5 -12 M-5 -11 L0 -11 L5 -12","-10 10 M5 -9 L4 -8 L5 -7 L6 -8 L6 -9 L5 -11 L3 -12 L0 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -3 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 3 L7 2 L6 -1 L4 -3 L1 -4 L0 -4 L-3 -3 L-5 -1 L-6 2 M0 -12 L-2 -11 L-4 -9 L-5 -7 L-6 -3 L-6 3 L-5 6 L-3 8 L-1 9 M1 9 L3 8 L5 6 L6 3 L6 2 L5 -1 L3 -3 L1 -4","-10 10 M-7 -12 L-7 -6 M-7 -8 L-6 -10 L-4 -12 L-2 -12 L3 -9 L5 -9 L6 -10 L7 -12 M-6 -10 L-4 -11 L-2 -11 L3 -9 M7 -12 L7 -9 L6 -6 L2 -1 L1 1 L0 4 L0 9 M6 -6 L1 -1 L0 1 L-1 4 L-1 9","-10 10 M-2 -12 L-5 -11 L-6 -9 L-6 -6 L-5 -4 L-2 -3 L2 -3 L5 -4 L6 -6 L6 -9 L5 -11 L2 -12 L-2 -12 M-2 -12 L-4 -11 L-5 -9 L-5 -6 L-4 -4 L-2 -3 M2 -3 L4 -4 L5 -6 L5 -9 L4 -11 L2 -12 M-2 -3 L-5 -2 L-6 -1 L-7 1 L-7 5 L-6 7 L-5 8 L-2 9 L2 9 L5 8 L6 7 L7 5 L7 1 L6 -1 L5 -2 L2 -3 M-2 -3 L-4 -2 L-5 -1 L-6 1 L-6 5 L-5 7 L-4 8 L-2 9 M2 9 L4 8 L5 7 L6 5 L6 1 L5 -1 L4 -2 L2 -3","-10 10 M6 -5 L5 -2 L3 0 L0 1 L-1 1 L-4 0 L-6 -2 L-7 -5 L-7 -6 L-6 -9 L-4 -11 L-1 -12 L1 -12 L4 -11 L6 -9 L7 -6 L7 0 L6 4 L5 6 L3 8 L0 9 L-3 9 L-5 8 L-6 6 L-6 5 L-5 4 L-4 5 L-5 6 M-1 1 L-3 0 L-5 -2 L-6 -5 L-6 -6 L-5 -9 L-3 -11 L-1 -12 M1 -12 L3 -11 L5 -9 L6 -6 L6 0 L5 4 L4 6 L2 8 L0 9","-5 5 M0 -5 L-1 -4 L0 -3 L1 -4 L0 -5 M0 7 L-1 8 L0 9 L1 8 L0 7","-17 12 M-11 20 L-10 20 L-9 19 L-9 18 L-10 17 L-11 17 L-12 18 L-12 20 L-11 22 L-9 23 L-7 23 L-4 22 L-2 20 L-1 18 L0 14 L0 3 L-1 -23 L-1 -30 L0 -35 L1 -37 L3 -38 L4 -38 L6 -37 L7 -35 L7 -31 L6 -28 L5 -26 L3 -23 L-2 -19 L-8 -15 L-10 -13 L-12 -10 L-13 -8 L-14 -4 L-14 0 L-13 4 L-11 7 L-8 9 L-4 10 L0 10 L4 9 L6 8 L8 5 L9 2 L9 -2 L8 -5 L7 -7 L5 -9 L2 -10 L-2 -10 L-5 -9 L-7 -7 L-8 -4 L-8 0 L-7 3 L-5 5 M-11 18 L-11 19 L-10 19 L-10 18 L-11 18 M3 -23 L-1 -19 L-6 -15 L-9 -12 L-11 -9 L-12 -7 L-13 -4 L-13 0 L-12 4 L-11 6 L-8 9 M0 10 L3 9 L5 8 L7 5 L8 2 L8 -2 L7 -5 L6 -7 L4 -9 L2 -10","-13 20 M-4 1 L-3 3 L-1 4 L1 4 L3 3 L4 1 L4 -1 L3 -3 L1 -4 L-1 -4 L-3 -3 L-4 -2 L-5 1 L-5 4 L-4 7 L-2 9 L1 10 L4 10 L7 9 L9 7 L10 5 L11 2 L11 -2 L10 -5 L8 -8 L6 -9 L3 -10 L0 -10 L-3 -9 L-5 -8 L-7 -6 L-9 -3 L-10 1 L-10 6 L-9 11 L-7 15 L-5 17 L-2 19 L2 20 L7 20 L11 19 L14 17 L16 15 M-7 -6 L-8 -4 L-9 0 L-9 6 L-8 10 L-6 14 L-4 16 L-1 18 L3 19 L7 19 L11 18 L13 17 L16 15 M-2 -3 L2 -3 M-3 -2 L3 -2 M-4 -1 L4 -1 M-4 0 L4 0 M-4 1 L4 1 M-3 2 L3 2 M-2 3 L2 3 M15 -6 L15 -4 L17 -4 L17 -6 L15 -6 M16 -6 L16 -4 M15 -5 L17 -5 M15 4 L15 6 L17 6 L17 4 L15 4 M16 4 L16 6 M15 5 L17 5","-9 24 M-4 -1 L-3 -3 L-1 -4 L1 -4 L3 -3 L4 -1 L4 1 L3 3 L1 4 L-1 4 L-3 3 L-4 2 L-5 -1 L-5 -4 L-4 -7 L-2 -9 L1 -10 L5 -10 L9 -9 L12 -7 L14 -4 L15 0 L15 5 L14 9 L13 11 L11 14 L8 17 L4 20 L-1 23 L-5 25 M5 -10 L8 -9 L11 -7 L13 -4 L14 0 L14 5 L13 9 L12 11 L10 14 L7 17 L2 21 L-1 23 M-2 -3 L2 -3 M-3 -2 L3 -2 M-4 -1 L4 -1 M-4 0 L4 0 M-4 1 L4 1 M-3 2 L3 2 M-2 3 L2 3 M19 -6 L19 -4 L21 -4 L21 -6 L19 -6 M20 -6 L20 -4 M19 -5 L21 -5 M19 4 L19 6 L21 6 L21 4 L19 4 M20 4 L20 6 M19 5 L21 5","-14 14 M-10 -18 L-10 18 M-5 -18 L-5 18 M5 -18 L5 18 M10 -18 L10 18 M-5 -5 L5 -7 M-5 -4 L5 -6 M-5 -3 L5 -5 M-5 5 L5 3 M-5 6 L5 4 M-5 7 L5 5","-14 14 M-10 -20 L-10 20 M-9 -20 L-9 20 M-5 -20 L-5 20 M-1 -16 L1 -16 L1 -14 L-1 -14 L-1 -17 L0 -19 L2 -20 L5 -20 L7 -19 L9 -17 L10 -14 L10 -9 L9 -6 L7 -4 L5 -3 L3 -3 L1 -4 L0 -6 L-1 -4 L-3 -1 L-4 0 L-3 1 L-1 4 L0 6 L1 4 L3 3 L5 3 L7 4 L9 6 L10 9 L10 14 L9 17 L7 19 L5 20 L2 20 L0 19 L-1 17 L-1 14 L1 14 L1 16 L-1 16 M0 -16 L0 -14 M-1 -15 L1 -15 M7 -19 L8 -17 L9 -14 L9 -9 L8 -6 L7 -4 M0 -6 L0 -4 L-2 -1 L-4 0 L-2 1 L0 4 L0 6 M7 4 L8 6 L9 9 L9 14 L8 17 L7 19 M0 14 L0 16 M-1 15 L1 15","-8 8 M-5 -4 L-5 -1 M5 -4 L5 -1 M-5 -4 L5 -4 M-5 -3 L5 -3 M-5 -2 L5 -2 M-5 -1 L5 -1","-10 10 M3 -12 L-10 9 M3 -12 L4 9 M2 -10 L3 9 M-6 3 L3 3 M-12 9 L-6 9 M0 9 L6 9","-12 12 M-3 -12 L-9 9 M-2 -12 L-8 9 M-6 -12 L5 -12 L8 -11 L9 -9 L9 -7 L8 -4 L7 -3 L4 -2 M5 -12 L7 -11 L8 -9 L8 -7 L7 -4 L6 -3 L4 -2 M-5 -2 L4 -2 L6 -1 L7 1 L7 3 L6 6 L4 8 L0 9 L-12 9 M4 -2 L5 -1 L6 1 L6 3 L5 6 L3 8 L0 9","-10 11 M8 -10 L9 -10 L10 -12 L9 -6 L9 -8 L8 -10 L7 -11 L5 -12 L2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 4 L-6 7 L-5 8 L-2 9 L1 9 L3 8 L5 6 L6 4 M2 -12 L0 -11 L-2 -9 L-4 -6 L-5 -3 L-6 1 L-6 4 L-5 7 L-4 8 L-2 9","-12 11 M-3 -12 L-9 9 M-2 -12 L-8 9 M-6 -12 L3 -12 L6 -11 L7 -10 L8 -7 L8 -3 L7 1 L5 5 L3 7 L1 8 L-3 9 L-12 9 M3 -12 L5 -11 L6 -10 L7 -7 L7 -3 L6 1 L4 5 L2 7 L0 8 L-3 9","-12 11 M-3 -12 L-9 9 M-2 -12 L-8 9 M2 -6 L0 2 M-6 -12 L9 -12 L8 -6 L8 -12 M-5 -2 L1 -2 M-12 9 L3 9 L5 4 L2 9","-12 10 M-3 -12 L-9 9 M-2 -12 L-8 9 M2 -6 L0 2 M-6 -12 L9 -12 L8 -6 L8 -12 M-5 -2 L1 -2 M-12 9 L-5 9","-10 12 M8 -10 L9 -10 L10 -12 L9 -6 L9 -8 L8 -10 L7 -11 L5 -12 L2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 4 L-6 7 L-5 8 L-2 9 L0 9 L3 8 L5 6 L7 2 M2 -12 L0 -11 L-2 -9 L-4 -6 L-5 -3 L-6 1 L-6 4 L-5 7 L-4 8 L-2 9 M0 9 L2 8 L4 6 L6 2 M3 2 L10 2","-13 13 M-4 -12 L-10 9 M-3 -12 L-9 9 M9 -12 L3 9 M10 -12 L4 9 M-7 -12 L0 -12 M6 -12 L13 -12 M-6 -2 L6 -2 M-13 9 L-6 9 M0 9 L7 9","-6 7 M3 -12 L-3 9 M4 -12 L-2 9 M0 -12 L7 -12 M-6 9 L1 9","-9 9 M6 -12 L1 5 L0 7 L-1 8 L-3 9 L-5 9 L-7 8 L-8 6 L-8 4 L-7 3 L-6 4 L-7 5 M5 -12 L0 5 L-1 7 L-3 9 M2 -12 L9 -12","-12 11 M-3 -12 L-9 9 M-2 -12 L-8 9 M11 -12 L-6 1 M1 -3 L5 9 M0 -3 L4 9 M-6 -12 L1 -12 M7 -12 L13 -12 M-12 9 L-5 9 M1 9 L7 9","-10 10 M-1 -12 L-7 9 M0 -12 L-6 9 M-4 -12 L3 -12 M-10 9 L5 9 L7 3 L4 9","-13 14 M-4 -12 L-10 9 M-4 -12 L-3 9 M-3 -12 L-2 7 M10 -12 L-3 9 M10 -12 L4 9 M11 -12 L5 9 M-7 -12 L-3 -12 M10 -12 L14 -12 M-13 9 L-7 9 M1 9 L8 9","-12 13 M-3 -12 L-9 9 M-3 -12 L4 6 M-3 -9 L4 9 M10 -12 L4 9 M-6 -12 L-3 -12 M7 -12 L13 -12 M-12 9 L-6 9","-11 11 M1 -12 L-2 -11 L-4 -9 L-6 -6 L-7 -3 L-8 1 L-8 4 L-7 7 L-6 8 L-4 9 L-1 9 L2 8 L4 6 L6 3 L7 0 L8 -4 L8 -7 L7 -10 L6 -11 L4 -12 L1 -12 M1 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 4 L-6 7 L-4 9 M-1 9 L1 8 L3 6 L5 3 L6 0 L7 -4 L7 -7 L6 -10 L4 -12","-12 11 M-3 -12 L-9 9 M-2 -12 L-8 9 M-6 -12 L6 -12 L9 -11 L10 -9 L10 -7 L9 -4 L7 -2 L3 -1 L-5 -1 M6 -12 L8 -11 L9 -9 L9 -7 L8 -4 L6 -2 L3 -1 M-12 9 L-5 9","-11 11 M1 -12 L-2 -11 L-4 -9 L-6 -6 L-7 -3 L-8 1 L-8 4 L-7 7 L-6 8 L-4 9 L-1 9 L2 8 L4 6 L6 3 L7 0 L8 -4 L8 -7 L7 -10 L6 -11 L4 -12 L1 -12 M1 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 4 L-6 7 L-4 9 M-1 9 L1 8 L3 6 L5 3 L6 0 L7 -4 L7 -7 L6 -10 L4 -12 M-6 7 L-6 6 L-5 4 L-3 3 L-2 3 L0 4 L1 6 L1 13 L2 14 L4 14 L5 12 L5 11 M1 6 L2 12 L3 13 L4 13 L5 12","-12 12 M-3 -12 L-9 9 M-2 -12 L-8 9 M-6 -12 L5 -12 L8 -11 L9 -9 L9 -7 L8 -4 L7 -3 L4 -2 L-5 -2 M5 -12 L7 -11 L8 -9 L8 -7 L7 -4 L6 -3 L4 -2 M0 -2 L2 -1 L3 0 L4 8 L5 9 L7 9 L8 7 L8 6 M3 0 L5 7 L6 8 L7 8 L8 7 M-12 9 L-5 9","-11 12 M8 -10 L9 -10 L10 -12 L9 -6 L9 -8 L8 -10 L7 -11 L4 -12 L0 -12 L-3 -11 L-5 -9 L-5 -7 L-4 -5 L-3 -4 L4 0 L6 2 M-5 -7 L-3 -5 L4 -1 L5 0 L6 2 L6 5 L5 7 L4 8 L1 9 L-3 9 L-6 8 L-7 7 L-8 5 L-8 3 L-9 9 L-8 7 L-7 7","-10 11 M3 -12 L-3 9 M4 -12 L-2 9 M-3 -12 L-6 -6 L-4 -12 L11 -12 L10 -6 L10 -12 M-6 9 L1 9","-12 13 M-4 -12 L-7 -1 L-8 3 L-8 6 L-7 8 L-4 9 L0 9 L3 8 L5 6 L6 3 L10 -12 M-3 -12 L-6 -1 L-7 3 L-7 6 L-6 8 L-4 9 M-7 -12 L0 -12 M7 -12 L13 -12","-10 10 M-4 -12 L-3 9 M-3 -12 L-2 7 M10 -12 L-3 9 M-6 -12 L0 -12 M6 -12 L12 -12","-13 13 M-5 -12 L-7 9 M-4 -12 L-6 7 M3 -12 L-7 9 M3 -12 L1 9 M4 -12 L2 7 M11 -12 L1 9 M-8 -12 L-1 -12 M8 -12 L14 -12","-11 11 M-4 -12 L3 9 M-3 -12 L4 9 M10 -12 L-10 9 M-6 -12 L0 -12 M6 -12 L12 -12 M-12 9 L-6 9 M0 9 L6 9","-10 11 M-4 -12 L0 -2 L-3 9 M-3 -12 L1 -2 L-2 9 M11 -12 L1 -2 M-6 -12 L0 -12 M7 -12 L13 -12 M-6 9 L1 9","-11 11 M9 -12 L-10 9 M10 -12 L-9 9 M-3 -12 L-6 -6 L-4 -12 L10 -12 M-10 9 L4 9 L6 3 L3 9","-7 7 M-3 -16 L-3 16 M-2 -16 L-2 16 M-3 -16 L4 -16 M-3 16 L4 16","-7 7 M-7 -12 L7 12","-7 7 M2 -16 L2 16 M3 -16 L3 16 M-4 -16 L3 -16 M-4 16 L3 16","-6 6 M2 -12 L-3 -6 M2 -12 L3 -11 L-3 -6","-13 13 M-9 0 L9 0","-6 6 M-2 -12 L3 -6 M-2 -12 L-3 -11 L3 -6","-10 11 M6 -5 L4 2 L3 6 L3 8 L4 9 L7 9 L9 7 L10 5 M7 -5 L5 2 L4 6 L4 8 L5 9 M4 2 L4 -1 L3 -4 L1 -5 L-1 -5 L-4 -4 L-6 -1 L-7 2 L-7 5 L-6 7 L-5 8 L-3 9 L-1 9 L1 8 L3 5 L4 2 M-1 -5 L-3 -4 L-5 -1 L-6 2 L-6 6 L-5 8","-10 9 M-2 -12 L-6 1 L-6 4 L-5 7 L-4 8 M-1 -12 L-5 1 M-5 1 L-4 -2 L-2 -4 L0 -5 L2 -5 L4 -4 L5 -3 L6 -1 L6 2 L5 5 L3 8 L0 9 L-2 9 L-4 8 L-5 5 L-5 1 M4 -4 L5 -2 L5 2 L4 5 L2 8 L0 9 M-5 -12 L-1 -12","-9 9 M5 -2 L5 -1 L6 -1 L6 -2 L5 -4 L3 -5 L0 -5 L-3 -4 L-5 -1 L-6 2 L-6 5 L-5 7 L-4 8 L-2 9 L0 9 L3 8 L5 5 M0 -5 L-2 -4 L-4 -1 L-5 2 L-5 6 L-4 8","-10 11 M8 -12 L4 2 L3 6 L3 8 L4 9 L7 9 L9 7 L10 5 M9 -12 L5 2 L4 6 L4 8 L5 9 M4 2 L4 -1 L3 -4 L1 -5 L-1 -5 L-4 -4 L-6 -1 L-7 2 L-7 5 L-6 7 L-5 8 L-3 9 L-1 9 L1 8 L3 5 L4 2 M-1 -5 L-3 -4 L-5 -1 L-6 2 L-6 6 L-5 8 M5 -12 L9 -12","-9 9 M-5 4 L-1 3 L2 2 L5 0 L6 -2 L5 -4 L3 -5 L0 -5 L-3 -4 L-5 -1 L-6 2 L-6 5 L-5 7 L-4 8 L-2 9 L0 9 L3 8 L5 6 M0 -5 L-2 -4 L-4 -1 L-5 2 L-5 6 L-4 8","-7 8 M8 -11 L7 -10 L8 -9 L9 -10 L9 -11 L8 -12 L6 -12 L4 -11 L3 -10 L2 -8 L1 -5 L-2 9 L-3 13 L-4 15 M6 -12 L4 -10 L3 -8 L2 -4 L0 5 L-1 9 L-2 12 L-3 14 L-4 15 L-6 16 L-8 16 L-9 15 L-9 14 L-8 13 L-7 14 L-8 15 M-3 -5 L7 -5","-10 10 M7 -5 L3 9 L2 12 L0 15 L-3 16 L-6 16 L-8 15 L-9 14 L-9 13 L-8 12 L-7 13 L-8 14 M6 -5 L2 9 L1 12 L-1 15 L-3 16 M4 2 L4 -1 L3 -4 L1 -5 L-1 -5 L-4 -4 L-6 -1 L-7 2 L-7 5 L-6 7 L-5 8 L-3 9 L-1 9 L1 8 L3 5 L4 2 M-1 -5 L-3 -4 L-5 -1 L-6 2 L-6 6 L-5 8","-10 11 M-2 -12 L-8 9 M-1 -12 L-7 9 M-5 2 L-3 -2 L-1 -4 L1 -5 L3 -5 L5 -4 L6 -3 L6 -1 L4 5 L4 8 L5 9 M3 -5 L5 -3 L5 -1 L3 5 L3 8 L4 9 L7 9 L9 7 L10 5 M-5 -12 L-1 -12","-6 7 M3 -12 L2 -11 L3 -10 L4 -11 L3 -12 M-5 -1 L-4 -3 L-2 -5 L1 -5 L2 -4 L2 -1 L0 5 L0 8 L1 9 M0 -5 L1 -4 L1 -1 L-1 5 L-1 8 L0 9 L3 9 L5 7 L6 5","-6 7 M4 -12 L3 -11 L4 -10 L5 -11 L4 -12 M-4 -1 L-3 -3 L-1 -5 L2 -5 L3 -4 L3 -1 L0 9 L-1 12 L-2 14 L-3 15 L-5 16 L-7 16 L-8 15 L-8 14 L-7 13 L-6 14 L-7 15 M1 -5 L2 -4 L2 -1 L-1 9 L-2 12 L-3 14 L-5 16","-10 10 M-2 -12 L-8 9 M-1 -12 L-7 9 M6 -4 L5 -3 L6 -2 L7 -3 L7 -4 L6 -5 L5 -5 L3 -4 L-1 0 L-3 1 L-5 1 M-3 1 L-1 2 L1 8 L2 9 M-3 1 L-2 2 L0 8 L1 9 L3 9 L5 8 L7 5 M-5 -12 L-1 -12","-5 7 M3 -12 L-1 2 L-2 6 L-2 8 L-1 9 L2 9 L4 7 L5 5 M4 -12 L0 2 L-1 6 L-1 8 L0 9 M0 -12 L4 -12","-17 16 M-16 -1 L-15 -3 L-13 -5 L-10 -5 L-9 -4 L-9 -2 L-10 2 L-12 9 M-11 -5 L-10 -4 L-10 -2 L-11 2 L-13 9 M-10 2 L-8 -2 L-6 -4 L-4 -5 L-2 -5 L0 -4 L1 -3 L1 -1 L-2 9 M-2 -5 L0 -3 L0 -1 L-3 9 M0 2 L2 -2 L4 -4 L6 -5 L8 -5 L10 -4 L11 -3 L11 -1 L9 5 L9 8 L10 9 M8 -5 L10 -3 L10 -1 L8 5 L8 8 L9 9 L12 9 L14 7 L15 5","-12 11 M-11 -1 L-10 -3 L-8 -5 L-5 -5 L-4 -4 L-4 -2 L-5 2 L-7 9 M-6 -5 L-5 -4 L-5 -2 L-6 2 L-8 9 M-5 2 L-3 -2 L-1 -4 L1 -5 L3 -5 L5 -4 L6 -3 L6 -1 L4 5 L4 8 L5 9 M3 -5 L5 -3 L5 -1 L3 5 L3 8 L4 9 L7 9 L9 7 L10 5","-9 9 M0 -5 L-3 -4 L-5 -1 L-6 2 L-6 5 L-5 7 L-4 8 L-2 9 L0 9 L3 8 L5 5 L6 2 L6 -1 L5 -3 L4 -4 L2 -5 L0 -5 M0 -5 L-2 -4 L-4 -1 L-5 2 L-5 6 L-4 8 M0 9 L2 8 L4 5 L5 2 L5 -2 L4 -4","-11 10 M-10 -1 L-9 -3 L-7 -5 L-4 -5 L-3 -4 L-3 -2 L-4 2 L-8 16 M-5 -5 L-4 -4 L-4 -2 L-5 2 L-9 16 M-4 2 L-3 -1 L-1 -4 L1 -5 L3 -5 L5 -4 L6 -3 L7 -1 L7 2 L6 5 L4 8 L1 9 L-1 9 L-3 8 L-4 5 L-4 2 M5 -4 L6 -2 L6 2 L5 5 L3 8 L1 9 M-12 16 L-5 16","-10 10 M6 -5 L0 16 M7 -5 L1 16 M4 2 L4 -1 L3 -4 L1 -5 L-1 -5 L-4 -4 L-6 -1 L-7 2 L-7 5 L-6 7 L-5 8 L-3 9 L-1 9 L1 8 L3 5 L4 2 M-1 -5 L-3 -4 L-5 -1 L-6 2 L-6 6 L-5 8 M-3 16 L4 16","-9 8 M-8 -1 L-7 -3 L-5 -5 L-2 -5 L-1 -4 L-1 -2 L-2 2 L-4 9 M-3 -5 L-2 -4 L-2 -2 L-3 2 L-5 9 M-2 2 L0 -2 L2 -4 L4 -5 L6 -5 L7 -4 L7 -3 L6 -2 L5 -3 L6 -4","-8 9 M6 -3 L6 -2 L7 -2 L7 -3 L6 -4 L3 -5 L0 -5 L-3 -4 L-4 -3 L-4 -1 L-3 0 L4 4 L5 5 M-4 -2 L-3 -1 L4 3 L5 4 L5 7 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-6 6 L-5 6 L-5 7","-7 7 M2 -12 L-2 2 L-3 6 L-3 8 L-2 9 L1 9 L3 7 L4 5 M3 -12 L-1 2 L-2 6 L-2 8 L-1 9 M-4 -5 L5 -5","-12 11 M-11 -1 L-10 -3 L-8 -5 L-5 -5 L-4 -4 L-4 -1 L-6 5 L-6 7 L-4 9 M-6 -5 L-5 -4 L-5 -1 L-7 5 L-7 7 L-6 8 L-4 9 L-2 9 L0 8 L2 6 L4 2 M6 -5 L4 2 L3 6 L3 8 L4 9 L7 9 L9 7 L10 5 M7 -5 L5 2 L4 6 L4 8 L5 9","-10 10 M-9 -1 L-8 -3 L-6 -5 L-3 -5 L-2 -4 L-2 -1 L-4 5 L-4 7 L-2 9 M-4 -5 L-3 -4 L-3 -1 L-5 5 L-5 7 L-4 8 L-2 9 L-1 9 L2 8 L4 6 L6 3 L7 -1 L7 -5 L6 -5 L7 -3","-15 14 M-14 -1 L-13 -3 L-11 -5 L-8 -5 L-7 -4 L-7 -1 L-9 5 L-9 7 L-7 9 M-9 -5 L-8 -4 L-8 -1 L-10 5 L-10 7 L-9 8 L-7 9 L-5 9 L-3 8 L-1 6 L0 4 M2 -5 L0 4 L0 7 L1 8 L3 9 L5 9 L7 8 L9 6 L10 4 L11 0 L11 -5 L10 -5 L11 -3 M3 -5 L1 4 L1 7 L3 9","-10 10 M-7 -1 L-5 -4 L-3 -5 L0 -5 L1 -3 L1 0 M-1 -5 L0 -3 L0 0 L-1 4 L-2 6 L-4 8 L-6 9 L-7 9 L-8 8 L-8 7 L-7 6 L-6 7 L-7 8 M-1 4 L-1 7 L0 9 L3 9 L5 8 L7 5 M7 -4 L6 -3 L7 -2 L8 -3 L8 -4 L7 -5 L6 -5 L4 -4 L2 -2 L1 0 L0 4 L0 7 L1 9","-11 10 M-10 -1 L-9 -3 L-7 -5 L-4 -5 L-3 -4 L-3 -1 L-5 5 L-5 7 L-3 9 M-5 -5 L-4 -4 L-4 -1 L-6 5 L-6 7 L-5 8 L-3 9 L-1 9 L1 8 L3 6 L5 2 M8 -5 L4 9 L3 12 L1 15 L-2 16 L-5 16 L-7 15 L-8 14 L-8 13 L-7 12 L-6 13 L-7 14 M7 -5 L3 9 L2 12 L0 15 L-2 16","-10 10 M7 -5 L6 -3 L4 -1 L-4 5 L-6 7 L-7 9 M-6 -1 L-5 -3 L-3 -5 L0 -5 L4 -3 M-5 -3 L-3 -4 L0 -4 L4 -3 L6 -3 M-6 7 L-4 7 L0 8 L3 8 L5 7 M-4 7 L0 9 L3 9 L5 7 L6 5","-7 7 M2 -16 L0 -15 L-1 -14 L-2 -12 L-2 -10 L-1 -8 L0 -7 L1 -5 L1 -3 L-1 -1 M0 -15 L-1 -13 L-1 -11 L0 -9 L1 -8 L2 -6 L2 -4 L1 -2 L-3 0 L1 2 L2 4 L2 6 L1 8 L0 9 L-1 11 L-1 13 L0 15 M-1 1 L1 3 L1 5 L0 7 L-1 8 L-2 10 L-2 12 L-1 14 L0 15 L2 16","-4 4 M0 -16 L0 16","-7 7 M-2 -16 L0 -15 L1 -14 L2 -12 L2 -10 L1 -8 L0 -7 L-1 -5 L-1 -3 L1 -1 M0 -15 L1 -13 L1 -11 L0 -9 L-1 -8 L-2 -6 L-2 -4 L-1 -2 L3 0 L-1 2 L-2 4 L-2 6 L-1 8 L0 9 L1 11 L1 13 L0 15 M1 1 L-1 3 L-1 5 L0 7 L1 8 L2 10 L2 12 L1 14 L0 15 L-2 16","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3","-8 8 M-8 -12 L-8 9 L-7 9 L-7 -12 L-6 -12 L-6 9 L-5 9 L-5 -12 L-4 -12 L-4 9 L-3 9 L-3 -12 L-2 -12 L-2 9 L-1 9 L-1 -12 L0 -12 L0 9 L1 9 L1 -12 L2 -12 L2 9 L3 9 L3 -12 L4 -12 L4 9 L5 9 L5 -12 L6 -12 L6 9 L7 9 L7 -12 L8 -12 L8 9"],
    :scriptc => ["-8 8","-5 6 M3 -12 L2 -11 L0 1 M3 -11 L0 1 M3 -12 L4 -11 L0 1 M-2 7 L-3 8 L-2 9 L-1 8 L-2 7","-9 9 M-2 -12 L-4 -5 M-1 -12 L-4 -5 M7 -12 L5 -5 M8 -12 L5 -5","-10 11 M1 -12 L-6 16 M7 -12 L0 16 M-6 -1 L8 -1 M-7 5 L7 5","-10 11 M2 -16 L-6 13 M7 -16 L-1 13 M8 -8 L7 -7 L8 -6 L9 -7 L9 -8 L8 -10 L7 -11 L4 -12 L0 -12 L-3 -11 L-5 -9 L-5 -7 L-4 -5 L-3 -4 L4 0 L6 2 M-5 -7 L-3 -5 L4 -1 L5 0 L6 2 L6 5 L5 7 L4 8 L1 9 L-3 9 L-6 8 L-7 7 L-8 5 L-8 4 L-7 3 L-6 4 L-7 5","-12 12 M9 -12 L-9 9 M-4 -12 L-2 -10 L-2 -8 L-3 -6 L-5 -5 L-7 -5 L-9 -7 L-9 -9 L-8 -11 L-6 -12 L-4 -12 L-2 -11 L1 -10 L4 -10 L7 -11 L9 -12 M5 2 L3 3 L2 5 L2 7 L4 9 L6 9 L8 8 L9 6 L9 4 L7 2 L5 2","-13 13 M10 -4 L9 -3 L10 -2 L11 -3 L11 -4 L10 -5 L9 -5 L7 -4 L5 -2 L0 6 L-2 8 L-4 9 L-7 9 L-10 8 L-11 6 L-11 4 L-10 2 L-9 1 L-7 0 L-2 -2 L0 -3 L2 -5 L3 -7 L3 -9 L2 -11 L0 -12 L-2 -11 L-3 -9 L-3 -6 L-2 0 L-1 3 L1 6 L3 8 L5 9 L7 9 L8 7 L8 6 M-7 9 L-9 8 L-10 6 L-10 4 L-9 2 L-8 1 L-2 -2 M-3 -6 L-2 -1 L-1 2 L1 5 L3 7 L5 8 L7 8 L8 7","-5 6 M3 -10 L2 -11 L3 -12 L4 -11 L4 -10 L3 -8 L1 -6","-7 8 M8 -16 L4 -13 L1 -10 L-1 -7 L-3 -3 L-4 2 L-4 6 L-3 11 L-2 14 L-1 16 M4 -13 L1 -9 L-1 -5 L-2 -2 L-3 3 L-3 8 L-2 13 L-1 16","-8 7 M1 -16 L2 -14 L3 -11 L4 -6 L4 -2 L3 3 L1 7 L-1 10 L-4 13 L-8 16 M1 -16 L2 -13 L3 -8 L3 -3 L2 2 L1 5 L-1 9 L-4 13","-8 9 M2 -12 L2 0 M-3 -9 L7 -3 M7 -9 L-3 -3","-13 13 M0 -9 L0 9 M-9 0 L9 0","-5 6 M-2 9 L-3 8 L-2 7 L-1 8 L-1 9 L-2 11 L-4 13","-13 13 M-9 0 L9 0","-5 6 M-2 7 L-3 8 L-2 9 L-1 8 L-2 7","-11 11 M13 -16 L-13 16","-10 11 M2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 4 L-6 7 L-5 8 L-3 9 L-1 9 L2 8 L4 6 L6 3 L7 0 L8 -4 L8 -7 L7 -10 L6 -11 L4 -12 L2 -12 M2 -12 L0 -11 L-2 -9 L-4 -6 L-5 -3 L-6 1 L-6 4 L-5 7 L-3 9 M-1 9 L1 8 L3 6 L5 3 L6 0 L7 -4 L7 -7 L6 -10 L4 -12","-10 11 M2 -8 L-3 9 M4 -12 L-2 9 M4 -12 L1 -9 L-2 -7 L-4 -6 M3 -9 L-1 -7 L-4 -6","-10 11 M-3 -8 L-2 -7 L-3 -6 L-4 -7 L-4 -8 L-3 -10 L-2 -11 L1 -12 L4 -12 L7 -11 L8 -9 L8 -7 L7 -5 L5 -3 L2 -1 L-2 1 L-5 3 L-7 5 L-9 9 M4 -12 L6 -11 L7 -9 L7 -7 L6 -5 L4 -3 L-2 1 M-8 7 L-7 6 L-5 6 L0 8 L3 8 L5 7 L6 5 M-5 6 L0 9 L3 9 L5 8 L6 5","-10 11 M-3 -8 L-2 -7 L-3 -6 L-4 -7 L-4 -8 L-3 -10 L-2 -11 L1 -12 L4 -12 L7 -11 L8 -9 L8 -7 L7 -5 L4 -3 L1 -2 M4 -12 L6 -11 L7 -9 L7 -7 L6 -5 L4 -3 M-1 -2 L1 -2 L4 -1 L5 0 L6 2 L6 5 L5 7 L4 8 L1 9 L-3 9 L-6 8 L-7 7 L-8 5 L-8 4 L-7 3 L-6 4 L-7 5 M1 -2 L3 -1 L4 0 L5 2 L5 5 L4 7 L3 8 L1 9","-10 11 M6 -11 L0 9 M7 -12 L1 9 M7 -12 L-8 3 L8 3","-10 11 M-1 -12 L-6 -2 M-1 -12 L9 -12 M-1 -11 L4 -11 L9 -12 M-6 -2 L-5 -3 L-2 -4 L1 -4 L4 -3 L5 -2 L6 0 L6 3 L5 6 L3 8 L0 9 L-3 9 L-6 8 L-7 7 L-8 5 L-8 4 L-7 3 L-6 4 L-7 5 M1 -4 L3 -3 L4 -2 L5 0 L5 3 L4 6 L2 8 L0 9","-10 11 M7 -9 L6 -8 L7 -7 L8 -8 L8 -9 L7 -11 L5 -12 L2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 5 L-6 7 L-5 8 L-3 9 L0 9 L3 8 L5 6 L6 4 L6 1 L5 -1 L4 -2 L2 -3 L-1 -3 L-3 -2 L-5 0 L-6 2 M2 -12 L0 -11 L-2 -9 L-4 -6 L-5 -3 L-6 1 L-6 6 L-5 8 M0 9 L2 8 L4 6 L5 4 L5 0 L4 -2","-10 11 M-4 -12 L-6 -6 M9 -12 L8 -9 L6 -6 L1 0 L-1 3 L-2 5 L-3 9 M6 -6 L0 0 L-2 3 L-3 5 L-4 9 M-5 -9 L-2 -12 L0 -12 L5 -9 M-4 -10 L-2 -11 L0 -11 L5 -9 L7 -9 L8 -10 L9 -12","-10 11 M1 -12 L-2 -11 L-3 -10 L-4 -8 L-4 -5 L-3 -3 L-1 -2 L2 -2 L6 -3 L7 -4 L8 -6 L8 -9 L7 -11 L4 -12 L1 -12 M1 -12 L-1 -11 L-2 -10 L-3 -8 L-3 -5 L-2 -3 L-1 -2 M2 -2 L5 -3 L6 -4 L7 -6 L7 -9 L6 -11 L4 -12 M-1 -2 L-5 -1 L-7 1 L-8 3 L-8 6 L-7 8 L-4 9 L0 9 L4 8 L5 7 L6 5 L6 2 L5 0 L4 -1 L2 -2 M-1 -2 L-4 -1 L-6 1 L-7 3 L-7 6 L-6 8 L-4 9 M0 9 L3 8 L4 7 L5 5 L5 1 L4 -1","-10 11 M7 -5 L6 -3 L4 -1 L2 0 L-1 0 L-3 -1 L-4 -2 L-5 -4 L-5 -7 L-4 -9 L-2 -11 L1 -12 L4 -12 L6 -11 L7 -10 L8 -8 L8 -4 L7 0 L6 3 L4 6 L2 8 L-1 9 L-4 9 L-6 8 L-7 6 L-7 5 L-6 4 L-5 5 L-6 6 M-3 -1 L-4 -3 L-4 -7 L-3 -9 L-1 -11 L1 -12 M6 -11 L7 -9 L7 -4 L6 0 L5 3 L3 6 L1 8 L-1 9","-5 6 M1 -5 L0 -4 L1 -3 L2 -4 L1 -5 M-2 7 L-3 8 L-2 9 L-1 8","-5 6 M1 -5 L0 -4 L1 -3 L2 -4 L1 -5 M-2 9 L-3 8 L-2 7 L-1 8 L-1 9 L-2 11 L-4 13","-12 12 M8 -9 L-8 0 L8 9","-13 13 M-9 -3 L9 -3 M-9 3 L9 3","-12 12 M-8 -9 L8 0 L-8 9","-10 11 M-3 -8 L-2 -7 L-3 -6 L-4 -7 L-4 -8 L-3 -10 L-2 -11 L1 -12 L5 -12 L8 -11 L9 -9 L9 -7 L8 -5 L7 -4 L1 -2 L-1 -1 L-1 1 L0 2 L2 2 M5 -12 L7 -11 L8 -9 L8 -7 L7 -5 L6 -4 L4 -3 M-2 7 L-3 8 L-2 9 L-1 8 L-2 7","-13 14 M5 -4 L4 -6 L2 -7 L-1 -7 L-3 -6 L-4 -5 L-5 -2 L-5 1 L-4 3 L-2 4 L1 4 L3 3 L4 1 M-1 -7 L-3 -5 L-4 -2 L-4 1 L-3 3 L-2 4 M5 -7 L4 1 L4 3 L6 4 L8 4 L10 2 L11 -1 L11 -3 L10 -6 L9 -8 L7 -10 L5 -11 L2 -12 L-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L2 9 L5 8 L7 7 L8 6 M6 -7 L5 1 L5 3 L6 4","-13 10 M6 -12 L4 -10 L2 -7 L-1 -2 L-3 1 L-6 5 L-9 8 L-11 9 L-13 9 L-14 8 L-14 6 L-13 5 L-12 6 L-13 7 M6 -12 L5 -8 L3 2 L2 9 M6 -12 L3 9 M2 9 L2 7 L1 4 L0 2 L-2 0 L-4 -1 L-6 -1 L-7 0 L-7 2 L-6 5 L-3 8 L0 9 L4 9 L6 8","-12 12 M3 -11 L2 -10 L1 -8 L-1 -3 L-3 3 L-4 5 L-6 8 L-8 9 M2 -10 L1 -7 L-1 1 L-2 4 L-3 6 L-5 8 L-8 9 L-10 9 L-11 8 L-11 6 L-10 5 L-9 6 L-10 7 M-3 -6 L-4 -4 L-5 -3 L-7 -3 L-8 -4 L-8 -6 L-7 -8 L-5 -10 L-3 -11 L0 -12 L6 -12 L8 -11 L9 -9 L9 -7 L8 -5 L6 -4 L2 -3 L0 -3 M6 -12 L7 -11 L8 -9 L8 -7 L7 -5 L6 -4 M2 -3 L5 -2 L6 -1 L7 1 L7 4 L6 7 L5 8 L3 9 L1 9 L0 8 L0 6 L1 3 M2 -3 L4 -2 L5 -1 L6 1 L6 4 L5 7 L3 9","-10 11 M-7 -10 L-8 -8 L-8 -6 L-7 -4 L-4 -3 L-1 -3 L3 -4 L5 -5 L7 -7 L8 -9 L8 -11 L7 -12 L5 -12 L2 -11 L-1 -8 L-3 -5 L-5 -1 L-6 3 L-6 6 L-5 8 L-2 9 L0 9 L3 8 L5 6 L6 4 L6 2 L5 0 L3 0 L1 1 L0 3 M5 -12 L3 -11 L0 -8 L-2 -5 L-4 -1 L-5 3 L-5 6 L-4 8 L-2 9","-12 11 M3 -11 L2 -10 L1 -8 L-1 -3 L-3 3 L-4 5 L-6 8 L-8 9 M2 -10 L1 -7 L-1 1 L-2 4 L-3 6 L-5 8 L-8 9 L-10 9 L-11 8 L-11 6 L-10 5 L-8 5 L-6 6 L-4 8 L-2 9 L1 9 L3 8 L5 6 L7 2 L8 -3 L8 -6 L7 -9 L5 -11 L3 -12 L-2 -12 L-5 -11 L-7 -9 L-8 -7 L-8 -5 L-7 -4 L-5 -4 L-4 -5 L-3 -7","-9 10 M5 -9 L4 -8 L4 -6 L5 -5 L7 -5 L8 -7 L8 -9 L7 -11 L5 -12 L2 -12 L0 -11 L-1 -10 L-2 -8 L-2 -6 L-1 -4 L1 -3 M2 -12 L0 -10 L-1 -8 L-1 -5 L1 -3 M1 -3 L-1 -3 L-4 -2 L-6 0 L-7 2 L-7 5 L-6 7 L-5 8 L-3 9 L0 9 L3 8 L5 6 L6 4 L6 2 L5 0 L3 0 L1 1 L0 3 M-1 -3 L-3 -2 L-5 0 L-6 2 L-6 6 L-5 8","-11 10 M5 -10 L4 -8 L2 -3 L0 3 L-1 5 L-3 8 L-5 9 M-1 -6 L-2 -4 L-4 -3 L-6 -3 L-7 -5 L-7 -7 L-6 -9 L-4 -11 L-1 -12 L9 -12 L6 -11 L5 -10 L4 -7 L2 1 L1 4 L0 6 L-2 8 L-5 9 L-7 9 L-9 8 L-10 7 L-10 6 L-9 5 L-8 6 L-9 7 M1 -12 L5 -11 L6 -11 M-3 1 L-2 0 L0 -1 L4 -1 L6 -2 L8 -5 L6 2","-11 11 M-8 -9 L-9 -7 L-9 -5 L-8 -3 L-6 -2 L-3 -2 L0 -3 L2 -4 L5 -7 L6 -10 L6 -11 L5 -12 L4 -12 L2 -11 L0 -9 L-1 -7 L-2 -4 L-2 -1 L-1 1 L1 2 L3 2 L5 1 L7 -1 L8 -3 M5 -12 L3 -11 L1 -9 L0 -7 L-1 -4 L-1 0 L1 2 M8 -3 L7 1 L5 5 L3 7 L1 8 L-3 9 L-6 9 L-8 8 L-9 6 L-9 5 L-8 4 L-7 5 L-8 6 M7 1 L5 4 L3 6 L0 8 L-3 9","-12 12 M-6 -6 L-7 -7 L-7 -9 L-6 -11 L-3 -12 L0 -12 L-3 -1 L-5 5 L-6 7 L-7 8 L-9 9 L-11 9 L-12 8 L-12 6 L-11 5 L-10 6 L-11 7 M0 -12 L-3 -3 L-4 0 L-6 5 L-7 7 L-9 9 M-8 2 L-7 1 L-5 0 L4 -3 L6 -4 L9 -6 L11 -8 L12 -10 L12 -11 L11 -12 L10 -12 L8 -11 L6 -8 L5 -6 L3 0 L2 4 L2 7 L4 9 L5 9 L7 8 L9 6 M10 -12 L8 -10 L6 -6 L4 0 L3 4 L3 7 L4 9","-9 7 M5 -10 L3 -7 L1 -2 L-1 3 L-2 5 L-4 8 L-6 9 M7 -6 L5 -4 L2 -3 L-1 -3 L-3 -4 L-4 -6 L-4 -8 L-3 -10 L-1 -11 L3 -12 L7 -12 L5 -10 L4 -8 L2 -2 L0 4 L-1 6 L-3 8 L-6 9 L-8 9 L-9 8 L-9 6 L-8 5 L-7 6 L-8 7","-9 8 M7 -12 L5 -10 L3 -7 L1 -2 L-2 7 L-4 11 M7 -5 L5 -3 L2 -2 L-1 -2 L-3 -3 L-4 -5 L-4 -7 L-3 -9 L-1 -11 L3 -12 L7 -12 L5 -9 L4 -7 L1 2 L-1 6 L-2 8 L-4 11 L-5 12 L-7 13 L-8 12 L-8 10 L-7 8 L-5 6 L-3 5 L0 4 L4 3","-12 12 M-6 -6 L-7 -7 L-7 -9 L-5 -11 L-2 -12 L0 -12 L-3 -1 L-5 5 L-6 7 L-7 8 L-9 9 L-11 9 L-12 8 L-12 6 L-11 5 L-10 6 L-11 7 M0 -12 L-3 -3 L-4 0 L-6 5 L-7 7 L-9 9 M8 -11 L5 -7 L3 -5 L1 -4 L-2 -3 M11 -11 L10 -10 L11 -9 L12 -10 L12 -11 L11 -12 L10 -12 L8 -11 L5 -6 L4 -5 L2 -4 L-2 -3 M-2 -3 L1 -2 L2 0 L3 7 L4 9 M-2 -3 L0 -2 L1 0 L2 7 L4 9 L5 9 L7 8 L9 6","-9 9 M-5 -9 L-6 -7 L-6 -5 L-5 -3 L-3 -2 L0 -2 L3 -3 L5 -4 L8 -7 L9 -10 L9 -11 L8 -12 L7 -12 L5 -11 L4 -10 L2 -7 L-2 3 L-3 5 L-5 8 L-7 9 M4 -10 L2 -6 L0 1 L-1 4 L-2 6 L-4 8 L-7 9 L-9 9 L-10 8 L-10 6 L-9 5 L-7 5 L-5 6 L-2 8 L0 9 L3 9 L5 8 L7 6","-14 14 M0 -12 L-4 -3 L-7 3 L-9 6 L-11 8 L-13 9 L-15 9 L-16 8 L-16 6 L-15 5 L-14 6 L-15 7 M0 -12 L-2 -5 L-3 -1 L-4 4 L-4 8 L-2 9 M0 -12 L-1 -8 L-2 -3 L-3 4 L-3 8 L-2 9 M9 -12 L5 -3 L0 6 L-2 9 M9 -12 L7 -5 L6 -1 L5 4 L5 8 L7 9 L8 9 L10 8 L12 6 M9 -12 L8 -8 L7 -3 L6 4 L6 8 L7 9","-11 12 M0 -12 L-1 -8 L-3 -2 L-5 3 L-6 5 L-8 8 L-10 9 L-12 9 L-13 8 L-13 6 L-12 5 L-11 6 L-12 7 M0 -12 L0 -7 L1 4 L2 9 M0 -12 L1 -7 L2 4 L2 9 M14 -11 L13 -10 L14 -9 L15 -10 L15 -11 L14 -12 L12 -12 L10 -11 L8 -8 L7 -6 L5 -1 L3 5 L2 9","-10 11 M1 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -4 L-7 0 L-7 4 L-6 7 L-5 8 L-3 9 L-1 9 L2 8 L4 6 L6 3 L7 1 L8 -3 L8 -7 L7 -10 L6 -11 L5 -11 L3 -10 L1 -8 L-1 -4 L-2 1 L-2 4 M-1 -11 L-3 -8 L-5 -4 L-6 0 L-6 4 L-5 7 L-3 9","-12 11 M3 -11 L2 -10 L1 -8 L-1 -3 L-3 3 L-4 5 L-6 8 L-8 9 M2 -10 L1 -7 L-1 1 L-2 4 L-3 6 L-5 8 L-8 9 L-10 9 L-11 8 L-11 6 L-10 5 L-9 6 L-10 7 M-3 -6 L-4 -4 L-5 -3 L-7 -3 L-8 -4 L-8 -6 L-7 -8 L-5 -10 L-3 -11 L0 -12 L4 -12 L7 -11 L8 -10 L9 -8 L9 -5 L8 -3 L7 -2 L4 -1 L2 -1 L0 -2 M4 -12 L6 -11 L7 -10 L8 -8 L8 -5 L7 -3 L6 -2 L4 -1","-10 11 M3 -8 L3 -6 L2 -4 L1 -3 L-1 -2 L-3 -2 L-4 -4 L-4 -6 L-3 -9 L-1 -11 L2 -12 L5 -12 L7 -11 L8 -9 L8 -5 L7 -2 L5 1 L1 5 L-2 7 L-4 8 L-7 9 L-9 9 L-10 8 L-10 6 L-9 5 L-7 5 L-5 6 L-2 8 L1 9 L4 9 L6 8 L8 6 M5 -12 L6 -11 L7 -9 L7 -5 L6 -2 L4 1 L1 4 L-3 7 L-7 9","-12 12 M3 -11 L2 -10 L1 -8 L-1 -3 L-3 3 L-4 5 L-6 8 L-8 9 M2 -10 L1 -7 L-1 1 L-2 4 L-3 6 L-5 8 L-8 9 L-10 9 L-11 8 L-11 6 L-10 5 L-9 6 L-10 7 M-3 -6 L-4 -4 L-5 -3 L-7 -3 L-8 -4 L-8 -6 L-7 -8 L-5 -10 L-3 -11 L0 -12 L5 -12 L8 -11 L9 -9 L9 -7 L8 -5 L7 -4 L4 -3 L0 -3 M5 -12 L7 -11 L8 -9 L8 -7 L7 -5 L6 -4 L4 -3 M0 -3 L3 -2 L4 0 L5 7 L6 9 M0 -3 L2 -2 L3 0 L4 7 L6 9 L7 9 L9 8 L11 6","-10 10 M-4 -9 L-5 -7 L-5 -5 L-4 -3 L-2 -2 L1 -2 L4 -3 L6 -4 L9 -7 L10 -10 L10 -11 L9 -12 L8 -12 L6 -11 L5 -10 L4 -8 L3 -5 L1 2 L0 5 L-2 8 L-4 9 M4 -8 L3 -4 L2 3 L1 6 L-1 8 L-4 9 L-7 9 L-9 8 L-10 6 L-10 5 L-9 4 L-8 5 L-9 6","-9 9 M7 -10 L6 -8 L4 -3 L2 3 L1 5 L-1 8 L-3 9 M1 -6 L0 -4 L-2 -3 L-4 -3 L-5 -5 L-5 -7 L-4 -9 L-2 -11 L1 -12 L10 -12 L8 -11 L7 -10 L6 -7 L4 1 L3 4 L2 6 L0 8 L-3 9 L-5 9 L-7 8 L-8 7 L-8 6 L-7 5 L-6 6 L-7 7 M3 -12 L7 -11 L8 -11","-11 11 M-10 -8 L-8 -11 L-6 -12 L-5 -12 L-3 -10 L-3 -7 L-4 -4 L-7 4 L-7 7 L-6 9 M-5 -12 L-4 -10 L-4 -7 L-7 1 L-8 4 L-8 7 L-6 9 L-4 9 L-2 8 L1 5 L3 2 L4 0 M8 -12 L4 0 L3 4 L3 7 L5 9 L6 9 L8 8 L10 6 M9 -12 L5 0 L4 4 L4 7 L5 9","-11 10 M-10 -8 L-8 -11 L-6 -12 L-5 -12 L-3 -10 L-3 -7 L-4 -3 L-6 4 L-6 7 L-5 9 M-5 -12 L-4 -10 L-4 -7 L-6 0 L-7 4 L-7 7 L-5 9 L-4 9 L-1 8 L2 5 L4 2 L6 -2 L7 -5 L8 -9 L8 -11 L7 -12 L6 -12 L5 -11 L4 -9 L4 -6 L5 -4 L7 -2 L9 -1 L11 -1","-12 11 M-9 -6 L-10 -6 L-11 -7 L-11 -9 L-10 -11 L-8 -12 L-4 -12 L-5 -10 L-6 -6 L-7 3 L-8 9 M-6 -6 L-6 3 L-7 9 M4 -12 L2 -10 L0 -6 L-3 3 L-5 7 L-7 9 M4 -12 L3 -10 L2 -6 L1 3 L0 9 M2 -6 L2 3 L1 9 M14 -12 L12 -11 L10 -9 L8 -6 L5 3 L3 7 L1 9","-10 10 M-2 -7 L-3 -6 L-5 -6 L-6 -7 L-6 -9 L-5 -11 L-3 -12 L-1 -12 L1 -11 L2 -9 L2 -6 L1 -2 L-1 3 L-3 6 L-5 8 L-8 9 L-10 9 L-11 8 L-11 6 L-10 5 L-9 6 L-10 7 M-1 -12 L0 -11 L1 -9 L1 -6 L0 -2 L-2 3 L-4 6 L-6 8 L-8 9 M11 -11 L10 -10 L11 -9 L12 -10 L12 -11 L11 -12 L9 -12 L7 -11 L5 -9 L3 -6 L1 -2 L0 3 L0 6 L1 8 L2 9 L3 9 L5 8 L7 6","-11 11 M-8 -8 L-6 -11 L-4 -12 L-3 -12 L-1 -11 L-1 -9 L-3 -3 L-3 0 L-2 2 M-3 -12 L-2 -11 L-2 -9 L-4 -3 L-4 0 L-2 2 L0 2 L3 1 L5 -1 L7 -4 L8 -6 M10 -12 L8 -6 L5 2 L3 6 M11 -12 L9 -6 L7 -1 L5 3 L3 6 L1 8 L-2 9 L-6 9 L-8 8 L-9 6 L-9 5 L-8 4 L-7 5 L-8 6","-11 10 M8 -10 L7 -8 L5 -3 L4 0 L3 2 L1 5 L-1 7 L-3 8 L-6 9 M1 -6 L0 -4 L-2 -3 L-4 -3 L-5 -5 L-5 -7 L-4 -9 L-2 -11 L1 -12 L11 -12 L9 -11 L8 -10 L7 -7 L6 -3 L4 3 L2 6 L-1 8 L-6 9 L-10 9 L-11 8 L-11 6 L-10 5 L-8 5 L-6 6 L-3 8 L-1 9 L2 9 L5 8 L7 6 M4 -12 L8 -11 L9 -11","-7 7 M-3 -16 L-3 16 M-2 -16 L-2 16 M-3 -16 L4 -16 M-3 16 L4 16","-7 7 M-7 -12 L7 12","-7 7 M2 -16 L2 16 M3 -16 L3 16 M-4 -16 L3 -16 M-4 16 L3 16","-8 8 M-2 -6 L0 -9 L2 -6 M-5 -3 L0 -8 L5 -3 M0 -8 L0 9","-8 8 M-8 11 L8 11","-5 6 M4 -12 L2 -10 L1 -8 L1 -7 L2 -6 L3 -7 L2 -8","-7 9 M3 3 L2 1 L0 0 L-2 0 L-4 1 L-5 2 L-6 4 L-6 6 L-5 8 L-3 9 L-1 9 L1 8 L2 6 M-2 0 L-4 2 L-5 4 L-5 7 L-3 9 M4 0 L2 6 L2 8 L4 9 L6 8 L7 7 L9 4 M5 0 L3 6 L3 8 L4 9","-6 8 M-6 4 L-4 1 L-2 -3 M1 -12 L-5 6 L-5 8 L-3 9 L-2 9 L0 8 L2 6 L3 3 L3 0 L4 4 L5 5 L6 5 L8 4 M2 -12 L-4 6 L-4 8 L-3 9","-6 6 M2 1 L1 2 L2 2 L2 1 L1 0 L-1 0 L-3 1 L-4 2 L-5 4 L-5 6 L-4 8 L-2 9 L1 9 L4 7 L6 4 M-1 0 L-3 2 L-4 4 L-4 7 L-2 9","-7 9 M3 3 L2 1 L0 0 L-2 0 L-4 1 L-5 2 L-6 4 L-6 6 L-5 8 L-3 9 L-1 9 L1 8 L2 6 M-2 0 L-4 2 L-5 4 L-5 7 L-3 9 M8 -12 L2 6 L2 8 L4 9 L6 8 L7 7 L9 4 M9 -12 L3 6 L3 8 L4 9","-6 6 M-3 7 L-1 6 L0 5 L1 3 L1 1 L0 0 L-1 0 L-3 1 L-4 2 L-5 4 L-5 6 L-4 8 L-2 9 L1 9 L4 7 L6 4 M-1 0 L-3 2 L-4 4 L-4 7 L-2 9","-3 6 M0 0 L3 -3 L5 -6 L6 -9 L6 -11 L5 -12 L3 -11 L2 -9 L-7 18 L-7 20 L-6 21 L-4 20 L-3 17 L-2 8 L-1 9 L1 9 L3 8 L4 7 L6 4 M2 -9 L1 -4 L0 0 L-3 9 L-5 14 L-7 18","-7 9 M3 3 L2 1 L0 0 L-2 0 L-4 1 L-5 2 L-6 4 L-6 6 L-5 8 L-3 9 L-1 9 L1 8 L2 6 M-2 0 L-4 2 L-5 4 L-5 7 L-3 9 M4 0 L-2 18 M5 0 L2 9 L0 14 L-2 18 L-3 20 L-5 21 L-6 20 L-6 18 L-5 15 L-3 13 L0 11 L4 9 L7 7 L9 4","-6 9 M-6 4 L-4 1 L-2 -3 M1 -12 L-6 9 M2 -12 L-5 9 M-3 3 L-1 1 L1 0 L2 0 L4 1 L4 3 L3 6 L3 8 L4 9 M2 0 L3 1 L3 3 L2 6 L2 8 L4 9 L6 8 L7 7 L9 4","-4 4 M1 -6 L0 -5 L1 -4 L2 -5 L1 -6 M-1 0 L-3 6 L-3 8 L-1 9 L1 8 L2 7 L4 4 M0 0 L-2 6 L-2 8 L-1 9","-4 4 M1 -6 L0 -5 L1 -4 L2 -5 L1 -6 M-1 0 L-7 18 M0 0 L-3 9 L-5 14 L-7 18 L-8 20 L-10 21 L-11 20 L-11 18 L-10 15 L-8 13 L-5 11 L-1 9 L2 7 L4 4","-6 8 M-6 4 L-4 1 L-2 -3 M1 -12 L-6 9 M2 -12 L-5 9 M3 0 L3 1 L4 1 L3 0 L2 0 L0 2 L-3 3 M-3 3 L0 4 L1 8 L2 9 M-3 3 L-1 4 L0 8 L2 9 L3 9 L6 7 L8 4","-4 4 M-4 4 L-2 1 L0 -3 M3 -12 L-3 6 L-3 8 L-1 9 L1 8 L2 7 L4 4 M4 -12 L-2 6 L-2 8 L-1 9","-13 12 M-13 4 L-11 1 L-9 0 L-7 1 L-7 3 L-9 9 M-9 0 L-8 1 L-8 3 L-10 9 M-7 3 L-5 1 L-3 0 L-2 0 L0 1 L0 3 L-2 9 M-2 0 L-1 1 L-1 3 L-3 9 M0 3 L2 1 L4 0 L5 0 L7 1 L7 3 L6 6 L6 8 L7 9 M5 0 L6 1 L6 3 L5 6 L5 8 L7 9 L9 8 L10 7 L12 4","-9 9 M-9 4 L-7 1 L-5 0 L-3 1 L-3 3 L-5 9 M-5 0 L-4 1 L-4 3 L-6 9 M-3 3 L-1 1 L1 0 L2 0 L4 1 L4 3 L3 6 L3 8 L4 9 M2 0 L3 1 L3 3 L2 6 L2 8 L4 9 L6 8 L7 7 L9 4","-7 7 M0 0 L-2 0 L-4 1 L-5 2 L-6 4 L-6 6 L-5 8 L-3 9 L-1 9 L1 8 L2 7 L3 5 L3 3 L2 1 L0 0 L-1 1 L-1 3 L0 5 L2 6 L4 6 L6 5 L7 4 M-2 0 L-4 2 L-5 4 L-5 7 L-3 9","-6 9 M-6 4 L-4 1 L-2 -3 M-1 -6 L-10 21 M0 -6 L-9 21 M-3 3 L-1 1 L1 0 L2 0 L4 1 L4 3 L3 6 L3 8 L4 9 M2 0 L3 1 L3 3 L2 6 L2 8 L4 9 L6 8 L7 7 L9 4","-7 9 M3 3 L2 1 L0 0 L-2 0 L-4 1 L-5 2 L-6 4 L-6 6 L-5 8 L-3 9 L-1 9 L1 8 M-2 0 L-4 2 L-5 4 L-5 7 L-3 9 M4 0 L-2 18 L-2 20 L-1 21 L1 20 L2 17 L2 9 L4 9 L7 7 L9 4 M5 0 L2 9 L0 14 L-2 18","-6 8 M-6 4 L-4 1 L-2 0 L0 1 L0 3 L-2 9 M-2 0 L-1 1 L-1 3 L-3 9 M0 3 L2 1 L4 0 L5 0 L4 3 M4 0 L4 3 L5 5 L6 5 L8 4","-4 8 M-4 4 L-2 1 L-1 -1 L-1 1 L2 3 L3 5 L3 7 L2 8 L0 9 M-1 1 L1 3 L2 5 L2 7 L0 9 M-4 8 L-2 9 L3 9 L6 7 L8 4","-4 4 M-4 4 L-2 1 L0 -3 M3 -12 L-3 6 L-3 8 L-1 9 L1 8 L2 7 L4 4 M4 -12 L-2 6 L-2 8 L-1 9 M-2 -4 L4 -4","-7 9 M-4 0 L-6 6 L-6 8 L-4 9 L-3 9 L-1 8 L1 6 L3 3 M-3 0 L-5 6 L-5 8 L-4 9 M4 0 L2 6 L2 8 L4 9 L6 8 L7 7 L9 4 M5 0 L3 6 L3 8 L4 9","-7 8 M-4 0 L-5 2 L-6 5 L-6 8 L-4 9 L-3 9 L0 8 L2 6 L3 3 L3 0 M-3 0 L-4 2 L-5 5 L-5 8 L-4 9 M3 0 L4 4 L5 5 L6 5 L8 4","-10 11 M-6 0 L-8 2 L-9 5 L-9 8 L-7 9 L-6 9 L-4 8 L-2 6 M-5 0 L-7 2 L-8 5 L-8 8 L-7 9 M0 0 L-2 6 L-2 8 L0 9 L1 9 L3 8 L5 6 L6 3 L6 0 M1 0 L-1 6 L-1 8 L0 9 M6 0 L7 4 L8 5 L9 5 L11 4","-8 8 M-8 4 L-6 1 L-4 0 L-2 0 L-1 1 L-1 3 L-2 6 L-3 8 L-5 9 L-6 9 L-7 8 L-7 7 L-6 7 L-7 8 M5 1 L4 2 L5 2 L5 1 L4 0 L3 0 L1 1 L0 3 L-1 6 L-1 8 L0 9 L3 9 L6 7 L8 4 M-1 1 L0 3 M1 1 L-1 3 M-2 6 L-1 8 M-1 6 L-3 8","-7 9 M-4 0 L-6 6 L-6 8 L-4 9 L-3 9 L-1 8 L1 6 L3 3 M-3 0 L-5 6 L-5 8 L-4 9 M4 0 L-2 18 M5 0 L2 9 L0 14 L-2 18 L-3 20 L-5 21 L-6 20 L-6 18 L-5 15 L-3 13 L0 11 L4 9 L7 7 L9 4","-6 7 M-6 4 L-4 1 L-2 0 L0 0 L2 1 L2 4 L1 6 L-2 8 L-4 9 M0 0 L1 1 L1 4 L0 6 L-2 8 M-4 9 L-2 10 L-1 12 L-1 15 L-2 18 L-4 20 L-6 21 L-7 20 L-7 18 L-6 15 L-3 12 L0 10 L4 7 L7 4 M-4 9 L-3 10 L-2 12 L-2 15 L-3 18 L-4 20","-7 7 M2 -16 L0 -15 L-1 -14 L-2 -12 L-2 -10 L-1 -8 L0 -7 L1 -5 L1 -3 L-1 -1 M0 -15 L-1 -13 L-1 -11 L0 -9 L1 -8 L2 -6 L2 -4 L1 -2 L-3 0 L1 2 L2 4 L2 6 L1 8 L0 9 L-1 11 L-1 13 L0 15 M-1 1 L1 3 L1 5 L0 7 L-1 8 L-2 10 L-2 12 L-1 14 L0 15 L2 16","-4 4 M0 -16 L0 16","-7 7 M-2 -16 L0 -15 L1 -14 L2 -12 L2 -10 L1 -8 L0 -7 L-1 -5 L-1 -3 L1 -1 M0 -15 L1 -13 L1 -11 L0 -9 L-1 -8 L-2 -6 L-2 -4 L-1 -2 L3 0 L-1 2 L-2 4 L-2 6 L-1 8 L0 9 L1 11 L1 13 L0 15 M1 1 L-1 3 L-1 5 L0 7 L1 8 L2 10 L2 12 L1 14 L0 15 L-2 16","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3","-7 8 M1 -12 L-1 -11 L-2 -9 L-2 -7 L-1 -5 L1 -4 L3 -4 L5 -5 L6 -7 L6 -9 L5 -11 L3 -12 L1 -12"],
    :scripts => ["-8 8","-5 6 M3 -12 L2 -11 L0 1 M3 -11 L0 1 M3 -12 L4 -11 L0 1 M-2 7 L-3 8 L-2 9 L-1 8 L-2 7","-9 9 M-2 -12 L-4 -5 M-1 -12 L-4 -5 M7 -12 L5 -5 M8 -12 L5 -5","-10 11 M1 -16 L-6 16 M7 -16 L0 16 M-6 -3 L8 -3 M-7 3 L7 3","-10 11 M2 -16 L-6 13 M7 -16 L-1 13 M8 -8 L7 -7 L8 -6 L9 -7 L9 -8 L8 -10 L7 -11 L4 -12 L0 -12 L-3 -11 L-5 -9 L-5 -7 L-4 -5 L-3 -4 L4 0 L6 2 M-5 -7 L-3 -5 L4 -1 L5 0 L6 2 L6 5 L5 7 L4 8 L1 9 L-3 9 L-6 8 L-7 7 L-8 5 L-8 4 L-7 3 L-6 4 L-7 5","-12 12 M9 -12 L-9 9 M-4 -12 L-2 -10 L-2 -8 L-3 -6 L-5 -5 L-7 -5 L-9 -7 L-9 -9 L-8 -11 L-6 -12 L-4 -12 L-2 -11 L1 -10 L4 -10 L7 -11 L9 -12 M5 2 L3 3 L2 5 L2 7 L4 9 L6 9 L8 8 L9 6 L9 4 L7 2 L5 2","-13 13 M10 -4 L9 -3 L10 -2 L11 -3 L11 -4 L10 -5 L9 -5 L7 -4 L5 -2 L0 6 L-2 8 L-4 9 L-7 9 L-10 8 L-11 6 L-11 4 L-10 2 L-9 1 L-7 0 L-2 -2 L0 -3 L2 -5 L3 -7 L3 -9 L2 -11 L0 -12 L-2 -11 L-3 -9 L-3 -6 L-2 0 L-1 3 L1 6 L3 8 L5 9 L7 9 L8 7 L8 6 M-7 9 L-9 8 L-10 6 L-10 4 L-9 2 L-8 1 L-2 -2 M-3 -6 L-2 -1 L-1 2 L1 5 L3 7 L5 8 L7 8 L8 7","-5 6 M3 -10 L2 -11 L3 -12 L4 -11 L4 -10 L3 -8 L1 -6","-7 8 M8 -16 L4 -13 L1 -10 L-1 -7 L-3 -3 L-4 2 L-4 6 L-3 11 L-2 14 L-1 16 M4 -13 L1 -9 L-1 -5 L-2 -2 L-3 3 L-3 8 L-2 13 L-1 16","-8 7 M1 -16 L2 -14 L3 -11 L4 -6 L4 -2 L3 3 L1 7 L-1 10 L-4 13 L-8 16 M1 -16 L2 -13 L3 -8 L3 -3 L2 2 L1 5 L-1 9 L-4 13","-8 9 M2 -12 L2 0 M-3 -9 L7 -3 M7 -9 L-3 -3","-13 13 M0 -9 L0 9 M-9 0 L9 0","-5 6 M-2 9 L-3 8 L-2 7 L-1 8 L-1 9 L-2 11 L-4 13","-13 13 M-9 0 L9 0","-5 5 M0 7 L-1 8 L0 9 L1 8 L0 7","-11 11 M13 -16 L-13 16","-10 11 M2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 4 L-6 7 L-5 8 L-3 9 L-1 9 L2 8 L4 6 L6 3 L7 0 L8 -4 L8 -7 L7 -10 L6 -11 L4 -12 L2 -12 M2 -12 L0 -11 L-2 -9 L-4 -6 L-5 -3 L-6 1 L-6 4 L-5 7 L-3 9 M-1 9 L1 8 L3 6 L5 3 L6 0 L7 -4 L7 -7 L6 -10 L4 -12","-10 11 M2 -8 L-3 9 M4 -12 L-2 9 M4 -12 L1 -9 L-2 -7 L-4 -6 M3 -9 L-1 -7 L-4 -6","-10 11 M-3 -8 L-2 -7 L-3 -6 L-4 -7 L-4 -8 L-3 -10 L-2 -11 L1 -12 L4 -12 L7 -11 L8 -9 L8 -7 L7 -5 L5 -3 L2 -1 L-2 1 L-5 3 L-7 5 L-9 9 M4 -12 L6 -11 L7 -9 L7 -7 L6 -5 L4 -3 L-2 1 M-8 7 L-7 6 L-5 6 L0 8 L3 8 L5 7 L6 5 M-5 6 L0 9 L3 9 L5 8 L6 5","-10 11 M-3 -8 L-2 -7 L-3 -6 L-4 -7 L-4 -8 L-3 -10 L-2 -11 L1 -12 L4 -12 L7 -11 L8 -9 L8 -7 L7 -5 L4 -3 L1 -2 M4 -12 L6 -11 L7 -9 L7 -7 L6 -5 L4 -3 M-1 -2 L1 -2 L4 -1 L5 0 L6 2 L6 5 L5 7 L4 8 L1 9 L-3 9 L-6 8 L-7 7 L-8 5 L-8 4 L-7 3 L-6 4 L-7 5 M1 -2 L3 -1 L4 0 L5 2 L5 5 L4 7 L3 8 L1 9","-10 11 M6 -11 L0 9 M7 -12 L1 9 M7 -12 L-8 3 L8 3","-10 11 M-1 -12 L-6 -2 M-1 -12 L9 -12 M-1 -11 L4 -11 L9 -12 M-6 -2 L-5 -3 L-2 -4 L1 -4 L4 -3 L5 -2 L6 0 L6 3 L5 6 L3 8 L0 9 L-3 9 L-6 8 L-7 7 L-8 5 L-8 4 L-7 3 L-6 4 L-7 5 M1 -4 L3 -3 L4 -2 L5 0 L5 3 L4 6 L2 8 L0 9","-10 11 M7 -9 L6 -8 L7 -7 L8 -8 L8 -9 L7 -11 L5 -12 L2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 5 L-6 7 L-5 8 L-3 9 L0 9 L3 8 L5 6 L6 4 L6 1 L5 -1 L4 -2 L2 -3 L-1 -3 L-3 -2 L-5 0 L-6 2 M2 -12 L0 -11 L-2 -9 L-4 -6 L-5 -3 L-6 1 L-6 6 L-5 8 M0 9 L2 8 L4 6 L5 4 L5 0 L4 -2","-10 11 M-4 -12 L-6 -6 M9 -12 L8 -9 L6 -6 L1 0 L-1 3 L-2 5 L-3 9 M6 -6 L0 0 L-2 3 L-3 5 L-4 9 M-5 -9 L-2 -12 L0 -12 L5 -9 M-4 -10 L-2 -11 L0 -11 L5 -9 L7 -9 L8 -10 L9 -12","-10 11 M1 -12 L-2 -11 L-3 -10 L-4 -8 L-4 -5 L-3 -3 L-1 -2 L2 -2 L6 -3 L7 -4 L8 -6 L8 -9 L7 -11 L4 -12 L1 -12 M1 -12 L-1 -11 L-2 -10 L-3 -8 L-3 -5 L-2 -3 L-1 -2 M2 -2 L5 -3 L6 -4 L7 -6 L7 -9 L6 -11 L4 -12 M-1 -2 L-5 -1 L-7 1 L-8 3 L-8 6 L-7 8 L-4 9 L0 9 L4 8 L5 7 L6 5 L6 2 L5 0 L4 -1 L2 -2 M-1 -2 L-4 -1 L-6 1 L-7 3 L-7 6 L-6 8 L-4 9 M0 9 L3 8 L4 7 L5 5 L5 1 L4 -1","-10 11 M7 -5 L6 -3 L4 -1 L2 0 L-1 0 L-3 -1 L-4 -2 L-5 -4 L-5 -7 L-4 -9 L-2 -11 L1 -12 L4 -12 L6 -11 L7 -10 L8 -8 L8 -4 L7 0 L6 3 L4 6 L2 8 L-1 9 L-4 9 L-6 8 L-7 6 L-7 5 L-6 4 L-5 5 L-6 6 M-3 -1 L-4 -3 L-4 -7 L-3 -9 L-1 -11 L1 -12 M6 -11 L7 -9 L7 -4 L6 0 L5 3 L3 6 L1 8 L-1 9","-5 6 M1 -5 L0 -4 L1 -3 L2 -4 L1 -5 M-2 7 L-3 8 L-2 9 L-1 8","-5 6 M1 -5 L0 -4 L1 -3 L2 -4 L1 -5 M-2 9 L-3 8 L-2 7 L-1 8 L-1 9 L-2 11 L-4 13","-12 12 M8 -9 L-8 0 L8 9","-13 13 M-9 -3 L9 -3 M-9 3 L9 3","-12 12 M-8 -9 L8 0 L-8 9","-10 11 M-3 -8 L-2 -7 L-3 -6 L-4 -7 L-4 -8 L-3 -10 L-2 -11 L1 -12 L5 -12 L8 -11 L9 -9 L9 -7 L8 -5 L7 -4 L1 -2 L-1 -1 L-1 1 L0 2 L2 2 M5 -12 L7 -11 L8 -9 L8 -7 L7 -5 L6 -4 L4 -3 M-2 7 L-3 8 L-2 9 L-1 8 L-2 7","-13 14 M5 -4 L4 -6 L2 -7 L-1 -7 L-3 -6 L-4 -5 L-5 -2 L-5 1 L-4 3 L-2 4 L1 4 L3 3 L4 1 M-1 -7 L-3 -5 L-4 -2 L-4 1 L-3 3 L-2 4 M5 -7 L4 1 L4 3 L6 4 L8 4 L10 2 L11 -1 L11 -3 L10 -6 L9 -8 L7 -10 L5 -11 L2 -12 L-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L2 9 L5 8 L7 7 L8 6 M6 -7 L5 1 L5 3 L6 4","-11 9 M-11 9 L-9 8 L-6 5 L-3 1 L1 -6 L4 -12 L4 9 L3 6 L1 3 L-1 1 L-4 -1 L-6 -1 L-7 0 L-7 2 L-6 4 L-4 6 L-1 8 L2 9 L7 9","-12 11 M1 -10 L2 -9 L2 -6 L1 -2 L0 1 L-1 3 L-3 6 L-5 8 L-7 9 L-8 9 L-9 8 L-9 5 L-8 0 L-7 -3 L-6 -5 L-4 -8 L-2 -10 L0 -11 L3 -12 L6 -12 L8 -11 L9 -9 L9 -7 L8 -5 L7 -4 L5 -3 L2 -2 M1 -2 L2 -2 L5 -1 L6 0 L7 2 L7 5 L6 7 L5 8 L3 9 L0 9 L-2 8 L-3 6","-10 10 M2 -6 L2 -5 L3 -4 L5 -4 L7 -5 L8 -7 L8 -9 L7 -11 L5 -12 L2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -4 L-7 0 L-7 4 L-6 7 L-5 8 L-3 9 L-1 9 L2 8 L4 6 L5 4","-11 12 M2 -12 L0 -11 L-1 -9 L-2 -5 L-3 1 L-4 4 L-5 6 L-7 8 L-9 9 L-11 9 L-12 8 L-12 6 L-11 5 L-9 5 L-7 6 L-5 8 L-2 9 L1 9 L4 8 L6 6 L8 2 L9 -3 L9 -7 L8 -10 L7 -11 L5 -12 L2 -12 L0 -10 L0 -8 L1 -5 L3 -2 L5 0 L8 2 L10 3","-10 10 M4 -8 L4 -7 L5 -6 L7 -6 L8 -7 L8 -9 L7 -11 L4 -12 L0 -12 L-3 -11 L-4 -9 L-4 -6 L-3 -4 L-2 -3 L1 -2 L-2 -2 L-5 -1 L-6 0 L-7 2 L-7 5 L-6 7 L-5 8 L-2 9 L1 9 L4 8 L6 6 L7 4","-10 10 M0 -6 L-2 -6 L-4 -7 L-5 -9 L-4 -11 L-1 -12 L2 -12 L6 -11 L9 -11 L11 -12 M6 -11 L4 -4 L2 2 L0 6 L-2 8 L-4 9 L-6 9 L-8 8 L-9 6 L-9 4 L-8 3 L-6 3 L-4 4 M-1 -2 L8 -2","-11 12 M-11 9 L-9 8 L-5 4 L-2 -1 L-1 -4 L0 -8 L0 -11 L-1 -12 L-2 -12 L-3 -11 L-4 -9 L-4 -6 L-3 -4 L-1 -3 L3 -3 L6 -4 L7 -5 L8 -7 L8 -1 L7 4 L6 6 L4 8 L1 9 L-3 9 L-6 8 L-8 6 L-9 4 L-9 2","-12 12 M-5 -5 L-7 -6 L-8 -8 L-8 -9 L-7 -11 L-5 -12 L-4 -12 L-2 -11 L-1 -9 L-1 -7 L-2 -3 L-4 3 L-6 7 L-8 9 L-10 9 L-11 8 L-11 6 M-5 0 L4 -3 L6 -4 L9 -6 L11 -8 L12 -10 L12 -11 L11 -12 L10 -12 L8 -10 L6 -6 L4 0 L3 5 L3 8 L4 9 L5 9 L7 8 L8 7 L10 4","-9 8 M5 4 L3 2 L1 -1 L0 -3 L-1 -6 L-1 -9 L0 -11 L1 -12 L3 -12 L4 -11 L5 -9 L5 -6 L4 -1 L2 4 L1 6 L-1 8 L-3 9 L-5 9 L-7 8 L-8 6 L-8 4 L-7 3 L-5 3 L-3 4","-8 7 M2 12 L0 9 L-2 4 L-3 -2 L-3 -8 L-2 -11 L0 -12 L2 -12 L3 -11 L4 -8 L4 -5 L3 0 L0 9 L-2 15 L-3 18 L-4 20 L-6 21 L-7 20 L-7 18 L-6 15 L-4 12 L-2 10 L1 8 L5 6","-12 12 M-5 -5 L-7 -6 L-8 -8 L-8 -9 L-7 -11 L-5 -12 L-4 -12 L-2 -11 L-1 -9 L-1 -7 L-2 -3 L-4 3 L-6 7 L-8 9 L-10 9 L-11 8 L-11 6 M12 -9 L12 -11 L11 -12 L10 -12 L8 -11 L6 -9 L4 -6 L2 -4 L0 -3 L-2 -3 M0 -3 L1 -1 L1 6 L2 8 L3 9 L4 9 L6 8 L7 7 L9 4","-9 10 M-5 0 L-3 0 L1 -1 L4 -3 L6 -5 L7 -7 L7 -10 L6 -12 L4 -12 L3 -11 L2 -9 L1 -4 L0 1 L-1 4 L-2 6 L-4 8 L-6 9 L-8 9 L-9 8 L-9 6 L-8 5 L-6 5 L-4 6 L-1 8 L2 9 L4 9 L7 8 L9 6","-18 15 M-13 -5 L-15 -6 L-16 -8 L-16 -9 L-15 -11 L-13 -12 L-12 -12 L-10 -11 L-9 -9 L-9 -7 L-10 -2 L-11 2 L-13 9 M-11 2 L-8 -6 L-6 -10 L-5 -11 L-3 -12 L-2 -12 L0 -11 L1 -9 L1 -7 L0 -2 L-1 2 L-3 9 M-1 2 L2 -6 L4 -10 L5 -11 L7 -12 L8 -12 L10 -11 L11 -9 L11 -7 L10 -2 L8 5 L8 8 L9 9 L10 9 L12 8 L13 7 L15 4","-13 11 M-8 -5 L-10 -6 L-11 -8 L-11 -9 L-10 -11 L-8 -12 L-7 -12 L-5 -11 L-4 -9 L-4 -7 L-5 -2 L-6 2 L-8 9 M-6 2 L-3 -6 L-1 -10 L0 -11 L2 -12 L4 -12 L6 -11 L7 -9 L7 -7 L6 -2 L4 5 L4 8 L5 9 L6 9 L8 8 L9 7 L11 4","-10 11 M2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -4 L-7 0 L-7 4 L-6 7 L-5 8 L-3 9 L-1 9 L2 8 L4 6 L6 3 L7 1 L8 -3 L8 -7 L7 -10 L6 -11 L4 -12 L2 -12 L0 -10 L0 -7 L1 -4 L3 -1 L5 1 L8 3 L10 4","-12 13 M1 -10 L2 -9 L2 -6 L1 -2 L0 1 L-1 3 L-3 6 L-5 8 L-7 9 L-8 9 L-9 8 L-9 5 L-8 0 L-7 -3 L-6 -5 L-4 -8 L-2 -10 L0 -11 L3 -12 L8 -12 L10 -11 L11 -10 L12 -8 L12 -5 L11 -3 L10 -2 L8 -1 L5 -1 L3 -2 L2 -3","-10 12 M3 -6 L2 -4 L1 -3 L-1 -2 L-3 -2 L-4 -4 L-4 -6 L-3 -9 L-1 -11 L2 -12 L5 -12 L7 -11 L8 -9 L8 -5 L7 -2 L5 1 L1 5 L-2 7 L-4 8 L-7 9 L-9 9 L-10 8 L-10 6 L-9 5 L-7 5 L-5 6 L-2 8 L1 9 L4 9 L7 8 L9 6","-12 13 M1 -10 L2 -9 L2 -6 L1 -2 L0 1 L-1 3 L-3 6 L-5 8 L-7 9 L-8 9 L-9 8 L-9 5 L-8 0 L-7 -3 L-6 -5 L-4 -8 L-2 -10 L0 -11 L3 -12 L7 -12 L9 -11 L10 -10 L11 -8 L11 -5 L10 -3 L9 -2 L7 -1 L4 -1 L1 -2 L2 -1 L3 1 L3 6 L4 8 L6 9 L8 8 L9 7 L11 4","-10 10 M-10 9 L-8 8 L-6 6 L-3 2 L-1 -1 L1 -5 L2 -8 L2 -11 L1 -12 L0 -12 L-1 -11 L-2 -9 L-2 -7 L-1 -5 L1 -3 L4 -1 L6 1 L7 3 L7 5 L6 7 L5 8 L2 9 L-2 9 L-5 8 L-7 6 L-8 4 L-8 2","-10 9 M0 -6 L-2 -6 L-4 -7 L-5 -9 L-4 -11 L-1 -12 L2 -12 L6 -11 L9 -11 L11 -12 M6 -11 L4 -4 L2 2 L0 6 L-2 8 L-4 9 L-6 9 L-8 8 L-9 6 L-9 4 L-8 3 L-6 3 L-4 4","-13 11 M-8 -5 L-10 -6 L-11 -8 L-11 -9 L-10 -11 L-8 -12 L-7 -12 L-5 -11 L-4 -9 L-4 -7 L-5 -3 L-6 0 L-7 4 L-7 6 L-6 8 L-4 9 L-2 9 L0 8 L1 7 L3 3 L6 -5 L8 -12 M6 -5 L5 -1 L4 5 L4 8 L5 9 L6 9 L8 8 L9 7 L11 4","-12 11 M-7 -5 L-9 -6 L-10 -8 L-10 -9 L-9 -11 L-7 -12 L-6 -12 L-4 -11 L-3 -9 L-3 -7 L-4 -3 L-5 0 L-6 4 L-6 7 L-5 9 L-3 9 L-1 8 L2 5 L4 2 L6 -2 L7 -5 L8 -9 L8 -11 L7 -12 L6 -12 L5 -11 L4 -9 L4 -7 L5 -4 L7 -2 L9 -1","-15 13 M-10 -5 L-12 -6 L-13 -8 L-13 -9 L-12 -11 L-10 -12 L-9 -12 L-7 -11 L-6 -9 L-6 -6 L-7 9 M3 -12 L-7 9 M3 -12 L1 9 M15 -12 L13 -11 L10 -8 L7 -4 L4 2 L1 9","-12 12 M-4 -6 L-6 -6 L-7 -7 L-7 -9 L-6 -11 L-4 -12 L-2 -12 L0 -11 L1 -9 L1 -6 L-1 3 L-1 6 L0 8 L2 9 L4 9 L6 8 L7 6 L7 4 L6 3 L4 3 M11 -9 L11 -11 L10 -12 L8 -12 L6 -11 L4 -9 L2 -6 L-2 3 L-4 6 L-6 8 L-8 9 L-10 9 L-11 8 L-11 6","-12 11 M-7 -5 L-9 -6 L-10 -8 L-10 -9 L-9 -11 L-7 -12 L-6 -12 L-4 -11 L-3 -9 L-3 -7 L-4 -3 L-5 0 L-6 4 L-6 6 L-5 8 L-4 9 L-2 9 L0 8 L2 6 L4 3 L5 1 L7 -5 M9 -12 L7 -5 L4 5 L2 11 L0 16 L-2 20 L-4 21 L-5 20 L-5 18 L-4 15 L-2 12 L1 9 L4 7 L9 4","-10 11 M3 -6 L2 -4 L1 -3 L-1 -2 L-3 -2 L-4 -4 L-4 -6 L-3 -9 L-1 -11 L2 -12 L5 -12 L7 -11 L8 -9 L8 -5 L7 -2 L5 2 L2 5 L-2 8 L-4 9 L-7 9 L-8 8 L-8 6 L-7 5 L-4 5 L-2 6 L-1 7 L0 9 L0 12 L-1 15 L-2 17 L-4 20 L-6 21 L-7 20 L-7 18 L-6 15 L-4 12 L-1 9 L2 7 L8 4","-7 7 M-3 -16 L-3 16 M-2 -16 L-2 16 M-3 -16 L4 -16 M-3 16 L4 16","-7 7 M-7 -12 L7 12","-7 7 M2 -16 L2 16 M3 -16 L3 16 M-4 -16 L3 -16 M-4 16 L3 16","-8 8 M-2 -6 L0 -9 L2 -6 M-5 -3 L0 -8 L5 -3 M0 -8 L0 9","-8 8 M-8 11 L8 11","-5 6 M4 -12 L2 -10 L1 -8 L1 -7 L2 -6 L3 -7 L2 -8","-6 10 M3 3 L2 1 L0 0 L-2 0 L-4 1 L-5 2 L-6 4 L-6 6 L-5 8 L-3 9 L-1 9 L1 8 L2 6 L4 0 L3 5 L3 8 L4 9 L5 9 L7 8 L8 7 L10 4","-5 9 M-5 4 L-3 1 L0 -4 L1 -6 L2 -9 L2 -11 L1 -12 L-1 -11 L-2 -9 L-3 -5 L-4 2 L-4 8 L-3 9 L-2 9 L0 8 L2 6 L3 3 L3 0 L4 4 L5 5 L7 5 L9 4","-5 6 M2 2 L2 1 L1 0 L-1 0 L-3 1 L-4 2 L-5 4 L-5 6 L-4 8 L-2 9 L1 9 L4 7 L6 4","-6 10 M3 3 L2 1 L0 0 L-2 0 L-4 1 L-5 2 L-6 4 L-6 6 L-5 8 L-3 9 L-1 9 L1 8 L2 6 L8 -12 M4 0 L3 5 L3 8 L4 9 L5 9 L7 8 L8 7 L10 4","-4 6 M-3 7 L-1 6 L0 5 L1 3 L1 1 L0 0 L-1 0 L-3 1 L-4 3 L-4 6 L-3 8 L-1 9 L1 9 L3 8 L4 7 L6 4","-3 5 M-3 4 L1 -1 L3 -4 L4 -6 L5 -9 L5 -11 L4 -12 L2 -11 L1 -9 L-1 -1 L-4 8 L-7 15 L-8 18 L-8 20 L-7 21 L-5 20 L-4 17 L-3 8 L-2 9 L0 9 L2 8 L3 7 L5 4","-6 9 M3 3 L2 1 L0 0 L-2 0 L-4 1 L-5 2 L-6 4 L-6 6 L-5 8 L-3 9 L-1 9 L1 8 L2 7 M4 0 L2 7 L-2 18 L-3 20 L-5 21 L-6 20 L-6 18 L-5 15 L-2 12 L1 10 L3 9 L6 7 L9 4","-5 10 M-5 4 L-3 1 L0 -4 L1 -6 L2 -9 L2 -11 L1 -12 L-1 -11 L-2 -9 L-3 -5 L-4 1 L-5 9 M-5 9 L-4 6 L-3 4 L-1 1 L1 0 L3 0 L4 1 L4 3 L3 6 L3 8 L4 9 L5 9 L7 8 L8 7 L10 4","-2 5 M1 -5 L1 -4 L2 -4 L2 -5 L1 -5 M-2 4 L0 0 L-2 6 L-2 8 L-1 9 L0 9 L2 8 L3 7 L5 4","-2 5 M1 -5 L1 -4 L2 -4 L2 -5 L1 -5 M-2 4 L0 0 L-6 18 L-7 20 L-9 21 L-10 20 L-10 18 L-9 15 L-6 12 L-3 10 L-1 9 L2 7 L5 4","-5 9 M-5 4 L-3 1 L0 -4 L1 -6 L2 -9 L2 -11 L1 -12 L-1 -11 L-2 -9 L-3 -5 L-4 1 L-5 9 M-5 9 L-4 6 L-3 4 L-1 1 L1 0 L3 0 L4 1 L4 3 L2 4 L-1 4 M-1 4 L1 5 L2 8 L3 9 L4 9 L6 8 L7 7 L9 4","-3 5 M-3 4 L-1 1 L2 -4 L3 -6 L4 -9 L4 -11 L3 -12 L1 -11 L0 -9 L-1 -5 L-2 2 L-2 8 L-1 9 L0 9 L2 8 L3 7 L5 4","-13 12 M-13 4 L-11 1 L-9 0 L-8 1 L-8 2 L-9 6 L-10 9 M-9 6 L-8 4 L-6 1 L-4 0 L-2 0 L-1 1 L-1 2 L-2 6 L-3 9 M-2 6 L-1 4 L1 1 L3 0 L5 0 L6 1 L6 3 L5 6 L5 8 L6 9 L7 9 L9 8 L10 7 L12 4","-8 10 M-8 4 L-6 1 L-4 0 L-3 1 L-3 2 L-4 6 L-5 9 M-4 6 L-3 4 L-1 1 L1 0 L3 0 L4 1 L4 3 L3 6 L3 8 L4 9 L5 9 L7 8 L8 7 L10 4","-6 8 M0 0 L-2 0 L-4 1 L-5 2 L-6 4 L-6 6 L-5 8 L-3 9 L-1 9 L1 8 L2 7 L3 5 L3 3 L2 1 L0 0 L-1 1 L-1 3 L0 5 L2 6 L5 6 L7 5 L8 4","-7 8 M-7 4 L-5 1 L-4 -1 L-5 3 L-11 21 M-5 3 L-4 1 L-2 0 L0 0 L2 1 L3 3 L3 5 L2 7 L1 8 L-1 9 M-5 8 L-3 9 L0 9 L3 8 L5 7 L8 4","-6 9 M3 3 L2 1 L0 0 L-2 0 L-4 1 L-5 2 L-6 4 L-6 6 L-5 8 L-3 9 L-1 9 L1 8 M4 0 L3 3 L1 8 L-2 15 L-3 18 L-3 20 L-2 21 L0 20 L1 17 L1 10 L3 9 L6 7 L9 4","-5 8 M-5 4 L-3 1 L-2 -1 L-2 1 L1 1 L2 2 L2 4 L1 7 L1 8 L2 9 L3 9 L5 8 L6 7 L8 4","-4 7 M-4 4 L-2 1 L-1 -1 L-1 1 L1 4 L2 6 L2 8 L0 9 M-4 8 L-2 9 L2 9 L4 8 L5 7 L7 4","-3 6 M-3 4 L-1 1 L1 -3 M4 -12 L-2 6 L-2 8 L-1 9 L1 9 L3 8 L4 7 L6 4 M-2 -4 L5 -4","-6 9 M-6 4 L-4 0 L-6 6 L-6 8 L-5 9 L-3 9 L-1 8 L1 6 L3 3 M4 0 L2 6 L2 8 L3 9 L4 9 L6 8 L7 7 L9 4","-6 9 M-6 4 L-4 0 L-5 5 L-5 8 L-4 9 L-3 9 L0 8 L2 6 L3 3 L3 0 M3 0 L4 4 L5 5 L7 5 L9 4","-9 12 M-6 0 L-8 2 L-9 5 L-9 7 L-8 9 L-6 9 L-4 8 L-2 6 M0 0 L-2 6 L-2 8 L-1 9 L1 9 L3 8 L5 6 L6 3 L6 0 M6 0 L7 4 L8 5 L10 5 L12 4","-8 8 M-8 4 L-6 1 L-4 0 L-2 0 L-1 1 L-1 8 L0 9 L3 9 L6 7 L8 4 M5 1 L4 0 L2 0 L1 1 L-3 8 L-4 9 L-6 9 L-7 8","-6 9 M-6 4 L-4 0 L-6 6 L-6 8 L-5 9 L-3 9 L-1 8 L1 6 L3 3 M4 0 L-2 18 L-3 20 L-5 21 L-6 20 L-6 18 L-5 15 L-2 12 L1 10 L3 9 L6 7 L9 4","-6 8 M-6 4 L-4 1 L-2 0 L0 0 L2 2 L2 4 L1 6 L-1 8 L-4 9 L-2 10 L-1 12 L-1 15 L-2 18 L-3 20 L-5 21 L-6 20 L-6 18 L-5 15 L-2 12 L1 10 L5 7 L8 4","-7 7 M2 -16 L0 -15 L-1 -14 L-2 -12 L-2 -10 L-1 -8 L0 -7 L1 -5 L1 -3 L-1 -1 M0 -15 L-1 -13 L-1 -11 L0 -9 L1 -8 L2 -6 L2 -4 L1 -2 L-3 0 L1 2 L2 4 L2 6 L1 8 L0 9 L-1 11 L-1 13 L0 15 M-1 1 L1 3 L1 5 L0 7 L-1 8 L-2 10 L-2 12 L-1 14 L0 15 L2 16","-4 4 M0 -16 L0 16","-7 7 M-2 -16 L0 -15 L1 -14 L2 -12 L2 -10 L1 -8 L0 -7 L-1 -5 L-1 -3 L1 -1 M0 -15 L1 -13 L1 -11 L0 -9 L-1 -8 L-2 -6 L-2 -4 L-1 -2 L3 0 L-1 2 L-2 4 L-2 6 L-1 8 L0 9 L1 11 L1 13 L0 15 M1 1 L-1 3 L-1 5 L0 7 L1 8 L2 10 L2 12 L1 14 L0 15 L-2 16","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3","-7 7 M-1 -12 L-3 -11 L-4 -9 L-4 -7 L-3 -5 L-1 -4 L1 -4 L3 -5 L4 -7 L4 -9 L3 -11 L1 -12 L-1 -12"],
    :symbolic => ["-8 8","-14 14 M-14 0 L14 0","-14 14 M-14 14 L14 -14","0 0 M0 -20 L0 20","-14 14 M-14 -14 L14 14","-14 14 M-14 0 L14 0","-12 12 M-12 7 L12 -7","-7 7 M-7 12 L7 -12","0 0 M0 -14 L0 14","-7 7 M-7 -12 L7 12","-12 12 M-12 -7 L12 7","-7 7 M-7 0 L7 0","-5 5 M-5 5 L5 -5","0 0 M0 -7 L0 7","-5 5 M-5 -5 L5 5","-11 0 M0 -11 L-2 -11 L-5 -10 L-8 -8 L-10 -5 L-11 -2 L-11 0","-11 0 M-11 0 L-11 2 L-10 5 L-8 8 L-5 10 L-2 11 L0 11","0 11 M0 11 L2 11 L5 10 L8 8 L10 5 L11 2 L11 0","0 11 M11 0 L11 -2 L10 -5 L8 -8 L5 -10 L2 -11 L0 -11","-14 14 M-14 -3 L-11 -1 L-7 1 L-2 2 L2 2 L7 1 L11 -1 L14 -3","-2 3 M3 -14 L1 -11 L-1 -7 L-2 -2 L-2 2 L-1 7 L1 11 L3 14","-3 2 M-3 -14 L-1 -11 L1 -7 L2 -2 L2 2 L1 7 L-1 11 L-3 14","-14 14 M-14 3 L-11 1 L-7 -1 L-2 -2 L2 -2 L7 -1 L11 1 L14 3","-7 7 M0 -8 L7 -4 L-7 4 L0 8","-8 8 M-8 0 L-4 -7 L4 7 L8 0","-7 7 M-7 4 L-7 -4 L7 4 L7 -4","-8 8 M-6 6 L-8 -2 L8 2 L6 -6","-8 8 M-8 11 L-6 11 L-3 10 L-1 9 L2 6 L3 4 L4 1 L4 -3 L3 -6 L2 -8 L1 -9 L-1 -9 L-2 -8 L-3 -6 L-4 -3 L-4 1 L-3 4 L-2 6 L1 9 L3 10 L6 11 L8 11","-9 11 M11 8 L11 6 L10 3 L9 1 L6 -2 L4 -3 L1 -4 L-3 -4 L-6 -3 L-8 -2 L-9 -1 L-9 1 L-8 2 L-6 3 L-3 4 L1 4 L4 3 L6 2 L9 -1 L10 -3 L11 -6 L11 -8","-8 8 M8 -11 L6 -11 L3 -10 L1 -9 L-2 -6 L-3 -4 L-4 -1 L-4 3 L-3 6 L-2 8 L-1 9 L1 9 L2 8 L3 6 L4 3 L4 -1 L3 -4 L2 -6 L-1 -9 L-3 -10 L-6 -11 L-8 -11","-11 9 M-11 -8 L-11 -6 L-10 -3 L-9 -1 L-6 2 L-4 3 L-1 4 L3 4 L6 3 L8 2 L9 1 L9 -1 L8 -2 L6 -3 L3 -4 L-1 -4 L-4 -3 L-6 -2 L-9 1 L-10 3 L-11 6 L-11 8","-13 9 M-13 -2 L-12 0 L-10 2 L-8 3 L-5 4 L-1 4 L3 3 L6 1 L8 -2 L9 -4 L8 -6 L5 -6 L1 -5 L-1 -4 L-4 -2 L-6 1 L-7 4 L-7 7 L-6 10 L-5 12","-13 7 M-13 2 L-10 4 L-7 5 L-2 5 L1 4 L4 2 L6 -1 L7 -4 L7 -6 L6 -7 L4 -7 L1 -6 L-2 -4 L-4 -1 L-5 2 L-5 7 L-4 10 L-2 13","-3 3 M-1 -3 L-3 -1 L-3 1 L-1 3 L1 3 L3 1 L3 -1 L1 -3 L-1 -3 M-1 -2 L-2 -1 L-2 1 L-1 2 L1 2 L2 1 L2 -1 L1 -2 L-1 -2 M0 -1 L-1 0 L0 1 L1 0 L0 -1","0 5 M0 -5 L1 -5 L3 -4 L4 -3 L5 -1 L5 1 L4 3 L3 4 L1 5 L0 5","-14 14 M-14 0 L-8 0 M-3 0 L3 0 M8 0 L14 0","-14 14 M-14 3 L-14 -3 L14 -3 L14 3","-8 8 M0 -14 L-8 0 M0 -14 L8 0","-14 14 M-14 0 L14 0 M-8 7 L8 7 M-2 14 L2 14","-14 14 M-14 0 L14 0 M-14 0 L0 16 M14 0 L0 16","-7 7 M-1 -7 L-4 -6 L-6 -4 L-7 -1 L-7 1 L-6 4 L-4 6 L-1 7 L1 7 L4 6 L6 4 L7 1 L7 -1 L6 -4 L4 -6 L1 -7 L-1 -7","-6 6 M-6 -6 L-6 6 L6 6 L6 -6 L-6 -6","-7 7 M0 -8 L-7 4 L7 4 L0 -8","-6 6 M0 -10 L-6 0 L0 10 L6 0 L0 -10","-8 8 M0 -9 L-2 -3 L-8 -3 L-3 1 L-5 7 L0 3 L5 7 L3 1 L8 -3 L2 -3 L0 -9","-7 7 M0 -7 L0 7 M-7 0 L7 0","-5 5 M-5 -5 L5 5 M5 -5 L-5 5","-5 5 M0 -6 L0 6 M-5 -3 L5 3 M5 -3 L-5 3","-4 4 M-1 -4 L-3 -3 L-4 -1 L-4 1 L-3 3 L-1 4 L1 4 L3 3 L4 1 L4 -1 L3 -3 L1 -4 L-1 -4 M-3 -1 L-3 1 M-2 -2 L-2 2 M-1 -3 L-1 3 M0 -3 L0 3 M1 -3 L1 3 M2 -2 L2 2 M3 -1 L3 1","-4 4 M-4 -4 L-4 4 L4 4 L4 -4 L-4 -4 M-3 -3 L-3 3 M-2 -3 L-2 3 M-1 -3 L-1 3 M0 -3 L0 3 M1 -3 L1 3 M2 -3 L2 3 M3 -3 L3 3","-5 5 M0 -6 L-5 3 L5 3 L0 -6 M0 -3 L-3 2 M0 -3 L3 2 M0 0 L-1 2 M0 0 L1 2","-6 3 M-6 0 L3 5 L3 -5 L-6 0 M-3 0 L2 3 M-3 0 L2 -3 M0 0 L2 1 M0 0 L2 -1","-5 5 M0 6 L5 -3 L-5 -3 L0 6 M0 3 L3 -2 M0 3 L-3 -2 M0 0 L1 -2 M0 0 L-1 -2","-3 6 M6 0 L-3 -5 L-3 5 L6 0 M3 0 L-2 -3 M3 0 L-2 3 M0 0 L-2 -1 M0 0 L-2 1","0 7 M0 -7 L0 7 M0 -7 L7 -4 L0 -1 M1 -5 L4 -4 L1 -3","-9 9 M0 -11 L0 4 M-5 -8 L5 -2 M5 -8 L-5 -2 M-9 4 L-6 10 M9 4 L6 10 M-9 4 L9 4 M-6 10 L6 10","-5 5 M0 -6 L0 6 M-3 -3 L3 -3 M-5 3 L-3 5 L-1 6 L1 6 L3 5 L5 3","-6 6 M0 -6 L0 6 M-6 -1 L-5 -3 L5 -3 L6 -1 M-2 5 L2 5","-7 7 M-5 -4 L5 6 M5 -4 L-5 6 M-3 -6 L-6 -3 L-7 -1 M3 -6 L6 -3 L7 -1","-9 9 M-4 -9 L-9 9 M4 -9 L9 9 M-5 -5 L9 9 M5 -5 L-9 9 M-4 -9 L4 -9 M-5 -5 L5 -5","-7 7 M-7 -12 L7 12","-11 9 M-5 -8 L1 4 M-7 -2 L1 -6 M-11 10 L9 10 L9 0 L-11 10","-6 6 M-2 -6 L-2 -2 L-6 -2 L-6 2 L-2 2 L-2 6 L2 6 L2 2 L6 2 L6 -2 L2 -2 L2 -6 L-2 -6","-7 7 M7 -2 L6 -4 L4 -6 L1 -7 L-1 -7 L-4 -6 L-6 -4 L-7 -1 L-7 1 L-6 4 L-4 6 L-1 7 L1 7 L4 6 L6 4 L7 2 M7 -2 L5 -4 L3 -5 L1 -5 L-1 -4 L-2 -3 L-3 -1 L-3 1 L-2 3 L-1 4 L1 5 L3 5 L5 4 L7 2","-7 7 M0 -8 L-7 4 L7 4 L0 -8 M0 8 L7 -4 L-7 -4 L0 8","-11 11 M-2 -9 L-2 -11 L-1 -12 L1 -12 L2 -11 L2 -9 M-11 8 L-10 6 L-8 4 L-7 2 L-6 -2 L-6 -7 L-5 -8 L-3 -9 L3 -9 L5 -8 L6 -7 L6 -2 L7 2 L8 4 L10 6 L11 8 M-11 8 L11 8 M-1 8 L-2 9 L-1 10 L1 10 L2 9 L1 8","-8 8 M0 -5 L0 1 M0 1 L-1 10 M0 1 L1 10 M-1 10 L1 10 M0 -5 L-1 -8 L-2 -10 L-4 -11 M-1 -8 L-4 -11 M0 -5 L1 -8 L2 -10 L4 -11 M1 -8 L4 -11 M0 -5 L-4 -7 L-6 -7 L-8 -5 M-2 -6 L-6 -6 L-8 -5 M0 -5 L4 -7 L6 -7 L8 -5 M2 -6 L6 -6 L8 -5 M0 -5 L-2 -4 L-3 -3 L-3 0 M0 -5 L-2 -3 L-3 0 M0 -5 L2 -4 L3 -3 L3 0 M0 -5 L2 -3 L3 0","-8 8 M0 -9 L0 -7 M0 -4 L0 -2 M0 1 L0 3 M0 7 L-1 10 M0 7 L1 10 M-1 10 L1 10 M0 -11 L-1 -9 L-2 -8 M0 -11 L1 -9 L2 -8 M-2 -8 L0 -9 L2 -8 M0 -7 L-2 -4 L-4 -3 L-5 -4 M0 -7 L2 -4 L4 -3 L5 -4 M-4 -3 L-2 -3 L0 -4 L2 -3 L4 -3 M0 -2 L-2 1 L-4 2 L-6 2 L-7 0 L-7 1 L-6 2 M0 -2 L2 1 L4 2 L6 2 L7 0 L7 1 L6 2 M-4 2 L-2 2 L0 1 L2 2 L4 2 M0 3 L-2 6 L-3 7 L-5 8 L-6 8 L-7 7 L-8 5 L-8 7 L-6 8 M0 3 L2 6 L3 7 L5 8 L6 8 L7 7 L8 5 L8 7 L6 8 M-5 8 L-3 8 L0 7 L3 8 L5 8","-8 8 M0 7 L-1 10 M0 7 L1 10 M-1 10 L1 10 M0 7 L3 8 L6 8 L8 6 L8 3 L7 2 L5 2 L7 0 L8 -3 L7 -5 L5 -6 L3 -5 L4 -8 L3 -10 L1 -11 L-1 -11 L-3 -10 L-4 -8 L-3 -5 L-5 -6 L-7 -5 L-8 -3 L-7 0 L-5 2 L-7 2 L-8 3 L-8 6 L-6 8 L-3 8 L0 7","-8 8 M0 7 L-1 10 M0 7 L1 10 M-1 10 L1 10 M0 7 L4 6 L4 4 L6 3 L6 0 L8 -1 L8 -6 L7 -9 L6 -10 L4 -10 L2 -11 L-2 -11 L-4 -10 L-6 -10 L-7 -9 L-8 -6 L-8 -1 L-6 0 L-6 3 L-4 4 L-4 6 L0 7","-9 9 M-9 -2 L-7 0 M-6 -7 L-4 -2 M0 -11 L0 -3 M6 -7 L4 -2 M9 -2 L7 0","-11 11 M-9 -9 L-8 -7 L-7 -3 L-7 3 L-8 7 L-9 9 M9 -9 L8 -7 L7 -3 L7 3 L8 7 L9 9 M-9 -9 L-7 -8 L-3 -7 L3 -7 L7 -8 L9 -9 M-9 9 L-7 8 L-3 7 L3 7 L7 8 L9 9","-12 12 M0 0 L0 9 L-1 10 M0 4 L-1 10 M0 -9 L-1 -10 L-3 -10 L-4 -9 L-4 -7 L-3 -4 L0 0 M0 -9 L1 -10 L3 -10 L4 -9 L4 -7 L3 -4 L0 0 M0 0 L-4 -3 L-6 -4 L-8 -4 L-9 -3 L-9 -1 L-8 0 M0 0 L4 -3 L6 -4 L8 -4 L9 -3 L9 -1 L8 0 M0 0 L-4 3 L-6 4 L-8 4 L-9 3 L-9 1 L-8 0 M0 0 L4 3 L6 4 L8 4 L9 3 L9 1 L8 0","-8 8 M3 -9 L2 -8 L3 -7 L4 -8 L4 -9 L3 -11 L1 -12 L-1 -12 L-3 -11 L-4 -9 L-4 -7 L-3 -5 L-1 -3 L4 0 M-3 -5 L2 -2 L4 0 L5 2 L5 4 L4 6 L2 8 M-2 -4 L-4 -2 L-5 0 L-5 2 L-4 4 L-2 6 L3 9 M-4 4 L1 7 L3 9 L4 11 L4 13 L3 15 L1 16 L-1 16 L-3 15 L-4 13 L-4 12 L-3 11 L-2 12 L-3 13","-8 8 M0 -12 L-1 -10 L0 -8 L1 -10 L0 -12 M0 -12 L0 16 M0 -1 L-1 2 L0 16 L1 2 L0 -1 M-6 -5 L-4 -4 L-2 -5 L-4 -6 L-6 -5 M-6 -5 L6 -5 M2 -5 L4 -4 L6 -5 L4 -6 L2 -5","-8 8 M0 -12 L-1 -10 L0 -8 L1 -10 L0 -12 M0 -12 L0 2 M0 -2 L-1 0 L1 4 L0 6 L-1 4 L1 0 L0 -2 M0 2 L0 16 M0 12 L-1 14 L0 16 L1 14 L0 12 M-6 -5 L-4 -4 L-2 -5 L-4 -6 L-6 -5 M-6 -5 L6 -5 M2 -5 L4 -4 L6 -5 L4 -6 L2 -5 M-6 9 L-4 10 L-2 9 L-4 8 L-6 9 M-6 9 L6 9 M2 9 L4 10 L6 9 L4 8 L2 9","-13 13 M0 -9 L-1 -8 L0 -7 L1 -8 L0 -9 M-9 7 L-10 8 L-9 9 L-8 8 L-9 7 M9 7 L8 8 L9 9 L10 8 L9 7","-12 12 M0 -10 L-4 -6 L-7 -2 L-8 1 L-8 3 L-7 5 L-5 6 L-3 6 L-1 5 L0 3 M0 -10 L4 -6 L7 -2 L8 1 L8 3 L7 5 L5 6 L3 6 L1 5 L0 3 M0 3 L-1 7 L-2 10 M0 3 L1 7 L2 10 M-2 10 L2 10","-12 12 M0 -4 L-1 -7 L-2 -9 L-4 -10 L-5 -10 L-7 -9 L-8 -7 L-8 -3 L-7 0 L-6 2 L-4 5 L0 10 M0 -4 L1 -7 L2 -9 L4 -10 L5 -10 L7 -9 L8 -7 L8 -3 L7 0 L6 2 L4 5 L0 10","-12 12 M0 -11 L-2 -8 L-6 -3 L-9 0 M0 -11 L2 -8 L6 -3 L9 0 M-9 0 L-6 3 L-2 8 L0 11 M9 0 L6 3 L2 8 L0 11","-12 12 M0 2 L2 5 L4 6 L6 6 L8 5 L9 3 L9 1 L8 -1 L6 -2 L4 -2 L1 -1 M1 -1 L3 -3 L4 -5 L4 -7 L3 -9 L1 -10 L-1 -10 L-3 -9 L-4 -7 L-4 -5 L-3 -3 L-1 -1 M-1 -1 L-4 -2 L-6 -2 L-8 -1 L-9 1 L-9 3 L-8 5 L-6 6 L-4 6 L-2 5 L0 2 M0 2 L-1 7 L-2 10 M0 2 L1 7 L2 10 M-2 10 L2 10","-9 9 M4 -39 L1 -37 L-1 -35 L-2 -33 L-3 -30 L-3 -26 L-2 -22 L2 -14 L3 -11 L3 -8 L2 -5 L0 -2 M1 -37 L-1 -34 L-2 -30 L-2 -26 L-1 -23 L3 -15 L4 -11 L4 -8 L3 -5 L0 -2 L-4 0 L0 2 L3 5 L4 8 L4 11 L3 15 L-1 23 L-2 26 L-2 30 L-1 34 L1 37 M0 2 L2 5 L3 8 L3 11 L2 14 L-2 22 L-3 26 L-3 30 L-2 33 L-1 35 L1 37 L4 39","-9 9 M-4 -39 L-1 -37 L1 -35 L2 -33 L3 -30 L3 -26 L2 -22 L-2 -14 L-3 -11 L-3 -8 L-2 -5 L0 -2 M-1 -37 L1 -34 L2 -30 L2 -26 L1 -23 L-3 -15 L-4 -11 L-4 -8 L-3 -5 L0 -2 L4 0 L0 2 L-3 5 L-4 8 L-4 11 L-3 15 L1 23 L2 26 L2 30 L1 34 L-1 37 M0 2 L-2 5 L-3 8 L-3 11 L-2 14 L2 22 L3 26 L3 30 L2 33 L1 35 L-1 37 L-4 39","-9 9 M4 -36 L1 -33 L-1 -30 L-3 -26 L-4 -21 L-4 -15 L-3 -9 L-2 -5 L1 6 L2 10 L3 16 L3 21 L2 26 L1 29 L-1 33 M1 -33 L-1 -29 L-2 -26 L-3 -21 L-3 -16 L-2 -10 L-1 -6 L2 5 L3 9 L4 15 L4 21 L3 26 L1 30 L-1 33 L-4 36","-9 9 M-4 -36 L-1 -33 L1 -30 L3 -26 L4 -21 L4 -15 L3 -9 L2 -5 L-1 6 L-2 10 L-3 16 L-3 21 L-2 26 L-1 29 L1 33 M-1 -33 L1 -29 L2 -26 L3 -21 L3 -16 L2 -10 L1 -6 L-2 5 L-3 9 L-4 15 L-4 21 L-3 26 L-1 30 L1 33 L4 36","-27 8 M-24 0 L-17 0 L0 29 M-18 0 L-1 29 M-19 0 L0 32 M8 -48 L4 -8 L0 32","-9 9 M2 -5 L4 -4 L6 -2 L6 -3 L5 -4 L2 -5 L-1 -5 L-4 -4 L-5 -3 L-6 -1 L-6 1 L-5 3 L-3 5 L1 8 M-1 -5 L-3 -4 L-4 -3 L-5 -1 L-5 1 L-4 3 L1 8 L2 10 L2 12 L1 13 L-1 13","-11 11 M-6 -5 L-7 -4 L-8 -2 L-8 0 L-7 3 L-3 7 L-2 9 M-8 0 L-7 2 L-3 6 L-2 9 L-2 11 L-3 14 L-5 16 L-6 16 L-7 15 L-8 13 L-8 10 L-7 6 L-5 2 L-3 -1 L0 -4 L2 -5 L4 -5 L7 -4 L8 -2 L8 2 L7 6 L5 8 L3 9 L2 9 L1 8 L1 6 L2 5 L3 6 L2 7 M4 -5 L6 -4 L7 -2 L7 2 L6 6 L5 8","-13 13 M7 -11 L6 -10 L7 -9 L8 -10 L7 -11 L5 -12 L2 -12 L-1 -11 L-3 -9 L-4 -7 L-5 -4 L-6 0 L-8 9 L-9 13 L-10 15 M2 -12 L0 -11 L-2 -9 L-3 -7 L-4 -4 L-6 5 L-7 9 L-8 12 L-9 14 L-10 15 L-12 16 L-14 16 L-15 15 L-15 14 L-14 13 L-13 14 L-14 15 M13 -11 L12 -10 L13 -9 L14 -10 L14 -11 L13 -12 L11 -12 L9 -11 L8 -10 L7 -8 L6 -5 L3 9 L2 13 L1 15 M11 -12 L9 -10 L8 -8 L7 -4 L5 5 L4 9 L3 12 L2 14 L1 15 L-1 16 L-3 16 L-4 15 L-4 14 L-3 13 L-2 14 L-3 15 M-9 -5 L12 -5","-12 12 M9 -11 L8 -10 L9 -9 L10 -10 L9 -11 L6 -12 L3 -12 L0 -11 L-2 -9 L-3 -7 L-4 -4 L-5 0 L-7 9 L-8 13 L-9 15 M3 -12 L1 -11 L-1 -9 L-2 -7 L-3 -4 L-5 5 L-6 9 L-7 12 L-8 14 L-9 15 L-11 16 L-13 16 L-14 15 L-14 14 L-13 13 L-12 14 L-13 15 M7 -5 L5 2 L4 6 L4 8 L5 9 L8 9 L10 7 L11 5 M8 -5 L6 2 L5 6 L5 8 L6 9 M-8 -5 L8 -5","-12 12 M7 -11 L6 -10 L7 -9 L8 -10 L8 -11 L6 -12 M10 -12 L3 -12 L0 -11 L-2 -9 L-3 -7 L-4 -4 L-5 0 L-7 9 L-8 13 L-9 15 M3 -12 L1 -11 L-1 -9 L-2 -7 L-3 -4 L-5 5 L-6 9 L-7 12 L-8 14 L-9 15 L-11 16 L-13 16 L-14 15 L-14 14 L-13 13 L-12 14 L-13 15 M9 -12 L5 2 L4 6 L4 8 L5 9 L8 9 L10 7 L11 5 M10 -12 L6 2 L5 6 L5 8 L6 9 M-8 -5 L7 -5","-18 17 M2 -11 L1 -10 L2 -9 L3 -10 L2 -11 L0 -12 L-3 -12 L-6 -11 L-8 -9 L-9 -7 L-10 -4 L-11 0 L-13 9 L-14 13 L-15 15 M-3 -12 L-5 -11 L-7 -9 L-8 -7 L-9 -4 L-11 5 L-12 9 L-13 12 L-14 14 L-15 15 L-17 16 L-19 16 L-20 15 L-20 14 L-19 13 L-18 14 L-19 15 M14 -11 L13 -10 L14 -9 L15 -10 L14 -11 L11 -12 L8 -12 L5 -11 L3 -9 L2 -7 L1 -4 L0 0 L-2 9 L-3 13 L-4 15 M8 -12 L6 -11 L4 -9 L3 -7 L2 -4 L0 5 L-1 9 L-2 12 L-3 14 L-4 15 L-6 16 L-8 16 L-9 15 L-9 14 L-8 13 L-7 14 L-8 15 M12 -5 L10 2 L9 6 L9 8 L10 9 L13 9 L15 7 L16 5 M13 -5 L11 2 L10 6 L10 8 L11 9 M-14 -5 L13 -5","-18 17 M2 -11 L1 -10 L2 -9 L3 -10 L2 -11 L0 -12 L-3 -12 L-6 -11 L-8 -9 L-9 -7 L-10 -4 L-11 0 L-13 9 L-14 13 L-15 15 M-3 -12 L-5 -11 L-7 -9 L-8 -7 L-9 -4 L-11 5 L-12 9 L-13 12 L-14 14 L-15 15 L-17 16 L-19 16 L-20 15 L-20 14 L-19 13 L-18 14 L-19 15 M12 -11 L11 -10 L12 -9 L13 -10 L13 -11 L11 -12 M15 -12 L8 -12 L5 -11 L3 -9 L2 -7 L1 -4 L0 0 L-2 9 L-3 13 L-4 15 M8 -12 L6 -11 L4 -9 L3 -7 L2 -4 L0 5 L-1 9 L-2 12 L-3 14 L-4 15 L-6 16 L-8 16 L-9 15 L-9 14 L-8 13 L-7 14 L-8 15 M14 -12 L10 2 L9 6 L9 8 L10 9 L13 9 L15 7 L16 5 M15 -12 L11 2 L10 6 L10 8 L11 9 M-14 -5 L12 -5","-6 7 M-5 -1 L-4 -3 L-2 -5 L1 -5 L2 -4 L2 -1 L0 5 L0 8 L1 9 M0 -5 L1 -4 L1 -1 L-1 5 L-1 8 L0 9 L3 9 L5 7 L6 5","-6 6 M0 -6 L-4 5 L6 -2 L-6 -2 L4 5 L0 -6 M0 0 L0 -6 M0 0 L-6 -2 M0 0 L-4 5 M0 0 L4 5 M0 0 L6 -2","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3"],
    :timesg => ["-8 8","-5 5 M0 -12 L-1 -10 L0 2 L1 -10 L0 -12 M0 -10 L0 -4 M0 7 L-1 8 L0 9 L1 8 L0 7","-8 8 M-4 -12 L-5 -5 M-3 -12 L-5 -5 M4 -12 L3 -5 M5 -12 L3 -5","-10 11 M1 -16 L-6 16 M7 -16 L0 16 M-6 -3 L8 -3 M-7 3 L7 3","-10 10 M-2 -16 L-2 13 M2 -16 L2 13 M6 -9 L5 -8 L6 -7 L7 -8 L7 -9 L5 -11 L2 -12 L-2 -12 L-5 -11 L-7 -9 L-7 -7 L-6 -5 L-5 -4 L-3 -3 L3 -1 L5 0 L7 2 M-7 -7 L-5 -5 L-3 -4 L3 -2 L5 -1 L6 0 L7 2 L7 6 L5 8 L2 9 L-2 9 L-5 8 L-7 6 L-7 5 L-6 4 L-5 5 L-6 6","-12 12 M9 -12 L-9 9 M-4 -12 L-2 -10 L-2 -8 L-3 -6 L-5 -5 L-7 -5 L-9 -7 L-9 -9 L-8 -11 L-6 -12 L-4 -12 L-2 -11 L1 -10 L4 -10 L7 -11 L9 -12 M5 2 L3 3 L2 5 L2 7 L4 9 L6 9 L8 8 L9 6 L9 4 L7 2 L5 2","-12 13 M9 -4 L8 -3 L9 -2 L10 -3 L10 -4 L9 -5 L8 -5 L7 -4 L6 -2 L4 3 L2 6 L0 8 L-2 9 L-5 9 L-8 8 L-9 6 L-9 3 L-8 1 L-2 -3 L0 -5 L1 -7 L1 -9 L0 -11 L-2 -12 L-4 -11 L-5 -9 L-5 -7 L-4 -4 L-2 -1 L3 6 L5 8 L8 9 L9 9 L10 8 L10 7 M-5 9 L-7 8 L-8 6 L-8 3 L-7 1 L-5 -1 M-5 -7 L-4 -5 L4 6 L6 8 L8 9","-4 4 M0 -12 L-1 -5 M1 -12 L-1 -5","-7 7 M3 -16 L1 -14 L-1 -11 L-3 -7 L-4 -2 L-4 2 L-3 7 L-1 11 L1 14 L3 16 L4 16 M3 -16 L4 -16 L2 -14 L0 -11 L-2 -7 L-3 -2 L-3 2 L-2 7 L0 11 L2 14 L4 16","-7 7 M-4 -16 L-2 -14 L0 -11 L2 -7 L3 -2 L3 2 L2 7 L0 11 L-2 14 L-4 16 L-3 16 M-4 -16 L-3 -16 L-1 -14 L1 -11 L3 -7 L4 -2 L4 2 L3 7 L1 11 L-1 14 L-3 16","-8 8 M0 -6 L0 6 M-5 -3 L5 3 M5 -3 L-5 3","-13 13 M0 -9 L0 9 M-9 0 L9 0","-4 4 M1 5 L0 6 L-1 5 L0 4 L1 5 L1 7 L-1 9","-13 13 M-9 0 L9 0","-4 4 M0 4 L-1 5 L0 6 L1 5 L0 4","-11 11 M9 -16 L-9 16","-10 10 M-1 -12 L-4 -11 L-6 -8 L-7 -3 L-7 0 L-6 5 L-4 8 L-1 9 L1 9 L4 8 L6 5 L7 0 L7 -3 L6 -8 L4 -11 L1 -12 L-1 -12 M-1 -12 L-3 -11 L-4 -10 L-5 -8 L-6 -3 L-6 0 L-5 5 L-4 7 L-3 8 L-1 9 M1 9 L3 8 L4 7 L5 5 L6 0 L6 -3 L5 -8 L4 -10 L3 -11 L1 -12","-10 10 M-4 -8 L-2 -9 L1 -12 L1 9 M0 -11 L0 9 M-4 9 L5 9","-10 10 M-6 -8 L-5 -7 L-6 -6 L-7 -7 L-7 -8 L-6 -10 L-5 -11 L-2 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -6 L6 -4 L3 -2 L-2 0 L-4 1 L-6 3 L-7 6 L-7 9 M2 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L2 -2 L-2 0 M-7 7 L-6 6 L-4 6 L1 8 L4 8 L6 7 L7 6 M-4 6 L1 9 L5 9 L6 8 L7 6 L7 4","-10 10 M-6 -8 L-5 -7 L-6 -6 L-7 -7 L-7 -8 L-6 -10 L-5 -11 L-2 -12 L2 -12 L5 -11 L6 -9 L6 -6 L5 -4 L2 -3 L-1 -3 M2 -12 L4 -11 L5 -9 L5 -6 L4 -4 L2 -3 M2 -3 L4 -2 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 4 L-6 3 L-5 4 L-6 5 M5 -1 L6 2 L6 5 L5 7 L4 8 L2 9","-10 10 M2 -10 L2 9 M3 -12 L3 9 M3 -12 L-8 3 L8 3 M-1 9 L6 9","-10 10 M-5 -12 L-7 -2 M-7 -2 L-5 -4 L-2 -5 L1 -5 L4 -4 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 4 L-6 3 L-5 4 L-6 5 M1 -5 L3 -4 L5 -2 L6 1 L6 3 L5 6 L3 8 L1 9 M-5 -12 L5 -12 M-5 -11 L0 -11 L5 -12","-10 10 M5 -9 L4 -8 L5 -7 L6 -8 L6 -9 L5 -11 L3 -12 L0 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -3 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 3 L7 2 L6 -1 L4 -3 L1 -4 L0 -4 L-3 -3 L-5 -1 L-6 2 M0 -12 L-2 -11 L-4 -9 L-5 -7 L-6 -3 L-6 3 L-5 6 L-3 8 L-1 9 M1 9 L3 8 L5 6 L6 3 L6 2 L5 -1 L3 -3 L1 -4","-10 10 M-7 -12 L-7 -6 M-7 -8 L-6 -10 L-4 -12 L-2 -12 L3 -9 L5 -9 L6 -10 L7 -12 M-6 -10 L-4 -11 L-2 -11 L3 -9 M7 -12 L7 -9 L6 -6 L2 -1 L1 1 L0 4 L0 9 M6 -6 L1 -1 L0 1 L-1 4 L-1 9","-10 10 M-2 -12 L-5 -11 L-6 -9 L-6 -6 L-5 -4 L-2 -3 L2 -3 L5 -4 L6 -6 L6 -9 L5 -11 L2 -12 L-2 -12 M-2 -12 L-4 -11 L-5 -9 L-5 -6 L-4 -4 L-2 -3 M2 -3 L4 -4 L5 -6 L5 -9 L4 -11 L2 -12 M-2 -3 L-5 -2 L-6 -1 L-7 1 L-7 5 L-6 7 L-5 8 L-2 9 L2 9 L5 8 L6 7 L7 5 L7 1 L6 -1 L5 -2 L2 -3 M-2 -3 L-4 -2 L-5 -1 L-6 1 L-6 5 L-5 7 L-4 8 L-2 9 M2 9 L4 8 L5 7 L6 5 L6 1 L5 -1 L4 -2 L2 -3","-10 10 M6 -5 L5 -2 L3 0 L0 1 L-1 1 L-4 0 L-6 -2 L-7 -5 L-7 -6 L-6 -9 L-4 -11 L-1 -12 L1 -12 L4 -11 L6 -9 L7 -6 L7 0 L6 4 L5 6 L3 8 L0 9 L-3 9 L-5 8 L-6 6 L-6 5 L-5 4 L-4 5 L-5 6 M-1 1 L-3 0 L-5 -2 L-6 -5 L-6 -6 L-5 -9 L-3 -11 L-1 -12 M1 -12 L3 -11 L5 -9 L6 -6 L6 0 L5 4 L4 6 L2 8 L0 9","-4 4 M0 -3 L-1 -2 L0 -1 L1 -2 L0 -3 M0 4 L-1 5 L0 6 L1 5 L0 4","-4 4 M0 -3 L-1 -2 L0 -1 L1 -2 L0 -3 M1 5 L0 6 L-1 5 L0 4 L1 5 L1 7 L-1 9","-12 12 M8 -9 L-8 0 L8 9","-13 13 M-9 -3 L9 -3 M-9 3 L9 3","-12 12 M-8 -9 L8 0 L-8 9","-9 9 M-5 -8 L-4 -7 L-5 -6 L-6 -7 L-6 -8 L-5 -10 L-4 -11 L-2 -12 L1 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L4 -3 L0 -1 L0 2 M1 -12 L3 -11 L4 -10 L5 -8 L5 -6 L4 -4 L2 -2 M0 7 L-1 8 L0 9 L1 8 L0 7","-13 14 M5 -4 L4 -6 L2 -7 L-1 -7 L-3 -6 L-4 -5 L-5 -2 L-5 1 L-4 3 L-2 4 L1 4 L3 3 L4 1 M-1 -7 L-3 -5 L-4 -2 L-4 1 L-3 3 L-2 4 M5 -7 L4 1 L4 3 L6 4 L8 4 L10 2 L11 -1 L11 -3 L10 -6 L9 -8 L7 -10 L5 -11 L2 -12 L-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L2 9 L5 8 L7 7 L8 6 M6 -7 L5 1 L5 3 L6 4","-10 10 M0 -12 L-7 9 M0 -12 L7 9 M0 -9 L6 9 M-5 3 L4 3 M-9 9 L-3 9 M3 9 L9 9","-11 11 M-6 -12 L-6 9 M-5 -12 L-5 9 M-9 -12 L3 -12 L6 -11 L7 -10 L8 -8 L8 -6 L7 -4 L6 -3 L3 -2 M3 -12 L5 -11 L6 -10 L7 -8 L7 -6 L6 -4 L5 -3 L3 -2 M-5 -2 L3 -2 L6 -1 L7 0 L8 2 L8 5 L7 7 L6 8 L3 9 L-9 9 M3 -2 L5 -1 L6 0 L7 2 L7 5 L6 7 L5 8 L3 9","-10 10 M-7 -12 L6 9 M-6 -12 L7 9 M7 -12 L-7 9 M-9 -12 L-3 -12 M3 -12 L9 -12 M-9 9 L-3 9 M3 9 L9 9","-10 10 M0 -12 L-8 9 M0 -12 L8 9 M0 -9 L7 9 M-7 8 L7 8 M-8 9 L8 9","-11 10 M-6 -12 L-6 9 M-5 -12 L-5 9 M1 -6 L1 2 M-9 -12 L7 -12 L7 -6 L6 -12 M-5 -2 L1 -2 M-9 9 L7 9 L7 3 L6 9","-10 11 M0 -12 L0 9 M1 -12 L1 9 M-2 -7 L-5 -6 L-6 -5 L-7 -3 L-7 0 L-6 2 L-5 3 L-2 4 L3 4 L6 3 L7 2 L8 0 L8 -3 L7 -5 L6 -6 L3 -7 L-2 -7 M-2 -7 L-4 -6 L-5 -5 L-6 -3 L-6 0 L-5 2 L-4 3 L-2 4 M3 4 L5 3 L6 2 L7 0 L7 -3 L6 -5 L5 -6 L3 -7 M-3 -12 L4 -12 M-3 9 L4 9","-9 9 M-4 -12 L-4 9 M-3 -12 L-3 9 M-7 -12 L8 -12 L8 -6 L7 -12 M-7 9 L0 9","-12 12 M-7 -12 L-7 9 M-6 -12 L-6 9 M6 -12 L6 9 M7 -12 L7 9 M-10 -12 L-3 -12 M3 -12 L10 -12 M-6 -2 L6 -2 M-10 9 L-3 9 M3 9 L10 9","-5 6 M0 -12 L0 9 M1 -12 L1 9 M-3 -12 L4 -12 M-3 9 L4 9","-2 3 M0 -1 L0 0 L1 0 L1 -1 L0 -1","-12 10 M-7 -12 L-7 9 M-6 -12 L-6 9 M7 -12 L-6 1 M-1 -3 L7 9 M-2 -3 L6 9 M-10 -12 L-3 -12 M3 -12 L9 -12 M-10 9 L-3 9 M3 9 L9 9","-10 10 M0 -12 L-7 9 M0 -12 L7 9 M0 -9 L6 9 M-9 9 L-3 9 M3 9 L9 9","-12 13 M-7 -12 L-7 9 M-6 -12 L0 6 M-7 -12 L0 9 M7 -12 L0 9 M7 -12 L7 9 M8 -12 L8 9 M-10 -12 L-6 -12 M7 -12 L11 -12 M-10 9 L-4 9 M4 9 L11 9","-11 12 M-6 -12 L-6 9 M-5 -12 L7 7 M-5 -10 L7 9 M7 -12 L7 9 M-9 -12 L-5 -12 M4 -12 L10 -12 M-9 9 L-3 9","-11 11 M-1 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -3 L-8 0 L-7 4 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 4 L8 0 L8 -3 L7 -7 L6 -9 L4 -11 L1 -12 L-1 -12 M-1 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -3 L-7 0 L-6 4 L-5 6 L-3 8 L-1 9 M1 9 L3 8 L5 6 L6 4 L7 0 L7 -3 L6 -7 L5 -9 L3 -11 L1 -12","-12 12 M-7 -12 L-7 9 M-6 -12 L-6 9 M6 -12 L6 9 M7 -12 L7 9 M-10 -12 L10 -12 M-10 9 L-3 9 M3 9 L10 9","-11 11 M-1 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -3 L-8 0 L-7 4 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 4 L8 0 L8 -3 L7 -7 L6 -9 L4 -11 L1 -12 L-1 -12 M-1 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -3 L-7 0 L-6 4 L-5 6 L-3 8 L-1 9 M1 9 L3 8 L5 6 L6 4 L7 0 L7 -3 L6 -7 L5 -9 L3 -11 L1 -12 M-3 -5 L-3 2 M3 -5 L3 2 M-3 -2 L3 -2 M-3 -1 L3 -1","-11 11 M-6 -12 L-6 9 M-5 -12 L-5 9 M-9 -12 L3 -12 L6 -11 L7 -10 L8 -8 L8 -5 L7 -3 L6 -2 L3 -1 L-5 -1 M3 -12 L5 -11 L6 -10 L7 -8 L7 -5 L6 -3 L5 -2 L3 -1 M-9 9 L-2 9","-10 11 M-7 -12 L0 -2 L-8 9 M-8 -12 L-1 -2 M-8 -12 L7 -12 L8 -6 L6 -12 M-7 8 L6 8 M-8 9 L7 9 L8 3 L6 9","-9 10 M0 -12 L0 9 M1 -12 L1 9 M-6 -12 L-7 -6 L-7 -12 L8 -12 L8 -6 L7 -12 M-3 9 L4 9","-9 10 M-7 -7 L-7 -9 L-6 -11 L-5 -12 L-3 -12 L-2 -11 L-1 -9 L0 -5 L0 9 M-7 -9 L-5 -11 L-3 -11 L-1 -9 M8 -7 L8 -9 L7 -11 L6 -12 L4 -12 L3 -11 L2 -9 L1 -5 L1 9 M8 -9 L6 -11 L4 -11 L2 -9 M-3 9 L4 9","-7 7 M-1 -12 L-3 -11 L-4 -9 L-4 -7 L-3 -5 L-1 -4 L1 -4 L3 -5 L4 -7 L4 -9 L3 -11 L1 -12 L-1 -12","-11 11 M-8 6 L-7 9 L-3 9 L-5 5 L-7 1 L-8 -2 L-8 -6 L-7 -9 L-5 -11 L-2 -12 L2 -12 L5 -11 L7 -9 L8 -6 L8 -2 L7 1 L5 5 L3 9 L7 9 L8 6 M-5 5 L-6 2 L-7 -2 L-7 -6 L-6 -9 L-4 -11 L-2 -12 M2 -12 L4 -11 L6 -9 L7 -6 L7 -2 L6 2 L5 5 M-7 8 L-4 8 M4 8 L7 8","-11 11 M-7 -13 L-8 -8 M8 -13 L7 -8 M-3 -4 L-4 1 M4 -4 L3 1 M-7 5 L-8 10 M8 5 L7 10 M-7 -11 L7 -11 M-7 -10 L7 -10 M-3 -2 L3 -2 M-3 -1 L3 -1 M-7 7 L7 7 M-7 8 L7 8","-11 12 M0 -12 L0 9 M1 -12 L1 9 M-9 -5 L-8 -6 L-6 -5 L-5 -1 L-4 1 L-3 2 L-1 3 M-8 -6 L-7 -5 L-6 -1 L-5 1 L-4 2 L-1 3 L2 3 L5 2 L6 1 L7 -1 L8 -5 L9 -6 M2 3 L4 2 L5 1 L6 -1 L7 -5 L9 -6 L10 -5 M-3 -12 L4 -12 M-3 9 L4 9","-10 10 M6 -12 L-7 9 M7 -12 L-6 9 M-6 -12 L-7 -6 L-7 -12 L7 -12 M-7 9 L7 9 L7 3 L6 9","-7 7 M-3 -16 L-3 16 M-2 -16 L-2 16 M-3 -16 L4 -16 M-3 16 L4 16","-7 7 M-7 -12 L7 12","-7 7 M2 -16 L2 16 M3 -16 L3 16 M-4 -16 L3 -16 M-4 16 L3 16","-11 11 M-8 2 L0 -3 L8 2 M-8 2 L0 -2 L8 2","-10 10 M-10 16 L10 16","-6 6 M-2 -12 L3 -6 M-2 -12 L-3 -11 L3 -6","-11 12 M-1 -5 L-4 -4 L-6 -2 L-7 0 L-8 3 L-8 6 L-7 8 L-4 9 L-2 9 L0 8 L3 5 L5 2 L7 -2 L8 -5 M-1 -5 L-3 -4 L-5 -2 L-6 0 L-7 3 L-7 6 L-6 8 L-4 9 M-1 -5 L1 -5 L3 -4 L4 -2 L6 6 L7 8 L8 9 M1 -5 L2 -4 L3 -2 L5 6 L6 8 L8 9 L9 9","-11 10 M2 -12 L-1 -11 L-3 -9 L-5 -5 L-6 -2 L-7 2 L-8 8 L-9 16 M2 -12 L0 -11 L-2 -9 L-4 -5 L-5 -2 L-6 2 L-7 8 L-8 16 M2 -12 L4 -12 L6 -11 L7 -10 L7 -7 L6 -5 L5 -4 L2 -3 L-2 -3 M4 -12 L6 -10 L6 -7 L5 -5 L4 -4 L2 -3 M-2 -3 L2 -2 L4 0 L5 2 L5 5 L4 7 L3 8 L0 9 L-2 9 L-4 8 L-5 7 L-6 4 M-2 -3 L1 -2 L3 0 L4 2 L4 5 L3 7 L2 8 L0 9","-9 9 M-7 -5 L-5 -5 L-3 -4 L-2 -2 L3 13 L4 15 L5 16 M-5 -5 L-4 -4 L-3 -2 L2 13 L3 15 L5 16 L7 16 M8 -5 L7 -3 L5 0 L-5 11 L-7 14 L-8 16","-9 10 M4 -4 L2 -5 L0 -5 L-3 -4 L-5 -1 L-6 2 L-6 5 L-5 7 L-4 8 L-2 9 L0 9 L3 8 L5 5 L6 2 L6 -1 L5 -3 L1 -8 L0 -10 L0 -12 L1 -13 L3 -13 L5 -12 L7 -10 M0 -5 L-2 -4 L-4 -1 L-5 2 L-5 6 L-4 8 M0 9 L2 8 L4 5 L5 2 L5 -2 L4 -4 L2 -7 L1 -9 L1 -11 L2 -12 L4 -12 L7 -10","-9 9 M6 -2 L4 -4 L2 -5 L-2 -5 L-4 -4 L-4 -2 L-2 0 L1 1 M-2 -5 L-3 -4 L-3 -2 L-1 0 L1 1 M1 1 L-4 2 L-6 4 L-6 6 L-5 8 L-2 9 L1 9 L3 8 L5 6 M1 1 L-3 2 L-5 4 L-5 6 L-4 8 L-2 9","-11 11 M-3 -4 L-5 -3 L-7 -1 L-8 2 L-8 5 L-7 7 L-6 8 L-4 9 L-1 9 L2 8 L5 6 L7 3 L8 0 L8 -3 L6 -5 L4 -5 L2 -3 L0 1 L-2 6 L-5 16 M-8 5 L-6 7 L-4 8 L-1 8 L2 7 L5 5 L7 3 M8 -3 L6 -4 L4 -4 L2 -2 L0 1 L-2 7 L-4 16","-10 10 M-9 -2 L-7 -4 L-5 -5 L-3 -5 L-1 -4 L0 -3 L1 0 L1 4 L0 8 L-3 16 M-8 -3 L-6 -4 L-2 -4 L0 -3 M8 -5 L7 -2 L6 0 L1 7 L-2 12 L-4 16 M7 -5 L6 -2 L5 0 L1 7","-11 11 M-10 -1 L-9 -3 L-7 -5 L-4 -5 L-3 -4 L-3 -2 L-4 2 L-6 9 M-5 -5 L-4 -4 L-4 -2 L-5 2 L-7 9 M-4 2 L-2 -2 L0 -4 L2 -5 L4 -5 L6 -4 L7 -3 L7 0 L6 5 L3 16 M4 -5 L6 -3 L6 0 L5 5 L2 16","-6 6 M0 -5 L-2 2 L-3 6 L-3 8 L-2 9 L1 9 L3 7 L4 5 M1 -5 L-1 2 L-2 6 L-2 8 L-1 9","-11 11 M-7 -7 L7 7 M7 -7 L-7 7","-10 10 M-4 -5 L-8 9 M-3 -5 L-7 9 M6 -5 L7 -4 L8 -4 L7 -5 L5 -5 L3 -4 L-1 0 L-3 1 L-5 1 M-3 1 L-1 2 L1 8 L2 9 M-3 1 L-2 2 L0 8 L1 9 L3 9 L5 8 L7 5","-10 10 M-7 -12 L-5 -12 L-3 -11 L-2 -10 L-1 -8 L5 6 L6 8 L7 9 M-5 -12 L-3 -10 L-2 -8 L4 6 L5 8 L7 9 L8 9 M0 -5 L-8 9 M0 -5 L-7 9","-12 11 M-5 -5 L-11 16 M-4 -5 L-10 16 M-5 -2 L-6 4 L-6 7 L-4 9 L-2 9 L0 8 L2 6 L4 3 M6 -5 L3 6 L3 8 L4 9 L7 9 L9 7 L10 5 M7 -5 L4 6 L4 8 L5 9","-10 10 M-4 -5 L-6 9 M-3 -5 L-4 1 L-5 6 L-6 9 M7 -5 L6 -1 L4 3 M8 -5 L7 -2 L6 0 L4 3 L2 5 L-1 7 L-3 8 L-6 9 M-7 -5 L-3 -5","-9 9 M0 -5 L-3 -4 L-5 -1 L-6 2 L-6 5 L-5 7 L-4 8 L-2 9 L0 9 L3 8 L5 5 L6 2 L6 -1 L5 -3 L4 -4 L2 -5 L0 -5 M0 -5 L-2 -4 L-4 -1 L-5 2 L-5 6 L-4 8 M0 9 L2 8 L4 5 L5 2 L5 -2 L4 -4","-11 11 M-2 -4 L-6 9 M-2 -4 L-5 9 M4 -4 L4 9 M4 -4 L5 9 M-9 -2 L-7 -4 L-4 -5 L9 -5 M-9 -2 L-7 -3 L-4 -4 L9 -4","-12 11 M-11 -1 L-10 -3 L-8 -5 L-5 -5 L-4 -4 L-4 -2 L-5 3 L-5 6 L-4 8 L-3 9 M-6 -5 L-5 -4 L-5 -2 L-6 3 L-6 6 L-5 8 L-3 9 L-1 9 L1 8 L3 6 L5 3 L6 0 L7 -5 L7 -9 L6 -11 L4 -12 L2 -12 L0 -10 L0 -8 L1 -5 L3 -2 L5 0 L8 2 M1 8 L3 5 L4 3 L5 0 L6 -5 L6 -9 L5 -11 L4 -12","-10 9 M-6 4 L-5 7 L-4 8 L-2 9 L0 9 L3 8 L5 5 L6 2 L6 -1 L5 -3 L4 -4 L2 -5 L0 -5 L-3 -4 L-5 -1 L-6 2 L-10 16 M0 9 L2 8 L4 5 L5 2 L5 -2 L4 -4 M0 -5 L-2 -4 L-4 -1 L-5 2 L-9 16","-10 11 M9 -5 L-1 -5 L-4 -4 L-6 -1 L-7 2 L-7 5 L-6 7 L-5 8 L-3 9 L-1 9 L2 8 L4 5 L5 2 L5 -1 L4 -3 L3 -4 L1 -5 M-1 -5 L-3 -4 L-5 -1 L-6 2 L-6 6 L-5 8 M-1 9 L1 8 L3 5 L4 2 L4 -2 L3 -4 M3 -4 L9 -4","-10 10 M1 -4 L-2 9 M1 -4 L-1 9 M-8 -2 L-6 -4 L-3 -5 L8 -5 M-8 -2 L-6 -3 L-3 -4 L8 -4","-10 10 M-9 -1 L-8 -3 L-6 -5 L-3 -5 L-2 -4 L-2 -2 L-4 4 L-4 7 L-2 9 M-4 -5 L-3 -4 L-3 -2 L-5 4 L-5 7 L-4 8 L-2 9 L-1 9 L2 8 L4 6 L6 3 L7 0 L7 -3 L6 -5 L5 -4 L6 -3 L7 0 M6 3 L7 -3","-13 13 M0 -9 L-1 -8 L0 -7 L1 -8 L0 -9 M-9 0 L9 0 M0 7 L-1 8 L0 9 L1 8 L0 7","-12 11 M-8 -1 L-6 -3 L-3 -4 L-4 -5 L-6 -4 L-8 -1 L-9 2 L-9 5 L-8 8 L-7 9 L-5 9 L-3 8 L-1 5 L0 2 M-9 5 L-8 7 L-7 8 L-5 8 L-3 7 L-1 5 M-1 2 L-1 5 L0 8 L1 9 L3 9 L5 8 L7 5 L8 2 L8 -1 L7 -4 L6 -5 L5 -4 L7 -3 L8 -1 M-1 5 L0 7 L1 8 L3 8 L5 7 L7 5","-9 8 M2 -12 L0 -11 L-1 -10 L-1 -9 L0 -8 L3 -7 L6 -7 M3 -7 L-1 -6 L-3 -5 L-4 -3 L-4 -1 L-2 1 L1 2 L4 2 M3 -7 L0 -6 L-2 -5 L-3 -3 L-3 -1 L-1 1 L1 2 M1 2 L-3 3 L-5 4 L-6 6 L-6 8 L-4 10 L1 12 L2 13 L2 15 L0 16 L-2 16 M1 2 L-2 3 L-4 4 L-5 6 L-5 8 L-3 10 L1 12","-12 11 M3 -12 L-3 16 M4 -12 L-4 16 M-11 -1 L-10 -3 L-8 -5 L-5 -5 L-4 -4 L-4 -2 L-5 3 L-5 6 L-3 8 L0 8 L2 7 L5 4 L7 1 M-6 -5 L-5 -4 L-5 -2 L-6 3 L-6 6 L-5 8 L-3 9 L0 9 L2 8 L4 6 L6 3 L7 1 L9 -5","-9 9 M2 -12 L0 -11 L-1 -10 L-1 -9 L0 -8 L3 -7 L8 -7 L8 -8 L5 -7 L1 -5 L-2 -3 L-5 0 L-6 3 L-6 5 L-5 7 L-2 9 L1 11 L2 13 L2 15 L1 16 L-1 16 L-2 15 M3 -6 L-1 -3 L-4 0 L-5 3 L-5 5 L-4 7 L-2 9","-7 7 M2 -16 L0 -15 L-1 -14 L-2 -12 L-2 -10 L-1 -8 L0 -7 L1 -5 L1 -3 L-1 -1 M0 -15 L-1 -13 L-1 -11 L0 -9 L1 -8 L2 -6 L2 -4 L1 -2 L-3 0 L1 2 L2 4 L2 6 L1 8 L0 9 L-1 11 L-1 13 L0 15 M-1 1 L1 3 L1 5 L0 7 L-1 8 L-2 10 L-2 12 L-1 14 L0 15 L2 16","-4 4 M0 -16 L0 16","-7 7 M-2 -16 L0 -15 L1 -14 L2 -12 L2 -10 L1 -8 L0 -7 L-1 -5 L-1 -3 L1 -1 M0 -15 L1 -13 L1 -11 L0 -9 L-1 -8 L-2 -6 L-2 -4 L-1 -2 L3 0 L-1 2 L-2 4 L-2 6 L-1 8 L0 9 L1 11 L1 13 L0 15 M1 1 L-1 3 L-1 5 L0 7 L1 8 L2 10 L2 12 L1 14 L0 15 L-2 16","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3","-8 8 M-8 -12 L-8 9 L-7 9 L-7 -12 L-6 -12 L-6 9 L-5 9 L-5 -12 L-4 -12 L-4 9 L-3 9 L-3 -12 L-2 -12 L-2 9 L-1 9 L-1 -12 L0 -12 L0 9 L1 9 L1 -12 L2 -12 L2 9 L3 9 L3 -12 L4 -12 L4 9 L5 9 L5 -12 L6 -12 L6 9 L7 9 L7 -12 L8 -12 L8 9"],
    :timesi => ["-8 8","-5 6 M3 -12 L2 -11 L0 1 M3 -11 L0 1 M3 -12 L4 -11 L0 1 M-2 7 L-3 8 L-2 9 L-1 8 L-2 7","-9 9 M-2 -12 L-4 -5 M-1 -12 L-4 -5 M7 -12 L5 -5 M8 -12 L5 -5","-10 11 M1 -16 L-6 16 M7 -16 L0 16 M-6 -3 L8 -3 M-7 3 L7 3","-10 11 M2 -16 L-6 13 M7 -16 L-1 13 M8 -8 L7 -7 L8 -6 L9 -7 L9 -8 L8 -10 L7 -11 L4 -12 L0 -12 L-3 -11 L-5 -9 L-5 -7 L-4 -5 L-3 -4 L4 0 L6 2 M-5 -7 L-3 -5 L4 -1 L5 0 L6 2 L6 5 L5 7 L4 8 L1 9 L-3 9 L-6 8 L-7 7 L-8 5 L-8 4 L-7 3 L-6 4 L-7 5","-12 12 M9 -12 L-9 9 M-4 -12 L-2 -10 L-2 -8 L-3 -6 L-5 -5 L-7 -5 L-9 -7 L-9 -9 L-8 -11 L-6 -12 L-4 -12 L-2 -11 L1 -10 L4 -10 L7 -11 L9 -12 M5 2 L3 3 L2 5 L2 7 L4 9 L6 9 L8 8 L9 6 L9 4 L7 2 L5 2","-12 13 M9 -4 L8 -3 L9 -2 L10 -3 L10 -4 L9 -5 L8 -5 L7 -4 L6 -2 L4 3 L2 6 L0 8 L-2 9 L-5 9 L-8 8 L-9 6 L-9 3 L-8 1 L-2 -3 L0 -5 L1 -7 L1 -9 L0 -11 L-2 -12 L-4 -11 L-5 -9 L-5 -7 L-4 -4 L-2 -1 L3 6 L5 8 L8 9 L9 9 L10 8 L10 7 M-5 9 L-7 8 L-8 6 L-8 3 L-7 1 L-5 -1 M-5 -7 L-4 -5 L4 6 L6 8 L8 9","-4 5 M3 -12 L1 -5 M4 -12 L1 -5","-7 8 M8 -16 L4 -13 L1 -10 L-1 -7 L-3 -3 L-4 2 L-4 6 L-3 11 L-2 14 L-1 16 M4 -13 L1 -9 L-1 -5 L-2 -2 L-3 3 L-3 8 L-2 13 L-1 16","-8 7 M1 -16 L2 -14 L3 -11 L4 -6 L4 -2 L3 3 L1 7 L-1 10 L-4 13 L-8 16 M1 -16 L2 -13 L3 -8 L3 -3 L2 2 L1 5 L-1 9 L-4 13","-8 8 M0 -6 L0 6 M-5 -3 L5 3 M5 -3 L-5 3","-13 13 M0 -9 L0 9 M-9 0 L9 0","-5 6 M-2 9 L-3 8 L-2 7 L-1 8 L-1 9 L-2 11 L-4 13","-13 13 M-9 0 L9 0","-5 6 M-2 7 L-3 8 L-2 9 L-1 8 L-2 7","-11 11 M9 -16 L-9 16","-10 11 M2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 4 L-6 7 L-5 8 L-3 9 L-1 9 L2 8 L4 6 L6 3 L7 0 L8 -4 L8 -7 L7 -10 L6 -11 L4 -12 L2 -12 M2 -12 L0 -11 L-2 -9 L-4 -6 L-5 -3 L-6 1 L-6 4 L-5 7 L-3 9 M-1 9 L1 8 L3 6 L5 3 L6 0 L7 -4 L7 -7 L6 -10 L4 -12","-10 11 M2 -8 L-3 9 M4 -12 L-2 9 M4 -12 L1 -9 L-2 -7 L-4 -6 M3 -9 L-1 -7 L-4 -6","-10 11 M-3 -8 L-2 -7 L-3 -6 L-4 -7 L-4 -8 L-3 -10 L-2 -11 L1 -12 L4 -12 L7 -11 L8 -9 L8 -7 L7 -5 L5 -3 L2 -1 L-2 1 L-5 3 L-7 5 L-9 9 M4 -12 L6 -11 L7 -9 L7 -7 L6 -5 L4 -3 L-2 1 M-8 7 L-7 6 L-5 6 L0 8 L3 8 L5 7 L6 5 M-5 6 L0 9 L3 9 L5 8 L6 5","-10 11 M-3 -8 L-2 -7 L-3 -6 L-4 -7 L-4 -8 L-3 -10 L-2 -11 L1 -12 L4 -12 L7 -11 L8 -9 L8 -7 L7 -5 L4 -3 L1 -2 M4 -12 L6 -11 L7 -9 L7 -7 L6 -5 L4 -3 M-1 -2 L1 -2 L4 -1 L5 0 L6 2 L6 5 L5 7 L4 8 L1 9 L-3 9 L-6 8 L-7 7 L-8 5 L-8 4 L-7 3 L-6 4 L-7 5 M1 -2 L3 -1 L4 0 L5 2 L5 5 L4 7 L3 8 L1 9","-10 11 M6 -11 L0 9 M7 -12 L1 9 M7 -12 L-8 3 L8 3","-10 11 M-1 -12 L-6 -2 M-1 -12 L9 -12 M-1 -11 L4 -11 L9 -12 M-6 -2 L-5 -3 L-2 -4 L1 -4 L4 -3 L5 -2 L6 0 L6 3 L5 6 L3 8 L0 9 L-3 9 L-6 8 L-7 7 L-8 5 L-8 4 L-7 3 L-6 4 L-7 5 M1 -4 L3 -3 L4 -2 L5 0 L5 3 L4 6 L2 8 L0 9","-10 11 M7 -9 L6 -8 L7 -7 L8 -8 L8 -9 L7 -11 L5 -12 L2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 5 L-6 7 L-5 8 L-3 9 L0 9 L3 8 L5 6 L6 4 L6 1 L5 -1 L4 -2 L2 -3 L-1 -3 L-3 -2 L-5 0 L-6 2 M2 -12 L0 -11 L-2 -9 L-4 -6 L-5 -3 L-6 1 L-6 6 L-5 8 M0 9 L2 8 L4 6 L5 4 L5 0 L4 -2","-10 11 M-4 -12 L-6 -6 M9 -12 L8 -9 L6 -6 L1 0 L-1 3 L-2 5 L-3 9 M6 -6 L0 0 L-2 3 L-3 5 L-4 9 M-5 -9 L-2 -12 L0 -12 L5 -9 M-4 -10 L-2 -11 L0 -11 L5 -9 L7 -9 L8 -10 L9 -12","-10 11 M1 -12 L-2 -11 L-3 -10 L-4 -8 L-4 -5 L-3 -3 L-1 -2 L2 -2 L6 -3 L7 -4 L8 -6 L8 -9 L7 -11 L4 -12 L1 -12 M1 -12 L-1 -11 L-2 -10 L-3 -8 L-3 -5 L-2 -3 L-1 -2 M2 -2 L5 -3 L6 -4 L7 -6 L7 -9 L6 -11 L4 -12 M-1 -2 L-5 -1 L-7 1 L-8 3 L-8 6 L-7 8 L-4 9 L0 9 L4 8 L5 7 L6 5 L6 2 L5 0 L4 -1 L2 -2 M-1 -2 L-4 -1 L-6 1 L-7 3 L-7 6 L-6 8 L-4 9 M0 9 L3 8 L4 7 L5 5 L5 1 L4 -1","-10 11 M7 -5 L6 -3 L4 -1 L2 0 L-1 0 L-3 -1 L-4 -2 L-5 -4 L-5 -7 L-4 -9 L-2 -11 L1 -12 L4 -12 L6 -11 L7 -10 L8 -8 L8 -4 L7 0 L6 3 L4 6 L2 8 L-1 9 L-4 9 L-6 8 L-7 6 L-7 5 L-6 4 L-5 5 L-6 6 M-3 -1 L-4 -3 L-4 -7 L-3 -9 L-1 -11 L1 -12 M6 -11 L7 -9 L7 -4 L6 0 L5 3 L3 6 L1 8 L-1 9","-5 6 M1 -5 L0 -4 L1 -3 L2 -4 L1 -5 M-2 7 L-3 8 L-2 9 L-1 8","-5 6 M1 -5 L0 -4 L1 -3 L2 -4 L1 -5 M-2 9 L-3 8 L-2 7 L-1 8 L-1 9 L-2 11 L-4 13","-12 12 M8 -9 L-8 0 L8 9","-13 13 M-9 -3 L9 -3 M-9 3 L9 3","-12 12 M-8 -9 L8 0 L-8 9","-10 11 M-3 -8 L-2 -7 L-3 -6 L-4 -7 L-4 -8 L-3 -10 L-2 -11 L1 -12 L5 -12 L8 -11 L9 -9 L9 -7 L8 -5 L7 -4 L1 -2 L-1 -1 L-1 1 L0 2 L2 2 M5 -12 L7 -11 L8 -9 L8 -7 L7 -5 L6 -4 L4 -3 M-2 7 L-3 8 L-2 9 L-1 8 L-2 7","-13 14 M5 -4 L4 -6 L2 -7 L-1 -7 L-3 -6 L-4 -5 L-5 -2 L-5 1 L-4 3 L-2 4 L1 4 L3 3 L4 1 M-1 -7 L-3 -5 L-4 -2 L-4 1 L-3 3 L-2 4 M5 -7 L4 1 L4 3 L6 4 L8 4 L10 2 L11 -1 L11 -3 L10 -6 L9 -8 L7 -10 L5 -11 L2 -12 L-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L2 9 L5 8 L7 7 L8 6 M6 -7 L5 1 L5 3 L6 4","-10 10 M3 -12 L-10 9 M3 -12 L4 9 M2 -10 L3 9 M-6 3 L3 3 M-12 9 L-6 9 M0 9 L6 9","-12 12 M-3 -12 L-9 9 M-2 -12 L-8 9 M-6 -12 L5 -12 L8 -11 L9 -9 L9 -7 L8 -4 L7 -3 L4 -2 M5 -12 L7 -11 L8 -9 L8 -7 L7 -4 L6 -3 L4 -2 M-5 -2 L4 -2 L6 -1 L7 1 L7 3 L6 6 L4 8 L0 9 L-12 9 M4 -2 L5 -1 L6 1 L6 3 L5 6 L3 8 L0 9","-10 11 M8 -10 L9 -10 L10 -12 L9 -6 L9 -8 L8 -10 L7 -11 L5 -12 L2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 4 L-6 7 L-5 8 L-2 9 L1 9 L3 8 L5 6 L6 4 M2 -12 L0 -11 L-2 -9 L-4 -6 L-5 -3 L-6 1 L-6 4 L-5 7 L-4 8 L-2 9","-12 11 M-3 -12 L-9 9 M-2 -12 L-8 9 M-6 -12 L3 -12 L6 -11 L7 -10 L8 -7 L8 -3 L7 1 L5 5 L3 7 L1 8 L-3 9 L-12 9 M3 -12 L5 -11 L6 -10 L7 -7 L7 -3 L6 1 L4 5 L2 7 L0 8 L-3 9","-12 11 M-3 -12 L-9 9 M-2 -12 L-8 9 M2 -6 L0 2 M-6 -12 L9 -12 L8 -6 L8 -12 M-5 -2 L1 -2 M-12 9 L3 9 L5 4 L2 9","-12 10 M-3 -12 L-9 9 M-2 -12 L-8 9 M2 -6 L0 2 M-6 -12 L9 -12 L8 -6 L8 -12 M-5 -2 L1 -2 M-12 9 L-5 9","-10 12 M8 -10 L9 -10 L10 -12 L9 -6 L9 -8 L8 -10 L7 -11 L5 -12 L2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 4 L-6 7 L-5 8 L-2 9 L0 9 L3 8 L5 6 L7 2 M2 -12 L0 -11 L-2 -9 L-4 -6 L-5 -3 L-6 1 L-6 4 L-5 7 L-4 8 L-2 9 M0 9 L2 8 L4 6 L6 2 M3 2 L10 2","-13 13 M-4 -12 L-10 9 M-3 -12 L-9 9 M9 -12 L3 9 M10 -12 L4 9 M-7 -12 L0 -12 M6 -12 L13 -12 M-6 -2 L6 -2 M-13 9 L-6 9 M0 9 L7 9","-6 7 M3 -12 L-3 9 M4 -12 L-2 9 M0 -12 L7 -12 M-6 9 L1 9","-9 9 M6 -12 L1 5 L0 7 L-1 8 L-3 9 L-5 9 L-7 8 L-8 6 L-8 4 L-7 3 L-6 4 L-7 5 M5 -12 L0 5 L-1 7 L-3 9 M2 -12 L9 -12","-12 11 M-3 -12 L-9 9 M-2 -12 L-8 9 M11 -12 L-6 1 M1 -3 L5 9 M0 -3 L4 9 M-6 -12 L1 -12 M7 -12 L13 -12 M-12 9 L-5 9 M1 9 L7 9","-10 10 M-1 -12 L-7 9 M0 -12 L-6 9 M-4 -12 L3 -12 M-10 9 L5 9 L7 3 L4 9","-13 14 M-4 -12 L-10 9 M-4 -12 L-3 9 M-3 -12 L-2 7 M10 -12 L-3 9 M10 -12 L4 9 M11 -12 L5 9 M-7 -12 L-3 -12 M10 -12 L14 -12 M-13 9 L-7 9 M1 9 L8 9","-12 13 M-3 -12 L-9 9 M-3 -12 L4 6 M-3 -9 L4 9 M10 -12 L4 9 M-6 -12 L-3 -12 M7 -12 L13 -12 M-12 9 L-6 9","-11 11 M1 -12 L-2 -11 L-4 -9 L-6 -6 L-7 -3 L-8 1 L-8 4 L-7 7 L-6 8 L-4 9 L-1 9 L2 8 L4 6 L6 3 L7 0 L8 -4 L8 -7 L7 -10 L6 -11 L4 -12 L1 -12 M1 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 4 L-6 7 L-4 9 M-1 9 L1 8 L3 6 L5 3 L6 0 L7 -4 L7 -7 L6 -10 L4 -12","-12 11 M-3 -12 L-9 9 M-2 -12 L-8 9 M-6 -12 L6 -12 L9 -11 L10 -9 L10 -7 L9 -4 L7 -2 L3 -1 L-5 -1 M6 -12 L8 -11 L9 -9 L9 -7 L8 -4 L6 -2 L3 -1 M-12 9 L-5 9","-11 11 M1 -12 L-2 -11 L-4 -9 L-6 -6 L-7 -3 L-8 1 L-8 4 L-7 7 L-6 8 L-4 9 L-1 9 L2 8 L4 6 L6 3 L7 0 L8 -4 L8 -7 L7 -10 L6 -11 L4 -12 L1 -12 M1 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 4 L-6 7 L-4 9 M-1 9 L1 8 L3 6 L5 3 L6 0 L7 -4 L7 -7 L6 -10 L4 -12 M-6 7 L-6 6 L-5 4 L-3 3 L-2 3 L0 4 L1 6 L1 13 L2 14 L4 14 L5 12 L5 11 M1 6 L2 12 L3 13 L4 13 L5 12","-12 12 M-3 -12 L-9 9 M-2 -12 L-8 9 M-6 -12 L5 -12 L8 -11 L9 -9 L9 -7 L8 -4 L7 -3 L4 -2 L-5 -2 M5 -12 L7 -11 L8 -9 L8 -7 L7 -4 L6 -3 L4 -2 M0 -2 L2 -1 L3 0 L4 8 L5 9 L7 9 L8 7 L8 6 M3 0 L5 7 L6 8 L7 8 L8 7 M-12 9 L-5 9","-11 12 M8 -10 L9 -10 L10 -12 L9 -6 L9 -8 L8 -10 L7 -11 L4 -12 L0 -12 L-3 -11 L-5 -9 L-5 -7 L-4 -5 L-3 -4 L4 0 L6 2 M-5 -7 L-3 -5 L4 -1 L5 0 L6 2 L6 5 L5 7 L4 8 L1 9 L-3 9 L-6 8 L-7 7 L-8 5 L-8 3 L-9 9 L-8 7 L-7 7","-10 11 M3 -12 L-3 9 M4 -12 L-2 9 M-3 -12 L-6 -6 L-4 -12 L11 -12 L10 -6 L10 -12 M-6 9 L1 9","-12 13 M-4 -12 L-7 -1 L-8 3 L-8 6 L-7 8 L-4 9 L0 9 L3 8 L5 6 L6 3 L10 -12 M-3 -12 L-6 -1 L-7 3 L-7 6 L-6 8 L-4 9 M-7 -12 L0 -12 M7 -12 L13 -12","-10 10 M-4 -12 L-3 9 M-3 -12 L-2 7 M10 -12 L-3 9 M-6 -12 L0 -12 M6 -12 L12 -12","-13 13 M-5 -12 L-7 9 M-4 -12 L-6 7 M3 -12 L-7 9 M3 -12 L1 9 M4 -12 L2 7 M11 -12 L1 9 M-8 -12 L-1 -12 M8 -12 L14 -12","-11 11 M-4 -12 L3 9 M-3 -12 L4 9 M10 -12 L-10 9 M-6 -12 L0 -12 M6 -12 L12 -12 M-12 9 L-6 9 M0 9 L6 9","-10 11 M-4 -12 L0 -2 L-3 9 M-3 -12 L1 -2 L-2 9 M11 -12 L1 -2 M-6 -12 L0 -12 M7 -12 L13 -12 M-6 9 L1 9","-11 11 M9 -12 L-10 9 M10 -12 L-9 9 M-3 -12 L-6 -6 L-4 -12 L10 -12 M-10 9 L4 9 L6 3 L3 9","-7 7 M-3 -16 L-3 16 M-2 -16 L-2 16 M-3 -16 L4 -16 M-3 16 L4 16","-7 7 M-7 -12 L7 12","-7 7 M2 -16 L2 16 M3 -16 L3 16 M-4 -16 L3 -16 M-4 16 L3 16","-11 11 M-8 2 L0 -3 L8 2 M-8 2 L0 -2 L8 2","-10 10 M-10 16 L10 16","-6 6 M-2 -12 L3 -6 M-2 -12 L-3 -11 L3 -6","-10 11 M6 -5 L4 2 L3 6 L3 8 L4 9 L7 9 L9 7 L10 5 M7 -5 L5 2 L4 6 L4 8 L5 9 M4 2 L4 -1 L3 -4 L1 -5 L-1 -5 L-4 -4 L-6 -1 L-7 2 L-7 5 L-6 7 L-5 8 L-3 9 L-1 9 L1 8 L3 5 L4 2 M-1 -5 L-3 -4 L-5 -1 L-6 2 L-6 6 L-5 8","-10 9 M-2 -12 L-6 1 L-6 4 L-5 7 L-4 8 M-1 -12 L-5 1 M-5 1 L-4 -2 L-2 -4 L0 -5 L2 -5 L4 -4 L5 -3 L6 -1 L6 2 L5 5 L3 8 L0 9 L-2 9 L-4 8 L-5 5 L-5 1 M4 -4 L5 -2 L5 2 L4 5 L2 8 L0 9 M-5 -12 L-1 -12","-9 9 M5 -2 L5 -1 L6 -1 L6 -2 L5 -4 L3 -5 L0 -5 L-3 -4 L-5 -1 L-6 2 L-6 5 L-5 7 L-4 8 L-2 9 L0 9 L3 8 L5 5 M0 -5 L-2 -4 L-4 -1 L-5 2 L-5 6 L-4 8","-10 11 M8 -12 L4 2 L3 6 L3 8 L4 9 L7 9 L9 7 L10 5 M9 -12 L5 2 L4 6 L4 8 L5 9 M4 2 L4 -1 L3 -4 L1 -5 L-1 -5 L-4 -4 L-6 -1 L-7 2 L-7 5 L-6 7 L-5 8 L-3 9 L-1 9 L1 8 L3 5 L4 2 M-1 -5 L-3 -4 L-5 -1 L-6 2 L-6 6 L-5 8 M5 -12 L9 -12","-9 9 M-5 4 L-1 3 L2 2 L5 0 L6 -2 L5 -4 L3 -5 L0 -5 L-3 -4 L-5 -1 L-6 2 L-6 5 L-5 7 L-4 8 L-2 9 L0 9 L3 8 L5 6 M0 -5 L-2 -4 L-4 -1 L-5 2 L-5 6 L-4 8","-7 8 M8 -11 L7 -10 L8 -9 L9 -10 L9 -11 L8 -12 L6 -12 L4 -11 L3 -10 L2 -8 L1 -5 L-2 9 L-3 13 L-4 15 M6 -12 L4 -10 L3 -8 L2 -4 L0 5 L-1 9 L-2 12 L-3 14 L-4 15 L-6 16 L-8 16 L-9 15 L-9 14 L-8 13 L-7 14 L-8 15 M-3 -5 L7 -5","-10 10 M7 -5 L3 9 L2 12 L0 15 L-3 16 L-6 16 L-8 15 L-9 14 L-9 13 L-8 12 L-7 13 L-8 14 M6 -5 L2 9 L1 12 L-1 15 L-3 16 M4 2 L4 -1 L3 -4 L1 -5 L-1 -5 L-4 -4 L-6 -1 L-7 2 L-7 5 L-6 7 L-5 8 L-3 9 L-1 9 L1 8 L3 5 L4 2 M-1 -5 L-3 -4 L-5 -1 L-6 2 L-6 6 L-5 8","-10 11 M-2 -12 L-8 9 M-1 -12 L-7 9 M-5 2 L-3 -2 L-1 -4 L1 -5 L3 -5 L5 -4 L6 -3 L6 -1 L4 5 L4 8 L5 9 M3 -5 L5 -3 L5 -1 L3 5 L3 8 L4 9 L7 9 L9 7 L10 5 M-5 -12 L-1 -12","-6 7 M3 -12 L2 -11 L3 -10 L4 -11 L3 -12 M-5 -1 L-4 -3 L-2 -5 L1 -5 L2 -4 L2 -1 L0 5 L0 8 L1 9 M0 -5 L1 -4 L1 -1 L-1 5 L-1 8 L0 9 L3 9 L5 7 L6 5","-6 7 M4 -12 L3 -11 L4 -10 L5 -11 L4 -12 M-4 -1 L-3 -3 L-1 -5 L2 -5 L3 -4 L3 -1 L0 9 L-1 12 L-2 14 L-3 15 L-5 16 L-7 16 L-8 15 L-8 14 L-7 13 L-6 14 L-7 15 M1 -5 L2 -4 L2 -1 L-1 9 L-2 12 L-3 14 L-5 16","-10 10 M-2 -12 L-8 9 M-1 -12 L-7 9 M6 -4 L5 -3 L6 -2 L7 -3 L7 -4 L6 -5 L5 -5 L3 -4 L-1 0 L-3 1 L-5 1 M-3 1 L-1 2 L1 8 L2 9 M-3 1 L-2 2 L0 8 L1 9 L3 9 L5 8 L7 5 M-5 -12 L-1 -12","-5 7 M3 -12 L-1 2 L-2 6 L-2 8 L-1 9 L2 9 L4 7 L5 5 M4 -12 L0 2 L-1 6 L-1 8 L0 9 M0 -12 L4 -12","-17 16 M-16 -1 L-15 -3 L-13 -5 L-10 -5 L-9 -4 L-9 -2 L-10 2 L-12 9 M-11 -5 L-10 -4 L-10 -2 L-11 2 L-13 9 M-10 2 L-8 -2 L-6 -4 L-4 -5 L-2 -5 L0 -4 L1 -3 L1 -1 L-2 9 M-2 -5 L0 -3 L0 -1 L-3 9 M0 2 L2 -2 L4 -4 L6 -5 L8 -5 L10 -4 L11 -3 L11 -1 L9 5 L9 8 L10 9 M8 -5 L10 -3 L10 -1 L8 5 L8 8 L9 9 L12 9 L14 7 L15 5","-12 11 M-11 -1 L-10 -3 L-8 -5 L-5 -5 L-4 -4 L-4 -2 L-5 2 L-7 9 M-6 -5 L-5 -4 L-5 -2 L-6 2 L-8 9 M-5 2 L-3 -2 L-1 -4 L1 -5 L3 -5 L5 -4 L6 -3 L6 -1 L4 5 L4 8 L5 9 M3 -5 L5 -3 L5 -1 L3 5 L3 8 L4 9 L7 9 L9 7 L10 5","-9 9 M0 -5 L-3 -4 L-5 -1 L-6 2 L-6 5 L-5 7 L-4 8 L-2 9 L0 9 L3 8 L5 5 L6 2 L6 -1 L5 -3 L4 -4 L2 -5 L0 -5 M0 -5 L-2 -4 L-4 -1 L-5 2 L-5 6 L-4 8 M0 9 L2 8 L4 5 L5 2 L5 -2 L4 -4","-11 10 M-10 -1 L-9 -3 L-7 -5 L-4 -5 L-3 -4 L-3 -2 L-4 2 L-8 16 M-5 -5 L-4 -4 L-4 -2 L-5 2 L-9 16 M-4 2 L-3 -1 L-1 -4 L1 -5 L3 -5 L5 -4 L6 -3 L7 -1 L7 2 L6 5 L4 8 L1 9 L-1 9 L-3 8 L-4 5 L-4 2 M5 -4 L6 -2 L6 2 L5 5 L3 8 L1 9 M-12 16 L-5 16","-10 10 M6 -5 L0 16 M7 -5 L1 16 M4 2 L4 -1 L3 -4 L1 -5 L-1 -5 L-4 -4 L-6 -1 L-7 2 L-7 5 L-6 7 L-5 8 L-3 9 L-1 9 L1 8 L3 5 L4 2 M-1 -5 L-3 -4 L-5 -1 L-6 2 L-6 6 L-5 8 M-3 16 L4 16","-9 8 M-8 -1 L-7 -3 L-5 -5 L-2 -5 L-1 -4 L-1 -2 L-2 2 L-4 9 M-3 -5 L-2 -4 L-2 -2 L-3 2 L-5 9 M-2 2 L0 -2 L2 -4 L4 -5 L6 -5 L7 -4 L7 -3 L6 -2 L5 -3 L6 -4","-8 9 M6 -3 L6 -2 L7 -2 L7 -3 L6 -4 L3 -5 L0 -5 L-3 -4 L-4 -3 L-4 -1 L-3 0 L4 4 L5 5 M-4 -2 L-3 -1 L4 3 L5 4 L5 7 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-6 6 L-5 6 L-5 7","-7 7 M2 -12 L-2 2 L-3 6 L-3 8 L-2 9 L1 9 L3 7 L4 5 M3 -12 L-1 2 L-2 6 L-2 8 L-1 9 M-4 -5 L5 -5","-12 11 M-11 -1 L-10 -3 L-8 -5 L-5 -5 L-4 -4 L-4 -1 L-6 5 L-6 7 L-4 9 M-6 -5 L-5 -4 L-5 -1 L-7 5 L-7 7 L-6 8 L-4 9 L-2 9 L0 8 L2 6 L4 2 M6 -5 L4 2 L3 6 L3 8 L4 9 L7 9 L9 7 L10 5 M7 -5 L5 2 L4 6 L4 8 L5 9","-10 10 M-9 -1 L-8 -3 L-6 -5 L-3 -5 L-2 -4 L-2 -1 L-4 5 L-4 7 L-2 9 M-4 -5 L-3 -4 L-3 -1 L-5 5 L-5 7 L-4 8 L-2 9 L-1 9 L2 8 L4 6 L6 3 L7 -1 L7 -5 L6 -5 L7 -3","-15 14 M-14 -1 L-13 -3 L-11 -5 L-8 -5 L-7 -4 L-7 -1 L-9 5 L-9 7 L-7 9 M-9 -5 L-8 -4 L-8 -1 L-10 5 L-10 7 L-9 8 L-7 9 L-5 9 L-3 8 L-1 6 L0 4 M2 -5 L0 4 L0 7 L1 8 L3 9 L5 9 L7 8 L9 6 L10 4 L11 0 L11 -5 L10 -5 L11 -3 M3 -5 L1 4 L1 7 L3 9","-10 10 M-7 -1 L-5 -4 L-3 -5 L0 -5 L1 -3 L1 0 M-1 -5 L0 -3 L0 0 L-1 4 L-2 6 L-4 8 L-6 9 L-7 9 L-8 8 L-8 7 L-7 6 L-6 7 L-7 8 M-1 4 L-1 7 L0 9 L3 9 L5 8 L7 5 M7 -4 L6 -3 L7 -2 L8 -3 L8 -4 L7 -5 L6 -5 L4 -4 L2 -2 L1 0 L0 4 L0 7 L1 9","-11 10 M-10 -1 L-9 -3 L-7 -5 L-4 -5 L-3 -4 L-3 -1 L-5 5 L-5 7 L-3 9 M-5 -5 L-4 -4 L-4 -1 L-6 5 L-6 7 L-5 8 L-3 9 L-1 9 L1 8 L3 6 L5 2 M8 -5 L4 9 L3 12 L1 15 L-2 16 L-5 16 L-7 15 L-8 14 L-8 13 L-7 12 L-6 13 L-7 14 M7 -5 L3 9 L2 12 L0 15 L-2 16","-10 10 M7 -5 L6 -3 L4 -1 L-4 5 L-6 7 L-7 9 M-6 -1 L-5 -3 L-3 -5 L0 -5 L4 -3 M-5 -3 L-3 -4 L0 -4 L4 -3 L6 -3 M-6 7 L-4 7 L0 8 L3 8 L5 7 M-4 7 L0 9 L3 9 L5 7 L6 5","-7 7 M2 -16 L0 -15 L-1 -14 L-2 -12 L-2 -10 L-1 -8 L0 -7 L1 -5 L1 -3 L-1 -1 M0 -15 L-1 -13 L-1 -11 L0 -9 L1 -8 L2 -6 L2 -4 L1 -2 L-3 0 L1 2 L2 4 L2 6 L1 8 L0 9 L-1 11 L-1 13 L0 15 M-1 1 L1 3 L1 5 L0 7 L-1 8 L-2 10 L-2 12 L-1 14 L0 15 L2 16","-4 4 M0 -16 L0 16","-7 7 M-2 -16 L0 -15 L1 -14 L2 -12 L2 -10 L1 -8 L0 -7 L-1 -5 L-1 -3 L1 -1 M0 -15 L1 -13 L1 -11 L0 -9 L-1 -8 L-2 -6 L-2 -4 L-1 -2 L3 0 L-1 2 L-2 4 L-2 6 L-1 8 L0 9 L1 11 L1 13 L0 15 M1 1 L-1 3 L-1 5 L0 7 L1 8 L2 10 L2 12 L1 14 L0 15 L-2 16","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3","-8 8 M-8 -12 L-8 9 L-7 9 L-7 -12 L-6 -12 L-6 9 L-5 9 L-5 -12 L-4 -12 L-4 9 L-3 9 L-3 -12 L-2 -12 L-2 9 L-1 9 L-1 -12 L0 -12 L0 9 L1 9 L1 -12 L2 -12 L2 9 L3 9 L3 -12 L4 -12 L4 9 L5 9 L5 -12 L6 -12 L6 9 L7 9 L7 -12 L8 -12 L8 9"],
    :timesib => ["-8 8","-5 6 M4 -12 L3 -12 L2 -11 L0 2 M4 -11 L3 -11 L0 2 M4 -11 L4 -10 L0 2 M4 -12 L5 -11 L5 -10 L0 2 M-2 6 L-3 7 L-3 8 L-2 9 L-1 9 L0 8 L0 7 L-1 6 L-2 6 M-2 7 L-2 8 L-1 8 L-1 7 L-2 7","-9 9 M-2 -12 L-4 -5 M-1 -12 L-4 -5 M7 -12 L5 -5 M8 -12 L5 -5","-10 11 M1 -16 L-6 16 M7 -16 L0 16 M-6 -3 L8 -3 M-7 3 L7 3","-10 11 M2 -16 L-6 13 M7 -16 L-1 13 M8 -7 L8 -8 L7 -8 L7 -6 L9 -6 L9 -8 L8 -10 L7 -11 L4 -12 L0 -12 L-3 -11 L-5 -9 L-5 -6 L-4 -4 L-2 -2 L4 1 L5 3 L5 6 L4 8 M-4 -6 L-3 -4 L4 0 L5 2 M-3 -11 L-4 -9 L-4 -7 L-3 -5 L3 -2 L5 0 L6 2 L6 5 L5 7 L4 8 L1 9 L-3 9 L-6 8 L-7 7 L-8 5 L-8 3 L-6 3 L-6 5 L-7 5 L-7 4","-12 12 M9 -12 L-9 9 M-4 -12 L-2 -10 L-2 -8 L-3 -6 L-5 -5 L-7 -5 L-9 -7 L-9 -9 L-8 -11 L-6 -12 L-4 -12 L-2 -11 L1 -10 L4 -10 L7 -11 L9 -12 M5 2 L3 3 L2 5 L2 7 L4 9 L6 9 L8 8 L9 6 L9 4 L7 2 L5 2","-13 13 M10 -3 L10 -4 L9 -4 L9 -2 L11 -2 L11 -4 L10 -5 L9 -5 L7 -4 L5 -2 L0 6 L-2 8 L-4 9 L-7 9 L-10 8 L-11 6 L-11 4 L-10 2 L-9 1 L-7 0 L-2 -2 L0 -3 L2 -5 L3 -7 L3 -9 L2 -11 L0 -12 L-2 -11 L-3 -9 L-3 -6 L-2 0 L-1 3 L0 5 L2 8 L4 9 L6 9 L7 7 L7 6 M-6 9 L-10 8 M-9 8 L-10 6 L-10 4 L-9 2 L-8 1 L-6 0 M-2 -2 L-1 1 L2 7 L4 8 M-7 9 L-8 8 L-9 6 L-9 4 L-8 2 L-7 1 L-5 0 L0 -3 M-3 -6 L-2 -3 L-1 0 L1 4 L3 7 L5 8 L6 8 L7 7","-4 5 M3 -12 L1 -5 M4 -12 L1 -5","-8 8 M8 -16 L6 -15 L3 -13 L0 -10 L-2 -7 L-4 -3 L-5 1 L-5 6 L-4 10 L-3 13 L-1 16 M1 -10 L-1 -7 L-3 -3 L-4 2 L-4 10 M8 -16 L5 -14 L2 -11 L0 -8 L-1 -6 L-2 -3 L-3 1 L-4 10 M-4 2 L-3 11 L-2 14 L-1 16","-8 8 M1 -16 L3 -13 L4 -10 L5 -6 L5 -1 L4 3 L2 7 L0 10 L-3 13 L-6 15 L-8 16 M4 -10 L4 -2 L3 3 L1 7 L-1 10 M1 -16 L2 -14 L3 -11 L4 -2 M4 -10 L3 -1 L2 3 L1 6 L0 8 L-2 11 L-5 14 L-8 16","-8 9 M2 -12 L1 -11 L3 -1 L2 0 M2 -12 L2 0 M2 -12 L3 -11 L1 -1 L2 0 M-3 -9 L-2 -9 L6 -3 L7 -3 M-3 -9 L7 -3 M-3 -9 L-3 -8 L7 -4 L7 -3 M7 -9 L6 -9 L-2 -3 L-3 -3 M7 -9 L-3 -3 M7 -9 L7 -8 L-3 -4 L-3 -3","-12 13 M0 -9 L0 8 L1 8 M0 -9 L1 -9 L1 8 M-8 -1 L9 -1 L9 0 M-8 -1 L-8 0 L9 0","-5 6 M-1 9 L-2 9 L-3 8 L-3 7 L-2 6 L-1 6 L0 7 L0 9 L-1 11 L-2 12 L-4 13 M-2 7 L-2 8 L-1 8 L-1 7 L-2 7 M-1 9 L-1 10 L-2 12","-13 13 M-9 0 L9 0","-5 6 M-2 6 L-3 7 L-3 8 L-2 9 L-1 9 L0 8 L0 7 L-1 6 L-2 6 M-2 7 L-2 8 L-1 8 L-1 7 L-2 7","-11 12 M9 -16 L-9 16 L-8 16 M9 -16 L10 -16 L-8 16","-10 11 M2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 4 L-6 7 L-5 8 L-3 9 L-1 9 L2 8 L4 6 L6 3 L7 0 L8 -4 L8 -7 L7 -10 L6 -11 L4 -12 L2 -12 M-1 -10 L-3 -8 L-4 -6 L-5 -3 L-6 1 L-6 5 L-5 7 M2 7 L4 5 L5 3 L6 0 L7 -4 L7 -8 L6 -10 M2 -12 L0 -11 L-2 -8 L-3 -6 L-4 -3 L-5 1 L-5 6 L-4 8 L-3 9 M-1 9 L1 8 L3 5 L4 3 L5 0 L6 -4 L6 -9 L5 -11 L4 -12","-10 11 M2 -8 L-3 9 L-1 9 M5 -12 L3 -8 L-2 9 M5 -12 L-1 9 M5 -12 L2 -9 L-1 -7 L-3 -6 M2 -8 L0 -7 L-3 -6","-10 11 M-3 -7 L-3 -8 L-2 -8 L-2 -6 L-4 -6 L-4 -8 L-3 -10 L-2 -11 L1 -12 L4 -12 L7 -11 L8 -9 L8 -7 L7 -5 L5 -3 L-5 3 L-7 5 L-9 9 M6 -11 L7 -9 L7 -7 L6 -5 L4 -3 L1 -1 M4 -12 L5 -11 L6 -9 L6 -7 L5 -5 L3 -3 L-5 3 M-8 7 L-7 6 L-5 6 L0 7 L5 7 L6 6 M-5 6 L0 8 L5 8 M-5 6 L0 9 L3 9 L5 8 L6 6 L6 5","-10 11 M-3 -7 L-3 -8 L-2 -8 L-2 -6 L-4 -6 L-4 -8 L-3 -10 L-2 -11 L1 -12 L4 -12 L7 -11 L8 -9 L8 -7 L7 -5 L6 -4 L4 -3 L1 -2 M6 -11 L7 -9 L7 -7 L6 -5 L5 -4 M4 -12 L5 -11 L6 -9 L6 -7 L5 -5 L3 -3 L1 -2 M-1 -2 L1 -2 L4 -1 L5 0 L6 2 L6 5 L5 7 L3 8 L0 9 L-3 9 L-6 8 L-7 7 L-8 5 L-8 3 L-6 3 L-6 5 L-7 5 L-7 4 M4 0 L5 2 L5 5 L4 7 M1 -2 L3 -1 L4 1 L4 5 L3 7 L2 8 L0 9","-10 11 M5 -8 L0 9 L2 9 M8 -12 L6 -8 L1 9 M8 -12 L2 9 M8 -12 L-8 3 L8 3","-10 11 M-1 -12 L-6 -2 M-1 -12 L9 -12 M-1 -11 L7 -11 M-2 -10 L3 -10 L7 -11 L9 -12 M-6 -2 L-5 -3 L-2 -4 L1 -4 L4 -3 L5 -2 L6 0 L6 3 L5 6 L3 8 L-1 9 L-4 9 L-6 8 L-7 7 L-8 5 L-8 3 L-6 3 L-6 5 L-7 5 L-7 4 M4 -2 L5 0 L5 3 L4 6 L2 8 M1 -4 L3 -3 L4 -1 L4 3 L3 6 L1 8 L-1 9","-10 11 M7 -8 L7 -9 L6 -9 L6 -7 L8 -7 L8 -9 L7 -11 L5 -12 L2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 4 L-6 7 L-5 8 L-3 9 L0 9 L3 8 L5 6 L6 4 L6 1 L5 -1 L4 -2 L2 -3 L-1 -3 L-3 -2 L-4 -1 L-5 1 M-2 -9 L-4 -6 L-5 -3 L-6 1 L-6 5 L-5 7 M4 6 L5 4 L5 1 L4 -1 M2 -12 L0 -11 L-2 -8 L-3 -6 L-4 -3 L-5 1 L-5 6 L-4 8 L-3 9 M0 9 L2 8 L3 7 L4 4 L4 0 L3 -2 L2 -3","-10 11 M-4 -12 L-6 -6 M9 -12 L8 -9 L6 -6 L2 -1 L0 2 L-1 5 L-2 9 M0 1 L-2 5 L-3 9 M6 -6 L0 0 L-2 3 L-3 5 L-4 9 L-2 9 M-5 -9 L-2 -12 L0 -12 L5 -9 M-3 -11 L0 -11 L5 -9 M-5 -9 L-3 -10 L0 -10 L5 -9 L7 -9 L8 -10 L9 -12","-10 11 M1 -12 L-2 -11 L-3 -10 L-4 -8 L-4 -5 L-3 -3 L-1 -2 L2 -2 L5 -3 L7 -4 L8 -6 L8 -9 L7 -11 L5 -12 L1 -12 M3 -12 L-2 -11 M-2 -10 L-3 -8 L-3 -4 L-2 -3 M-3 -3 L0 -2 M1 -2 L5 -3 M6 -4 L7 -6 L7 -9 L6 -11 M7 -11 L3 -12 M1 -12 L-1 -10 L-2 -8 L-2 -4 L-1 -2 M2 -2 L4 -3 L5 -4 L6 -6 L6 -10 L5 -12 M-1 -2 L-5 -1 L-7 1 L-8 3 L-8 6 L-7 8 L-4 9 L0 9 L4 8 L5 7 L6 5 L6 2 L5 0 L4 -1 L2 -2 M0 -2 L-5 -1 M-4 -1 L-6 1 L-7 3 L-7 6 L-6 8 M-7 8 L-2 9 L4 8 M4 7 L5 5 L5 2 L4 0 M4 -1 L1 -2 M-1 -2 L-3 -1 L-5 1 L-6 3 L-6 6 L-5 8 L-4 9 M0 9 L2 8 L3 7 L4 5 L4 1 L3 -1 L2 -2","-10 11 M6 -4 L5 -2 L4 -1 L2 0 L-1 0 L-3 -1 L-4 -2 L-5 -4 L-5 -7 L-4 -9 L-2 -11 L1 -12 L4 -12 L6 -11 L7 -10 L8 -7 L8 -4 L7 0 L6 3 L4 6 L2 8 L-1 9 L-4 9 L-6 8 L-7 6 L-7 4 L-5 4 L-5 6 L-6 6 L-6 5 M-3 -2 L-4 -4 L-4 -7 L-3 -9 M6 -10 L7 -8 L7 -4 L6 0 L5 3 L3 6 M-1 0 L-2 -1 L-3 -3 L-3 -7 L-2 -10 L-1 -11 L1 -12 M4 -12 L5 -11 L6 -9 L6 -4 L5 0 L4 3 L3 5 L1 8 L-1 9","-5 6 M1 -5 L0 -4 L0 -3 L1 -2 L2 -2 L3 -3 L3 -4 L2 -5 L1 -5 M1 -4 L1 -3 L2 -3 L2 -4 L1 -4 M-2 6 L-3 7 L-3 8 L-2 9 L-1 9 L0 8 L0 7 L-1 6 L-2 6 M-2 7 L-2 8 L-1 8 L-1 7 L-2 7","-5 6 M1 -5 L0 -4 L0 -3 L1 -2 L2 -2 L3 -3 L3 -4 L2 -5 L1 -5 M1 -4 L1 -3 L2 -3 L2 -4 L1 -4 M-1 9 L-2 9 L-3 8 L-3 7 L-2 6 L-1 6 L0 7 L0 9 L-1 11 L-2 12 L-4 13 M-2 7 L-2 8 L-1 8 L-1 7 L-2 7 M-1 9 L-1 10 L-2 12","-12 12 M8 -9 L-8 0 L8 9","-12 13 M-8 -5 L9 -5 L9 -4 M-8 -5 L-8 -4 L9 -4 M-8 3 L9 3 L9 4 M-8 3 L-8 4 L9 4","-12 12 M-8 -9 L8 0 L-8 9","-10 11 M-3 -7 L-3 -8 L-2 -8 L-2 -6 L-4 -6 L-4 -8 L-3 -10 L-2 -11 L1 -12 L5 -12 L8 -11 L9 -9 L9 -7 L8 -5 L7 -4 L5 -3 L1 -2 L-1 -1 L-1 1 L1 2 L2 2 M3 -12 L8 -11 M7 -11 L8 -9 L8 -7 L7 -5 L6 -4 L4 -3 M5 -12 L6 -11 L7 -9 L7 -7 L6 -5 L5 -4 L1 -2 L0 -1 L0 1 L1 2 M-2 6 L-3 7 L-3 8 L-2 9 L-1 9 L0 8 L0 7 L-1 6 L-2 6 M-2 7 L-2 8 L-1 8 L-1 7 L-2 7","-13 14 M5 -4 L4 -6 L2 -7 L-1 -7 L-3 -6 L-4 -5 L-5 -2 L-5 1 L-4 3 L-2 4 L1 4 L3 3 L4 1 M-1 -7 L-3 -5 L-4 -2 L-4 1 L-3 3 L-2 4 M5 -7 L4 1 L4 3 L6 4 L8 4 L10 2 L11 -1 L11 -3 L10 -6 L9 -8 L7 -10 L5 -11 L2 -12 L-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L2 9 L5 8 L7 7 L8 6 M6 -7 L5 1 L5 3 L6 4","-10 10 M3 -12 L-9 8 M1 -8 L2 9 M2 -10 L3 8 M3 -12 L3 -10 L4 7 L4 9 M-6 3 L2 3 M-12 9 L-6 9 M-1 9 L6 9 M-9 8 L-11 9 M-9 8 L-7 9 M2 8 L0 9 M2 7 L1 9 M4 7 L5 9","-12 12 M-3 -12 L-9 9 M-2 -12 L-8 9 M-1 -12 L-7 9 M-6 -12 L5 -12 L8 -11 L9 -9 L9 -7 L8 -4 L7 -3 L4 -2 M7 -11 L8 -9 L8 -7 L7 -4 L6 -3 M5 -12 L6 -11 L7 -9 L7 -7 L6 -4 L4 -2 M-4 -2 L4 -2 L6 -1 L7 1 L7 3 L6 6 L4 8 L0 9 L-12 9 M5 -1 L6 1 L6 3 L5 6 L3 8 M4 -2 L5 0 L5 3 L4 6 L2 8 L0 9 M-5 -12 L-2 -11 M-4 -12 L-3 -10 M0 -12 L-2 -10 M1 -12 L-2 -11 M-8 8 L-11 9 M-8 7 L-10 9 M-7 7 L-6 9 M-8 8 L-5 9","-10 11 M8 -10 L9 -10 L10 -12 L9 -6 L9 -8 L8 -10 L7 -11 L5 -12 L2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 4 L-6 7 L-5 8 L-2 9 L1 9 L3 8 L5 6 L6 4 M-1 -10 L-3 -8 L-4 -6 L-5 -3 L-6 1 L-6 5 L-5 7 M2 -12 L0 -11 L-2 -8 L-3 -6 L-4 -3 L-5 1 L-5 6 L-4 8 L-2 9","-12 11 M-3 -12 L-9 9 M-2 -12 L-8 9 M-1 -12 L-7 9 M-6 -12 L3 -12 L6 -11 L7 -10 L8 -7 L8 -3 L7 1 L5 5 L3 7 L1 8 L-3 9 L-12 9 M5 -11 L6 -10 L7 -7 L7 -3 L6 1 L4 5 L2 7 M3 -12 L5 -10 L6 -7 L6 -3 L5 1 L3 5 L0 8 L-3 9 M-5 -12 L-2 -11 M-4 -12 L-3 -10 M0 -12 L-2 -10 M1 -12 L-2 -11 M-8 8 L-11 9 M-8 7 L-10 9 M-7 7 L-6 9 M-8 8 L-5 9","-12 11 M-3 -12 L-9 9 M-2 -12 L-8 9 M-1 -12 L-7 9 M3 -6 L1 2 M-6 -12 L9 -12 L8 -6 M-4 -2 L2 -2 M-12 9 L3 9 L5 4 M-5 -12 L-2 -11 M-4 -12 L-3 -10 M0 -12 L-2 -10 M1 -12 L-2 -11 M5 -12 L8 -11 M6 -12 L8 -10 M7 -12 L8 -9 M8 -12 L8 -6 M3 -6 L1 -2 L1 2 M2 -4 L0 -2 L1 0 M2 -3 L-1 -2 L1 -1 M-8 8 L-11 9 M-8 7 L-10 9 M-7 7 L-6 9 M-8 8 L-5 9 M-2 9 L3 8 M0 9 L3 7 M3 7 L5 4","-12 10 M-3 -12 L-9 9 M-2 -12 L-8 9 M-1 -12 L-7 9 M3 -6 L1 2 M-6 -12 L9 -12 L8 -6 M-4 -2 L2 -2 M-12 9 L-4 9 M-5 -12 L-2 -11 M-4 -12 L-3 -10 M0 -12 L-2 -10 M1 -12 L-2 -11 M5 -12 L8 -11 M6 -12 L8 -10 M7 -12 L8 -9 M8 -12 L8 -6 M3 -6 L1 -2 L1 2 M2 -4 L0 -2 L1 0 M2 -3 L-1 -2 L1 -1 M-8 8 L-11 9 M-8 7 L-10 9 M-7 7 L-6 9 M-8 8 L-5 9","-10 12 M8 -10 L9 -10 L10 -12 L9 -6 L9 -8 L8 -10 L7 -11 L5 -12 L2 -12 L-1 -11 L-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 4 L-6 7 L-5 8 L-2 9 L0 9 L3 8 L5 6 L7 2 M-1 -10 L-3 -8 L-4 -6 L-5 -3 L-6 1 L-6 5 L-5 7 M4 6 L5 5 L6 2 M2 -12 L0 -11 L-2 -8 L-3 -6 L-4 -3 L-5 1 L-5 6 L-4 8 L-2 9 M0 9 L2 8 L4 5 L5 2 M2 2 L10 2 M3 2 L5 3 M4 2 L5 5 M8 2 L6 4 M9 2 L6 3","-13 13 M-4 -12 L-10 9 M-3 -12 L-9 9 M-2 -12 L-8 9 M8 -12 L2 9 M9 -12 L3 9 M10 -12 L4 9 M-7 -12 L1 -12 M5 -12 L13 -12 M-6 -2 L6 -2 M-13 9 L-5 9 M-1 9 L7 9 M-6 -12 L-3 -11 M-5 -12 L-4 -10 M-1 -12 L-3 -10 M0 -12 L-3 -11 M6 -12 L9 -11 M7 -12 L8 -10 M11 -12 L9 -10 M12 -12 L9 -11 M-9 8 L-12 9 M-9 7 L-11 9 M-8 7 L-7 9 M-9 8 L-6 9 M3 8 L0 9 M3 7 L1 9 M4 7 L5 9 M3 8 L6 9","-7 7 M2 -12 L-4 9 M3 -12 L-3 9 M4 -12 L-2 9 M-1 -12 L7 -12 M-7 9 L1 9 M0 -12 L3 -11 M1 -12 L2 -10 M5 -12 L3 -10 M6 -12 L3 -11 M-3 8 L-6 9 M-3 7 L-5 9 M-2 7 L-1 9 M-3 8 L0 9","-9 10 M5 -12 L0 5 L-1 7 L-3 9 M6 -12 L2 1 L1 4 L0 6 M7 -12 L3 1 L1 6 L-1 8 L-3 9 L-5 9 L-7 8 L-8 6 L-8 4 L-7 3 L-6 3 L-5 4 L-5 5 L-6 6 L-7 6 M-7 4 L-7 5 L-6 5 L-6 4 L-7 4 M2 -12 L10 -12 M3 -12 L6 -11 M4 -12 L5 -10 M8 -12 L6 -10 M9 -12 L6 -11","-12 11 M-3 -12 L-9 9 M-2 -12 L-8 9 M-1 -12 L-7 9 M10 -11 L-5 0 M-1 -3 L3 9 M0 -3 L4 9 M1 -4 L5 8 M-6 -12 L2 -12 M7 -12 L13 -12 M-12 9 L-4 9 M0 9 L7 9 M-5 -12 L-2 -11 M-4 -12 L-3 -10 M0 -12 L-2 -10 M1 -12 L-2 -11 M8 -12 L10 -11 M12 -12 L10 -11 M-8 8 L-11 9 M-8 7 L-10 9 M-7 7 L-6 9 M-8 8 L-5 9 M3 8 L1 9 M3 7 L2 9 M4 7 L6 9","-10 10 M-1 -12 L-7 9 M0 -12 L-6 9 M1 -12 L-5 9 M-4 -12 L4 -12 M-10 9 L5 9 L7 3 M-3 -12 L0 -11 M-2 -12 L-1 -10 M2 -12 L0 -10 M3 -12 L0 -11 M-6 8 L-9 9 M-6 7 L-8 9 M-5 7 L-4 9 M-6 8 L-3 9 M0 9 L5 8 M2 9 L6 6 M4 9 L7 3","-14 14 M-5 -12 L-11 8 M-5 -11 L-4 7 L-4 9 M-4 -12 L-3 7 M-3 -12 L-2 6 M9 -12 L-2 6 L-4 9 M9 -12 L3 9 M10 -12 L4 9 M11 -12 L5 9 M-8 -12 L-3 -12 M9 -12 L14 -12 M-14 9 L-8 9 M0 9 L8 9 M-7 -12 L-5 -11 M-6 -12 L-5 -10 M12 -12 L10 -10 M13 -12 L10 -11 M-11 8 L-13 9 M-11 8 L-9 9 M4 8 L1 9 M4 7 L2 9 M5 7 L6 9 M4 8 L7 9","-12 13 M-3 -12 L-9 8 M-3 -12 L4 9 M-2 -12 L4 6 M-1 -12 L5 6 M10 -11 L5 6 L4 9 M-6 -12 L-1 -12 M7 -12 L13 -12 M-12 9 L-6 9 M-5 -12 L-2 -11 M-4 -12 L-2 -10 M8 -12 L10 -11 M12 -12 L10 -11 M-9 8 L-11 9 M-9 8 L-7 9","-11 11 M1 -12 L-2 -11 L-4 -9 L-6 -6 L-7 -3 L-8 1 L-8 4 L-7 7 L-6 8 L-4 9 L-1 9 L2 8 L4 6 L6 3 L7 0 L8 -4 L8 -7 L7 -10 L6 -11 L4 -12 L1 -12 M-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 5 L-6 7 M3 6 L5 3 L6 0 L7 -4 L7 -8 L6 -10 M1 -12 L-1 -11 L-3 -8 L-4 -6 L-5 -3 L-6 1 L-6 6 L-5 8 L-4 9 M-1 9 L1 8 L3 5 L4 3 L5 0 L6 -4 L6 -9 L5 -11 L4 -12","-12 11 M-3 -12 L-9 9 M-2 -12 L-8 9 M-1 -12 L-7 9 M-6 -12 L6 -12 L9 -11 L10 -9 L10 -7 L9 -4 L7 -2 L3 -1 L-5 -1 M8 -11 L9 -9 L9 -7 L8 -4 L6 -2 M6 -12 L7 -11 L8 -9 L8 -7 L7 -4 L5 -2 L3 -1 M-12 9 L-4 9 M-5 -12 L-2 -11 M-4 -12 L-3 -10 M0 -12 L-2 -10 M1 -12 L-2 -11 M-8 8 L-11 9 M-8 7 L-10 9 M-7 7 L-6 9 M-8 8 L-5 9","-11 11 M1 -12 L-2 -11 L-4 -9 L-6 -6 L-7 -3 L-8 1 L-8 4 L-7 7 L-6 8 L-4 9 L-1 9 L2 8 L4 6 L6 3 L7 0 L8 -4 L8 -7 L7 -10 L6 -11 L4 -12 L1 -12 M-3 -9 L-5 -6 L-6 -3 L-7 1 L-7 5 L-6 7 M3 6 L5 3 L6 0 L7 -4 L7 -8 L6 -10 M1 -12 L-1 -11 L-3 -8 L-4 -6 L-5 -3 L-6 1 L-6 6 L-5 8 L-4 9 M-1 9 L1 8 L3 5 L4 3 L5 0 L6 -4 L6 -9 L5 -11 L4 -12 M-6 6 L-5 4 L-3 3 L-2 3 L0 4 L1 6 L2 11 L3 12 L4 12 L5 11 M2 12 L3 13 L4 13 M1 6 L1 13 L2 14 L4 14 L5 11 L5 10","-12 12 M-3 -12 L-9 9 M-2 -12 L-8 9 M-1 -12 L-7 9 M-6 -12 L5 -12 L8 -11 L9 -9 L9 -7 L8 -4 L7 -3 L4 -2 L-4 -2 M7 -11 L8 -9 L8 -7 L7 -4 L6 -3 M5 -12 L6 -11 L7 -9 L7 -7 L6 -4 L4 -2 M0 -2 L2 -1 L3 0 L5 6 L6 7 L7 7 L8 6 M5 7 L6 8 L7 8 M3 0 L4 8 L5 9 L7 9 L8 6 L8 5 M-12 9 L-4 9 M-5 -12 L-2 -11 M-4 -12 L-3 -10 M0 -12 L-2 -10 M1 -12 L-2 -11 M-8 8 L-11 9 M-8 7 L-10 9 M-7 7 L-6 9 M-8 8 L-5 9","-11 12 M8 -10 L9 -10 L10 -12 L9 -6 L9 -8 L8 -10 L7 -11 L4 -12 L0 -12 L-3 -11 L-5 -9 L-5 -6 L-4 -4 L-2 -2 L4 1 L5 3 L5 6 L4 8 M-4 -6 L-3 -4 L4 0 L5 2 M-3 -11 L-4 -9 L-4 -7 L-3 -5 L3 -2 L5 0 L6 2 L6 5 L5 7 L4 8 L1 9 L-3 9 L-6 8 L-7 7 L-8 5 L-8 3 L-9 9 L-8 7 L-7 7","-11 11 M2 -12 L-4 9 M3 -12 L-3 9 M4 -12 L-2 9 M-5 -12 L-7 -6 M11 -12 L10 -6 M-5 -12 L11 -12 M-7 9 L1 9 M-4 -12 L-7 -6 M-2 -12 L-6 -9 M0 -12 L-5 -11 M7 -12 L10 -11 M8 -12 L10 -10 M9 -12 L10 -9 M10 -12 L10 -6 M-3 8 L-6 9 M-3 7 L-5 9 M-2 7 L-1 9 M-3 8 L0 9","-12 13 M-4 -12 L-7 -1 L-8 3 L-8 6 L-7 8 L-4 9 L0 9 L3 8 L5 6 L6 3 L10 -11 M-3 -12 L-6 -1 L-7 3 L-7 7 L-6 8 M-2 -12 L-5 -1 L-6 3 L-6 7 L-4 9 M-7 -12 L1 -12 M7 -12 L13 -12 M-6 -12 L-3 -11 M-5 -12 L-4 -10 M-1 -12 L-3 -10 M0 -12 L-3 -11 M8 -12 L10 -11 M12 -12 L10 -11","-10 10 M-4 -12 L-4 -10 L-3 7 L-3 9 M-3 -11 L-2 6 M-2 -12 L-1 5 M9 -11 L-3 9 M-6 -12 L1 -12 M6 -12 L12 -12 M-5 -12 L-4 -10 M-1 -12 L-2 -10 M0 -12 L-3 -11 M7 -12 L9 -11 M11 -12 L9 -11","-13 13 M-5 -12 L-5 -10 L-7 7 L-7 9 M-4 -11 L-6 6 M-3 -12 L-5 5 M3 -12 L-5 5 L-7 9 M3 -12 L3 -10 L1 7 L1 9 M4 -11 L2 6 M5 -12 L3 5 M11 -11 L3 5 L1 9 M-8 -12 L0 -12 M3 -12 L5 -12 M8 -12 L14 -12 M-7 -12 L-4 -11 M-6 -12 L-5 -10 M-2 -12 L-4 -9 M-1 -12 L-4 -11 M9 -12 L11 -11 M13 -12 L11 -11","-11 11 M-4 -12 L2 9 M-3 -12 L3 9 M-2 -12 L4 9 M9 -11 L-9 8 M-6 -12 L1 -12 M6 -12 L12 -12 M-12 9 L-6 9 M-1 9 L6 9 M-5 -12 L-3 -10 M-1 -12 L-2 -10 M0 -12 L-2 -11 M7 -12 L9 -11 M11 -12 L9 -11 M-9 8 L-11 9 M-9 8 L-7 9 M2 8 L0 9 M2 7 L1 9 M3 7 L5 9","-11 11 M-5 -12 L-1 -2 L-4 9 M-4 -12 L0 -2 L-3 9 M-3 -12 L1 -2 L-2 9 M10 -11 L1 -2 M-7 -12 L0 -12 M7 -12 L13 -12 M-7 9 L1 9 M-6 -12 L-4 -11 M-2 -12 L-3 -10 M-1 -12 L-4 -11 M8 -12 L10 -11 M12 -12 L10 -11 M-3 8 L-6 9 M-3 7 L-5 9 M-2 7 L-1 9 M-3 8 L0 9","-11 11 M8 -12 L-10 9 M9 -12 L-9 9 M10 -12 L-8 9 M10 -12 L-4 -12 L-6 -6 M-10 9 L4 9 L6 3 M-3 -12 L-6 -6 M-2 -12 L-5 -9 M0 -12 L-4 -11 M0 9 L4 8 M2 9 L5 6 M3 9 L6 3","-7 7 M-3 -16 L-3 16 M-2 -16 L-2 16 M-3 -16 L4 -16 M-3 16 L4 16","-7 7 M-7 -12 L7 12","-7 7 M2 -16 L2 16 M3 -16 L3 16 M-4 -16 L3 -16 M-4 16 L3 16","-11 11 M-8 2 L0 -3 L8 2 M-8 2 L0 -2 L8 2","-10 10 M-10 16 L10 16","-6 6 M-2 -12 L3 -6 M-2 -12 L-3 -11 L3 -6","-11 11 M5 -5 L3 2 L3 6 L4 8 L5 9 L7 9 L9 7 L10 5 M6 -5 L4 2 L4 8 M5 -5 L7 -5 L5 2 L4 6 M3 2 L3 -1 L2 -4 L0 -5 L-2 -5 L-5 -4 L-7 -1 L-8 2 L-8 4 L-7 7 L-6 8 L-4 9 L-2 9 L0 8 L1 7 L2 5 L3 2 M-4 -4 L-6 -1 L-7 2 L-7 5 L-6 7 M-2 -5 L-4 -3 L-5 -1 L-6 2 L-6 5 L-5 8 L-4 9","-9 10 M-2 -12 L-4 -5 L-5 1 L-5 5 L-4 7 L-3 8 L-1 9 L1 9 L4 8 L6 5 L7 2 L7 0 L6 -3 L5 -4 L3 -5 L1 -5 L-1 -4 L-2 -3 L-3 -1 L-4 2 M-1 -12 L-3 -5 L-4 -1 L-4 5 L-3 8 M4 7 L5 5 L6 2 L6 -1 L5 -3 M-5 -12 L0 -12 L-2 -5 L-4 2 M1 9 L3 7 L4 5 L5 2 L5 -1 L4 -4 L3 -5 M-4 -12 L-1 -11 M-3 -12 L-2 -10","-9 9 M5 -1 L5 -2 L4 -2 L4 0 L6 0 L6 -2 L5 -4 L3 -5 L0 -5 L-3 -4 L-5 -1 L-6 2 L-6 4 L-5 7 L-4 8 L-2 9 L0 9 L3 8 L5 5 M-3 -3 L-4 -1 L-5 2 L-5 5 L-4 7 M0 -5 L-2 -3 L-3 -1 L-4 2 L-4 5 L-3 8 L-2 9","-11 11 M7 -12 L4 -1 L3 3 L3 6 L4 8 L5 9 L7 9 L9 7 L10 5 M8 -12 L5 -1 L4 3 L4 8 M4 -12 L9 -12 L5 2 L4 6 M3 2 L3 -1 L2 -4 L0 -5 L-2 -5 L-5 -4 L-7 -1 L-8 2 L-8 4 L-7 7 L-6 8 L-4 9 L-2 9 L0 8 L1 7 L2 5 L3 2 M-5 -3 L-6 -1 L-7 2 L-7 5 L-6 7 M-2 -5 L-4 -3 L-5 -1 L-6 2 L-6 5 L-5 8 L-4 9 M5 -12 L8 -11 M6 -12 L7 -10","-9 9 M-5 4 L-1 3 L2 2 L5 0 L6 -2 L5 -4 L3 -5 L0 -5 L-3 -4 L-5 -1 L-6 2 L-6 4 L-5 7 L-4 8 L-2 9 L0 9 L3 8 L5 6 M-3 -3 L-4 -1 L-5 2 L-5 5 L-4 7 M0 -5 L-2 -3 L-3 -1 L-4 2 L-4 5 L-3 8 L-2 9","-8 8 M8 -10 L8 -11 L7 -11 L7 -9 L9 -9 L9 -11 L8 -12 L6 -12 L4 -11 L2 -9 L1 -7 L0 -4 L-1 0 L-3 9 L-4 12 L-5 14 L-7 16 M2 -8 L1 -5 L0 0 L-2 9 L-3 12 M6 -12 L4 -10 L3 -8 L2 -5 L1 0 L-1 8 L-2 11 L-3 13 L-5 15 L-7 16 L-9 16 L-10 15 L-10 13 L-8 13 L-8 15 L-9 15 L-9 14 M-4 -5 L7 -5","-10 11 M6 -5 L2 9 L1 12 L-1 15 L-3 16 M7 -5 L3 9 L1 13 M6 -5 L8 -5 L4 9 L2 13 L0 15 L-3 16 L-6 16 L-8 15 L-9 14 L-9 12 L-7 12 L-7 14 L-8 14 L-8 13 M4 2 L4 -1 L3 -4 L1 -5 L-1 -5 L-4 -4 L-6 -1 L-7 2 L-7 4 L-6 7 L-5 8 L-3 9 L-1 9 L1 8 L2 7 L3 5 L4 2 M-4 -3 L-5 -1 L-6 2 L-6 5 L-5 7 M-1 -5 L-3 -3 L-4 -1 L-5 2 L-5 5 L-4 8 L-3 9","-11 11 M-3 -12 L-9 9 L-7 9 M-2 -12 L-8 9 M-6 -12 L-1 -12 L-7 9 M-5 2 L-3 -2 L-1 -4 L1 -5 L3 -5 L5 -4 L6 -2 L6 1 L4 6 M5 -4 L5 0 L4 4 L4 8 M5 -2 L3 3 L3 6 L4 8 L5 9 L7 9 L9 7 L10 5 M-5 -12 L-2 -11 M-4 -12 L-3 -10","-7 6 M1 -12 L1 -10 L3 -10 L3 -12 L1 -12 M2 -12 L2 -10 M1 -11 L3 -11 M-6 -1 L-5 -3 L-3 -5 L-1 -5 L0 -4 L1 -2 L1 1 L-1 6 M0 -4 L0 0 L-1 4 L-1 8 M0 -2 L-2 3 L-2 6 L-1 8 L0 9 L2 9 L4 7 L5 5","-7 6 M3 -12 L3 -10 L5 -10 L5 -12 L3 -12 M4 -12 L4 -10 M3 -11 L5 -11 M-5 -1 L-4 -3 L-2 -5 L0 -5 L1 -4 L2 -2 L2 1 L0 8 L-1 11 L-2 13 L-4 15 L-6 16 L-8 16 L-9 15 L-9 13 L-7 13 L-7 15 L-8 15 L-8 14 M1 -4 L1 1 L-1 8 L-2 11 L-3 13 M1 -2 L0 2 L-2 9 L-3 12 L-4 14 L-6 16","-11 11 M-3 -12 L-9 9 L-7 9 M-2 -12 L-8 9 M-6 -12 L-1 -12 L-7 9 M7 -3 L7 -4 L6 -4 L6 -2 L8 -2 L8 -4 L7 -5 L5 -5 L3 -4 L-1 0 L-3 1 M-5 1 L-3 1 L-1 2 L0 3 L2 7 L3 8 L5 8 M-1 3 L1 7 L2 8 M-3 1 L-2 2 L0 8 L1 9 L3 9 L5 8 L7 5 M-5 -12 L-2 -11 M-4 -12 L-3 -10","-6 6 M2 -12 L-1 -1 L-2 3 L-2 6 L-1 8 L0 9 L2 9 L4 7 L5 5 M3 -12 L0 -1 L-1 3 L-1 8 M-1 -12 L4 -12 L0 2 L-1 6 M0 -12 L3 -11 M1 -12 L2 -10","-18 17 M-17 -1 L-16 -3 L-14 -5 L-12 -5 L-11 -4 L-10 -2 L-10 1 L-12 9 M-11 -4 L-11 1 L-13 9 M-11 -2 L-12 2 L-14 9 L-12 9 M-10 1 L-8 -2 L-6 -4 L-4 -5 L-2 -5 L0 -4 L1 -2 L1 1 L-1 9 M0 -4 L0 1 L-2 9 M0 -2 L-1 2 L-3 9 L-1 9 M1 1 L3 -2 L5 -4 L7 -5 L9 -5 L11 -4 L12 -2 L12 1 L10 6 M11 -4 L11 0 L10 4 L10 8 M11 -2 L9 3 L9 6 L10 8 L11 9 L13 9 L15 7 L16 5","-12 12 M-11 -1 L-10 -3 L-8 -5 L-6 -5 L-5 -4 L-4 -2 L-4 1 L-6 9 M-5 -4 L-5 1 L-7 9 M-5 -2 L-6 2 L-8 9 L-6 9 M-4 1 L-2 -2 L0 -4 L2 -5 L4 -5 L6 -4 L7 -2 L7 1 L5 6 M6 -4 L6 0 L5 4 L5 8 M6 -2 L4 3 L4 6 L5 8 L6 9 L8 9 L10 7 L11 5","-10 10 M-1 -5 L-4 -4 L-6 -1 L-7 2 L-7 4 L-6 7 L-5 8 L-2 9 L1 9 L4 8 L6 5 L7 2 L7 0 L6 -3 L5 -4 L2 -5 L-1 -5 M-4 -3 L-5 -1 L-6 2 L-6 5 L-5 7 M4 7 L5 5 L6 2 L6 -1 L5 -3 M-1 -5 L-3 -3 L-4 -1 L-5 2 L-5 5 L-4 8 L-2 9 M1 9 L3 7 L4 5 L5 2 L5 -1 L4 -4 L2 -5","-11 11 M-10 -1 L-9 -3 L-7 -5 L-5 -5 L-4 -4 L-3 -2 L-3 1 L-4 5 L-7 16 M-4 -4 L-4 1 L-5 5 L-8 16 M-4 -2 L-5 2 L-9 16 M-3 2 L-2 -1 L-1 -3 L0 -4 L2 -5 L4 -5 L6 -4 L7 -3 L8 0 L8 2 L7 5 L5 8 L2 9 L0 9 L-2 8 L-3 5 L-3 2 M6 -3 L7 -1 L7 2 L6 5 L5 7 M4 -5 L5 -4 L6 -1 L6 2 L5 5 L4 7 L2 9 M-12 16 L-4 16 M-8 15 L-11 16 M-8 14 L-10 16 M-7 14 L-6 16 M-8 15 L-5 16","-11 10 M5 -5 L-1 16 M6 -5 L0 16 M5 -5 L7 -5 L1 16 M3 2 L3 -1 L2 -4 L0 -5 L-2 -5 L-5 -4 L-7 -1 L-8 2 L-8 4 L-7 7 L-6 8 L-4 9 L-2 9 L0 8 L1 7 L2 5 L3 2 M-5 -3 L-6 -1 L-7 2 L-7 5 L-6 7 M-2 -5 L-4 -3 L-5 -1 L-6 2 L-6 5 L-5 8 L-4 9 M-4 16 L4 16 M0 15 L-3 16 M0 14 L-2 16 M1 14 L2 16 M0 15 L3 16","-9 9 M-8 -1 L-7 -3 L-5 -5 L-3 -5 L-2 -4 L-1 -2 L-1 2 L-3 9 M-2 -4 L-2 2 L-4 9 M-2 -2 L-3 2 L-5 9 L-3 9 M7 -3 L7 -4 L6 -4 L6 -2 L8 -2 L8 -4 L7 -5 L5 -5 L3 -4 L1 -2 L-1 2","-8 9 M6 -2 L6 -3 L5 -3 L5 -1 L7 -1 L7 -3 L6 -4 L3 -5 L0 -5 L-3 -4 L-4 -3 L-4 -1 L-3 1 L-1 2 L2 3 L4 4 L5 6 M-3 -4 L-4 -1 M-3 0 L-1 1 L2 2 L4 3 M5 4 L4 8 M-4 -3 L-3 -1 L-1 0 L2 1 L4 2 L5 4 L5 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-6 5 L-4 5 L-4 7 L-5 7 L-5 6","-7 7 M2 -12 L-1 -1 L-2 3 L-2 6 L-1 8 L0 9 L2 9 L4 7 L5 5 M3 -12 L0 -1 L-1 3 L-1 8 M2 -12 L4 -12 L0 2 L-1 6 M-4 -5 L6 -5","-12 12 M-11 -1 L-10 -3 L-8 -5 L-6 -5 L-5 -4 L-4 -2 L-4 1 L-6 6 M-5 -4 L-5 0 L-6 4 L-6 8 M-5 -2 L-7 3 L-7 6 L-6 8 L-4 9 L-2 9 L0 8 L2 6 L4 3 M6 -5 L4 3 L4 6 L5 8 L6 9 L8 9 L10 7 L11 5 M7 -5 L5 3 L5 8 M6 -5 L8 -5 L6 2 L5 6","-10 10 M-9 -1 L-8 -3 L-6 -5 L-4 -5 L-3 -4 L-2 -2 L-2 1 L-4 6 M-3 -4 L-3 0 L-4 4 L-4 8 M-3 -2 L-5 3 L-5 6 L-4 8 L-2 9 L0 9 L2 8 L4 6 L6 3 L7 -1 L7 -5 L6 -5 L6 -4 L7 -2","-15 15 M-14 -1 L-13 -3 L-11 -5 L-9 -5 L-8 -4 L-7 -2 L-7 1 L-9 6 M-8 -4 L-8 0 L-9 4 L-9 8 M-8 -2 L-10 3 L-10 6 L-9 8 L-7 9 L-5 9 L-3 8 L-1 6 L0 3 M2 -5 L0 3 L0 6 L1 8 L3 9 L5 9 L7 8 L9 6 L11 3 L12 -1 L12 -5 L11 -5 L11 -4 L12 -2 M3 -5 L1 3 L1 8 M2 -5 L4 -5 L2 2 L1 6","-11 11 M-8 -1 L-6 -4 L-4 -5 L-2 -5 L0 -4 L1 -2 L1 0 M-2 -5 L-1 -4 L-1 0 L-2 4 L-3 6 L-5 8 L-7 9 L-9 9 L-10 8 L-10 6 L-8 6 L-8 8 L-9 8 L-9 7 M0 -3 L0 0 L-1 4 L-1 7 M8 -3 L8 -4 L7 -4 L7 -2 L9 -2 L9 -4 L8 -5 L6 -5 L4 -4 L2 -2 L1 0 L0 4 L0 8 L1 9 M-2 4 L-2 6 L-1 8 L1 9 L3 9 L5 8 L7 5","-11 11 M-10 -1 L-9 -3 L-7 -5 L-5 -5 L-4 -4 L-3 -2 L-3 1 L-5 6 M-4 -4 L-4 0 L-5 4 L-5 8 M-4 -2 L-6 3 L-6 6 L-5 8 L-3 9 L-1 9 L1 8 L3 6 L5 2 M7 -5 L3 9 L2 12 L0 15 L-2 16 M8 -5 L4 9 L2 13 M7 -5 L9 -5 L5 9 L3 13 L1 15 L-2 16 L-5 16 L-7 15 L-8 14 L-8 12 L-6 12 L-6 14 L-7 14 L-7 13","-10 10 M7 -5 L6 -3 L4 -1 L-4 5 L-6 7 L-7 9 M6 -3 L-3 -3 L-5 -2 L-6 0 M4 -3 L0 -4 L-3 -4 L-4 -3 M4 -3 L0 -5 L-3 -5 L-5 -3 L-6 0 M-6 7 L3 7 L5 6 L6 4 M-4 7 L0 8 L3 8 L4 7 M-4 7 L0 9 L3 9 L5 7 L6 4","-7 7 M2 -16 L0 -15 L-1 -14 L-2 -12 L-2 -10 L-1 -8 L0 -7 L1 -5 L1 -3 L-1 -1 M0 -15 L-1 -13 L-1 -11 L0 -9 L1 -8 L2 -6 L2 -4 L1 -2 L-3 0 L1 2 L2 4 L2 6 L1 8 L0 9 L-1 11 L-1 13 L0 15 M-1 1 L1 3 L1 5 L0 7 L-1 8 L-2 10 L-2 12 L-1 14 L0 15 L2 16","-4 4 M0 -16 L0 16","-7 7 M-2 -16 L0 -15 L1 -14 L2 -12 L2 -10 L1 -8 L0 -7 L-1 -5 L-1 -3 L1 -1 M0 -15 L1 -13 L1 -11 L0 -9 L-1 -8 L-2 -6 L-2 -4 L-1 -2 L3 0 L-1 2 L-2 4 L-2 6 L-1 8 L0 9 L1 11 L1 13 L0 15 M1 1 L-1 3 L-1 5 L0 7 L1 8 L2 10 L2 12 L1 14 L0 15 L-2 16","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3","-8 8 M-8 -12 L-8 9 L-7 9 L-7 -12 L-6 -12 L-6 9 L-5 9 L-5 -12 L-4 -12 L-4 9 L-3 9 L-3 -12 L-2 -12 L-2 9 L-1 9 L-1 -12 L0 -12 L0 9 L1 9 L1 -12 L2 -12 L2 9 L3 9 L3 -12 L4 -12 L4 9 L5 9 L5 -12 L6 -12 L6 9 L7 9 L7 -12 L8 -12 L8 9"],
    :timesr => ["-8 8","-5 5 M0 -12 L-1 -10 L0 2 L1 -10 L0 -12 M0 -10 L0 -4 M0 7 L-1 8 L0 9 L1 8 L0 7","-9 9 M-4 -12 L-5 -11 L-5 -5 M-4 -11 L-5 -5 M-4 -12 L-3 -11 L-5 -5 M5 -12 L4 -11 L4 -5 M5 -11 L4 -5 M5 -12 L6 -11 L4 -5","-10 11 M1 -16 L-6 16 M7 -16 L0 16 M-6 -3 L8 -3 M-7 3 L7 3","-10 10 M-2 -16 L-2 13 M2 -16 L2 13 M6 -9 L5 -8 L6 -7 L7 -8 L7 -9 L5 -11 L2 -12 L-2 -12 L-5 -11 L-7 -9 L-7 -7 L-6 -5 L-5 -4 L-3 -3 L3 -1 L5 0 L7 2 M-7 -7 L-5 -5 L-3 -4 L3 -2 L5 -1 L6 0 L7 2 L7 6 L5 8 L2 9 L-2 9 L-5 8 L-7 6 L-7 5 L-6 4 L-5 5 L-6 6","-12 12 M9 -12 L-9 9 M-4 -12 L-2 -10 L-2 -8 L-3 -6 L-5 -5 L-7 -5 L-9 -7 L-9 -9 L-8 -11 L-6 -12 L-4 -12 L-2 -11 L1 -10 L4 -10 L7 -11 L9 -12 M5 2 L3 3 L2 5 L2 7 L4 9 L6 9 L8 8 L9 6 L9 4 L7 2 L5 2","-12 13 M9 -4 L8 -3 L9 -2 L10 -3 L10 -4 L9 -5 L8 -5 L7 -4 L6 -2 L4 3 L2 6 L0 8 L-2 9 L-5 9 L-8 8 L-9 6 L-9 3 L-8 1 L-2 -3 L0 -5 L1 -7 L1 -9 L0 -11 L-2 -12 L-4 -11 L-5 -9 L-5 -7 L-4 -4 L-2 -1 L3 6 L5 8 L8 9 L9 9 L10 8 L10 7 M-5 9 L-7 8 L-8 6 L-8 3 L-7 1 L-5 -1 M-5 -7 L-4 -5 L4 6 L6 8 L8 9","-4 4 M0 -12 L-1 -5 M1 -12 L-1 -5","-7 7 M4 -16 L2 -14 L0 -11 L-2 -7 L-3 -2 L-3 2 L-2 7 L0 11 L2 14 L4 16 M2 -14 L0 -10 L-1 -7 L-2 -2 L-2 2 L-1 7 L0 10 L2 14","-7 7 M-4 -16 L-2 -14 L0 -11 L2 -7 L3 -2 L3 2 L2 7 L0 11 L-2 14 L-4 16 M-2 -14 L0 -10 L1 -7 L2 -2 L2 2 L1 7 L0 10 L-2 14","-8 8 M0 -6 L0 6 M-5 -3 L5 3 M5 -3 L-5 3","-13 13 M0 -9 L0 9 M-9 0 L9 0","-4 4 M1 5 L0 6 L-1 5 L0 4 L1 5 L1 7 L-1 9","-13 13 M-9 0 L9 0","-4 4 M0 4 L-1 5 L0 6 L1 5 L0 4","-11 11 M9 -16 L-9 16","-10 10 M-1 -12 L-4 -11 L-6 -8 L-7 -3 L-7 0 L-6 5 L-4 8 L-1 9 L1 9 L4 8 L6 5 L7 0 L7 -3 L6 -8 L4 -11 L1 -12 L-1 -12 M-1 -12 L-3 -11 L-4 -10 L-5 -8 L-6 -3 L-6 0 L-5 5 L-4 7 L-3 8 L-1 9 M1 9 L3 8 L4 7 L5 5 L6 0 L6 -3 L5 -8 L4 -10 L3 -11 L1 -12","-10 10 M-4 -8 L-2 -9 L1 -12 L1 9 M0 -11 L0 9 M-4 9 L5 9","-10 10 M-6 -8 L-5 -7 L-6 -6 L-7 -7 L-7 -8 L-6 -10 L-5 -11 L-2 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -6 L6 -4 L3 -2 L-2 0 L-4 1 L-6 3 L-7 6 L-7 9 M2 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L2 -2 L-2 0 M-7 7 L-6 6 L-4 6 L1 8 L4 8 L6 7 L7 6 M-4 6 L1 9 L5 9 L6 8 L7 6 L7 4","-10 10 M-6 -8 L-5 -7 L-6 -6 L-7 -7 L-7 -8 L-6 -10 L-5 -11 L-2 -12 L2 -12 L5 -11 L6 -9 L6 -6 L5 -4 L2 -3 L-1 -3 M2 -12 L4 -11 L5 -9 L5 -6 L4 -4 L2 -3 M2 -3 L4 -2 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 4 L-6 3 L-5 4 L-6 5 M5 -1 L6 2 L6 5 L5 7 L4 8 L2 9","-10 10 M2 -10 L2 9 M3 -12 L3 9 M3 -12 L-8 3 L8 3 M-1 9 L6 9","-10 10 M-5 -12 L-7 -2 M-7 -2 L-5 -4 L-2 -5 L1 -5 L4 -4 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 4 L-6 3 L-5 4 L-6 5 M1 -5 L3 -4 L5 -2 L6 1 L6 3 L5 6 L3 8 L1 9 M-5 -12 L5 -12 M-5 -11 L0 -11 L5 -12","-10 10 M5 -9 L4 -8 L5 -7 L6 -8 L6 -9 L5 -11 L3 -12 L0 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -3 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 3 L7 2 L6 -1 L4 -3 L1 -4 L0 -4 L-3 -3 L-5 -1 L-6 2 M0 -12 L-2 -11 L-4 -9 L-5 -7 L-6 -3 L-6 3 L-5 6 L-3 8 L-1 9 M1 9 L3 8 L5 6 L6 3 L6 2 L5 -1 L3 -3 L1 -4","-10 10 M-7 -12 L-7 -6 M-7 -8 L-6 -10 L-4 -12 L-2 -12 L3 -9 L5 -9 L6 -10 L7 -12 M-6 -10 L-4 -11 L-2 -11 L3 -9 M7 -12 L7 -9 L6 -6 L2 -1 L1 1 L0 4 L0 9 M6 -6 L1 -1 L0 1 L-1 4 L-1 9","-10 10 M-2 -12 L-5 -11 L-6 -9 L-6 -6 L-5 -4 L-2 -3 L2 -3 L5 -4 L6 -6 L6 -9 L5 -11 L2 -12 L-2 -12 M-2 -12 L-4 -11 L-5 -9 L-5 -6 L-4 -4 L-2 -3 M2 -3 L4 -4 L5 -6 L5 -9 L4 -11 L2 -12 M-2 -3 L-5 -2 L-6 -1 L-7 1 L-7 5 L-6 7 L-5 8 L-2 9 L2 9 L5 8 L6 7 L7 5 L7 1 L6 -1 L5 -2 L2 -3 M-2 -3 L-4 -2 L-5 -1 L-6 1 L-6 5 L-5 7 L-4 8 L-2 9 M2 9 L4 8 L5 7 L6 5 L6 1 L5 -1 L4 -2 L2 -3","-10 10 M6 -5 L5 -2 L3 0 L0 1 L-1 1 L-4 0 L-6 -2 L-7 -5 L-7 -6 L-6 -9 L-4 -11 L-1 -12 L1 -12 L4 -11 L6 -9 L7 -6 L7 0 L6 4 L5 6 L3 8 L0 9 L-3 9 L-5 8 L-6 6 L-6 5 L-5 4 L-4 5 L-5 6 M-1 1 L-3 0 L-5 -2 L-6 -5 L-6 -6 L-5 -9 L-3 -11 L-1 -12 M1 -12 L3 -11 L5 -9 L6 -6 L6 0 L5 4 L4 6 L2 8 L0 9","-4 4 M0 -3 L-1 -2 L0 -1 L1 -2 L0 -3 M0 4 L-1 5 L0 6 L1 5 L0 4","-4 4 M0 -3 L-1 -2 L0 -1 L1 -2 L0 -3 M1 5 L0 6 L-1 5 L0 4 L1 5 L1 7 L-1 9","-12 12 M8 -9 L-8 0 L8 9","-13 13 M-9 -3 L9 -3 M-9 3 L9 3","-12 12 M-8 -9 L8 0 L-8 9","-9 9 M-5 -8 L-4 -7 L-5 -6 L-6 -7 L-6 -8 L-5 -10 L-4 -11 L-2 -12 L1 -12 L4 -11 L5 -10 L6 -8 L6 -6 L5 -4 L4 -3 L0 -1 L0 2 M1 -12 L3 -11 L4 -10 L5 -8 L5 -6 L4 -4 L2 -2 M0 7 L-1 8 L0 9 L1 8 L0 7","-13 14 M5 -4 L4 -6 L2 -7 L-1 -7 L-3 -6 L-4 -5 L-5 -2 L-5 1 L-4 3 L-2 4 L1 4 L3 3 L4 1 M-1 -7 L-3 -5 L-4 -2 L-4 1 L-3 3 L-2 4 M5 -7 L4 1 L4 3 L6 4 L8 4 L10 2 L11 -1 L11 -3 L10 -6 L9 -8 L7 -10 L5 -11 L2 -12 L-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L2 9 L5 8 L7 7 L8 6 M6 -7 L5 1 L5 3 L6 4","-10 10 M0 -12 L-7 9 M0 -12 L7 9 M0 -9 L6 9 M-5 3 L4 3 M-9 9 L-3 9 M3 9 L9 9","-11 11 M-6 -12 L-6 9 M-5 -12 L-5 9 M-9 -12 L3 -12 L6 -11 L7 -10 L8 -8 L8 -6 L7 -4 L6 -3 L3 -2 M3 -12 L5 -11 L6 -10 L7 -8 L7 -6 L6 -4 L5 -3 L3 -2 M-5 -2 L3 -2 L6 -1 L7 0 L8 2 L8 5 L7 7 L6 8 L3 9 L-9 9 M3 -2 L5 -1 L6 0 L7 2 L7 5 L6 7 L5 8 L3 9","-11 10 M6 -9 L7 -6 L7 -12 L6 -9 L4 -11 L1 -12 L-1 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 4 M-1 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -4 L-7 1 L-6 4 L-5 6 L-3 8 L-1 9","-11 11 M-6 -12 L-6 9 M-5 -12 L-5 9 M-9 -12 L1 -12 L4 -11 L6 -9 L7 -7 L8 -4 L8 1 L7 4 L6 6 L4 8 L1 9 L-9 9 M1 -12 L3 -11 L5 -9 L6 -7 L7 -4 L7 1 L6 4 L5 6 L3 8 L1 9","-11 10 M-6 -12 L-6 9 M-5 -12 L-5 9 M1 -6 L1 2 M-9 -12 L7 -12 L7 -6 L6 -12 M-5 -2 L1 -2 M-9 9 L7 9 L7 3 L6 9","-11 9 M-6 -12 L-6 9 M-5 -12 L-5 9 M1 -6 L1 2 M-9 -12 L7 -12 L7 -6 L6 -12 M-5 -2 L1 -2 M-9 9 L-2 9","-11 12 M6 -9 L7 -6 L7 -12 L6 -9 L4 -11 L1 -12 L-1 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 M-1 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -4 L-7 1 L-6 4 L-5 6 L-3 8 L-1 9 M6 1 L6 9 M7 1 L7 9 M3 1 L10 1","-12 12 M-7 -12 L-7 9 M-6 -12 L-6 9 M6 -12 L6 9 M7 -12 L7 9 M-10 -12 L-3 -12 M3 -12 L10 -12 M-6 -2 L6 -2 M-10 9 L-3 9 M3 9 L10 9","-5 6 M0 -12 L0 9 M1 -12 L1 9 M-3 -12 L4 -12 M-3 9 L4 9","-7 8 M3 -12 L3 5 L2 8 L0 9 L-2 9 L-4 8 L-5 6 L-5 4 L-4 3 L-3 4 L-4 5 M2 -12 L2 5 L1 8 L0 9 M-1 -12 L6 -12","-12 10 M-7 -12 L-7 9 M-6 -12 L-6 9 M7 -12 L-6 1 M-1 -3 L7 9 M-2 -3 L6 9 M-10 -12 L-3 -12 M3 -12 L9 -12 M-10 9 L-3 9 M3 9 L9 9","-9 9 M-4 -12 L-4 9 M-3 -12 L-3 9 M-7 -12 L0 -12 M-7 9 L8 9 L8 3 L7 9","-12 13 M-7 -12 L-7 9 M-6 -12 L0 6 M-7 -12 L0 9 M7 -12 L0 9 M7 -12 L7 9 M8 -12 L8 9 M-10 -12 L-6 -12 M7 -12 L11 -12 M-10 9 L-4 9 M4 9 L11 9","-11 12 M-6 -12 L-6 9 M-5 -12 L7 7 M-5 -10 L7 9 M7 -12 L7 9 M-9 -12 L-5 -12 M4 -12 L10 -12 M-9 9 L-3 9","-11 11 M-1 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -3 L-8 0 L-7 4 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 4 L8 0 L8 -3 L7 -7 L6 -9 L4 -11 L1 -12 L-1 -12 M-1 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -3 L-7 0 L-6 4 L-5 6 L-3 8 L-1 9 M1 9 L3 8 L5 6 L6 4 L7 0 L7 -3 L6 -7 L5 -9 L3 -11 L1 -12","-11 11 M-6 -12 L-6 9 M-5 -12 L-5 9 M-9 -12 L3 -12 L6 -11 L7 -10 L8 -8 L8 -5 L7 -3 L6 -2 L3 -1 L-5 -1 M3 -12 L5 -11 L6 -10 L7 -8 L7 -5 L6 -3 L5 -2 L3 -1 M-9 9 L-2 9","-11 11 M-1 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -3 L-8 0 L-7 4 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 4 L8 0 L8 -3 L7 -7 L6 -9 L4 -11 L1 -12 L-1 -12 M-1 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -3 L-7 0 L-6 4 L-5 6 L-3 8 L-1 9 M1 9 L3 8 L5 6 L6 4 L7 0 L7 -3 L6 -7 L5 -9 L3 -11 L1 -12 M-4 7 L-4 6 L-3 4 L-1 3 L0 3 L2 4 L3 6 L4 13 L5 14 L7 14 L8 12 L8 11 M3 6 L4 10 L5 12 L6 13 L7 13 L8 12","-11 11 M-6 -12 L-6 9 M-5 -12 L-5 9 M-9 -12 L3 -12 L6 -11 L7 -10 L8 -8 L8 -6 L7 -4 L6 -3 L3 -2 L-5 -2 M3 -12 L5 -11 L6 -10 L7 -8 L7 -6 L6 -4 L5 -3 L3 -2 M-9 9 L-2 9 M0 -2 L2 -1 L3 0 L6 7 L7 8 L8 8 L9 7 M2 -1 L3 1 L5 8 L6 9 L8 9 L9 7 L9 6","-10 10 M6 -9 L7 -12 L7 -6 L6 -9 L4 -11 L1 -12 L-2 -12 L-5 -11 L-7 -9 L-7 -7 L-6 -5 L-5 -4 L-3 -3 L3 -1 L5 0 L7 2 M-7 -7 L-5 -5 L-3 -4 L3 -2 L5 -1 L6 0 L7 2 L7 6 L5 8 L2 9 L-1 9 L-4 8 L-6 6 L-7 3 L-7 9 L-6 6","-9 10 M0 -12 L0 9 M1 -12 L1 9 M-6 -12 L-7 -6 L-7 -12 L8 -12 L8 -6 L7 -12 M-3 9 L4 9","-12 12 M-7 -12 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 3 L7 -12 M-6 -12 L-6 3 L-5 6 L-3 8 L-1 9 M-10 -12 L-3 -12 M4 -12 L10 -12","-10 10 M-7 -12 L0 9 M-6 -12 L0 6 M7 -12 L0 9 M-9 -12 L-3 -12 M3 -12 L9 -12","-12 12 M-8 -12 L-4 9 M-7 -12 L-4 4 M0 -12 L-4 9 M0 -12 L4 9 M1 -12 L4 4 M8 -12 L4 9 M-11 -12 L-4 -12 M5 -12 L11 -12","-10 10 M-7 -12 L6 9 M-6 -12 L7 9 M7 -12 L-7 9 M-9 -12 L-3 -12 M3 -12 L9 -12 M-9 9 L-3 9 M3 9 L9 9","-10 11 M-7 -12 L0 -1 L0 9 M-6 -12 L1 -1 L1 9 M8 -12 L1 -1 M-9 -12 L-3 -12 M4 -12 L10 -12 M-3 9 L4 9","-10 10 M6 -12 L-7 9 M7 -12 L-6 9 M-6 -12 L-7 -6 L-7 -12 L7 -12 M-7 9 L7 9 L7 3 L6 9","-7 7 M-3 -16 L-3 16 M-2 -16 L-2 16 M-3 -16 L4 -16 M-3 16 L4 16","-7 7 M-7 -12 L7 12","-7 7 M2 -16 L2 16 M3 -16 L3 16 M-4 -16 L3 -16 M-4 16 L3 16","-11 11 M-8 2 L0 -3 L8 2 M-8 2 L0 -2 L8 2","-10 10 M-10 16 L10 16","-6 6 M-2 -12 L3 -6 M-2 -12 L-3 -11 L3 -6","-9 11 M-4 -3 L-4 -2 L-5 -2 L-5 -3 L-4 -4 L-2 -5 L2 -5 L4 -4 L5 -3 L6 -1 L6 6 L7 8 L8 9 M5 -3 L5 6 L6 8 L8 9 L9 9 M5 -1 L4 0 L-2 1 L-5 2 L-6 4 L-6 6 L-5 8 L-2 9 L1 9 L3 8 L5 6 M-2 1 L-4 2 L-5 4 L-5 6 L-4 8 L-2 9","-11 10 M-6 -12 L-6 9 M-5 -12 L-5 9 M-5 -2 L-3 -4 L-1 -5 L1 -5 L4 -4 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-1 9 L-3 8 L-5 6 M1 -5 L3 -4 L5 -2 L6 1 L6 3 L5 6 L3 8 L1 9 M-9 -12 L-5 -12","-10 9 M5 -2 L4 -1 L5 0 L6 -1 L6 -2 L4 -4 L2 -5 L-1 -5 L-4 -4 L-6 -2 L-7 1 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 M-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9","-10 11 M5 -12 L5 9 M6 -12 L6 9 M5 -2 L3 -4 L1 -5 L-1 -5 L-4 -4 L-6 -2 L-7 1 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L3 8 L5 6 M-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 M2 -12 L6 -12 M5 9 L9 9","-10 9 M-6 1 L6 1 L6 -1 L5 -3 L4 -4 L2 -5 L-1 -5 L-4 -4 L-6 -2 L-7 1 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 M5 1 L5 -2 L4 -4 M-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9","-7 6 M3 -11 L2 -10 L3 -9 L4 -10 L4 -11 L3 -12 L1 -12 L-1 -11 L-2 -9 L-2 9 M1 -12 L0 -11 L-1 -9 L-1 9 M-5 -5 L3 -5 M-5 9 L2 9","-9 10 M-1 -5 L-3 -4 L-4 -3 L-5 -1 L-5 1 L-4 3 L-3 4 L-1 5 L1 5 L3 4 L4 3 L5 1 L5 -1 L4 -3 L3 -4 L1 -5 L-1 -5 M-3 -4 L-4 -2 L-4 2 L-3 4 M3 4 L4 2 L4 -2 L3 -4 M4 -3 L5 -4 L7 -5 L7 -4 L5 -4 M-4 3 L-5 4 L-6 6 L-6 7 L-5 9 L-2 10 L3 10 L6 11 L7 12 M-6 7 L-5 8 L-2 9 L3 9 L6 10 L7 12 L7 13 L6 15 L3 16 L-3 16 L-6 15 L-7 13 L-7 12 L-6 10 L-3 9","-11 11 M-6 -12 L-6 9 M-5 -12 L-5 9 M-5 -2 L-3 -4 L0 -5 L2 -5 L5 -4 L6 -2 L6 9 M2 -5 L4 -4 L5 -2 L5 9 M-9 -12 L-5 -12 M-9 9 L-2 9 M2 9 L9 9","-5 6 M0 -12 L-1 -11 L0 -10 L1 -11 L0 -12 M0 -5 L0 9 M1 -5 L1 9 M-3 -5 L1 -5 M-3 9 L4 9","-5 6 M1 -12 L0 -11 L1 -10 L2 -11 L1 -12 M2 -5 L2 13 L1 15 L-1 16 L-3 16 L-4 15 L-4 14 L-3 13 L-2 14 L-3 15 M1 -5 L1 13 L0 15 L-1 16 M-2 -5 L2 -5","-11 10 M-6 -12 L-6 9 M-5 -12 L-5 9 M5 -5 L-5 5 M0 1 L6 9 M-1 1 L5 9 M-9 -12 L-5 -12 M2 -5 L8 -5 M-9 9 L-2 9 M2 9 L8 9","-5 6 M0 -12 L0 9 M1 -12 L1 9 M-3 -12 L1 -12 M-3 9 L4 9","-16 17 M-11 -5 L-11 9 M-10 -5 L-10 9 M-10 -2 L-8 -4 L-5 -5 L-3 -5 L0 -4 L1 -2 L1 9 M-3 -5 L-1 -4 L0 -2 L0 9 M1 -2 L3 -4 L6 -5 L8 -5 L11 -4 L12 -2 L12 9 M8 -5 L10 -4 L11 -2 L11 9 M-14 -5 L-10 -5 M-14 9 L-7 9 M-3 9 L4 9 M8 9 L15 9","-11 11 M-6 -5 L-6 9 M-5 -5 L-5 9 M-5 -2 L-3 -4 L0 -5 L2 -5 L5 -4 L6 -2 L6 9 M2 -5 L4 -4 L5 -2 L5 9 M-9 -5 L-5 -5 M-9 9 L-2 9 M2 9 L9 9","-10 10 M-1 -5 L-4 -4 L-6 -2 L-7 1 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 3 L7 1 L6 -2 L4 -4 L1 -5 L-1 -5 M-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 M1 9 L3 8 L5 6 L6 3 L6 1 L5 -2 L3 -4 L1 -5","-11 10 M-6 -5 L-6 16 M-5 -5 L-5 16 M-5 -2 L-3 -4 L-1 -5 L1 -5 L4 -4 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-1 9 L-3 8 L-5 6 M1 -5 L3 -4 L5 -2 L6 1 L6 3 L5 6 L3 8 L1 9 M-9 -5 L-5 -5 M-9 16 L-2 16","-10 10 M5 -5 L5 16 M6 -5 L6 16 M5 -2 L3 -4 L1 -5 L-1 -5 L-4 -4 L-6 -2 L-7 1 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L3 8 L5 6 M-1 -5 L-3 -4 L-5 -2 L-6 1 L-6 3 L-5 6 L-3 8 L-1 9 M2 16 L9 16","-9 8 M-4 -5 L-4 9 M-3 -5 L-3 9 M-3 1 L-2 -2 L0 -4 L2 -5 L5 -5 L6 -4 L6 -3 L5 -2 L4 -3 L5 -4 M-7 -5 L-3 -5 M-7 9 L0 9","-8 9 M5 -3 L6 -5 L6 -1 L5 -3 L4 -4 L2 -5 L-2 -5 L-4 -4 L-5 -3 L-5 -1 L-4 0 L-2 1 L3 3 L5 4 L6 5 M-5 -2 L-4 -1 L-2 0 L3 2 L5 3 L6 4 L6 7 L5 8 L3 9 L-1 9 L-3 8 L-4 7 L-5 5 L-5 9 L-4 7","-7 8 M-2 -12 L-2 5 L-1 8 L1 9 L3 9 L5 8 L6 6 M-1 -12 L-1 5 L0 8 L1 9 M-5 -5 L3 -5","-11 11 M-6 -5 L-6 6 L-5 8 L-2 9 L0 9 L3 8 L5 6 M-5 -5 L-5 6 L-4 8 L-2 9 M5 -5 L5 9 M6 -5 L6 9 M-9 -5 L-5 -5 M2 -5 L6 -5 M5 9 L9 9","-9 9 M-6 -5 L0 9 M-5 -5 L0 7 M6 -5 L0 9 M-8 -5 L-2 -5 M2 -5 L8 -5","-12 12 M-8 -5 L-4 9 M-7 -5 L-4 6 M0 -5 L-4 9 M0 -5 L4 9 M1 -5 L4 6 M8 -5 L4 9 M-11 -5 L-4 -5 M5 -5 L11 -5","-10 10 M-6 -5 L5 9 M-5 -5 L6 9 M6 -5 L-6 9 M-8 -5 L-2 -5 M2 -5 L8 -5 M-8 9 L-2 9 M2 9 L8 9","-10 9 M-6 -5 L0 9 M-5 -5 L0 7 M6 -5 L0 9 L-2 13 L-4 15 L-6 16 L-7 16 L-8 15 L-7 14 L-6 15 M-8 -5 L-2 -5 M2 -5 L8 -5","-9 9 M5 -5 L-6 9 M6 -5 L-5 9 M-5 -5 L-6 -1 L-6 -5 L6 -5 M-6 9 L6 9 L6 5 L5 9","-7 7 M2 -16 L0 -15 L-1 -14 L-2 -12 L-2 -10 L-1 -8 L0 -7 L1 -5 L1 -3 L-1 -1 M0 -15 L-1 -13 L-1 -11 L0 -9 L1 -8 L2 -6 L2 -4 L1 -2 L-3 0 L1 2 L2 4 L2 6 L1 8 L0 9 L-1 11 L-1 13 L0 15 M-1 1 L1 3 L1 5 L0 7 L-1 8 L-2 10 L-2 12 L-1 14 L0 15 L2 16","-4 4 M0 -16 L0 16","-7 7 M-2 -16 L0 -15 L1 -14 L2 -12 L2 -10 L1 -8 L0 -7 L-1 -5 L-1 -3 L1 -1 M0 -15 L1 -13 L1 -11 L0 -9 L-1 -8 L-2 -6 L-2 -4 L-1 -2 L3 0 L-1 2 L-2 4 L-2 6 L-1 8 L0 9 L1 11 L1 13 L0 15 M1 1 L-1 3 L-1 5 L0 7 L1 8 L2 10 L2 12 L1 14 L0 15 L-2 16","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3","-8 8 M-8 -12 L-8 9 L-7 9 L-7 -12 L-6 -12 L-6 9 L-5 9 L-5 -12 L-4 -12 L-4 9 L-3 9 L-3 -12 L-2 -12 L-2 9 L-1 9 L-1 -12 L0 -12 L0 9 L1 9 L1 -12 L2 -12 L2 9 L3 9 L3 -12 L4 -12 L4 9 L5 9 L5 -12 L6 -12 L6 9 L7 9 L7 -12 L8 -12 L8 9"],
    :timesrb => ["-8 8","-5 6 M0 -12 L-1 -11 L-1 -9 L0 -1 M0 -12 L0 2 L1 2 M0 -12 L1 -12 L1 2 M1 -12 L2 -11 L2 -9 L1 -1 M0 6 L-1 7 L-1 8 L0 9 L1 9 L2 8 L2 7 L1 6 L0 6 M0 7 L0 8 L1 8 L1 7 L0 7","-9 9 M-4 -12 L-5 -11 L-5 -5 M-4 -11 L-5 -5 M-4 -12 L-3 -11 L-5 -5 M5 -12 L4 -11 L4 -5 M5 -11 L4 -5 M5 -12 L6 -11 L4 -5","-10 11 M1 -16 L-6 16 M7 -16 L0 16 M-6 -3 L8 -3 M-7 3 L7 3","-10 10 M-2 -16 L-2 13 M2 -16 L2 13 M6 -7 L6 -8 L5 -8 L5 -6 L7 -6 L7 -8 L6 -10 L5 -11 L2 -12 L-2 -12 L-5 -11 L-7 -9 L-7 -6 L-6 -4 L-3 -2 L3 0 L5 1 L6 3 L6 6 L5 8 M-6 -6 L-5 -4 L-3 -3 L3 -1 L5 0 L6 2 M-5 -11 L-6 -9 L-6 -7 L-5 -5 L-3 -4 L3 -2 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 3 L-5 3 L-5 5 L-6 5 L-6 4","-12 12 M9 -12 L-9 9 M-4 -12 L-2 -10 L-2 -8 L-3 -6 L-5 -5 L-7 -5 L-9 -7 L-9 -9 L-8 -11 L-6 -12 L-4 -12 L-2 -11 L1 -10 L4 -10 L7 -11 L9 -12 M5 2 L3 3 L2 5 L2 7 L4 9 L6 9 L8 8 L9 6 L9 4 L7 2 L5 2","-13 13 M9 -3 L9 -4 L8 -4 L8 -2 L10 -2 L10 -4 L9 -5 L8 -5 L7 -4 L6 -2 L4 3 L2 6 L0 8 L-2 9 L-6 9 L-8 8 L-9 6 L-9 3 L-8 1 L-2 -3 L0 -5 L1 -7 L1 -9 L0 -11 L-2 -12 L-4 -11 L-5 -9 L-5 -6 L-4 -3 L-2 0 L2 5 L5 8 L7 9 L9 9 L10 7 L10 6 M-7 8 L-8 6 L-8 3 L-7 1 L-6 0 M0 -5 L1 -9 M1 -7 L0 -11 M-4 -11 L-5 -7 M-4 -4 L-2 -1 L2 4 L5 7 L7 8 M-4 9 L-6 8 L-7 6 L-7 3 L-6 1 L-2 -3 M-5 -9 L-4 -5 L-1 -1 L3 4 L6 7 L8 8 L9 8 L10 7","-4 5 M1 -12 L0 -11 L0 -5 M1 -11 L0 -5 M1 -12 L2 -11 L0 -5","-7 7 M3 -16 L1 -14 L-1 -11 L-3 -7 L-4 -2 L-4 2 L-3 7 L-1 11 L1 14 L3 16 M-1 -10 L-2 -7 L-3 -3 L-3 3 L-2 7 L-1 10 M1 -14 L0 -12 L-1 -9 L-2 -3 L-2 3 L-1 9 L0 12 L1 14","-7 7 M-3 -16 L-1 -14 L1 -11 L3 -7 L4 -2 L4 2 L3 7 L1 11 L-1 14 L-3 16 M1 -10 L2 -7 L3 -3 L3 3 L2 7 L1 10 M-1 -14 L0 -12 L1 -9 L2 -3 L2 3 L1 9 L0 12 L-1 14","-8 8 M0 -12 L-1 -11 L1 -1 L0 0 M0 -12 L0 0 M0 -12 L1 -11 L-1 -1 L0 0 M-5 -9 L-4 -9 L4 -3 L5 -3 M-5 -9 L5 -3 M-5 -9 L-5 -8 L5 -4 L5 -3 M5 -9 L4 -9 L-4 -3 L-5 -3 M5 -9 L-5 -3 M5 -9 L5 -8 L-5 -4 L-5 -3","-12 13 M0 -9 L0 8 L1 8 M0 -9 L1 -9 L1 8 M-8 -1 L9 -1 L9 0 M-8 -1 L-8 0 L9 0","-5 6 M2 8 L1 9 L0 9 L-1 8 L-1 7 L0 6 L1 6 L2 7 L2 10 L1 12 L-1 13 M0 7 L0 8 L1 8 L1 7 L0 7 M1 9 L2 10 M2 8 L1 12","-13 13 M-9 0 L9 0","-5 6 M0 6 L-1 7 L-1 8 L0 9 L1 9 L2 8 L2 7 L1 6 L0 6 M0 7 L0 8 L1 8 L1 7 L0 7","-11 12 M9 -16 L-9 16 L-8 16 M9 -16 L10 -16 L-8 16","-10 10 M-1 -12 L-4 -11 L-6 -8 L-7 -3 L-7 0 L-6 5 L-4 8 L-1 9 L1 9 L4 8 L6 5 L7 0 L7 -3 L6 -8 L4 -11 L1 -12 L-1 -12 M-4 -10 L-5 -8 L-6 -4 L-6 1 L-5 5 L-4 7 M4 7 L5 5 L6 1 L6 -4 L5 -8 L4 -10 M-1 -12 L-3 -11 L-4 -9 L-5 -4 L-5 1 L-4 6 L-3 8 L-1 9 M1 9 L3 8 L4 6 L5 1 L5 -4 L4 -9 L3 -11 L1 -12","-10 10 M-1 -10 L-1 9 M0 -10 L0 8 M1 -12 L1 9 M1 -12 L-2 -9 L-4 -8 M-5 9 L5 9 M-1 8 L-3 9 M-1 7 L-2 9 M1 7 L2 9 M1 8 L3 9","-10 10 M-6 -8 L-6 -7 L-5 -7 L-5 -8 L-6 -8 M-6 -9 L-5 -9 L-4 -8 L-4 -7 L-5 -6 L-6 -6 L-7 -7 L-7 -8 L-6 -10 L-5 -11 L-2 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -6 L6 -4 L3 -2 L-2 0 L-4 1 L-6 3 L-7 6 L-7 9 M5 -10 L6 -8 L6 -6 L5 -4 M2 -12 L4 -11 L5 -8 L5 -6 L4 -4 L2 -2 L-2 0 M-7 7 L-6 6 L-4 6 L1 7 L5 7 L7 6 M-4 6 L1 8 L5 8 L6 7 M-4 6 L1 9 L5 9 L6 8 L7 6 L7 4","-10 10 M-6 -8 L-6 -7 L-5 -7 L-5 -8 L-6 -8 M-6 -9 L-5 -9 L-4 -8 L-4 -7 L-5 -6 L-6 -6 L-7 -7 L-7 -8 L-6 -10 L-5 -11 L-2 -12 L2 -12 L5 -11 L6 -9 L6 -6 L5 -4 L2 -3 M4 -11 L5 -9 L5 -6 L4 -4 M1 -12 L3 -11 L4 -9 L4 -6 L3 -4 L1 -3 M-1 -3 L2 -3 L4 -2 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 4 L-6 3 L-5 3 L-4 4 L-4 5 L-5 6 L-6 6 M5 0 L6 2 L6 5 L5 7 M1 -3 L3 -2 L4 -1 L5 2 L5 5 L4 8 L2 9 M-6 4 L-6 5 L-5 5 L-5 4 L-6 4","-10 10 M1 -9 L1 9 M2 -10 L2 8 M3 -12 L3 9 M3 -12 L-8 3 L8 3 M-2 9 L6 9 M1 8 L-1 9 M1 7 L0 9 M3 7 L4 9 M3 8 L5 9","-10 10 M-5 -12 L-7 -2 L-5 -4 L-2 -5 L1 -5 L4 -4 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-2 9 L-5 8 L-6 7 L-7 5 L-7 4 L-6 3 L-5 3 L-4 4 L-4 5 L-5 6 L-6 6 M5 -2 L6 0 L6 4 L5 6 M1 -5 L3 -4 L4 -3 L5 0 L5 4 L4 7 L3 8 L1 9 M-6 4 L-6 5 L-5 5 L-5 4 L-6 4 M-5 -12 L5 -12 M-5 -11 L3 -11 M-5 -10 L-1 -10 L3 -11 L5 -12","-10 10 M4 -9 L4 -8 L5 -8 L5 -9 L4 -9 M5 -10 L4 -10 L3 -9 L3 -8 L4 -7 L5 -7 L6 -8 L6 -9 L5 -11 L3 -12 L0 -12 L-3 -11 L-5 -9 L-6 -7 L-7 -3 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 3 L7 2 L6 -1 L4 -3 L1 -4 L-1 -4 L-3 -3 L-4 -2 L-5 0 M-4 -9 L-5 -7 L-6 -3 L-6 3 L-5 6 L-4 7 M5 6 L6 4 L6 1 L5 -1 M0 -12 L-2 -11 L-3 -10 L-4 -8 L-5 -4 L-5 3 L-4 6 L-3 8 L-1 9 M1 9 L3 8 L4 7 L5 4 L5 1 L4 -2 L3 -3 L1 -4","-10 10 M-7 -12 L-7 -6 M7 -12 L7 -9 L6 -6 L2 -1 L1 1 L0 5 L0 9 M1 0 L0 2 L-1 5 L-1 9 M6 -6 L1 -1 L-1 2 L-2 5 L-2 9 L0 9 M-7 -8 L-6 -10 L-4 -12 L-2 -12 L3 -9 L5 -9 L6 -10 L7 -12 M-5 -10 L-4 -11 L-2 -11 L0 -10 M-7 -8 L-6 -9 L-4 -10 L-2 -10 L3 -9","-10 10 M-2 -12 L-5 -11 L-6 -9 L-6 -6 L-5 -4 L-2 -3 L2 -3 L5 -4 L6 -6 L6 -9 L5 -11 L2 -12 L-2 -12 M-4 -11 L-5 -9 L-5 -6 L-4 -4 M4 -4 L5 -6 L5 -9 L4 -11 M-2 -12 L-3 -11 L-4 -9 L-4 -6 L-3 -4 L-2 -3 M2 -3 L3 -4 L4 -6 L4 -9 L3 -11 L2 -12 M-2 -3 L-5 -2 L-6 -1 L-7 1 L-7 5 L-6 7 L-5 8 L-2 9 L2 9 L5 8 L6 7 L7 5 L7 1 L6 -1 L5 -2 L2 -3 M-5 -1 L-6 1 L-6 5 L-5 7 M5 7 L6 5 L6 1 L5 -1 M-2 -3 L-4 -2 L-5 1 L-5 5 L-4 8 L-2 9 M2 9 L4 8 L5 5 L5 1 L4 -2 L2 -3","-10 10 M-5 5 L-5 6 L-4 6 L-4 5 L-5 5 M5 -3 L4 -1 L3 0 L1 1 L-1 1 L-4 0 L-6 -2 L-7 -5 L-7 -6 L-6 -9 L-4 -11 L-1 -12 L1 -12 L4 -11 L6 -9 L7 -6 L7 0 L6 4 L5 6 L3 8 L0 9 L-3 9 L-5 8 L-6 6 L-6 5 L-5 4 L-4 4 L-3 5 L-3 6 L-4 7 L-5 7 M-5 -2 L-6 -4 L-6 -7 L-5 -9 M4 -10 L5 -9 L6 -6 L6 0 L5 4 L4 6 M-1 1 L-3 0 L-4 -1 L-5 -4 L-5 -7 L-4 -10 L-3 -11 L-1 -12 M1 -12 L3 -11 L4 -9 L5 -6 L5 1 L4 5 L3 7 L2 8 L0 9","-5 6 M0 -5 L-1 -4 L-1 -3 L0 -2 L1 -2 L2 -3 L2 -4 L1 -5 L0 -5 M0 -4 L0 -3 L1 -3 L1 -4 L0 -4 M0 6 L-1 7 L-1 8 L0 9 L1 9 L2 8 L2 7 L1 6 L0 6 M0 7 L0 8 L1 8 L1 7 L0 7","-5 6 M0 -5 L-1 -4 L-1 -3 L0 -2 L1 -2 L2 -3 L2 -4 L1 -5 L0 -5 M0 -4 L0 -3 L1 -3 L1 -4 L0 -4 M2 8 L1 9 L0 9 L-1 8 L-1 7 L0 6 L1 6 L2 7 L2 10 L1 12 L-1 13 M0 7 L0 8 L1 8 L1 7 L0 7 M1 9 L2 10 M2 8 L1 12","-12 12 M8 -9 L-8 0 L8 9","-12 13 M-8 -5 L9 -5 L9 -4 M-8 -5 L-8 -4 L9 -4 M-8 3 L9 3 L9 4 M-8 3 L-8 4 L9 4","-12 12 M-8 -9 L8 0 L-8 9","-9 10 M-5 -7 L-5 -8 L-4 -8 L-4 -6 L-6 -6 L-6 -8 L-5 -10 L-4 -11 L-2 -12 L2 -12 L5 -11 L6 -10 L7 -8 L7 -6 L6 -4 L5 -3 L1 -1 M5 -10 L6 -9 L6 -5 L5 -4 M2 -12 L4 -11 L5 -9 L5 -5 L4 -3 L3 -2 M0 -1 L0 2 L1 2 L1 -1 L0 -1 M0 6 L-1 7 L-1 8 L0 9 L1 9 L2 8 L2 7 L1 6 L0 6 M0 7 L0 8 L1 8 L1 7 L0 7","-13 14 M5 -4 L4 -6 L2 -7 L-1 -7 L-3 -6 L-4 -5 L-5 -2 L-5 1 L-4 3 L-2 4 L1 4 L3 3 L4 1 M-1 -7 L-3 -5 L-4 -2 L-4 1 L-3 3 L-2 4 M5 -7 L4 1 L4 3 L6 4 L8 4 L10 2 L11 -1 L11 -3 L10 -6 L9 -8 L7 -10 L5 -11 L2 -12 L-1 -12 L-4 -11 L-6 -10 L-8 -8 L-9 -6 L-10 -3 L-10 0 L-9 3 L-8 5 L-6 7 L-4 8 L-1 9 L2 9 L5 8 L7 7 L8 6 M6 -7 L5 1 L5 3 L6 4","-10 10 M0 -12 L-7 8 M-1 -9 L5 9 M0 -9 L6 9 M0 -12 L7 9 M-5 3 L4 3 M-9 9 L-3 9 M2 9 L9 9 M-7 8 L-8 9 M-7 8 L-5 9 M5 8 L3 9 M5 7 L4 9 M6 7 L8 9","-11 11 M-6 -12 L-6 9 M-5 -11 L-5 8 M-4 -12 L-4 9 M-9 -12 L3 -12 L6 -11 L7 -10 L8 -8 L8 -6 L7 -4 L6 -3 L3 -2 M6 -10 L7 -8 L7 -6 L6 -4 M3 -12 L5 -11 L6 -9 L6 -5 L5 -3 L3 -2 M-4 -2 L3 -2 L6 -1 L7 0 L8 2 L8 5 L7 7 L6 8 L3 9 L-9 9 M6 0 L7 2 L7 5 L6 7 M3 -2 L5 -1 L6 1 L6 6 L5 8 L3 9 M-8 -12 L-6 -11 M-7 -12 L-6 -10 M-3 -12 L-4 -10 M-2 -12 L-4 -11 M-6 8 L-8 9 M-6 7 L-7 9 M-4 7 L-3 9 M-4 8 L-2 9","-11 10 M6 -9 L7 -12 L7 -6 L6 -9 L4 -11 L2 -12 L-1 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 L-1 9 L2 9 L4 8 L6 6 L7 4 M-5 -9 L-6 -7 L-7 -4 L-7 1 L-6 4 L-5 6 M-1 -12 L-3 -11 L-5 -8 L-6 -4 L-6 1 L-5 5 L-3 8 L-1 9","-11 11 M-6 -12 L-6 9 M-5 -11 L-5 8 M-4 -12 L-4 9 M-9 -12 L1 -12 L4 -11 L6 -9 L7 -7 L8 -4 L8 1 L7 4 L6 6 L4 8 L1 9 L-9 9 M5 -9 L6 -7 L7 -4 L7 1 L6 4 L5 6 M1 -12 L3 -11 L5 -8 L6 -4 L6 1 L5 5 L3 8 L1 9 M-8 -12 L-6 -11 M-7 -12 L-6 -10 M-3 -12 L-4 -10 M-2 -12 L-4 -11 M-6 8 L-8 9 M-6 7 L-7 9 M-4 7 L-3 9 M-4 8 L-2 9","-11 10 M-6 -12 L-6 9 M-5 -11 L-5 8 M-4 -12 L-4 9 M-9 -12 L7 -12 L7 -6 M-4 -2 L2 -2 M2 -6 L2 2 M-9 9 L7 9 L7 3 M-8 -12 L-6 -11 M-7 -12 L-6 -10 M-3 -12 L-4 -10 M-2 -12 L-4 -11 M2 -12 L7 -11 M4 -12 L7 -10 M5 -12 L7 -9 M6 -12 L7 -6 M2 -6 L1 -2 L2 2 M2 -4 L0 -2 L2 0 M2 -3 L-2 -2 L2 -1 M-6 8 L-8 9 M-6 7 L-7 9 M-4 7 L-3 9 M-4 8 L-2 9 M2 9 L7 8 M4 9 L7 7 M5 9 L7 6 M6 9 L7 3","-11 9 M-6 -12 L-6 9 M-5 -11 L-5 8 M-4 -12 L-4 9 M-9 -12 L7 -12 L7 -6 M-4 -2 L2 -2 M2 -6 L2 2 M-9 9 L-1 9 M-8 -12 L-6 -11 M-7 -12 L-6 -10 M-3 -12 L-4 -10 M-2 -12 L-4 -11 M2 -12 L7 -11 M4 -12 L7 -10 M5 -12 L7 -9 M6 -12 L7 -6 M2 -6 L1 -2 L2 2 M2 -4 L0 -2 L2 0 M2 -3 L-2 -2 L2 -1 M-6 8 L-8 9 M-6 7 L-7 9 M-4 7 L-3 9 M-4 8 L-2 9","-11 12 M6 -9 L7 -12 L7 -6 L6 -9 L4 -11 L2 -12 L-1 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -4 L-8 1 L-7 4 L-6 6 L-4 8 L-1 9 L2 9 L4 8 L6 8 L7 9 L7 1 M-5 -9 L-6 -7 L-7 -4 L-7 1 L-6 4 L-5 6 M-1 -12 L-3 -11 L-5 -8 L-6 -4 L-6 1 L-5 5 L-3 8 L-1 9 M6 2 L6 7 M5 1 L5 7 L4 8 M2 1 L10 1 M3 1 L5 2 M4 1 L5 3 M8 1 L7 3 M9 1 L7 2","-12 12 M-7 -12 L-7 9 M-6 -11 L-6 8 M-5 -12 L-5 9 M5 -12 L5 9 M6 -11 L6 8 M7 -12 L7 9 M-10 -12 L-2 -12 M2 -12 L10 -12 M-5 -2 L5 -2 M-10 9 L-2 9 M2 9 L10 9 M-9 -12 L-7 -11 M-8 -12 L-7 -10 M-4 -12 L-5 -10 M-3 -12 L-5 -11 M3 -12 L5 -11 M4 -12 L5 -10 M8 -12 L7 -10 M9 -12 L7 -11 M-7 8 L-9 9 M-7 7 L-8 9 M-5 7 L-4 9 M-5 8 L-3 9 M5 8 L3 9 M5 7 L4 9 M7 7 L8 9 M7 8 L9 9","-6 6 M-1 -12 L-1 9 M0 -11 L0 8 M1 -12 L1 9 M-4 -12 L4 -12 M-4 9 L4 9 M-3 -12 L-1 -11 M-2 -12 L-1 -10 M2 -12 L1 -10 M3 -12 L1 -11 M-1 8 L-3 9 M-1 7 L-2 9 M1 7 L2 9 M1 8 L3 9","-8 8 M1 -12 L1 5 L0 8 L-1 9 M2 -11 L2 5 L1 8 M3 -12 L3 5 L2 8 L-1 9 L-3 9 L-5 8 L-6 6 L-6 4 L-5 3 L-4 3 L-3 4 L-3 5 L-4 6 L-5 6 M-5 4 L-5 5 L-4 5 L-4 4 L-5 4 M-2 -12 L6 -12 M-1 -12 L1 -11 M0 -12 L1 -10 M4 -12 L3 -10 M5 -12 L3 -11","-12 10 M-7 -12 L-7 9 M-6 -11 L-6 8 M-5 -12 L-5 9 M6 -11 L-5 0 M-2 -2 L5 9 M-1 -2 L6 9 M-1 -4 L7 9 M-10 -12 L-2 -12 M3 -12 L9 -12 M-10 9 L-2 9 M2 9 L9 9 M-9 -12 L-7 -11 M-8 -12 L-7 -10 M-4 -12 L-5 -10 M-3 -12 L-5 -11 M5 -12 L6 -11 M8 -12 L6 -11 M-7 8 L-9 9 M-7 7 L-8 9 M-5 7 L-4 9 M-5 8 L-3 9 M5 7 L3 9 M5 7 L8 9","-9 9 M-4 -12 L-4 9 M-3 -11 L-3 8 M-2 -12 L-2 9 M-7 -12 L1 -12 M-7 9 L8 9 L8 3 M-6 -12 L-4 -11 M-5 -12 L-4 -10 M-1 -12 L-2 -10 M0 -12 L-2 -11 M-4 8 L-6 9 M-4 7 L-5 9 M-2 7 L-1 9 M-2 8 L0 9 M3 9 L8 8 M5 9 L8 7 M6 9 L8 6 M7 9 L8 3","-13 13 M-8 -12 L-8 8 M-8 -12 L-1 9 M-7 -12 L-1 6 M-6 -12 L0 6 M6 -12 L-1 9 M6 -12 L6 9 M7 -11 L7 8 M8 -12 L8 9 M-11 -12 L-6 -12 M6 -12 L11 -12 M-11 9 L-5 9 M3 9 L11 9 M-10 -12 L-8 -11 M9 -12 L8 -10 M10 -12 L8 -11 M-8 8 L-10 9 M-8 8 L-6 9 M6 8 L4 9 M6 7 L5 9 M8 7 L9 9 M8 8 L10 9","-12 12 M-7 -12 L-7 8 M-7 -12 L7 9 M-6 -12 L6 6 M-5 -12 L7 6 M7 -11 L7 9 M-10 -12 L-5 -12 M4 -12 L10 -12 M-10 9 L-4 9 M-9 -12 L-7 -11 M5 -12 L7 -11 M9 -12 L7 -11 M-7 8 L-9 9 M-7 8 L-5 9","-11 11 M-1 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -3 L-8 0 L-7 4 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 4 L8 0 L8 -3 L7 -7 L6 -9 L4 -11 L1 -12 L-1 -12 M-5 -9 L-6 -7 L-7 -4 L-7 1 L-6 4 L-5 6 M5 6 L6 4 L7 1 L7 -4 L6 -7 L5 -9 M-1 -12 L-3 -11 L-5 -8 L-6 -4 L-6 1 L-5 5 L-3 8 L-1 9 M1 9 L3 8 L5 5 L6 1 L6 -4 L5 -8 L3 -11 L1 -12","-11 11 M-6 -12 L-6 9 M-5 -11 L-5 8 M-4 -12 L-4 9 M-9 -12 L3 -12 L6 -11 L7 -10 L8 -8 L8 -5 L7 -3 L6 -2 L3 -1 L-4 -1 M6 -10 L7 -8 L7 -5 L6 -3 M3 -12 L5 -11 L6 -9 L6 -4 L5 -2 L3 -1 M-9 9 L-1 9 M-8 -12 L-6 -11 M-7 -12 L-6 -10 M-3 -12 L-4 -10 M-2 -12 L-4 -11 M-6 8 L-8 9 M-6 7 L-7 9 M-4 7 L-3 9 M-4 8 L-2 9","-11 11 M-1 -12 L-4 -11 L-6 -9 L-7 -7 L-8 -3 L-8 0 L-7 4 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 4 L8 0 L8 -3 L7 -7 L6 -9 L4 -11 L1 -12 L-1 -12 M-5 -9 L-6 -7 L-7 -4 L-7 1 L-6 4 L-5 6 M5 6 L6 4 L7 1 L7 -4 L6 -7 L5 -9 M-1 -12 L-3 -11 L-5 -8 L-6 -4 L-6 1 L-5 5 L-3 8 L-1 9 M1 9 L3 8 L5 5 L6 1 L6 -4 L5 -8 L3 -11 L1 -12 M-4 6 L-3 4 L-1 3 L0 3 L2 4 L3 6 L4 12 L5 14 L7 14 L8 12 L8 10 M4 10 L5 12 L6 13 L7 13 M3 6 L5 11 L6 12 L7 12 L8 11","-11 11 M-6 -12 L-6 9 M-5 -11 L-5 8 M-4 -12 L-4 9 M-9 -12 L3 -12 L6 -11 L7 -10 L8 -8 L8 -6 L7 -4 L6 -3 L3 -2 L-4 -2 M6 -10 L7 -8 L7 -6 L6 -4 M3 -12 L5 -11 L6 -9 L6 -5 L5 -3 L3 -2 M0 -2 L2 -1 L3 1 L5 7 L6 9 L8 9 L9 7 L9 5 M5 5 L6 7 L7 8 L8 8 M2 -1 L3 0 L6 6 L7 7 L8 7 L9 6 M-9 9 L-1 9 M-8 -12 L-6 -11 M-7 -12 L-6 -10 M-3 -12 L-4 -10 M-2 -12 L-4 -11 M-6 8 L-8 9 M-6 7 L-7 9 M-4 7 L-3 9 M-4 8 L-2 9","-10 10 M6 -9 L7 -12 L7 -6 L6 -9 L4 -11 L1 -12 L-2 -12 L-5 -11 L-7 -9 L-7 -6 L-6 -4 L-3 -2 L3 0 L5 1 L6 3 L6 6 L5 8 M-6 -6 L-5 -4 L-3 -3 L3 -1 L5 0 L6 2 M-5 -11 L-6 -9 L-6 -7 L-5 -5 L-3 -4 L3 -2 L6 0 L7 2 L7 5 L6 7 L5 8 L2 9 L-1 9 L-4 8 L-6 6 L-7 3 L-7 9 L-6 6","-10 10 M-8 -12 L-8 -6 M-1 -12 L-1 9 M0 -11 L0 8 M1 -12 L1 9 M8 -12 L8 -6 M-8 -12 L8 -12 M-4 9 L4 9 M-7 -12 L-8 -6 M-6 -12 L-8 -9 M-5 -12 L-8 -10 M-3 -12 L-8 -11 M3 -12 L8 -11 M5 -12 L8 -10 M6 -12 L8 -9 M7 -12 L8 -6 M-1 8 L-3 9 M-1 7 L-2 9 M1 7 L2 9 M1 8 L3 9","-12 12 M-7 -12 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 3 L7 -11 M-6 -11 L-6 4 L-5 6 M-5 -12 L-5 4 L-4 7 L-3 8 L-1 9 M-10 -12 L-2 -12 M4 -12 L10 -12 M-9 -12 L-7 -11 M-8 -12 L-7 -10 M-4 -12 L-5 -10 M-3 -12 L-5 -11 M5 -12 L7 -11 M9 -12 L7 -11","-10 10 M-7 -12 L0 9 M-6 -12 L0 6 L0 9 M-5 -12 L1 6 M7 -11 L0 9 M-9 -12 L-2 -12 M3 -12 L9 -12 M-8 -12 L-6 -10 M-4 -12 L-5 -10 M-3 -12 L-5 -11 M5 -12 L7 -11 M8 -12 L7 -11","-12 12 M-8 -12 L-4 9 M-7 -12 L-4 4 L-4 9 M-6 -12 L-3 4 M0 -12 L-3 4 L-4 9 M0 -12 L4 9 M1 -12 L4 4 L4 9 M2 -12 L5 4 M8 -11 L5 4 L4 9 M-11 -12 L-3 -12 M0 -12 L2 -12 M5 -12 L11 -12 M-10 -12 L-7 -11 M-9 -12 L-7 -10 M-5 -12 L-6 -10 M-4 -12 L-6 -11 M6 -12 L8 -11 M10 -12 L8 -11","-10 10 M-7 -12 L5 9 M-6 -12 L6 9 M-5 -12 L7 9 M6 -11 L-6 8 M-9 -12 L-2 -12 M3 -12 L9 -12 M-9 9 L-3 9 M2 9 L9 9 M-8 -12 L-5 -10 M-4 -12 L-5 -10 M-3 -12 L-5 -11 M4 -12 L6 -11 M8 -12 L6 -11 M-6 8 L-8 9 M-6 8 L-4 9 M5 8 L3 9 M5 7 L4 9 M5 7 L8 9","-11 11 M-8 -12 L-1 -1 L-1 9 M-7 -12 L0 -1 L0 8 M-6 -12 L1 -1 L1 9 M7 -11 L1 -1 M-10 -12 L-3 -12 M4 -12 L10 -12 M-4 9 L4 9 M-9 -12 L-7 -11 M-4 -12 L-6 -11 M5 -12 L7 -11 M9 -12 L7 -11 M-1 8 L-3 9 M-1 7 L-2 9 M1 7 L2 9 M1 8 L3 9","-10 10 M7 -12 L-7 -12 L-7 -6 M5 -12 L-7 9 M6 -12 L-6 9 M7 -12 L-5 9 M-7 9 L7 9 L7 3 M-6 -12 L-7 -6 M-5 -12 L-7 -9 M-4 -12 L-7 -10 M-2 -12 L-7 -11 M2 9 L7 8 M4 9 L7 7 M5 9 L7 6 M6 9 L7 3","-7 7 M-3 -16 L-3 16 M-2 -16 L-2 16 M-3 -16 L4 -16 M-3 16 L4 16","-7 7 M-7 -12 L7 12","-7 7 M2 -16 L2 16 M3 -16 L3 16 M-4 -16 L3 -16 M-4 16 L3 16","-11 11 M-8 2 L0 -3 L8 2 M-8 2 L0 -2 L8 2","-10 10 M-10 16 L10 16","-6 6 M-2 -12 L3 -6 M-2 -12 L-3 -11 L3 -6","-9 11 M-4 -2 L-4 -3 L-3 -3 L-3 -1 L-5 -1 L-5 -3 L-4 -4 L-2 -5 L2 -5 L4 -4 L5 -3 L6 -1 L6 6 L7 8 L8 9 M4 -3 L5 -1 L5 6 L6 8 M2 -5 L3 -4 L4 -2 L4 6 L5 8 L8 9 L9 9 M4 0 L3 1 L-2 2 L-5 3 L-6 5 L-6 6 L-5 8 L-2 9 L1 9 L3 8 L4 6 M-4 3 L-5 5 L-5 6 L-4 8 M3 1 L-1 2 L-3 3 L-4 5 L-4 6 L-3 8 L-2 9","-11 10 M-6 -12 L-6 9 L-5 8 L-3 8 M-5 -11 L-5 7 M-9 -12 L-4 -12 L-4 8 M-4 -2 L-3 -4 L-1 -5 L1 -5 L4 -4 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-1 9 L-3 8 L-4 6 M5 -2 L6 0 L6 4 L5 6 M1 -5 L3 -4 L4 -3 L5 0 L5 4 L4 7 L3 8 L1 9 M-8 -12 L-6 -11 M-7 -12 L-6 -10","-10 9 M5 -1 L5 -2 L4 -2 L4 0 L6 0 L6 -2 L4 -4 L2 -5 L-1 -5 L-4 -4 L-6 -2 L-7 1 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 M-5 -2 L-6 0 L-6 4 L-5 6 M-1 -5 L-3 -4 L-4 -3 L-5 0 L-5 4 L-4 7 L-3 8 L-1 9","-10 11 M4 -12 L4 9 L9 9 M5 -11 L5 8 M1 -12 L6 -12 L6 9 M4 -2 L3 -4 L1 -5 L-1 -5 L-4 -4 L-6 -2 L-7 1 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L3 8 L4 6 M-5 -2 L-6 0 L-6 4 L-5 6 M-1 -5 L-3 -4 L-4 -3 L-5 0 L-5 4 L-4 7 L-3 8 L-1 9 M2 -12 L4 -11 M3 -12 L4 -10 M6 7 L7 9 M6 8 L8 9","-10 9 M-5 1 L6 1 L6 -1 L5 -3 L4 -4 L1 -5 L-1 -5 L-4 -4 L-6 -2 L-7 1 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 M5 0 L5 -1 L4 -3 M-5 -2 L-6 0 L-6 4 L-5 6 M4 1 L4 -2 L3 -4 L1 -5 M-1 -5 L-3 -4 L-4 -3 L-5 0 L-5 4 L-4 7 L-3 8 L-1 9","-7 7 M5 -10 L5 -11 L4 -11 L4 -9 L6 -9 L6 -11 L5 -12 L2 -12 L0 -11 L-1 -10 L-2 -7 L-2 9 M0 -10 L-1 -7 L-1 8 M2 -12 L1 -11 L0 -9 L0 9 M-5 -5 L4 -5 M-5 9 L3 9 M-2 8 L-4 9 M-2 7 L-3 9 M0 7 L1 9 M0 8 L2 9","-9 10 M6 -4 L7 -3 L8 -4 L7 -5 L6 -5 L4 -4 L3 -3 M-1 -5 L-3 -4 L-4 -3 L-5 -1 L-5 1 L-4 3 L-3 4 L-1 5 L1 5 L3 4 L4 3 L5 1 L5 -1 L4 -3 L3 -4 L1 -5 L-1 -5 M-3 -3 L-4 -1 L-4 1 L-3 3 M3 3 L4 1 L4 -1 L3 -3 M-1 -5 L-2 -4 L-3 -2 L-3 2 L-2 4 L-1 5 M1 5 L2 4 L3 2 L3 -2 L2 -4 L1 -5 M-4 3 L-5 4 L-6 6 L-6 7 L-5 9 L-4 10 L-1 11 L3 11 L6 12 L7 13 M-4 9 L-1 10 L3 10 L6 11 M-6 7 L-5 8 L-2 9 L3 9 L6 10 L7 12 L7 13 L6 15 L3 16 L-3 16 L-6 15 L-7 13 L-7 12 L-6 10 L-3 9 M-3 16 L-5 15 L-6 13 L-6 12 L-5 10 L-3 9","-11 12 M-6 -12 L-6 9 M-5 -11 L-5 8 M-9 -12 L-4 -12 L-4 9 M-4 -1 L-3 -3 L-2 -4 L0 -5 L3 -5 L5 -4 L6 -3 L7 0 L7 9 M5 -3 L6 0 L6 8 M3 -5 L4 -4 L5 -1 L5 9 M-9 9 L-1 9 M2 9 L10 9 M-8 -12 L-6 -11 M-7 -12 L-6 -10 M-6 8 L-8 9 M-6 7 L-7 9 M-4 7 L-3 9 M-4 8 L-2 9 M5 8 L3 9 M5 7 L4 9 M7 7 L8 9 M7 8 L9 9","-6 6 M-1 -12 L-1 -10 L1 -10 L1 -12 L-1 -12 M0 -12 L0 -10 M-1 -11 L1 -11 M-1 -5 L-1 9 M0 -4 L0 8 M-4 -5 L1 -5 L1 9 M-4 9 L4 9 M-3 -5 L-1 -4 M-2 -5 L-1 -3 M-1 8 L-3 9 M-1 7 L-2 9 M1 7 L2 9 M1 8 L3 9","-7 6 M0 -12 L0 -10 L2 -10 L2 -12 L0 -12 M1 -12 L1 -10 M0 -11 L2 -11 M0 -5 L0 12 L-1 15 L-2 16 M1 -4 L1 11 L0 14 M-3 -5 L2 -5 L2 11 L1 14 L0 15 L-2 16 L-5 16 L-6 15 L-6 13 L-4 13 L-4 15 L-5 15 L-5 14 M-2 -5 L0 -4 M-1 -5 L0 -3","-11 11 M-6 -12 L-6 9 M-5 -11 L-5 8 M-9 -12 L-4 -12 L-4 9 M5 -4 L-4 5 M0 1 L7 9 M0 2 L6 9 M-1 2 L5 9 M2 -5 L9 -5 M-9 9 L-1 9 M2 9 L9 9 M-8 -12 L-6 -11 M-7 -12 L-6 -10 M3 -5 L5 -4 M8 -5 L5 -4 M-6 8 L-8 9 M-6 7 L-7 9 M-4 7 L-3 9 M-4 8 L-2 9 M5 7 L3 9 M4 7 L8 9","-6 6 M-1 -12 L-1 9 M0 -11 L0 8 M-4 -12 L1 -12 L1 9 M-4 9 L4 9 M-3 -12 L-1 -11 M-2 -12 L-1 -10 M-1 8 L-3 9 M-1 7 L-2 9 M1 7 L2 9 M1 8 L3 9","-17 17 M-12 -5 L-12 9 M-11 -4 L-11 8 M-15 -5 L-10 -5 L-10 9 M-10 -1 L-9 -3 L-8 -4 L-6 -5 L-3 -5 L-1 -4 L0 -3 L1 0 L1 9 M-1 -3 L0 0 L0 8 M-3 -5 L-2 -4 L-1 -1 L-1 9 M1 -1 L2 -3 L3 -4 L5 -5 L8 -5 L10 -4 L11 -3 L12 0 L12 9 M10 -3 L11 0 L11 8 M8 -5 L9 -4 L10 -1 L10 9 M-15 9 L-7 9 M-4 9 L4 9 M7 9 L15 9 M-14 -5 L-12 -4 M-13 -5 L-12 -3 M-12 8 L-14 9 M-12 7 L-13 9 M-10 7 L-9 9 M-10 8 L-8 9 M-1 8 L-3 9 M-1 7 L-2 9 M1 7 L2 9 M1 8 L3 9 M10 8 L8 9 M10 7 L9 9 M12 7 L13 9 M12 8 L14 9","-11 12 M-6 -5 L-6 9 M-5 -4 L-5 8 M-9 -5 L-4 -5 L-4 9 M-4 -1 L-3 -3 L-2 -4 L0 -5 L3 -5 L5 -4 L6 -3 L7 0 L7 9 M5 -3 L6 0 L6 8 M3 -5 L4 -4 L5 -1 L5 9 M-9 9 L-1 9 M2 9 L10 9 M-8 -5 L-6 -4 M-7 -5 L-6 -3 M-6 8 L-8 9 M-6 7 L-7 9 M-4 7 L-3 9 M-4 8 L-2 9 M5 8 L3 9 M5 7 L4 9 M7 7 L8 9 M7 8 L9 9","-10 10 M-1 -5 L-4 -4 L-6 -2 L-7 1 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L4 8 L6 6 L7 3 L7 1 L6 -2 L4 -4 L1 -5 L-1 -5 M-5 -2 L-6 0 L-6 4 L-5 6 M5 6 L6 4 L6 0 L5 -2 M-1 -5 L-3 -4 L-4 -3 L-5 0 L-5 4 L-4 7 L-3 8 L-1 9 M1 9 L3 8 L4 7 L5 4 L5 0 L4 -3 L3 -4 L1 -5","-11 10 M-6 -5 L-6 16 M-5 -4 L-5 15 M-9 -5 L-4 -5 L-4 16 M-4 -2 L-3 -4 L-1 -5 L1 -5 L4 -4 L6 -2 L7 1 L7 3 L6 6 L4 8 L1 9 L-1 9 L-3 8 L-4 6 M5 -2 L6 0 L6 4 L5 6 M1 -5 L3 -4 L4 -3 L5 0 L5 4 L4 7 L3 8 L1 9 M-9 16 L-1 16 M-8 -5 L-6 -4 M-7 -5 L-6 -3 M-6 15 L-8 16 M-6 14 L-7 16 M-4 14 L-3 16 M-4 15 L-2 16","-10 10 M4 -4 L4 16 M5 -3 L5 15 M3 -4 L5 -4 L6 -5 L6 16 M4 -2 L3 -4 L1 -5 L-1 -5 L-4 -4 L-6 -2 L-7 1 L-7 3 L-6 6 L-4 8 L-1 9 L1 9 L3 8 L4 6 M-5 -2 L-6 0 L-6 4 L-5 6 M-1 -5 L-3 -4 L-4 -3 L-5 0 L-5 4 L-4 7 L-3 8 L-1 9 M1 16 L9 16 M4 15 L2 16 M4 14 L3 16 M6 14 L7 16 M6 15 L8 16","-9 8 M-4 -5 L-4 9 M-3 -4 L-3 8 M-7 -5 L-2 -5 L-2 9 M5 -3 L5 -4 L4 -4 L4 -2 L6 -2 L6 -4 L5 -5 L3 -5 L1 -4 L-1 -2 L-2 1 M-7 9 L1 9 M-6 -5 L-4 -4 M-5 -5 L-4 -3 M-4 8 L-6 9 M-4 7 L-5 9 M-2 7 L-1 9 M-2 8 L0 9","-8 9 M5 -3 L6 -5 L6 -1 L5 -3 L4 -4 L2 -5 L-2 -5 L-4 -4 L-5 -3 L-5 -1 L-4 1 L-2 2 L3 3 L5 4 L6 7 M-4 -4 L-5 -1 M-4 0 L-2 1 L3 2 L5 3 M6 4 L5 8 M-5 -3 L-4 -1 L-2 0 L3 1 L5 2 L6 4 L6 7 L5 8 L3 9 L-1 9 L-3 8 L-4 7 L-5 5 L-5 9 L-4 7","-7 8 M-2 -10 L-2 4 L-1 7 L0 8 L2 9 L4 9 L6 8 L7 6 M-1 -10 L-1 5 L0 7 M-2 -10 L0 -12 L0 5 L1 8 L2 9 M-5 -5 L4 -5","-11 12 M-6 -5 L-6 4 L-5 7 L-4 8 L-2 9 L1 9 L3 8 L4 7 L5 5 M-5 -4 L-5 5 L-4 7 M-9 -5 L-4 -5 L-4 5 L-3 8 L-2 9 M5 -5 L5 9 L10 9 M6 -4 L6 8 M2 -5 L7 -5 L7 9 M-8 -5 L-6 -4 M-7 -5 L-6 -3 M7 7 L8 9 M7 8 L9 9","-9 9 M-6 -5 L0 9 M-5 -5 L0 7 M-4 -5 L1 7 M6 -4 L1 7 L0 9 M-8 -5 L-1 -5 M2 -5 L8 -5 M-7 -5 L-4 -3 M-2 -5 L-4 -4 M4 -5 L6 -4 M7 -5 L6 -4","-12 12 M-8 -5 L-4 9 M-7 -5 L-4 6 M-6 -5 L-3 6 M0 -5 L-3 6 L-4 9 M0 -5 L4 9 M1 -5 L4 6 M0 -5 L2 -5 L5 6 M8 -4 L5 6 L4 9 M-11 -5 L-3 -5 M5 -5 L11 -5 M-10 -5 L-7 -4 M-4 -5 L-6 -4 M6 -5 L8 -4 M10 -5 L8 -4","-10 10 M-6 -5 L4 9 M-5 -5 L5 9 M-4 -5 L6 9 M5 -4 L-5 8 M-8 -5 L-1 -5 M2 -5 L8 -5 M-8 9 L-2 9 M1 9 L8 9 M-7 -5 L-5 -4 M-2 -5 L-4 -4 M3 -5 L5 -4 M7 -5 L5 -4 M-5 8 L-7 9 M-5 8 L-3 9 M4 8 L2 9 M5 8 L7 9","-10 9 M-6 -5 L0 9 M-5 -5 L0 7 M-4 -5 L1 7 M6 -4 L1 7 L-2 13 L-4 15 L-6 16 L-8 16 L-9 15 L-9 13 L-7 13 L-7 15 L-8 15 L-8 14 M-8 -5 L-1 -5 M2 -5 L8 -5 M-7 -5 L-4 -3 M-2 -5 L-4 -4 M4 -5 L6 -4 M7 -5 L6 -4","-9 9 M4 -5 L-6 9 M5 -5 L-5 9 M6 -5 L-4 9 M6 -5 L-6 -5 L-6 -1 M-6 9 L6 9 L6 5 M-5 -5 L-6 -1 M-4 -5 L-6 -2 M-3 -5 L-6 -3 M-1 -5 L-6 -4 M1 9 L6 8 M3 9 L6 7 M4 9 L6 6 M5 9 L6 5","-7 7 M2 -16 L0 -15 L-1 -14 L-2 -12 L-2 -10 L-1 -8 L0 -7 L1 -5 L1 -3 L-1 -1 M0 -15 L-1 -13 L-1 -11 L0 -9 L1 -8 L2 -6 L2 -4 L1 -2 L-3 0 L1 2 L2 4 L2 6 L1 8 L0 9 L-1 11 L-1 13 L0 15 M-1 1 L1 3 L1 5 L0 7 L-1 8 L-2 10 L-2 12 L-1 14 L0 15 L2 16","-4 4 M0 -16 L0 16","-7 7 M-2 -16 L0 -15 L1 -14 L2 -12 L2 -10 L1 -8 L0 -7 L-1 -5 L-1 -3 L1 -1 M0 -15 L1 -13 L1 -11 L0 -9 L-1 -8 L-2 -6 L-2 -4 L-1 -2 L3 0 L-1 2 L-2 4 L-2 6 L-1 8 L0 9 L1 11 L1 13 L0 15 M1 1 L-1 3 L-1 5 L0 7 L1 8 L2 10 L2 12 L1 14 L0 15 L-2 16","-12 12 M-9 3 L-9 1 L-8 -2 L-6 -3 L-4 -3 L-2 -2 L2 1 L4 2 L6 2 L8 1 L9 -1 M-9 1 L-8 -1 L-6 -2 L-4 -2 L-2 -1 L2 2 L4 3 L6 3 L8 2 L9 -1 L9 -3","-8 8 M-8 -12 L-8 9 L-7 9 L-7 -12 L-6 -12 L-6 9 L-5 9 L-5 -12 L-4 -12 L-4 9 L-3 9 L-3 -12 L-2 -12 L-2 9 L-1 9 L-1 -12 L0 -12 L0 9 L1 9 L1 -12 L2 -12 L2 9 L3 9 L3 -12 L4 -12 L4 9 L5 9 L5 -12 L6 -12 L6 9 L7 9 L7 -12 L8 -12 L8 9"],
  }.freeze
end
